#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 50, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _123
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _131
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2656
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
};

struct _4700
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _5637
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _800_802
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
    vec4 _m38;
    vec4 _m39;
    vec4 _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    uint _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    float _m68;
    float _m69;
    float _m70;
    float _m71;
    float _m72;
    float _m73;
    float _m74;
    float _m75;
    float _m76;
    float _m77;
    uint _m78;
    float _m79[2];
} _802;

layout(set = 2, binding = 0, std140) uniform _1182_1184
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    uint _m23;
    int _m24;
    int _m25;
    uint _m26;
    uint _m27;
    uint _m28;
    uint _m29;
    uint _m30;
    uint _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    float _m68;
    float _m69;
    uint _m70;
    float _m71[1];
} _1184;

layout(set = 1, binding = 0, std140) uniform _1195_1197
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    uint _m15;
    uint _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    int _m31;
    uint _m32;
    float _m33[1];
} _1197;

layout(set = 3, binding = 0, std140) uniform _1235_1237
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1237;

layout(set = 0, binding = 24, std430) restrict readonly buffer _2205_2207
{
    vec4 _m0[];
} _2207;

layout(set = 0, binding = 25, std430) restrict readonly buffer _2567_2569
{
    uint _m0[];
} _2569;

layout(set = 0, binding = 26, std140) uniform _2661_2663
{
    vec4 _m0[4096];
} _2663;

layout(set = 0, binding = 27, std140) uniform _2681_2683
{
    vec4 _m0[4096];
} _2683;

layout(set = 0, binding = 28, std140) uniform _2734_2736
{
    vec4 _m0[2048];
} _2736;

layout(set = 0, binding = 35, std430) restrict readonly buffer _4056_4058
{
    uint _m0[];
} _4058;

layout(set = 0, binding = 39, std140) uniform _4704_4706
{
    vec4 _m0[4096];
} _4706;

layout(set = 0, binding = 40, std140) uniform _4780_4782
{
    vec4 _m0[4096];
} _4782;

layout(set = 0, binding = 42, std430) restrict readonly buffer _5061_5063
{
    uint _m0[];
} _5063;

layout(set = 0, binding = 43, std140) uniform _5642_5644
{
    vec4 _m0[4095];
} _5644;

layout(set = 0, binding = 1, std140) uniform _6456_6458
{
    vec4 _m0[64];
} _6458;

layout(push_constant, std430) uniform _2191_2193
{
    int _m0;
    int _m1;
    int _m2;
} _2193;

layout(set = 3, binding = 1) uniform TEXTURE_2D _1278[5];
layout(set = 0, binding = 13) uniform sampler _1286;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1304[5];
layout(set = 0, binding = 14) uniform sampler _1309;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1316[5];
layout(set = 0, binding = 15) uniform sampler _1321;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1338[5];
layout(set = 0, binding = 16) uniform sampler _1343;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1350[5];
layout(set = 0, binding = 17) uniform sampler _1355;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1362[5];
layout(set = 0, binding = 18) uniform sampler _1367;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1374[5];
layout(set = 0, binding = 19) uniform sampler _1379;
layout(set = 4, binding = 0) uniform TEXTURE_2D _1461[34816];
layout(set = 0, binding = 20) uniform sampler _1466;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1996[5];
layout(set = 0, binding = 21) uniform sampler _2001;
layout(set = 0, binding = 22) uniform TEXTURE_2D _2163;
layout(set = 0, binding = 23) uniform sampler _2165;
layout(set = 0, binding = 29) uniform TEXTURE_2D _2931;
layout(set = 0, binding = 30) uniform TEXTURE_2D _2982;
layout(set = 0, binding = 31) uniform TEXTURE_2D _3395;
layout(set = 0, binding = 32) uniform sampler _3397;
layout(set = 0, binding = 33) uniform TEXTURE_2D _3634;
layout(set = 0, binding = 34) uniform sampler _3636;
layout(set = 0, binding = 36) uniform TEXTURE_2D _4309;
layout(set = 0, binding = 37) uniform sampler _4311;
layout(set = 0, binding = 38) uniform TEXTURE_2D _4607;
layout(set = 0, binding = 41) uniform textureCubeArray _5034;
layout(set = 0, binding = 11) uniform sampler _5036;
layout(set = 0, binding = 44) uniform texture2D _5965;
layout(set = 0, binding = 45) uniform samplerShadow _5967;
layout(set = 0, binding = 8) uniform texture3D _6461;
layout(set = 0, binding = 9) uniform sampler _6462;
layout(set = 0, binding = 10) uniform texture3D _6463;

layout(location = 17, component = 3) in float _1060;
layout(location = 18, component = 0) in float _1062;
layout(location = 18, component = 1) in float _1067;
layout(location = 18, component = 2) in float _1069;
layout(location = 18, component = 3) in float _1071;
layout(location = 19, component = 0) in float _1102;
layout(location = 19, component = 1) in float _1104;
layout(location = 19, component = 2) in float _1106;
layout(location = 19, component = 3) in float _1110;
layout(location = 20, component = 0) in float _1112;
layout(location = 20, component = 1) in float _1114;
layout(location = 20, component = 2) in float _1126;
layout(location = 10, component = 0) in vec4 _1151;
layout(location = 11, component = 0) in vec4 _1154;
layout(location = 12, component = 0) in vec4 _1157;
layout(location = 0, component = 0) in vec4 _2055;
layout(location = 0, component = 0) out vec4 _6396;
layout(location = 1, component = 0) out vec4 _6410;
layout(location = 2, component = 0) out vec4 _6437;
layout(location = 15, component = 0) in vec4 _6464;
uint _196;
uint _198;
uint _200;
uint _202;
uint _204;
uint _206;
uint _208;
uint _209;
uint _211;
uint _212;
uint _214;
uint _216;
uint _218;
uint _220;
uint _222;
uint _224;
uint _226;
uint _228;
uint _230;

_131 _133()
{
    _131 _692;
    _692._m0 = vec3(0.0);
    _692._m2 = vec3(0.0);
    _692._m3 = 0.0;
    _692._m4 = 0u;
    _692._m5 = 0.0;
    _692._m6 = vec3(0.0);
    _692._m7 = vec3(0.0, 0.0, 1.0);
    _692._m8 = vec3(0.0, 0.0, 1.0);
    _692._m1 = vec3(0.0);
    _692._m9 = 1.0;
    _692._m10 = 1.0;
    _692._m14 = vec3(0.0);
    _692._m15 = vec3(0.0);
    _692._m16 = vec4(0.0);
    _692._m17 = vec4(0.0);
    _692._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _692._m19 = vec3(0.0);
    _692._m20 = vec3(0.0);
    _692._m21 = vec3(0.0);
    _692._m22 = vec3(0.0);
    _692._m23 = vec3(0.0);
    _692._m24 = vec3(0.0);
    _692._m25 = 1.0;
    _692._m26 = uvec4(0u);
    _692._m27 = uvec4(0u);
    _692._m28 = uvec4(0u);
    _692._m29 = vec4(0.0);
    _692._m30 = vec4(0.0);
    _692._m31 = vec4(0.0);
    _692._m32 = vec4(0.0);
    _692._m33 = uvec2(0u);
    _692._m34 = vec2(0.0);
    _692._m35 = 0.0;
    _692._m36 = -1;
    _692._m37 = 0;
    _692._m38 = vec2(0.0);
    _692._m39 = 1.0;
    _692._m41 = -1;
    _692._m45 = 1.0;
    _692._m11 = 1.0;
    _692._m12 = 0u;
    _692._m13 = uvec3(0u);
    _692._m40 = vec3(0.0);
    _692._m46 = 0.0;
    _692._m47 = 1.0;
    return _692;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_123 _125()
{
    _123 _680;
    _680._m0 = vec4(0.0);
    _680._m1 = vec4(0.0);
    _680._m2 = vec4(0.0);
    _680._m3 = vec4(0.0);
    _680._m4 = vec4(0.0);
    _680._m5 = 0.0;
    return _680;
}

vec2 _149(vec2 _148)
{
    return ((_148 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _154(inout vec2 _152, bool _153)
{
    vec2 _835 = _152;
    _152 = _149(_835);
    float _855 = (1.0 - (_152.x * _152.x)) - (_152.y * _152.y);
    vec3 _838 = vec3(_152.x, _152.y, sqrt(_10(_855)));
    if (_153 == false)
    {
        _838.z = -_838.z;
    }
    return _838;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _89(inout vec4 _88)
{
    vec4 _434 = _88;
    _88 = _22(_434);
    return packUnorm4x8(_88.wzyx);
}

vec3 _71(mat3 _69, vec3 _70)
{
    return _69 * _70;
}

vec3 _159(vec3 _157, mat3 _158)
{
    mat3 _871 = _158;
    vec3 _873 = _157;
    return normalize(_71(_871, _873));
}

vec3 _165(vec2 _162, mat3 _163, bool _164)
{
    vec2 _880 = _162;
    bool _882 = _164;
    vec3 _884 = _154(_880, _882);
    vec3 _879 = _884;
    vec3 _885 = _879;
    mat3 _887 = _163;
    return _159(_885, _887);
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _82(float _81)
{
    return sqrt(_81);
}

float _121(vec3 _118, float _119, float _120)
{
    float _635 = length(_118) * _120;
    if (_635 < 1.0)
    {
        float _644 = 1.0 - _119;
        float _647 = _635 * _635;
        float _651 = ((3.0 * _635) - (_635 * _647)) / (1.0 - _647);
        float _662 = 1.0 / (2.0 * _651);
        float _672 = (_644 * _644) + _662;
        return 1.0 - _82(_672);
    }
    return _119;
}

float _145(inout float _143, bool _144)
{
    if (_144)
    {
        _143 += (float(_143 < _802._m41) * _802._m42);
    }
    float _816 = _143;
    return _802._m0.w / (_10(_816) + _802._m0.z);
}

float _38(float _35, float _36, float _37)
{
    return min(_35, min(_36, _37));
}

float _33(float _30, float _31, float _32)
{
    return max(_30, max(_31, _32));
}

float _138(vec2 _137)
{
    return dot(_137, _137);
}

vec4 _96(uint _95)
{
    return vec4(float((_95 >> uint(24)) & 255u), float((_95 >> uint(16)) & 255u), float((_95 >> uint(8)) & 255u), float(_95 & 255u));
}

vec4 _93(uint _92)
{
    return unpackUnorm4x8(_92).wzyx;
}

float _74(float _73)
{
    return exp2(_73);
}

vec3 _115(float _112, float _113, vec3 _114)
{
    float _587 = 0.0949999988079071044921875 + (_113 * (0.60000002384185791015625 + (4.190000057220458984375 * _113)));
    float _597 = _112 + 0.02500000037252902984619140625;
    float _601 = (9.5 * _113) * _112;
    float _615 = 1.0 - (14.0 * _112);
    float _607 = (_587 * _597) * _74(_615);
    float _622 = -_601;
    float _618 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _74(_622)));
    return mix(vec3(_607), vec3(_618), _114);
}

float _182(uvec2 _180, uint _181)
{
    uvec2 _942 = _180 & uvec2(3u);
    return float(((((2068378560u * (1u - (_942.x >> uint(1)))) + (1500172770u * (_942.x >> uint(1)))) >> ((_942.y + ((_942.x & 1u) << uint(2))) << uint(2))) + _181) & 15u) / 16.0;
}

vec3 _176(vec3 _173, vec4 _174, vec4 _175)
{
    return vec3((_174.xy * _173.xy) + _174.zw, _175.z) / vec3((_175.x * _173.z) + _175.y);
}

vec3 _170(vec3 _168, vec4 _169)
{
    return vec3(vec2(0.5) + (_169.xy * (_168.xy / vec2(_168.z))), (_169.w / _168.z) + _169.z);
}

int _50(uint _49)
{
    return findLSB(_49);
}

vec4 _64(vec3 _59, vec4 _60, vec4 _61, vec4 _62, vec4 _63)
{
    return vec4((_59.x * _60.x) + ((_59.y * _60.y) + ((_59.z * _60.z) + _60.w)), (_59.x * _61.x) + ((_59.y * _61.y) + ((_59.z * _61.z) + _61.w)), (_59.x * _62.x) + ((_59.y * _62.y) + ((_59.z * _62.z) + _62.w)), (_59.x * _63.x) + ((_59.y * _63.y) + ((_59.z * _63.z) + _63.w)));
}

float _56(float _55)
{
    return _55 * _55;
}

vec3 _53(vec3 _52)
{
    return _52 * _52;
}

uint _44(float _41, float _42, float _43)
{
    bool _272 = abs(_43) >= abs(_41);
    bool _280;
    if (_272)
    {
        _280 = abs(_43) >= abs(_42);
    }
    else
    {
        _280 = _272;
    }
    if (_280)
    {
        return uint((_43 < 0.0) ? 5 : 4);
    }
    if (abs(_42) >= abs(_41))
    {
        return uint((_42 < 0.0) ? 3 : 2);
    }
    return uint(int(_41 < 0.0));
}

float _79(float _77, float _78)
{
    return pow(_77, _78);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _101(vec3 _99, float _100)
{
    float _474 = dot(_99, vec3(16.666500091552734375));
    float _469 = _10(_474);
    float _483 = 1.0 - _100;
    float _486 = _10(_483);
    float _487 = 5.0;
    vec3 _491 = _99 + ((vec3(_469) - _99) * _79(_486, _487));
    return _16(_491);
}

vec3 _109(vec3 _104, vec3 _105, vec3 _106, vec3 _107, float _108)
{
    float _499 = dot(_104, _105);
    float _495 = _10(_499);
    vec3 _501 = normalize(_105 + _106);
    float _510 = dot(_104, _501);
    float _506 = _10(_510);
    float _516 = dot(_106, _501);
    float _512 = _10(_516);
    vec3 _519 = _107;
    float _521 = _512;
    vec3 _518 = _101(_519, _521);
    float _528 = dot(_104, _106);
    float _524 = _10(_528);
    float _530 = 1.0 - (_108 * 0.800000011920928955078125);
    _530 *= _530;
    _530 *= _530;
    float _541 = _530 * _530;
    float _545 = ((_506 * _506) * (_541 - 1.0)) + 1.0;
    _545 = _541 / ((_545 * _545) + 9.9999999392252902907785028219223e-09);
    float _560 = (_495 * (1.0 - _530)) + _530;
    float _567 = (_524 * (1.0 - _530)) + _530;
    _545 /= (((4.0 * _560) * _567) + 9.9999999392252902907785028219223e-09);
    return _518 * _545;
}

vec2 _185(vec2 _184)
{
    return (vec2(1.0) - abs(_184.yx)) * vec2((_184.x >= 0.0) ? 1.0 : (-1.0), (_184.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _190(inout vec3 _188, bool _189)
{
    _188 /= vec3((abs(_188.x) + abs(_188.y)) + abs(_188.z));
    vec2 _1011;
    if (_188.z >= 0.0)
    {
        _1011 = _188.xy;
    }
    else
    {
        vec2 _1017 = _188.xy;
        _1011 = _185(_1017);
    }
    _188 = vec3(_1011.x, _1011.y, _188.z);
    if (_189)
    {
        vec2 _1031 = (_188.xy * 0.5) + vec2(0.5);
        _188 = vec3(_1031.x, _1031.y, _188.z);
    }
    return _188.xy;
}

float _85(float _84)
{
    return sqrt(_84);
}

float _193(float _192)
{
    float _1041 = abs(_192);
    float _1038 = _85(_1041);
    float _1045;
    if (_192 > 0.0)
    {
        _1045 = _1038;
    }
    else
    {
        _1045 = -_1038;
    }
    return (_1045 * 0.5) + 0.5;
}

void main()
{
    _196 = 2147483648u;
    _198 = 1073741824u;
    _200 = 0u;
    _202 = 268435456u;
    _204 = 536870912u;
    _206 = 805306368u;
    _208 = 1073741824u;
    _209 = 1342177280u;
    _211 = 0u;
    _212 = 16777216u;
    _214 = 33554432u;
    _216 = 50331648u;
    _218 = 67108864u;
    _220 = 83886080u;
    _222 = 100663296u;
    _224 = 117440512u;
    _226 = 134217728u;
    _228 = 150994944u;
    _230 = 167772160u;
    _131 _1057 = _133();
    _1057._m16 = vec4(0.0, 0.0, _1060, _1062);
    vec3 _1066 = vec3(_1067, _1069, _1071);
    _1057._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1057._m15 = vec3(_802._m52, _802._m53, _802._m54) + _1066;
    vec3 _1100 = vec3(0.0);
    vec3 _1101 = vec3(0.0);
    _1100 = normalize(vec3(_1102, _1104, _1106));
    _1101 = normalize(vec3(_1110, _1112, _1114));
    vec3 _1118 = _1100;
    vec3 _1120 = _1101;
    vec3 _1122 = normalize(cross(_1118, _1120) * _1126);
    _1057._m18 = mat3(vec3(_1120), vec3(_1122), vec3(_1118));
    _1057._m14 = normalize(-_1066);
    _1057._m29 = _1151;
    _1057._m30 = _1154;
    _1057._m31 = _1157;
    uint _1160 = 0u;
    vec4 _1161 = vec4(0.0);
    vec4 _1162 = vec4(0.0);
    vec4 _1163 = vec4(0.0);
    vec4 _1164 = vec4(0.0);
    vec4 _1165 = vec4(0.0);
    float _1166 = 0.0;
    uvec2 _1167 = uvec2(0u, 65535u);
    vec2 _1170 = _1057._m16.zw;
    vec2 _1174 = _1170;
    vec2 _1176 = _1170;
    float _1178 = 0.0009765625;
    vec3 _1191;
    if ((_1184._m70 & 1u) != 0u)
    {
        _1191 = vec3(_1197._m17, _1197._m18, _1197._m19);
    }
    else
    {
        _1191 = vec3(1.0);
    }
    vec3 _1180 = _1191;
    float _1208 = 1.0;
    float _1209 = _1197._m20;
    bool _1212 = _1209 > 0.0;
    float _1215 = 1.0;
    uint _1216 = _1167.x;
    uint _1219 = _1216 & 7u;
    uint _1223 = _1219;
    uint _1225 = _1223;
    float _1227 = 0.0;
    vec2 _1228 = _1174;
    _1228.x *= _1237._m1[_1225].w;
    _1228.y *= _1237._m2[_1225].x;
    _1228.x += (_802._m70 * _1237._m2[_1225].y);
    _1228.y += (_802._m70 * _1237._m2[_1225].z);
    vec2 _1272 = _1228;
    uint _1280 = _1225;
    vec3 _1274 = (SAMPLE_TEXTURE(SAMPLER_2D(_1278[nonuniformEXT(_1280)], _1286), _1272).xyz * vec3(_1237._m0[_1225].x)) + vec3(_1237._m0[_1225].y);
    uint _1306 = _1225;
    vec2 _1303 = SAMPLE_TEXTURE(SAMPLER_2D(_1304[nonuniformEXT(_1306)], _1309), _1272).xy;
    uint _1318 = _1225;
    vec3 _1315 = (SAMPLE_TEXTURE(SAMPLER_2D(_1316[nonuniformEXT(_1318)], _1321), _1272).xyz * vec3(_1237._m0[_1225].z)) + vec3(_1237._m0[_1225].w);
    uint _1340 = _1225;
    float _1337 = SAMPLE_TEXTURE(SAMPLER_2D(_1338[nonuniformEXT(_1340)], _1343), _1272).x;
    uint _1352 = _1225;
    float _1349 = SAMPLE_TEXTURE(SAMPLER_2D(_1350[nonuniformEXT(_1352)], _1355), _1272).x;
    uint _1364 = _1225;
    vec3 _1361 = SAMPLE_TEXTURE(SAMPLER_2D(_1362[nonuniformEXT(_1364)], _1367), _1272).xyz;
    uint _1376 = _1225;
    float _1373 = SAMPLE_TEXTURE(SAMPLER_2D(_1374[nonuniformEXT(_1376)], _1379), _1272).x;
    _1161 = vec4(_1274.x, _1274.y, _1274.z, _1161.w);
    _1161.w = 0.0;
    _1162 = vec4(_1315.x, _1315.y, _1315.z, _1162.w);
    _1162.w = _1349;
    _1163 = vec4(_1303.x, _1303.y, _1163.z, _1163.w);
    _1164.x = 0.0;
    _1164.y = _1227;
    _1164.z = _1349;
    _1164.w = _1337;
    _1166 = _1373;
    _1215 = _1237._m1[_1225].x;
    vec3 _1414 = _1361 * _1237._m3[_1225].xyz;
    _1165 = vec4(_1414.x, _1414.y, _1414.z, _1165.w);
    float _1417 = _1212 ? _1209 : _1215;
    vec3 _1426 = _1165.xyz * vec3(_1417);
    _1165 = vec4(_1426.x, _1426.y, _1426.z, _1165.w);
    vec2 _1429 = vec2(0.0);
    _123 _1430;
    _1430._m0 = _1161;
    _1430._m1 = _1162;
    _1430._m2 = _1164;
    _1430._m3 = _1163;
    _1430._m4 = _1165;
    _1430._m5 = _1166;
    _1429 = _1430._m3.xy;
    _1430._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1430._m3.z, _1430._m3.w);
    bool _1449 = (_1184._m70 & 2u) != 0u;
    if (_1449)
    {
        vec4 _1457 = vec4(0.0);
        _1457 = SAMPLE_TEXTURE(SAMPLER_2D(_1461[_1184._m28], _1466), _1174);
        _1457 *= _1184._m7;
        _1457 = min(_1457, vec4(1.0));
        float _1478 = (_1166 - 0.4980392158031463623046875) * _1184._m17;
        for (int _1485 = 0; _1485 < 4; _1485++)
        {
            float _1493 = _1457[_1485];
            if (!(_1493 == 0.0))
            {
                float _1501 = 0.0;
                vec2 _1502 = vec2(_1184._m2[_1485]);
                uint _1507 = uint(_1485 + 1);
                uint _1511 = _1507 & 7u;
                uint _1514 = _1511;
                uint _1516 = _1514;
                uint _1519 = _1516;
                _1501 = SAMPLE_TEXTURE(SAMPLER_2D(_1374[nonuniformEXT(_1519)], _1379), _1170 * _1502).x;
                _1501 -= 0.4980392158031463623046875;
                _1501 *= _1184._m6[_1485];
                float _1536 = (_1478 + 1.0) - _1493;
                float _1541 = (_1501 + 0.0) + _1493;
                float _1546 = _1541 - _1536;
                float _1550 = (clamp(_1546 / _1184._m10[_1485], -1.0, 1.0) / 2.0) + 0.5;
                float _1559 = 0.100000001490116119384765625;
                float _1561 = abs(0.5 - _1493);
                float _1572 = (_1561 - (0.5 - _1559)) / _1559;
                float _1565 = _10(_1572);
                float _1574 = 0.0;
                if ((_1493 < _1559) && (_1550 > _1493))
                {
                    _1574 = mix(_1550, _1493, _1565);
                }
                else
                {
                    if ((_1493 > (1.0 - _1559)) && (_1550 < _1493))
                    {
                        _1574 = mix(_1550, _1493, _1565);
                    }
                    else
                    {
                        _1574 = _1550;
                    }
                }
                float _1605 = _1184._m4[_1485];
                float _1609 = _1184._m8[_1485];
                float _1613 = _1184._m11[_1485];
                float _1617 = _1184._m9[_1485];
                float _1621 = _1184._m5[_1485];
                _123 _1625 = _125();
                float _1627 = _1197._m20;
                bool _1630 = _1627 > 0.0;
                float _1633 = 1.0;
                uint _1634 = uint(_1485 + 1);
                uint _1638 = _1634 & 7u;
                uint _1641 = _1638;
                uint _1643 = _1641;
                float _1645 = 0.0;
                vec2 _1646 = _1170 * _1502;
                _1646.x *= _1237._m1[_1643].w;
                _1646.y *= _1237._m2[_1643].x;
                _1646.x += (_802._m70 * _1237._m2[_1643].y);
                _1646.y += (_802._m70 * _1237._m2[_1643].z);
                vec2 _1684 = _1646;
                uint _1688 = _1643;
                vec3 _1686 = (SAMPLE_TEXTURE(SAMPLER_2D(_1278[nonuniformEXT(_1688)], _1286), _1684).xyz * vec3(_1237._m0[_1643].x)) + vec3(_1237._m0[_1643].y);
                uint _1708 = _1643;
                vec2 _1706 = SAMPLE_TEXTURE(SAMPLER_2D(_1304[nonuniformEXT(_1708)], _1309), _1684).xy;
                uint _1718 = _1643;
                vec3 _1716 = (SAMPLE_TEXTURE(SAMPLER_2D(_1316[nonuniformEXT(_1718)], _1321), _1684).xyz * vec3(_1237._m0[_1643].z)) + vec3(_1237._m0[_1643].w);
                uint _1738 = _1643;
                float _1736 = SAMPLE_TEXTURE(SAMPLER_2D(_1338[nonuniformEXT(_1738)], _1343), _1684).x;
                uint _1748 = _1643;
                float _1746 = SAMPLE_TEXTURE(SAMPLER_2D(_1350[nonuniformEXT(_1748)], _1355), _1684).x;
                uint _1758 = _1643;
                vec3 _1756 = SAMPLE_TEXTURE(SAMPLER_2D(_1362[nonuniformEXT(_1758)], _1367), _1684).xyz;
                uint _1768 = _1643;
                float _1766 = SAMPLE_TEXTURE(SAMPLER_2D(_1374[nonuniformEXT(_1768)], _1379), _1684).x;
                _1625._m0 = vec4(_1686.x, _1686.y, _1686.z, _1625._m0.w);
                _1625._m0.w = 0.0;
                _1625._m1 = vec4(_1716.x, _1716.y, _1716.z, _1625._m1.w);
                _1625._m1.w = _1746;
                _1625._m3 = vec4(_1706.x, _1706.y, _1625._m3.z, _1625._m3.w);
                _1625._m2.x = 0.0;
                _1625._m2.y = _1645;
                _1625._m2.z = _1746;
                _1625._m2.w = _1736;
                _1625._m5 = _1766;
                _1633 = _1237._m1[_1643].x;
                vec3 _1808 = _1756 * _1237._m3[_1643].xyz;
                _1625._m4 = vec4(_1808.x, _1808.y, _1808.z, _1625._m4.w);
                float _1812 = _1630 ? _1627 : _1633;
                vec3 _1822 = _1625._m4.xyz * vec3(_1812);
                _1625._m4 = vec4(_1822.x, _1822.y, _1822.z, _1625._m4.w);
                _1430._m0 = mix(_1430._m0, _1625._m0, vec4(_1574 * _1605));
                _1430._m1 = mix(_1430._m1, _1625._m1, vec4(_1574 * _1613));
                _1430._m2.w = mix(_1430._m2.w, _1625._m2.w, _1574 * _1617);
                vec3 _1863 = mix(_1430._m2.xyz, _1625._m2.xyz, vec3(_1574));
                _1430._m2 = vec4(_1863.x, _1863.y, _1863.z, _1430._m2.w);
                _1430._m3 = mix(_1430._m3, _1625._m3, vec4(_1574 * _1609));
                _1430._m4 = mix(_1430._m4, _1625._m4, vec4(_1574 * _1621));
                _1430._m5 = mix(_1430._m5, _1625._m5, _1574);
            }
        }
    }
    _1161 = _1430._m0;
    _1162 = _1430._m1;
    _1164.w = _1430._m2.w;
    _1163 = _1430._m3;
    _1165 = _1430._m4;
    _1166 = _1430._m5;
    vec2 _1911 = _1429;
    bool _1913 = true;
    vec3 _1914 = _154(_1911, _1913);
    vec3 _1909 = _1914;
    vec2 _1916 = _1163.xy;
    bool _1919 = true;
    vec3 _1920 = _154(_1916, _1919);
    vec3 _1915 = _1920;
    vec3 _1921 = _1909 + vec3(0.0, 0.0, 1.0);
    vec3 _1924 = vec3(-_1915.xy, _1915.z);
    vec3 _1933 = (_1921 * dot(_1921, _1924)) - (_1924 * _1921.z);
    vec3 _1945 = normalize(_1933);
    _1163 = vec4(_1945.x, _1945.y, _1945.z, _1163.w);
    vec3 _1950 = _1163.xyz + vec3(1.0);
    _1163 = vec4(_1950.x, _1950.y, _1950.z, _1163.w);
    vec3 _1955 = _1163.xyz * 0.5;
    _1163 = vec4(_1955.x, _1955.y, _1955.z, _1163.w);
    _1057._m22 = _1165.xyz * _1180;
    vec3 _1963 = vec3(0.0);
    vec3 _1964 = vec3(0.0);
    float _1965 = 0.0;
    uint _1966 = 0u;
    uint _1967 = _1966 & 7u;
    uint _1970 = _1967;
    uint _1972 = _1970;
    vec4 _1974 = vec4(_1170, 0.0, _1184._m33);
    uint _1982 = _1972;
    vec2 _1992 = SAMPLE_TEXTURE1(SAMPLER_2D(_1304[nonuniformEXT(_1982)], _1309), _1974.xy, _1974.w).xy;
    _1963 = vec3(_1992.x, _1992.y, _1963.z);
    uint _1998 = _1972;
    vec4 _1995 = SAMPLE_TEXTURE1(SAMPLER_2D(_1996[nonuniformEXT(_1998)], _2001), _1974.xy, _1974.w);
    _1964 = _1995.xyz;
    _1965 = _1995.w;
    _1057._m8 = _1963;
    float _2020 = _1965 * _1184._m37;
    float _2015 = _10(_2020);
    vec4 _2028 = vec4(_1964, _2015);
    uint _2029 = _89(_2028);
    _1057._m4 = _2029;
    float _2036 = (1.0 - _2015) * _1184._m32;
    _1057._m10 = _10(_2036);
    _1057._m0 = _1161.xyz;
    _1057._m2 = _1162.xyz;
    _1057._m1 = _1165.xyz;
    _1057._m3 = _1164.w;
    _1057._m6 = _1163.xyz;
    vec3 _2054 = _2055.xyz;
    vec3 _2058 = vec3(1.0) - _2055.xyz;
    _1057._m0 *= mix(vec3(1.0), mix(_2058, _2054, bvec3(_1184._m61 >= 0.0)), vec3(abs(_1184._m61)));
    _1057._m2 *= mix(vec3(1.0), mix(_2058, _2054, bvec3(_1184._m63 >= 0.0)), vec3(abs(_1184._m63)));
    _1057._m22 *= mix(vec3(1.0), mix(_2058, _2054, bvec3(_1184._m62 >= 0.0)), vec3(abs(_1184._m62)));
    uint _2114 = 0u;
    bool _2115 = true;
    vec2 _2116 = _1057._m6.xy;
    bool _2120 = _2115;
    vec3 _2122 = _154(_2116, _2120);
    _1057._m7 = _2122;
    vec2 _2124 = _1057._m6.xy;
    mat3 _2128 = _1057._m18;
    bool _2131 = _2115;
    _1057._m6 = _165(_2124, _2128, _2131);
    vec2 _2135 = _1057._m8.xy;
    mat3 _2139 = _1057._m18;
    bool _2142 = _2115;
    _1057._m8 = _165(_2135, _2139, _2142);
    vec3 _2146 = dFdx(_1057._m15);
    vec3 _2150 = dFdy(_1057._m15);
    vec2 _2154 = _1057._m17.xy * _802._m18.xy;
    uint _2162 = uint(int(TEXTURE_LOD(SAMPLER_2D(_2163, _2165), vec4(_2154, 0.0, 0.0).xy, vec4(_2154, 0.0, 0.0).w).x * 255.0));
    if ((_2162 > 0u) && (_2162 < 255u))
    {
        int _2190 = _2193._m2;
        if (_2190 > 0)
        {
            _2190--;
            vec4 _2203 = _2207._m0[((uint(_2190) + _2162) - 1u) * 2u];
            vec4 _2217 = _2207._m0[(((uint(_2190) + _2162) - 1u) * 2u) + 1u];
            vec2 _2227 = vec2((_1057._m15.x * _2203.x) + ((_1057._m15.y * _2203.y) + ((_1057._m15.z * _2203.z) + _2203.w)), (_1057._m15.x * _2217.x) + ((_1057._m15.y * _2217.y) + ((_1057._m15.z * _2217.z) + _2217.w)));
            vec2 _2269 = vec2(dot(_2146, _2203.xyz), dot(_2146, _2217.xyz));
            vec2 _2279 = vec2(dot(_2150, _2203.xyz), dot(_2150, _2217.xyz));
            int _2289 = int(_1184._m45);
            vec4 _2293 = vec4(0.0);
            vec4 _2294 = vec4(0.0);
            vec4 _2295 = vec4(0.0);
            uint _2296 = uint(_2289);
            uint _2301 = _2296 + 0u;
            _2293 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2301)], _1286), _2227, _2269, _2279);
            uint _2312 = _2296 + 1u;
            _2294 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2312)], _1309), _2227, _2269, _2279);
            uint _2323 = _2296 + 2u;
            _2295 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2323)], _1321), _2227, _2269, _2279);
            vec2 _2333 = _2294.xy;
            bool _2336 = true;
            vec3 _2337 = _154(_2333, _2336);
            vec3 _2332 = _2337;
            float _2338 = _2294.w;
            float _2341 = _2294.z;
            vec3 _2344 = _2293.xyz;
            float _2347 = _2293.w;
            vec4 _2350 = _2295;
            float _2353 = _1197._m14;
            if (_2162 > _27(_2353))
            {
                _2344 *= _1197._m3.xyz;
                _2341 *= _1197._m3.w;
            }
            _1057._m0 = mix(_1057._m0, _2344, vec3(_2338));
            _1057._m2 = mix(_1057._m2, _2350.xyz, vec3(_2338));
            _1057._m22 = mix(_1057._m22, _2344 * (_2347 * 16.0), vec3(_2347));
            vec3 _2394 = _1057._m18[2];
            float _2397 = sign(dot(cross(_2217.xyz, _2203.xyz), _2394));
            vec3 _2415 = normalize(_2203.xyz + (_2394 * dot(_2203.xyz, _2394)));
            _2203 = vec4(_2415.x, _2415.y, _2415.z, _2203.w);
            vec3 _2424 = normalize(cross(_2394, _2203.xyz)) * _2397;
            _2217 = vec4(_2424.x, _2424.y, _2424.z, _2217.w);
            _2332 = ((_2203.xyz * _2332.x) + (_2217.xyz * _2332.y)) + (_2394 * _2332.z);
            vec3 _2443 = _2332;
            float _2445 = dot(_2443, _2394);
            _2332 = (_1057._m6 * _2445) + ((_2443 - (_2394 * _2445)) * dot(_1057._m6, _2394));
            _1057._m6 = normalize(_2332);
            vec3 _2467 = _2332;
            float _2469 = _2350.w;
            float _2472 = 1.0;
            _1057._m3 = mix(_1057._m3, _2350.w, _2341);
        }
    }
    uvec2 _2481 = uvec2(_1057._m17.xy);
    uint _2486 = _2481.x / 256u;
    uint _2491 = _2481.y / 256u;
    float _2496 = _1057._m17.z;
    bool _2499 = false;
    float _2500 = _145(_2496, _2499);
    float _2495 = _2500;
    float _2501 = log2(max(1.0, _2495 / _802._m19.z)) * _802._m19.w;
    uint _2511 = min(23u, uint(_2501));
    float _2518 = _802._m71;
    float _2524 = _802._m72;
    uint _2516 = (_27(_2518) + ((_2486 + (_27(_2524) * _2491)) * 24u)) + _2511;
    uvec2 _2536 = uvec2(_1057._m17.xy);
    uint _2541 = _2536.x / 32u;
    uint _2546 = _2536.y / 32u;
    float _2554 = _802._m73;
    uint _2550 = _2541 + (_2546 * _27(_2554));
    float _2561 = _1197._m30;
    uint _2560 = _27(_2561);
    uint _2565 = _2569._m0[_2516 * 64u];
    uint _2576 = _2565 & 255u;
    uint _2579 = _2569._m0[_2550 * 64u];
    uint _2584 = _2579 & 255u;
    uint _2592;
    uint _2594;
    uint _2596;
    if (_2576 < _2584)
    {
        _2592 = _2576;
        _2594 = _2565;
        _2596 = _2516;
    }
    else
    {
        _2592 = _2584;
        _2594 = _2579;
        _2596 = _2550;
    }
    vec3 _2602 = dFdx(_1057._m15);
    vec3 _2606 = dFdy(_1057._m15);
    uint _2610 = _2560 & 3u;
    bool _2613 = (_2560 & 4u) != 0u;
    uint _2618 = ((_2610 == 0u) && (!_2613)) ? 0u : _2592;
    uint _2626 = 1u;
    _2656 _2658;
    vec3 _3078;
    while (_2626 <= _2618)
    {
        uint _2635 = (_2596 * 64u) + _2626;
        uint _2640 = _2569._m0[_2635];
        uint _2644 = _2640;
        if (_2644 >= _2640)
        {
            _2626++;
        }
        int _2653 = 2;
        int _2654 = 2;
        int _2655 = 1;
        _2658._m0 = _2663._m0[(uint(_2653) * _2644) + 0u];
        _2658._m1 = _2663._m0[(uint(_2653) * _2644) + 1u];
        _2658._m2 = _2683._m0[(uint(_2654) * _2644) + 0u];
        float _2697 = _2683._m0[(uint(_2654) * _2644) + 1u].x;
        _2658._m3 = _27(_2697);
        float _2707 = _2683._m0[(uint(_2654) * _2644) + 1u].y;
        _2658._m4 = _27(_2707);
        float _2717 = _2683._m0[(uint(_2654) * _2644) + 1u].z;
        _2658._m5 = _27(_2717);
        float _2727 = _2683._m0[(uint(_2654) * _2644) + 1u].w;
        _2658._m6 = _27(_2727);
        float _2742 = _2736._m0[(uint(_2655) * _2644) + 0u].x;
        _2658._m7 = _27(_2742);
        float _2752 = _2736._m0[(uint(_2655) * _2644) + 0u].y;
        _2658._m8 = _27(_2752);
        float _2762 = _2736._m0[(uint(_2655) * _2644) + 0u].z;
        _2658._m9 = _27(_2762);
        vec4 _2767 = _2658._m0;
        vec4 _2770 = _2658._m1;
        vec4 _2773 = _2658._m2;
        vec3 _2776 = vec3(dot(_1057._m15, _2767.xyz) + _2767.w, dot(_1057._m15, _2770.xyz) + _2770.w, dot(_1057._m15, _2773.xyz) + _2773.w);
        float _2802 = 0.0039215688593685626983642578125;
        float _2804 = _2776.x;
        float _2807 = _2776.y;
        float _2810 = _2776.z;
        bool _2815 = _38(_2804, _2807, _2810) <= _2802;
        bool _2832;
        if (!_2815)
        {
            float _2819 = _2776.x;
            float _2822 = _2776.y;
            float _2825 = _2776.z;
            _2832 = _33(_2819, _2822, _2825) >= (1.0 - _2802);
        }
        else
        {
            _2832 = _2815;
        }
        if (_2832)
        {
            continue;
        }
        uint _2836 = _2658._m5;
        uint _2839 = _2658._m9;
        uint _2842 = _2560 & 3u;
        bool _2851 = ((_2839 & 512u) != 0u) && (_2842 != 0u);
        bool _2862;
        if (!_2851)
        {
            _2862 = ((_2839 & 1024u) != 0u) && (_2842 != 1u);
        }
        else
        {
            _2862 = _2851;
        }
        bool _2870;
        if (!_2862)
        {
            _2870 = (_2839 & 16384u) != 0u;
        }
        else
        {
            _2870 = _2862;
        }
        if (_2870)
        {
            continue;
        }
        vec2 _2874 = vec2(dot(_2602, _2767.xyz), dot(_2602, _2770.xyz));
        vec2 _2884 = vec2(dot(_2606, _2767.xyz), dot(_2606, _2770.xyz));
        vec4 _2894 = vec4(0.0);
        vec4 _2895 = vec4(0.0);
        uint _2896 = _2658._m3;
        uint _2902 = _2896 + 1u;
        vec4 _2899 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_2902)], _1309), _2776.xy, _2874 * vec2(1.0), _2884 * vec2(1.0));
        if ((_2839 & 32768u) != 0u)
        {
            vec2 _2921 = vec2(1.0 / length(_2767.xyz), 1.0 / length(_2770.xyz));
            vec2 _2952 = TEXTURE_LOD(SAMPLER_2D(_2931, _1466), vec4(_2776.xy * _2921, 0.0, 0.0).xy, vec4(_2776.xy * _2921, 0.0, 0.0).w).xy;
            _2899 = vec4(_2952.x, _2952.y, _2899.z, _2899.w);
            vec2 _2959 = _2899.xy - vec2(0.4980392158031463623046875);
            float _2962 = 1.0 - _138(_2959);
            _2899.z = sqrt(_10(_2962));
        }
        else
        {
            if ((_2839 & 65536u) != 0u)
            {
                vec2 _2973 = vec2(1.0, (1.0 / length(_2770.xyz)) / 2.5);
                vec2 _2981 = TEXTURE_GRAD(SAMPLER_2D(_2982, _1466), _2776.xy * _2973, _2874 * _2973, _2884 * _2973).xy;
                vec2 _3002 = _2899.xy + (_2981 - vec2(0.4980392158031463623046875));
                _2899 = vec4(_3002.x, _3002.y, _2899.z, _2899.w);
                vec2 _3008 = _2899.xy - vec2(0.4980392158031463623046875);
                float _3011 = 1.0 - _138(_3008);
                _2899.z = sqrt(_10(_3011));
            }
        }
        if ((_2836 & 1u) != 0u)
        {
            uint _3022 = _2896 + 0u;
            _2894 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_3022)], _1286), _2776.xy, _2874 * vec2(1.0), _2884 * vec2(1.0));
        }
        if ((_2836 & 2u) != 0u)
        {
            uint _3041 = _2896 + 2u;
            _2895 = TEXTURE_GRAD(SAMPLER_2D(_1461[nonuniformEXT(_3041)], _1321), _2776.xy, _2874 * vec2(1.0), _2884 * vec2(1.0));
        }
        float _3053 = 1.0;
        vec3 _3054 = vec3(0.5, 0.5, 1.0);
        vec3 _3056 = vec3(0.0, 0.0, 1.0);
        vec4 _3057 = _2899;
        _3054 = _3057.xyz;
        _3053 = _3057.w;
        _3056 = (_3054 * 2.0) - vec3(1.0);
        if (_3053 <= (4.0 * _2802))
        {
            continue;
        }
        _3054 = _3056;
        if ((_2839 & 128u) != 0u)
        {
            _3078 = vec3(-_3054.x, -_3054.y, _3054.z);
        }
        else
        {
            _3078 = _3054;
        }
        _3054 = _3078;
        uint _3093 = _2658._m6;
        uint _3097 = _3093;
        float _3096 = 1.0 + (_96(_3097).w * 0.062745101749897003173828125);
        uint _3105 = _2836;
        float _3104 = _93(_3105).z;
        uint _3110 = _3093;
        vec3 _3109 = _93(_3110).xyz;
        float _3123 = _3096 - (_3096 * abs((_2776.z * 2.0) - 1.0));
        _3053 *= _10(_3123);
        float _3127 = _3053;
        if ((_2836 & 1u) != 0u)
        {
            _3109 *= _2894.xyz;
            _3127 *= _2894.w;
        }
        vec3 _3142 = _1057._m18[2];
        float _3151 = dot(_3142, normalize(_2773.xyz));
        float _3145 = _10(_3151);
        uint _3153 = _2658._m7;
        uint _3157 = _3153;
        vec4 _3156 = _93(_3157);
        _1057._m22 = mix(_1057._m22, ((_3156.xyz * ((_3127 * _3156.w) * 16.0)) * _3104) * _3145, vec3(_3127));
        uint _3178 = _2658._m8;
        uint _3182 = _3178;
        vec4 _3181 = _93(_3182);
        if ((_2836 & 2u) != 0u)
        {
            _3181 = _2895;
        }
        if ((_2836 & 32u) != 0u)
        {
            uint _3197 = _2836;
            float _3196 = _93(_3197).x;
            uint _3202 = _2836;
            float _3201 = _96(_3202).y;
            float _3222 = dot((_2776.xy + _3056.xy) - vec2(0.5), (_2776.xy + _3056.xy) - vec2(0.5));
            float _3206 = _10(_3222);
            float _3230 = _3201 * (_3196 - _3206);
            float _3232 = _10(_3230);
            float _3224 = _82(_3232);
            _3053 = min(_3053, _3224);
        }
        float _3237 = _3053 * _3145;
        uint _3241 = _2658._m4;
        uint _3245 = _3241;
        vec4 _3244 = _93(_3245) * _3237;
        _1057._m9 = max(_1057._m9, _3244.x);
        _1057._m0 = mix(_1057._m0, _3109, _3244.xxx);
        _1057._m2 = mix(_1057._m2, _3181.xyz, _3244.yyy);
        if (!(_3237 == 0.0))
        {
            float _3275 = 1.0;
            vec3 _3285 = normalize(_2767.xyz + (_3142 * dot(_2767.xyz, _3142)));
            _2767 = vec4(_3285.x, _3285.y, _3285.z, _2767.w);
            vec3 _3294 = normalize(cross(_3142, _2767.xyz)) * _3275;
            _2770 = vec4(_3294.x, _3294.y, _3294.z, _2770.w);
            _3054 = ((_2767.xyz * _3054.x) + (_2770.xyz * _3054.y)) + (_3142 * _3054.z);
            if ((_2839 & 256u) != 0u)
            {
                vec3 _3318 = mix(_3142, _3054, _3244.www);
                float _3324 = dot(_3318, _3142);
                _3054 = (_1057._m6 * _3324) + ((_3318 - (_3142 * _3324)) * dot(_1057._m6, _3142));
            }
            else
            {
                if ((_2839 & 64u) != 0u)
                {
                    _3054 = mix(mix(_1057._m6, _3142, vec3(_3237)), _3054, _3244.www);
                }
                else
                {
                    _3054 = mix(_1057._m6, _3054, _3244.www);
                }
            }
            _1057._m6 = normalize(_3054);
        }
        float _3369 = _3181.w;
        _1057._m3 = mix(_1057._m3, _3369, _3244.z);
    }
    float _3379 = _802._m20.x;
    if (_3379 > 0.0)
    {
        vec2 _3386 = _1057._m17.xy * _802._m18.xy;
        vec3 _3394 = (TEXTURE_LOD(SAMPLER_2D(_3395, _3397), vec4(_3386, 0.0, 0.0).xy, vec4(_3386, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _3419 = dot(_3394, _1057._m6);
        _1057._m11 = _10(_3419);
        float _3427 = 1.0 - pow(_1057._m11, 0.699999988079071044921875);
        _1057._m11 = _10(_3427);
        _1057._m11 *= _1057._m11;
    }
    _1057._m21 = _1057._m22;
    _1057._m25 = 1.0;
    float _3440 = _802._m21.w;
    bool _3443 = _3440 < 0.0;
    _3440 = abs(_3440);
    vec3 _3448 = _1057._m15;
    float _3467 = (1.0 - (length(_3448 - vec3(_802._m52, _802._m53, _802._m54)) / _3440)) / 0.25;
    float _3451 = _10(_3467);
    if ((!_3443) && (_3451 > 0.0))
    {
        vec3 _3476 = _802._m21.xyz;
        vec3 _3480 = _802._m22.xyz;
        float _3484 = _3448.z - _3480.z;
        float _3490 = _802._m23.w;
        float _3493 = _802._m24.w;
        float _3496 = float(_3493 < 0.0);
        _3493 = abs(_3493) - 1.0;
        bool _3503 = _3484 <= 0.0;
        float _3506 = 3.5 * float(!(_3493 == 0.0));
        float _3515;
        if (!(_3490 == 0.0))
        {
            _3515 = _3476.z;
        }
        else
        {
            _3515 = _3480.z;
        }
        float _3512 = _3515;
        float _3524 = min(_3503 ? 2.0 : 1000.0, abs(_3484));
        float _3531 = max(_3476.x - _3448.x, _3448.x - _3480.x);
        float _3543 = max(_3476.y - _3448.y, _3448.y - _3480.y);
        float _3555 = max(_3531, _3543) - _3524;
        _3555 = max(_3555, _3512 - _3448.z);
        _3555 = max(_3555, _3484 - _3506);
        if (_3555 <= 0.0)
        {
            float _3576 = _3503 ? _3490 : _3493;
            vec2 _3581 = _1057._m18[2].xy;
            float _3585 = length(_3581);
            vec3 _3588 = vec3(_3581, (-1.73205077648162841796875) * _3585);
            _3588 /= vec3(2.0 * _3585);
            vec3 _3601 = _802._m24.xyz;
            vec3 _3605 = mix(_3588, _3601, bvec3(_3503));
            vec2 _3611 = _3448.xy - (_3605.xy * (_3484 / _3605.z));
            float _3622 = (_802._m74 / 100.0) * 16.0;
            vec2 _3629 = _3611 * _3622;
            float _3633 = TEXTURE_LOD(SAMPLER_2D(_3634, _3636), vec4(_3629, 0.0, 0.0).xy, vec4(_3629, 0.0, 0.0).w).x;
            float _3651 = min(8.0, _3480.z - _3476.z);
            float _3664 = (-_3484) / _3651;
            float _3659 = _10(_3664);
            float _3671 = dot(_1057._m6, _3605);
            float _3666 = _10(_3671);
            float _3677 = _3531 / _3524;
            float _3673 = 1.0 - _10(_3677);
            float _3683 = _3543 / _3524;
            _3673 *= (1.0 - _10(_3683));
            _3673 *= _3673;
            float _3699 = min(_3484 / 1.0, 1.0 - (_3484 / _3506));
            float _3691 = _10(_3699);
            _3673 *= max(_3691, _3659);
            _3673 *= _3673;
            _3673 *= _3451;
            float _3712 = _3633 - 1.0;
            float _3715 = float(_3503) * _3496;
            float _3720 = max(0.0, _3633 - 0.85000002384185791015625);
            float _3725 = _3503 ? _3712 : _3720;
            float _3730 = (((1.0 - _3715) * _3666) * _3673) * _3576;
            vec3 _3739 = _1057._m0 + (_1057._m2 * (vec3(1.0) - _1057._m0));
            _1057._m21 += ((_3739 * (_3725 * _3730)) * _802._m23.xyz);
            float _3763 = _3715 * _3673;
            _1057._m25 = 1.0 + (_3763 * (_3633 - 1.0));
        }
    }
    else
    {
        if (_3451 > 0.0)
        {
            _3451 *= _802._m75;
            float _3783 = float(_802._m24.w < 0.0);
            vec3 _3788 = _802._m24.xyz;
            float _3797 = dot(_1057._m6, _3788);
            float _3792 = _10(_3797);
            vec2 _3799 = _3448.xy - (_3788.xy * (_3448.z / _3788.z));
            float _3811 = (_802._m74 / 100.0) * 16.0;
            vec2 _3816 = _3799 * _3811;
            float _3820 = TEXTURE_LOD(SAMPLER_2D(_3634, _3636), vec4(_3816, 0.0, 0.0).xy, vec4(_3816, 0.0, 0.0).w).x;
            vec4 _3836 = _802._m23;
            _1057._m21 += (_3836.xyz * (((((1.0 - _3783) * (_3820 - 1.0)) * _3792) * _3451) * _3836.w));
            _1057._m25 = 1.0 + ((_3783 * (_3820 - 1.0)) * _3451);
        }
    }
    _1057._m14 = normalize(vec3(_802._m52, _802._m53, _802._m54) - _1057._m15);
    vec3 _3878 = vec3(0.0);
    vec3 _3879 = vec3(0.0);
    vec3 _3880 = vec3(0.0);
    vec3 _3881 = vec3(0.0);
    vec3 _3882 = vec3(0.0);
    vec4 _3883 = _1057._m29;
    vec4 _3886 = _1057._m30;
    vec4 _3889 = _1057._m31;
    _3879 = vec3(_3883.x, _3883.y, _3883.z);
    _3880 = vec3(_3883.w, _3886.x, _3886.y);
    _3881 = vec3(_3886.z, _3886.w, _3889.x);
    _3882 = vec3(_3889.y, _3889.z, _3889.w);
    vec3 _3920 = ((_3879 - (_3880 * _1057._m6.y)) + (_3881 * _1057._m6.z)) - (_3882 * _1057._m6.x);
    float _3944 = _1197._m21 * _802._m76;
    _3878 += (max(vec3(0.0), _3920 * _10(_3944)) * _1057._m0);
    vec3 _3953 = vec3(0.0);
    vec3 _3954 = vec3(0.0);
    vec3 _3955 = vec3(0.0);
    vec3 _3956 = vec3(0.0);
    vec3 _3957 = vec3(0.0);
    vec4 _3958 = _1057._m29;
    vec4 _3961 = _1057._m30;
    vec4 _3964 = _1057._m31;
    _3954 = vec3(_3958.x, _3958.y, _3958.z);
    _3955 = vec3(_3958.w, _3961.x, _3961.y);
    _3956 = vec3(_3961.z, _3961.w, _3964.x);
    _3957 = vec3(_3964.y, _3964.z, _3964.w);
    vec3 _3995 = ((_3954 - (_3955 * _1057._m8.y)) + (_3956 * _1057._m8.z)) - (_3957 * _1057._m8.x);
    float _4018 = _1197._m21 * _802._m76;
    _3953 += (max(vec3(0.0), _3995 * _10(_4018)) * _1057._m0);
    uint _4029 = _1057._m4;
    _3878 = mix(_3878, _3953, vec3(_93(_4029).w));
    _1057._m21 += _3878;
    bool _4041 = true;
    _4041 = (((_802._m78 & 1u) != 0u) == true) ? false : true;
    if (true && (_4041 == true))
    {
        uint _4054 = _4058._m0[_2516 * 64u];
        uint _4063 = _4054 & 255u;
        uint _4066 = _4058._m0[_2550 * 64u];
        uint _4071 = _4066 & 255u;
        uint _4079;
        uint _4081;
        uint _4083;
        if (_4063 < _4071)
        {
            _4079 = _4063;
            _4081 = _4054;
            _4083 = _2516;
        }
        else
        {
            _4079 = _4071;
            _4081 = _4066;
            _4083 = _2550;
        }
        float _4089 = _1057._m47;
        float _4098 = dot(_1057._m14, _1057._m6);
        float _4092 = _10(_4098);
        float _4100 = _4092;
        float _4102 = _1057._m3;
        vec3 _4105 = _1057._m2;
        _1057._m24 = (_115(_4100, _4102, _4105) * _1057._m11) * _1057._m39;
        float _4116 = _802._m25.x;
        float _4119 = _802._m25.z;
        bool _4123 = _4116 > 0.0;
        bool _4130;
        if (_4123)
        {
            _4130 = _1057._m3 > _4119;
        }
        else
        {
            _4130 = _4123;
        }
        if (_4130)
        {
            float _4133 = 0.0;
            vec3 _4134 = normalize(reflect(-_1057._m14, _1057._m6));
            if (dot(_1057._m14, _4134) <= _4133)
            {
                vec2 _4150 = vec2(1.0);
                uvec2 _4163 = uvec2(_1057._m17.xy * (vec2(1.0) / _4150));
                uint _4164 = uint(_802._m25.w);
                float _4151 = _182(_4163, _4164);
                _4151 -= 1.0;
                vec2 _4168 = _1057._m17.xy * _802._m18.xy;
                vec3 _4183 = vec3(_4168, _1057._m17.z);
                vec4 _4184 = _802._m26;
                vec4 _4187 = _802._m27;
                vec3 _4176 = _176(_4183, _4184, _4187);
                mat3 _4191 = mat3(vec3(_802._m28.xyz), vec3(_802._m29.xyz), vec3(_802._m30.xyz));
                mat3 _4215 = _4191;
                vec3 _4217 = _4134;
                vec3 _4214 = normalize(_71(_4215, _4217));
                float _4221 = 1.0;
                uint _4222 = uint((_4116 == 1.0) ? 8 : 12);
                _4222 = (_4116 == 3.0) ? 16u : _4222;
                vec3 _4232 = _4176;
                float _4237 = _1057._m17.z;
                bool _4240 = true;
                float _4241 = _145(_4237, _4240);
                vec3 _4234 = _4232 + (_4214 * _4241);
                vec4 _4244 = vec4(0.0);
                vec3 _4246 = _4232;
                vec4 _4248 = _802._m31;
                vec3 _4245 = _170(_4246, _4248);
                vec3 _4253 = _4234;
                vec4 _4255 = _802._m31;
                vec3 _4252 = _170(_4253, _4255);
                vec3 _4259 = ((_4252 - _4245) * (_4221 / float(_4222))) / vec3(length(_4252.xy - _4245.xy));
                vec3 _4276 = _4245 + (_4259 * _4151);
                float _4282 = abs(_4259.z) * 1.0;
                uint _4287 = 0u;
                vec3 _4288 = _4276;
                float _4290 = _4245.z;
                float _4477;
                for (uint _4293 = 0u; _4293 < _4222; _4293 += 4u)
                {
                    vec4 _4302 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_4293));
                    vec4 _4308 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_4309, _4311), vec4(_4276.xy + (_4259.xy * _4302.x), 0.0, 0.0).xy, vec4(_4276.xy + (_4259.xy * _4302.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4309, _4311), vec4(_4276.xy + (_4259.xy * _4302.y), 0.0, 0.0).xy, vec4(_4276.xy + (_4259.xy * _4302.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4309, _4311), vec4(_4276.xy + (_4259.xy * _4302.z), 0.0, 0.0).xy, vec4(_4276.xy + (_4259.xy * _4302.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4309, _4311), vec4(_4276.xy + (_4259.xy * _4302.w), 0.0, 0.0).xy, vec4(_4276.xy + (_4259.xy * _4302.w), 0.0, 0.0).w).x);
                    uvec4 _4430 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_4276.zzzz + (_4259.zzzz * _4302)) - _4308) - vec4(_4282)), vec4(_4282)));
                    uint _4450 = (((_4430.x << uint(0)) | (_4430.y << uint(1))) | (_4430.z << uint(2))) | (_4430.w << uint(3));
                    if (_4450 > 0u)
                    {
                        uint _4471 = _4450;
                        uint _4470 = uint(_50(_4471));
                        if (_4470 > 0u)
                        {
                            _4477 = _4308[_4470 - 1u];
                        }
                        else
                        {
                            _4477 = _4290;
                        }
                        _4290 = _4477;
                        _4288 = _4276 + (_4259 * float((_4293 + _4470) + 1u));
                        float _4496 = _4308[_4470] - _4288.z;
                        float _4503 = (_4290 - _4288.z) + _4259.z;
                        float _4517 = _4496 / (_4496 - _4503);
                        float _4511 = _10(_4517);
                        vec3 _4519 = _4288 - _4259;
                        _4288 = (_4519 * _4511) + (_4288 * (1.0 - _4511));
                        _4287 = _4293 + _4470;
                        break;
                    }
                    _4290 = _4308.w;
                }
                if (_4287 > 0u)
                {
                    vec3 _4544 = _4288;
                    vec4 _4546 = _802._m32;
                    vec4 _4549 = _802._m33;
                    vec4 _4552 = _802._m34;
                    vec4 _4555 = _802._m35;
                    vec3 _4543 = _64(_4544, _4546, _4549, _4552, _4555).xyw;
                    vec2 _4565 = _4543.xy / vec2(_4543.z);
                    _4543 = vec3(_4565.x, _4565.y, _4543.z);
                    vec2 _4568 = (_4543.xy * 2.0) - vec2(1.0);
                    float _4582 = (1.0 - (float(_4287) / float(_4222))) * 4.0;
                    float _4574 = _10(_4582);
                    if (false)
                    {
                        float _4586 = _4568.y;
                        float _4591 = 1.0 - _56(_4586);
                        _4574 *= smoothstep(0.0, 0.25, _10(_4591));
                    }
                    else
                    {
                        float _4601 = 1.0 - dot(_4568, _4568);
                        _4574 *= smoothstep(0.0, 0.5, _10(_4601));
                    }
                    vec3 _4606 = TEXTURE_LOD(SAMPLER_2D(_4607, _3397), vec4(_4543.xy, 0.0, 0.0).xy, vec4(_4543.xy, 0.0, 0.0).w).xyz;
                    _4244 = vec4(_4606, _4574);
                }
                float _4639 = 1.0 - ((1.0 - _1057._m3) / (1.0 - _4119));
                float _4631 = _10(_4639);
                float _4641 = (_4244.w * _4631) * _802._m77;
                _1057._m21 += ((_4244.xyz * _4641) * _1057._m24);
                _4089 = 1.0 - _4641;
            }
        }
        uint _4663 = 1u;
        _4700 _4702;
        while (_4663 <= _4079)
        {
            uint _4672 = (_4083 * 64u) + _4663;
            uint _4677 = _4058._m0[_4672];
            uint _4681 = _4677;
            if (_4681 >= _4677)
            {
                _4663++;
            }
            float _4690 = 0.0039215688593685626983642578125;
            if (_4089 <= (_4690 * 4.0))
            {
                break;
            }
            int _4698 = 4;
            int _4699 = 4;
            _4702._m0 = _4706._m0[(uint(_4698) * _4681) + 0u].xyz;
            float _4721 = _4706._m0[(uint(_4698) * _4681) + 0u].w;
            _4702._m1 = _27(_4721);
            _4702._m2 = _4706._m0[(uint(_4698) * _4681) + 1u].xyz;
            _4702._m3 = _4706._m0[(uint(_4698) * _4681) + 1u].w;
            _4702._m4 = _4706._m0[(uint(_4698) * _4681) + 2u];
            float _4756 = _4706._m0[(uint(_4698) * _4681) + 3u].x;
            _4702._m8 = _27(_4756);
            float _4766 = _4706._m0[(uint(_4698) * _4681) + 3u].y;
            _4702._m9 = _27(_4766);
            _4702._m10 = _4706._m0[(uint(_4698) * _4681) + 3u].z;
            _4702._m5 = _4782._m0[(uint(_4699) * _4681) + 0u];
            _4702._m6 = _4782._m0[(uint(_4699) * _4681) + 1u];
            _4702._m7 = _4782._m0[(uint(_4699) * _4681) + 2u];
            _4702._m12 = _4782._m0[(uint(_4699) * _4681) + 3u].xyz;
            _4702._m13 = _4782._m0[(uint(_4699) * _4681) + 3u].w;
            vec3 _4824 = vec3(dot(_1057._m15, _4702._m5.xyz) + _4702._m5.w, dot(_1057._m15, _4702._m6.xyz) + _4702._m6.w, dot(_1057._m15, _4702._m4.xyz) + _4702._m4.w);
            float _4853 = _4824.x;
            float _4856 = _4824.y;
            float _4859 = _4824.z;
            bool _4864 = _38(_4853, _4856, _4859) <= _4690;
            bool _4881;
            if (!_4864)
            {
                float _4868 = _4824.x;
                float _4871 = _4824.y;
                float _4874 = _4824.z;
                _4881 = _33(_4868, _4871, _4874) >= (1.0 - _4690);
            }
            else
            {
                _4881 = _4864;
            }
            if (_4881)
            {
                continue;
            }
            uint _4885 = _4702._m1;
            vec3 _4888 = _4702._m0;
            float _4891 = float(bitfieldExtract(_4702._m8, 20, 12));
            float _4896 = 0.800000011920928955078125;
            vec3 _4897 = (_4824 * 2.0) - vec3(1.0);
            vec3 _4902 = _4897;
            vec3 _4901 = _53(_4902);
            vec3 _4905 = _4897 * sqrt(((vec3(1.0) - (_4901.yzx * 0.5)) - (_4901.zxy * 0.5)) + ((_4901.yzx * _4901.zxy) / vec3(3.0)));
            float _4936 = 1.0 - ((length(_4905) - _4896) / ((1.0 - _4896) + 9.9999999747524270787835121154785e-07));
            float _4925 = _10(_4936);
            _4925 *= _4925;
            _4925 *= _4089;
            float _4944 = _4702._m7.w;
            _4925 *= _4944;
            _4089 *= (1.0 - _4925);
            vec3 _4954 = _4702._m12;
            float _4957 = _4702._m13;
            float _4962 = _4925;
            vec3 _4960 = _4954 * (_10(_4962) * _4957);
            vec3 _4968 = _4702._m2;
            vec3 _4971 = _4702._m7.xyz;
            vec3 _4975 = vec3(0.0);
            vec3 _4976 = reflect(-_1057._m14, _1057._m6);
            vec3 _4983 = (_4971 - _1057._m15) / _4976;
            vec3 _4990 = (_4968 - _1057._m15) / _4976;
            vec3 _4997 = max(_4983, _4990);
            float _5002 = _4997.x;
            float _5005 = _4997.y;
            float _5008 = _4997.z;
            float _5001 = _38(_5002, _5005, _5008);
            vec3 _5012 = _1057._m15 + (_4976 * _5001);
            vec3 _5019 = _5012 - _4888;
            float _5023 = 6.0;
            float _5025 = _5023 - (_5023 * _1057._m3);
            _4975 = textureLod(samplerCubeArray(_5034, _5036), vec4(_5019, _4891), _5025).xyz;
            _1057._m21 += ((_4975 * _4960) * _1057._m24);
        }
    }
    uint _5059 = _5063._m0[_2516 * 64u];
    uint _5068 = _5059 & 255u;
    uint _5071 = _5063._m0[_2550 * 64u];
    uint _5076 = _5071 & 255u;
    uint _5084;
    uint _5086;
    uint _5088;
    if (_5068 < _5076)
    {
        _5084 = _5068;
        _5086 = _5059;
        _5088 = _2516;
    }
    else
    {
        _5084 = _5076;
        _5086 = _5071;
        _5088 = _2550;
    }
    uint _5094 = 1u;
    _4700 _5123;
    vec3 _5250;
    float _5371;
    vec2 _5439;
    _5637 _5639;
    _5637 _5786;
    while (_5094 <= _5084)
    {
        uint _5103 = (_5088 * 64u) + _5094;
        uint _5108 = _5063._m0[_5103];
        uint _5112 = _5108;
        if (_5112 >= _5108)
        {
            _5094++;
        }
        int _5121 = 4;
        int _5122 = 4;
        _5123._m0 = _4706._m0[(uint(_5121) * _5112) + 0u].xyz;
        float _5138 = _4706._m0[(uint(_5121) * _5112) + 0u].w;
        _5123._m1 = _27(_5138);
        _5123._m2 = _4706._m0[(uint(_5121) * _5112) + 1u].xyz;
        _5123._m3 = _4706._m0[(uint(_5121) * _5112) + 1u].w;
        _5123._m4 = _4706._m0[(uint(_5121) * _5112) + 2u];
        float _5173 = _4706._m0[(uint(_5121) * _5112) + 3u].x;
        _5123._m8 = _27(_5173);
        float _5183 = _4706._m0[(uint(_5121) * _5112) + 3u].y;
        _5123._m9 = _27(_5183);
        _5123._m10 = _4706._m0[(uint(_5121) * _5112) + 3u].z;
        _5123._m5 = _4782._m0[(uint(_5122) * _5112) + 0u];
        _5123._m6 = _4782._m0[(uint(_5122) * _5112) + 1u];
        _5123._m7 = _4782._m0[(uint(_5122) * _5112) + 2u];
        _5123._m12 = _4782._m0[(uint(_5122) * _5112) + 3u].xyz;
        _5123._m13 = _4782._m0[(uint(_5122) * _5112) + 3u].w;
        float _5237 = 0.0;
        uint _5238 = _5123._m1;
        vec3 _5241 = _5123._m0;
        vec3 _5244 = _5241;
        if ((_5238 & 7u) == 2u)
        {
            _5250 = _5244;
        }
        else
        {
            _5250 = normalize(_5241 - _1057._m15);
        }
        vec3 _5246 = _5250;
        uint _5261 = uint(((_2560 & 3u) != 0u) ? 16 : 0);
        _5261 |= 32u;
        if ((_5238 & _5261) != 0u)
        {
            continue;
        }
        vec3 _5276 = vec3(dot(_1057._m15, _5123._m5.xyz) + _5123._m5.w, dot(_1057._m15, _5123._m6.xyz) + _5123._m6.w, dot(_1057._m15, _5123._m7.xyz) + _5123._m7.w);
        vec2 _5310 = _5276.xy / vec2(_5276.z);
        _5276 = vec3(_5310.x, _5310.y, _5276.z);
        _5276.z = dot(_1057._m15, _5123._m4.xyz) + _5123._m4.w;
        float _5323 = _5276.x;
        float _5326 = _5276.y;
        float _5329 = _5276.z;
        bool _5334 = _38(_5323, _5326, _5329) <= _5237;
        bool _5351;
        if (!_5334)
        {
            float _5338 = _5276.x;
            float _5341 = _5276.y;
            float _5344 = _5276.z;
            _5351 = _33(_5338, _5341, _5344) >= (1.0 - _5237);
        }
        else
        {
            _5351 = _5334;
        }
        if (_5351)
        {
            continue;
        }
        vec3 _5355 = vec3(1.0);
        uint _5356 = _5238 & 7u;
        vec3 _5359 = _5123._m0 - _1057._m15;
        float _5365 = dot(_5359, _5359);
        if (_5356 != 2u)
        {
            _5371 = 1.0 / (1.0 + _5365);
        }
        else
        {
            _5371 = _1057._m25;
        }
        _5355 = vec3(_5371);
        if (_5356 == 0u)
        {
            float _5391 = _5365 * _5123._m3;
            float _5394 = 1.0 - _56(_5391);
            float _5396 = _10(_5394);
            float _5386 = _56(_5396);
            _5355 *= _5386;
        }
        else
        {
            if (_5356 == 4u)
            {
                float _5412 = length((_5276.xy - vec2(0.5)) * 2.0);
                float _5406 = _10(_5412);
                float _5414 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_5406 * 7.80000019073486328125))));
                _5355 *= _5414;
            }
            else
            {
                if ((_5356 == 1u) || (_5356 == 2u))
                {
                    if (_5356 == 2u)
                    {
                        _5439 = fract((_5276.xy * _802._m36.xy) + _802._m36.zw);
                    }
                    else
                    {
                        _5439 = _5276.xy;
                    }
                    vec2 _5436 = _5439;
                    vec3 _5457 = vec3(0.0);
                    uint _5458 = bitfieldExtract(_5123._m8, 0, 20);
                    uint _5462 = _5458;
                    uint _5466 = _5462 + 0u;
                    vec3 _5482 = TEXTURE_LOD(SAMPLER_2D(_1461[nonuniformEXT(_5466)], _1343), vec4(_5436, 0.0, 0.0).xy, vec4(_5436, 0.0, 0.0).w).xyz;
                    _5457 = _53(_5482);
                    _5355 *= _5457;
                }
            }
        }
        float _5488 = float((_5238 >> uint(8)) & 255u) / 255.0;
        if ((_5356 == 0u) || (_5356 == 2u))
        {
            vec3 _5501 = abs((_5276 * 2.0) - vec3(1.0));
            float _5507 = _5501.x;
            float _5510 = _5501.y;
            float _5513 = _5501.z;
            float _5518 = 1.0 - _33(_5507, _5510, _5513);
            float _5523 = _10(_5518) / (9.9999999392252902907785028219223e-09 + _5488);
            float _5506 = _10(_5523);
            _5355 *= ((_5506 * _5506) * (3.0 - (2.0 * _5506)));
        }
        else
        {
            if ((_5356 == 1u) || (_5356 == 4u))
            {
                float _5543 = _5276.z;
                float _5547 = _56(_5543);
                float _5550 = 1.0 - _56(_5547);
                float _5552 = _10(_5550);
                float _5557 = _56(_5552) / (9.9999999392252902907785028219223e-09 + _5488);
                float _5542 = _10(_5557);
                _5355 *= _5542;
            }
        }
        float _5562 = _5355.x;
        float _5565 = _5355.y;
        float _5568 = _5355.z;
        if (_33(_5562, _5565, _5568) <= _5237)
        {
            continue;
        }
        float _5577 = 1.0;
        if ((_5238 & 8u) != 0u)
        {
            float _5584 = 0.00200000009499490261077880859375;
            vec3 _5586 = _1057._m15 + (_1057._m6 * _5584);
            uint _5594 = 0u;
            if ((_5238 & 7u) == 0u)
            {
                vec3 _5600 = _5586 - _5123._m2;
                float _5605 = _5600.x;
                float _5608 = _5600.y;
                float _5611 = _5600.z;
                _5594 = _44(_5605, _5608, _5611);
            }
            else
            {
                if ((_5238 & 7u) == 2u)
                {
                    float _5621 = 0.0;
                    uint _5622 = uint((_802._m37.w > 0.0) ? 3 : 4);
                    for (; _5594 < _5622; _5594++)
                    {
                        int _5636 = 5;
                        _5639._m0 = _5644._m0[(uint(_5636) * ((_5238 >> uint(22)) + _5594)) + 0u];
                        _5639._m1 = _5644._m0[(uint(_5636) * ((_5238 >> uint(22)) + _5594)) + 1u];
                        _5639._m2 = _5644._m0[(uint(_5636) * ((_5238 >> uint(22)) + _5594)) + 2u];
                        _5639._m3 = _5644._m0[(uint(_5636) * ((_5238 >> uint(22)) + _5594)) + 3u];
                        _5639._m4 = _5644._m0[(uint(_5636) * ((_5238 >> uint(22)) + _5594)) + 4u];
                        vec2 _5700 = vec2(dot(_5586, _5639._m0.xyz) + _5639._m0.w, dot(_5586, _5639._m1.xyz) + _5639._m1.w);
                        _5700 = abs((_5700 * 2.0) - vec2(1.0));
                        bool _5726 = _5700.x < 0.9900000095367431640625;
                        bool _5732;
                        if (_5726)
                        {
                            _5732 = _5700.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _5732 = _5726;
                        }
                        if (_5732)
                        {
                            _5621 = (1.0 - max(_5700.x, _5700.y)) * _802._m38.w;
                            break;
                        }
                    }
                    _1057._m36 = int(_5594);
                    _5594 = min((_5622 - 1u), _5594);
                    if (_802._m37.w > 0.0)
                    {
                        uint _5759 = uint(_1057._m17.x) ^ (uint(_1057._m17.y) << uint(1));
                        _5759 ^= uint(_802._m39.x);
                        _5594 += uint(int(((float(_5759 & 3u) * 0.25) + 0.125) > _5621));
                    }
                }
            }
            int _5785 = 5;
            _5786._m0 = _5644._m0[(uint(_5785) * ((_5238 >> uint(22)) + _5594)) + 0u];
            _5786._m1 = _5644._m0[(uint(_5785) * ((_5238 >> uint(22)) + _5594)) + 1u];
            _5786._m2 = _5644._m0[(uint(_5785) * ((_5238 >> uint(22)) + _5594)) + 2u];
            _5786._m3 = _5644._m0[(uint(_5785) * ((_5238 >> uint(22)) + _5594)) + 3u];
            _5786._m4 = _5644._m0[(uint(_5785) * ((_5238 >> uint(22)) + _5594)) + 4u];
            vec4 _5842 = vec4((_5586.x * _5786._m0.x) + ((_5586.y * _5786._m0.y) + ((_5586.z * _5786._m0.z) + _5786._m0.w)), (_5586.x * _5786._m1.x) + ((_5586.y * _5786._m1.y) + ((_5586.z * _5786._m1.z) + _5786._m1.w)), (_5586.x * _5786._m2.x) + ((_5586.y * _5786._m2.y) + ((_5586.z * _5786._m2.z) + _5786._m2.w)), (_5586.x * _5786._m3.x) + ((_5586.y * _5786._m3.y) + ((_5586.z * _5786._m3.z) + _5786._m3.w)));
            vec3 _5929 = _5842.xyz / vec3(_5842.w);
            _5842 = vec4(_5929.x, _5929.y, _5929.z, _5842.w);
            bool _5937 = min(_5842.x, _5842.y) > 0.0;
            bool _5946;
            if (_5937)
            {
                _5946 = max(_5842.x, _5842.y) < 1.0;
            }
            else
            {
                _5946 = _5937;
            }
            if (_5946)
            {
                vec2 _5958 = (_5842.xy * _5786._m4.xy) + _5786._m4.zw;
                _5842 = vec4(_5958.x, _5958.y, _5842.z, _5842.w);
                if (false)
                {
                    _5577 = textureLod(sampler2DShadow(_5965, _5967), vec3(_5842.xyz.xy, _5842.xyz.z), 0.0);
                }
                else
                {
                    vec2 _5976 = (_5842.xy * _802._m40.xy) + vec2(0.5);
                    vec2 _5985 = floor(_5976);
                    vec2 _5988 = _5976 - _5985;
                    _5985 -= vec2(0.5);
                    vec2 _5995 = vec2(4.0) - (_5988 * 3.0);
                    vec2 _6000 = vec2(7.0);
                    vec2 _6003 = vec2(1.0) + (_5988 * 3.0);
                    vec2 _6008 = (_5985 + (((vec2(3.0) - (_5988 * 2.0)) / _5995) - vec2(2.0))) * _802._m40.zw;
                    vec2 _6023 = (_5985 + ((vec2(3.0) + _5988) / _6000)) * _802._m40.zw;
                    vec2 _6035 = (_5985 + ((_5988 / _6003) + vec2(2.0))) * _802._m40.zw;
                    vec3 _6061 = vec3(_6008.x, _6008.y, _5842.z);
                    _5577 = (_5995.x * _5995.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6061.xy, _6061.z), 0.0);
                    vec3 _6079 = vec3(_6023.x, _6008.y, _5842.z);
                    _5577 += ((_6000.x * _5995.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6079.xy, _6079.z), 0.0));
                    vec3 _6099 = vec3(_6035.x, _6008.y, _5842.z);
                    _5577 += ((_6003.x * _5995.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6099.xy, _6099.z), 0.0));
                    vec3 _6119 = vec3(_6008.x, _6023.y, _5842.z);
                    _5577 += ((_5995.x * _6000.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6119.xy, _6119.z), 0.0));
                    vec3 _6139 = vec3(_6023.x, _6023.y, _5842.z);
                    _5577 += ((_6000.x * _6000.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6139.xy, _6139.z), 0.0));
                    vec3 _6159 = vec3(_6035.x, _6023.y, _5842.z);
                    _5577 += ((_6003.x * _6000.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6159.xy, _6159.z), 0.0));
                    vec3 _6179 = vec3(_6008.x, _6035.y, _5842.z);
                    _5577 += ((_5995.x * _6003.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6179.xy, _6179.z), 0.0));
                    vec3 _6199 = vec3(_6023.x, _6035.y, _5842.z);
                    _5577 += ((_6000.x * _6003.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6199.xy, _6199.z), 0.0));
                    vec3 _6219 = vec3(_6035.x, _6035.y, _5842.z);
                    _5577 += ((_6003.x * _6003.y) * textureLod(sampler2DShadow(_5965, _5967), vec3(_6219.xy, _6219.z), 0.0));
                    _5577 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _5577 = float((_5238 & 7u) == 2u);
                if ((_5238 & 7u) == 2u)
                {
                    _1057._m36 = -1;
                }
            }
            float _6239 = float((_5238 >> uint(16)) & 63u) / 63.0;
            float _6253 = ((_5577 * _6239) + 1.0) - _6239;
            _5577 = _10(_6253);
        }
        if (_5577 <= _5237)
        {
            continue;
        }
        vec3 _6261 = (_5123._m12 * _5577) * _5355;
        float _6268 = _5123._m13;
        vec3 _6271 = _6261;
        float _6278 = dot(_1057._m6, _5246);
        float _6273 = _10(_6278);
        float _6280 = 1.0;
        vec3 _6282 = _1057._m6;
        vec3 _6285 = _1057._m14;
        vec3 _6288 = _5246;
        vec3 _6290 = _1057._m2;
        float _6293 = _1057._m3;
        vec3 _6281 = _109(_6282, _6285, _6288, _6290, _6293);
        _1057._m21 += ((((_6281 * _6268) * _6271) * _6273) * _6280);
        vec3 _6310 = _6271;
        uint _6313 = _1057._m4;
        vec4 _6312 = _93(_6313);
        vec3 _6317 = _6312.xyz;
        float _6325 = dot(_1057._m8, _5246);
        float _6320 = _10(_6325);
        vec3 _6327 = vec3(mix(_6273, _6320, _1184._m36), mix(_6273, _6320, _1184._m35), mix(_6273, _6320, _1184._m34));
        float _6356 = dot(_1057._m14, -_5246);
        float _6358 = _10(_6356);
        float _6359 = _1184._m12.w;
        vec3 _6366 = ((_1184._m12.xyz + vec3(_1057._m5)) * _79(_6358, _6359)) * _6317;
        _6327 += _16(_6366);
        float _6370 = _6312.w;
        _6327 = mix(vec3(_6273), _6327, vec3(_6370));
        _1057._m21 += ((_6310 * _6327) * _1057._m0);
    }
    _1057._m21 *= _1057._m11;
    _6396 = vec4(_1057._m21, 0.0);
    if (((_802._m78 & 1u) != 0u) == true)
    {
        vec3 _6411 = _1057._m6;
        bool _6414 = false;
        vec2 _6415 = _190(_6411, _6414);
        _6410 = vec4(_6415, 0.0, 0.0);
        float _6425 = dot(_1057._m14, _1057._m6);
        float _6419 = _10(_6425);
        float _6428 = _6419;
        float _6430 = _1057._m3;
        vec3 _6433 = _1057._m2;
        vec3 _6427 = _115(_6428, _6430, _6433);
        float _6438 = _6427.x;
        float _6442 = _6427.y;
        float _6446 = _6427.z;
        float _6450 = _1057._m3;
        _6437 = vec4(_82(_6438), _82(_6442), _82(_6446), _193(_6450));
    }
}

