#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 50, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _123
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _131
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2592
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
};

struct _4637
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _5574
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _800_802
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    uint _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    uint _m66;
    float _m67[2];
} _802;

layout(set = 2, binding = 0, std140) uniform _1178_1180
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    uint _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    uint _m26;
} _1180;

layout(set = 1, binding = 0, std140) uniform _1190_1192
{
    vec4 _m0;
    int _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11[2];
} _1192;

layout(set = 3, binding = 0, std140) uniform _1230_1232
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1232;

layout(set = 0, binding = 22, std430) restrict readonly buffer _2141_2143
{
    vec4 _m0[];
} _2143;

layout(set = 0, binding = 23, std430) restrict readonly buffer _2503_2505
{
    uint _m0[];
} _2505;

layout(set = 0, binding = 24, std140) uniform _2597_2599
{
    vec4 _m0[4096];
} _2599;

layout(set = 0, binding = 25, std140) uniform _2617_2619
{
    vec4 _m0[4096];
} _2619;

layout(set = 0, binding = 26, std140) uniform _2670_2672
{
    vec4 _m0[2048];
} _2672;

layout(set = 0, binding = 33, std430) restrict readonly buffer _3993_3995
{
    uint _m0[];
} _3995;

layout(set = 0, binding = 37, std140) uniform _4641_4643
{
    vec4 _m0[4096];
} _4643;

layout(set = 0, binding = 38, std140) uniform _4717_4719
{
    vec4 _m0[4096];
} _4719;

layout(set = 0, binding = 40, std430) restrict readonly buffer _4998_5000
{
    uint _m0[];
} _5000;

layout(set = 0, binding = 41, std140) uniform _5579_5581
{
    vec4 _m0[4095];
} _5581;

layout(set = 0, binding = 1, std140) uniform _6393_6395
{
    vec4 _m0[64];
} _6395;

layout(push_constant, std430) uniform _2127_2129
{
    int _m0;
    int _m1;
    int _m2;
} _2129;

layout(set = 3, binding = 1) uniform TEXTURE_2D _1274[5];
layout(set = 0, binding = 11) uniform sampler _1282;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1300[5];
layout(set = 0, binding = 12) uniform sampler _1305;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1312[5];
layout(set = 0, binding = 13) uniform sampler _1317;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1334[5];
layout(set = 0, binding = 14) uniform sampler _1339;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1346[5];
layout(set = 0, binding = 15) uniform sampler _1351;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1358[5];
layout(set = 0, binding = 16) uniform sampler _1363;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1370[5];
layout(set = 0, binding = 17) uniform sampler _1375;
layout(set = 4, binding = 0) uniform TEXTURE_2D _1457[34816];
layout(set = 0, binding = 18) uniform sampler _1462;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1992[5];
layout(set = 0, binding = 19) uniform sampler _1997;
layout(set = 0, binding = 20) uniform TEXTURE_2D _2099;
layout(set = 0, binding = 21) uniform sampler _2101;
layout(set = 0, binding = 27) uniform TEXTURE_2D _2867;
layout(set = 0, binding = 28) uniform TEXTURE_2D _2918;
layout(set = 0, binding = 29) uniform TEXTURE_2D _3331;
layout(set = 0, binding = 30) uniform sampler _3333;
layout(set = 0, binding = 31) uniform TEXTURE_2D _3571;
layout(set = 0, binding = 32) uniform sampler _3573;
layout(set = 0, binding = 34) uniform TEXTURE_2D _4246;
layout(set = 0, binding = 35) uniform sampler _4248;
layout(set = 0, binding = 36) uniform TEXTURE_2D _4544;
layout(set = 0, binding = 39) uniform textureCubeArray _4971;
layout(set = 0, binding = 10) uniform sampler _4973;
layout(set = 0, binding = 42) uniform texture2D _5902;
layout(set = 0, binding = 43) uniform samplerShadow _5904;
layout(set = 0, binding = 7) uniform texture3D _6398;
layout(set = 0, binding = 8) uniform sampler _6399;
layout(set = 0, binding = 9) uniform texture3D _6400;

layout(location = 17, component = 3) in float _1059;
layout(location = 18, component = 0) in float _1061;
layout(location = 18, component = 1) in float _1066;
layout(location = 18, component = 2) in float _1068;
layout(location = 18, component = 3) in float _1070;
layout(location = 19, component = 0) in float _1099;
layout(location = 19, component = 1) in float _1101;
layout(location = 19, component = 2) in float _1103;
layout(location = 19, component = 3) in float _1107;
layout(location = 20, component = 0) in float _1109;
layout(location = 20, component = 1) in float _1111;
layout(location = 20, component = 2) in float _1123;
layout(location = 10, component = 0) in vec4 _1148;
layout(location = 11, component = 0) in vec4 _1151;
layout(location = 12, component = 0) in vec4 _1154;
layout(location = 0, component = 0) out vec4 _6333;
layout(location = 1, component = 0) out vec4 _6347;
layout(location = 2, component = 0) out vec4 _6374;
uint _196;
uint _198;
uint _200;
uint _202;
uint _204;
uint _206;
uint _208;
uint _209;
uint _211;
uint _212;
uint _214;
uint _216;
uint _218;
uint _220;
uint _222;
uint _224;
uint _226;
uint _228;
uint _230;

_131 _133()
{
    _131 _692;
    _692._m0 = vec3(0.0);
    _692._m2 = vec3(0.0);
    _692._m3 = 0.0;
    _692._m4 = 0u;
    _692._m5 = 0.0;
    _692._m6 = vec3(0.0);
    _692._m7 = vec3(0.0, 0.0, 1.0);
    _692._m8 = vec3(0.0, 0.0, 1.0);
    _692._m1 = vec3(0.0);
    _692._m9 = 1.0;
    _692._m10 = 1.0;
    _692._m14 = vec3(0.0);
    _692._m15 = vec3(0.0);
    _692._m16 = vec4(0.0);
    _692._m17 = vec4(0.0);
    _692._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _692._m19 = vec3(0.0);
    _692._m20 = vec3(0.0);
    _692._m21 = vec3(0.0);
    _692._m22 = vec3(0.0);
    _692._m23 = vec3(0.0);
    _692._m24 = vec3(0.0);
    _692._m25 = 1.0;
    _692._m26 = uvec4(0u);
    _692._m27 = uvec4(0u);
    _692._m28 = uvec4(0u);
    _692._m29 = vec4(0.0);
    _692._m30 = vec4(0.0);
    _692._m31 = vec4(0.0);
    _692._m32 = vec4(0.0);
    _692._m33 = uvec2(0u);
    _692._m34 = vec2(0.0);
    _692._m35 = 0.0;
    _692._m36 = -1;
    _692._m37 = 0;
    _692._m38 = vec2(0.0);
    _692._m39 = 1.0;
    _692._m41 = -1;
    _692._m45 = 1.0;
    _692._m11 = 1.0;
    _692._m12 = 0u;
    _692._m13 = uvec3(0u);
    _692._m40 = vec3(0.0);
    _692._m46 = 0.0;
    _692._m47 = 1.0;
    return _692;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_123 _125()
{
    _123 _680;
    _680._m0 = vec4(0.0);
    _680._m1 = vec4(0.0);
    _680._m2 = vec4(0.0);
    _680._m3 = vec4(0.0);
    _680._m4 = vec4(0.0);
    _680._m5 = 0.0;
    return _680;
}

vec2 _149(vec2 _148)
{
    return ((_148 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _154(inout vec2 _152, bool _153)
{
    vec2 _834 = _152;
    _152 = _149(_834);
    float _854 = (1.0 - (_152.x * _152.x)) - (_152.y * _152.y);
    vec3 _837 = vec3(_152.x, _152.y, sqrt(_10(_854)));
    if (_153 == false)
    {
        _837.z = -_837.z;
    }
    return _837;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _89(inout vec4 _88)
{
    vec4 _434 = _88;
    _88 = _22(_434);
    return packUnorm4x8(_88.wzyx);
}

vec3 _71(mat3 _69, vec3 _70)
{
    return _69 * _70;
}

vec3 _159(vec3 _157, mat3 _158)
{
    mat3 _870 = _158;
    vec3 _872 = _157;
    return normalize(_71(_870, _872));
}

vec3 _165(vec2 _162, mat3 _163, bool _164)
{
    vec2 _879 = _162;
    bool _881 = _164;
    vec3 _883 = _154(_879, _881);
    vec3 _878 = _883;
    vec3 _884 = _878;
    mat3 _886 = _163;
    return _159(_884, _886);
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _82(float _81)
{
    return sqrt(_81);
}

float _121(vec3 _118, float _119, float _120)
{
    float _635 = length(_118) * _120;
    if (_635 < 1.0)
    {
        float _644 = 1.0 - _119;
        float _647 = _635 * _635;
        float _651 = ((3.0 * _635) - (_635 * _647)) / (1.0 - _647);
        float _662 = 1.0 / (2.0 * _651);
        float _672 = (_644 * _644) + _662;
        return 1.0 - _82(_672);
    }
    return _119;
}

float _145(inout float _143, bool _144)
{
    if (_144)
    {
        _143 += (float(_143 < _802._m29) * _802._m30);
    }
    float _815 = _143;
    return _802._m0.w / (_10(_815) + _802._m0.z);
}

float _38(float _35, float _36, float _37)
{
    return min(_35, min(_36, _37));
}

float _33(float _30, float _31, float _32)
{
    return max(_30, max(_31, _32));
}

float _138(vec2 _137)
{
    return dot(_137, _137);
}

vec4 _96(uint _95)
{
    return vec4(float((_95 >> uint(24)) & 255u), float((_95 >> uint(16)) & 255u), float((_95 >> uint(8)) & 255u), float(_95 & 255u));
}

vec4 _93(uint _92)
{
    return unpackUnorm4x8(_92).wzyx;
}

float _74(float _73)
{
    return exp2(_73);
}

vec3 _115(float _112, float _113, vec3 _114)
{
    float _587 = 0.0949999988079071044921875 + (_113 * (0.60000002384185791015625 + (4.190000057220458984375 * _113)));
    float _597 = _112 + 0.02500000037252902984619140625;
    float _601 = (9.5 * _113) * _112;
    float _615 = 1.0 - (14.0 * _112);
    float _607 = (_587 * _597) * _74(_615);
    float _622 = -_601;
    float _618 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _74(_622)));
    return mix(vec3(_607), vec3(_618), _114);
}

float _182(uvec2 _180, uint _181)
{
    uvec2 _941 = _180 & uvec2(3u);
    return float(((((2068378560u * (1u - (_941.x >> uint(1)))) + (1500172770u * (_941.x >> uint(1)))) >> ((_941.y + ((_941.x & 1u) << uint(2))) << uint(2))) + _181) & 15u) / 16.0;
}

vec3 _176(vec3 _173, vec4 _174, vec4 _175)
{
    return vec3((_174.xy * _173.xy) + _174.zw, _175.z) / vec3((_175.x * _173.z) + _175.y);
}

vec3 _170(vec3 _168, vec4 _169)
{
    return vec3(vec2(0.5) + (_169.xy * (_168.xy / vec2(_168.z))), (_169.w / _168.z) + _169.z);
}

int _50(uint _49)
{
    return findLSB(_49);
}

vec4 _64(vec3 _59, vec4 _60, vec4 _61, vec4 _62, vec4 _63)
{
    return vec4((_59.x * _60.x) + ((_59.y * _60.y) + ((_59.z * _60.z) + _60.w)), (_59.x * _61.x) + ((_59.y * _61.y) + ((_59.z * _61.z) + _61.w)), (_59.x * _62.x) + ((_59.y * _62.y) + ((_59.z * _62.z) + _62.w)), (_59.x * _63.x) + ((_59.y * _63.y) + ((_59.z * _63.z) + _63.w)));
}

float _56(float _55)
{
    return _55 * _55;
}

vec3 _53(vec3 _52)
{
    return _52 * _52;
}

uint _44(float _41, float _42, float _43)
{
    bool _272 = abs(_43) >= abs(_41);
    bool _280;
    if (_272)
    {
        _280 = abs(_43) >= abs(_42);
    }
    else
    {
        _280 = _272;
    }
    if (_280)
    {
        return uint((_43 < 0.0) ? 5 : 4);
    }
    if (abs(_42) >= abs(_41))
    {
        return uint((_42 < 0.0) ? 3 : 2);
    }
    return uint(int(_41 < 0.0));
}

float _79(float _77, float _78)
{
    return pow(_77, _78);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _101(vec3 _99, float _100)
{
    float _474 = dot(_99, vec3(16.666500091552734375));
    float _469 = _10(_474);
    float _483 = 1.0 - _100;
    float _486 = _10(_483);
    float _487 = 5.0;
    vec3 _491 = _99 + ((vec3(_469) - _99) * _79(_486, _487));
    return _16(_491);
}

vec3 _109(vec3 _104, vec3 _105, vec3 _106, vec3 _107, float _108)
{
    float _499 = dot(_104, _105);
    float _495 = _10(_499);
    vec3 _501 = normalize(_105 + _106);
    float _510 = dot(_104, _501);
    float _506 = _10(_510);
    float _516 = dot(_106, _501);
    float _512 = _10(_516);
    vec3 _519 = _107;
    float _521 = _512;
    vec3 _518 = _101(_519, _521);
    float _528 = dot(_104, _106);
    float _524 = _10(_528);
    float _530 = 1.0 - (_108 * 0.800000011920928955078125);
    _530 *= _530;
    _530 *= _530;
    float _541 = _530 * _530;
    float _545 = ((_506 * _506) * (_541 - 1.0)) + 1.0;
    _545 = _541 / ((_545 * _545) + 9.9999999392252902907785028219223e-09);
    float _560 = (_495 * (1.0 - _530)) + _530;
    float _567 = (_524 * (1.0 - _530)) + _530;
    _545 /= (((4.0 * _560) * _567) + 9.9999999392252902907785028219223e-09);
    return _518 * _545;
}

vec2 _185(vec2 _184)
{
    return (vec2(1.0) - abs(_184.yx)) * vec2((_184.x >= 0.0) ? 1.0 : (-1.0), (_184.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _190(inout vec3 _188, bool _189)
{
    _188 /= vec3((abs(_188.x) + abs(_188.y)) + abs(_188.z));
    vec2 _1010;
    if (_188.z >= 0.0)
    {
        _1010 = _188.xy;
    }
    else
    {
        vec2 _1016 = _188.xy;
        _1010 = _185(_1016);
    }
    _188 = vec3(_1010.x, _1010.y, _188.z);
    if (_189)
    {
        vec2 _1030 = (_188.xy * 0.5) + vec2(0.5);
        _188 = vec3(_1030.x, _1030.y, _188.z);
    }
    return _188.xy;
}

float _85(float _84)
{
    return sqrt(_84);
}

float _193(float _192)
{
    float _1040 = abs(_192);
    float _1037 = _85(_1040);
    float _1044;
    if (_192 > 0.0)
    {
        _1044 = _1037;
    }
    else
    {
        _1044 = -_1037;
    }
    return (_1044 * 0.5) + 0.5;
}

void main()
{
    _196 = 2147483648u;
    _198 = 1073741824u;
    _200 = 0u;
    _202 = 268435456u;
    _204 = 536870912u;
    _206 = 805306368u;
    _208 = 1073741824u;
    _209 = 1342177280u;
    _211 = 0u;
    _212 = 16777216u;
    _214 = 33554432u;
    _216 = 50331648u;
    _218 = 67108864u;
    _220 = 83886080u;
    _222 = 100663296u;
    _224 = 117440512u;
    _226 = 134217728u;
    _228 = 150994944u;
    _230 = 167772160u;
    _131 _1056 = _133();
    _1056._m16 = vec4(0.0, 0.0, _1059, _1061);
    vec3 _1065 = vec3(_1066, _1068, _1070);
    _1056._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1056._m15 = vec3(_802._m40, _802._m41, _802._m42) + _1065;
    vec3 _1097 = vec3(0.0);
    vec3 _1098 = vec3(0.0);
    _1097 = normalize(vec3(_1099, _1101, _1103));
    _1098 = normalize(vec3(_1107, _1109, _1111));
    vec3 _1115 = _1097;
    vec3 _1117 = _1098;
    vec3 _1119 = normalize(cross(_1115, _1117) * _1123);
    _1056._m18 = mat3(vec3(_1117), vec3(_1119), vec3(_1115));
    _1056._m14 = normalize(-_1065);
    _1056._m29 = _1148;
    _1056._m30 = _1151;
    _1056._m31 = _1154;
    uint _1157 = 0u;
    vec4 _1158 = vec4(0.0);
    vec4 _1159 = vec4(0.0);
    vec4 _1160 = vec4(0.0);
    vec4 _1161 = vec4(0.0);
    vec4 _1162 = vec4(0.0);
    float _1163 = 0.0;
    uvec2 _1164 = uvec2(0u, 65535u);
    vec2 _1167 = _1056._m16.zw;
    vec2 _1171 = _1167;
    vec2 _1173 = _1167;
    float _1175 = 0.0009765625;
    vec3 _1186;
    if ((_1180._m26 & 1u) != 0u)
    {
        _1186 = vec3(_1192._m3, _1192._m4, _1192._m5);
    }
    else
    {
        _1186 = vec3(1.0);
    }
    vec3 _1177 = _1186;
    float _1203 = 1.0;
    float _1204 = _1192._m6;
    bool _1207 = _1204 > 0.0;
    float _1210 = 1.0;
    uint _1211 = _1164.x;
    uint _1214 = _1211 & 7u;
    uint _1218 = _1214;
    uint _1220 = _1218;
    float _1222 = 0.0;
    vec2 _1223 = _1171;
    _1223.x *= _1232._m1[_1220].w;
    _1223.y *= _1232._m2[_1220].x;
    _1223.x += (_802._m58 * _1232._m2[_1220].y);
    _1223.y += (_802._m58 * _1232._m2[_1220].z);
    vec2 _1268 = _1223;
    uint _1276 = _1220;
    vec3 _1270 = (SAMPLE_TEXTURE(SAMPLER_2D(_1274[nonuniformEXT(_1276)], _1282), _1268).xyz * vec3(_1232._m0[_1220].x)) + vec3(_1232._m0[_1220].y);
    uint _1302 = _1220;
    vec2 _1299 = SAMPLE_TEXTURE(SAMPLER_2D(_1300[nonuniformEXT(_1302)], _1305), _1268).xy;
    uint _1314 = _1220;
    vec3 _1311 = (SAMPLE_TEXTURE(SAMPLER_2D(_1312[nonuniformEXT(_1314)], _1317), _1268).xyz * vec3(_1232._m0[_1220].z)) + vec3(_1232._m0[_1220].w);
    uint _1336 = _1220;
    float _1333 = SAMPLE_TEXTURE(SAMPLER_2D(_1334[nonuniformEXT(_1336)], _1339), _1268).x;
    uint _1348 = _1220;
    float _1345 = SAMPLE_TEXTURE(SAMPLER_2D(_1346[nonuniformEXT(_1348)], _1351), _1268).x;
    uint _1360 = _1220;
    vec3 _1357 = SAMPLE_TEXTURE(SAMPLER_2D(_1358[nonuniformEXT(_1360)], _1363), _1268).xyz;
    uint _1372 = _1220;
    float _1369 = SAMPLE_TEXTURE(SAMPLER_2D(_1370[nonuniformEXT(_1372)], _1375), _1268).x;
    _1158 = vec4(_1270.x, _1270.y, _1270.z, _1158.w);
    _1158.w = 0.0;
    _1159 = vec4(_1311.x, _1311.y, _1311.z, _1159.w);
    _1159.w = _1345;
    _1160 = vec4(_1299.x, _1299.y, _1160.z, _1160.w);
    _1161.x = 0.0;
    _1161.y = _1222;
    _1161.z = _1345;
    _1161.w = _1333;
    _1163 = _1369;
    _1210 = _1232._m1[_1220].x;
    vec3 _1410 = _1357 * _1232._m3[_1220].xyz;
    _1162 = vec4(_1410.x, _1410.y, _1410.z, _1162.w);
    float _1413 = _1207 ? _1204 : _1210;
    vec3 _1422 = _1162.xyz * vec3(_1413);
    _1162 = vec4(_1422.x, _1422.y, _1422.z, _1162.w);
    vec2 _1425 = vec2(0.0);
    _123 _1426;
    _1426._m0 = _1158;
    _1426._m1 = _1159;
    _1426._m2 = _1161;
    _1426._m3 = _1160;
    _1426._m4 = _1162;
    _1426._m5 = _1163;
    _1425 = _1426._m3.xy;
    _1426._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1426._m3.z, _1426._m3.w);
    bool _1445 = (_1180._m26 & 2u) != 0u;
    if (_1445)
    {
        vec4 _1453 = vec4(0.0);
        _1453 = SAMPLE_TEXTURE(SAMPLER_2D(_1457[_1180._m18], _1462), _1171);
        _1453 *= _1180._m1;
        _1453 = min(_1453, vec4(1.0));
        float _1474 = (_1163 - 0.4980392158031463623046875) * _1180._m19;
        for (int _1481 = 0; _1481 < 4; _1481++)
        {
            float _1489 = _1453[_1481];
            if (!(_1489 == 0.0))
            {
                float _1497 = 0.0;
                vec2 _1498 = vec2(_1180._m2[_1481]);
                uint _1503 = uint(_1481 + 1);
                uint _1507 = _1503 & 7u;
                uint _1510 = _1507;
                uint _1512 = _1510;
                uint _1515 = _1512;
                _1497 = SAMPLE_TEXTURE(SAMPLER_2D(_1370[nonuniformEXT(_1515)], _1375), _1167 * _1498).x;
                _1497 -= 0.4980392158031463623046875;
                _1497 *= _1180._m3[_1481];
                float _1532 = (_1474 + 1.0) - _1489;
                float _1537 = (_1497 + 0.0) + _1489;
                float _1542 = _1537 - _1532;
                float _1546 = (clamp(_1542 / _1180._m4[_1481], -1.0, 1.0) / 2.0) + 0.5;
                float _1555 = 0.100000001490116119384765625;
                float _1557 = abs(0.5 - _1489);
                float _1568 = (_1557 - (0.5 - _1555)) / _1555;
                float _1561 = _10(_1568);
                float _1570 = 0.0;
                if ((_1489 < _1555) && (_1546 > _1489))
                {
                    _1570 = mix(_1546, _1489, _1561);
                }
                else
                {
                    if ((_1489 > (1.0 - _1555)) && (_1546 < _1489))
                    {
                        _1570 = mix(_1546, _1489, _1561);
                    }
                    else
                    {
                        _1570 = _1546;
                    }
                }
                float _1601 = _1180._m5[_1481];
                float _1605 = _1180._m6[_1481];
                float _1609 = _1180._m7[_1481];
                float _1613 = _1180._m8[_1481];
                float _1617 = _1180._m9[_1481];
                _123 _1621 = _125();
                float _1623 = _1192._m6;
                bool _1626 = _1623 > 0.0;
                float _1629 = 1.0;
                uint _1630 = uint(_1481 + 1);
                uint _1634 = _1630 & 7u;
                uint _1637 = _1634;
                uint _1639 = _1637;
                float _1641 = 0.0;
                vec2 _1642 = _1167 * _1498;
                _1642.x *= _1232._m1[_1639].w;
                _1642.y *= _1232._m2[_1639].x;
                _1642.x += (_802._m58 * _1232._m2[_1639].y);
                _1642.y += (_802._m58 * _1232._m2[_1639].z);
                vec2 _1680 = _1642;
                uint _1684 = _1639;
                vec3 _1682 = (SAMPLE_TEXTURE(SAMPLER_2D(_1274[nonuniformEXT(_1684)], _1282), _1680).xyz * vec3(_1232._m0[_1639].x)) + vec3(_1232._m0[_1639].y);
                uint _1704 = _1639;
                vec2 _1702 = SAMPLE_TEXTURE(SAMPLER_2D(_1300[nonuniformEXT(_1704)], _1305), _1680).xy;
                uint _1714 = _1639;
                vec3 _1712 = (SAMPLE_TEXTURE(SAMPLER_2D(_1312[nonuniformEXT(_1714)], _1317), _1680).xyz * vec3(_1232._m0[_1639].z)) + vec3(_1232._m0[_1639].w);
                uint _1734 = _1639;
                float _1732 = SAMPLE_TEXTURE(SAMPLER_2D(_1334[nonuniformEXT(_1734)], _1339), _1680).x;
                uint _1744 = _1639;
                float _1742 = SAMPLE_TEXTURE(SAMPLER_2D(_1346[nonuniformEXT(_1744)], _1351), _1680).x;
                uint _1754 = _1639;
                vec3 _1752 = SAMPLE_TEXTURE(SAMPLER_2D(_1358[nonuniformEXT(_1754)], _1363), _1680).xyz;
                uint _1764 = _1639;
                float _1762 = SAMPLE_TEXTURE(SAMPLER_2D(_1370[nonuniformEXT(_1764)], _1375), _1680).x;
                _1621._m0 = vec4(_1682.x, _1682.y, _1682.z, _1621._m0.w);
                _1621._m0.w = 0.0;
                _1621._m1 = vec4(_1712.x, _1712.y, _1712.z, _1621._m1.w);
                _1621._m1.w = _1742;
                _1621._m3 = vec4(_1702.x, _1702.y, _1621._m3.z, _1621._m3.w);
                _1621._m2.x = 0.0;
                _1621._m2.y = _1641;
                _1621._m2.z = _1742;
                _1621._m2.w = _1732;
                _1621._m5 = _1762;
                _1629 = _1232._m1[_1639].x;
                vec3 _1804 = _1752 * _1232._m3[_1639].xyz;
                _1621._m4 = vec4(_1804.x, _1804.y, _1804.z, _1621._m4.w);
                float _1808 = _1626 ? _1623 : _1629;
                vec3 _1818 = _1621._m4.xyz * vec3(_1808);
                _1621._m4 = vec4(_1818.x, _1818.y, _1818.z, _1621._m4.w);
                _1426._m0 = mix(_1426._m0, _1621._m0, vec4(_1570 * _1601));
                _1426._m1 = mix(_1426._m1, _1621._m1, vec4(_1570 * _1609));
                _1426._m2.w = mix(_1426._m2.w, _1621._m2.w, _1570 * _1613);
                vec3 _1859 = mix(_1426._m2.xyz, _1621._m2.xyz, vec3(_1570));
                _1426._m2 = vec4(_1859.x, _1859.y, _1859.z, _1426._m2.w);
                _1426._m3 = mix(_1426._m3, _1621._m3, vec4(_1570 * _1605));
                _1426._m4 = mix(_1426._m4, _1621._m4, vec4(_1570 * _1617));
                _1426._m5 = mix(_1426._m5, _1621._m5, _1570);
            }
        }
    }
    _1158 = _1426._m0;
    _1159 = _1426._m1;
    _1161.w = _1426._m2.w;
    _1160 = _1426._m3;
    _1162 = _1426._m4;
    _1163 = _1426._m5;
    vec2 _1907 = _1425;
    bool _1909 = true;
    vec3 _1910 = _154(_1907, _1909);
    vec3 _1905 = _1910;
    vec2 _1912 = _1160.xy;
    bool _1915 = true;
    vec3 _1916 = _154(_1912, _1915);
    vec3 _1911 = _1916;
    vec3 _1917 = _1905 + vec3(0.0, 0.0, 1.0);
    vec3 _1920 = vec3(-_1911.xy, _1911.z);
    vec3 _1929 = (_1917 * dot(_1917, _1920)) - (_1920 * _1917.z);
    vec3 _1941 = normalize(_1929);
    _1160 = vec4(_1941.x, _1941.y, _1941.z, _1160.w);
    vec3 _1946 = _1160.xyz + vec3(1.0);
    _1160 = vec4(_1946.x, _1946.y, _1946.z, _1160.w);
    vec3 _1951 = _1160.xyz * 0.5;
    _1160 = vec4(_1951.x, _1951.y, _1951.z, _1160.w);
    _1056._m22 = _1162.xyz * _1177;
    vec3 _1959 = vec3(0.0);
    vec3 _1960 = vec3(0.0);
    float _1961 = 0.0;
    uint _1962 = 0u;
    uint _1963 = _1962 & 7u;
    uint _1966 = _1963;
    uint _1968 = _1966;
    vec4 _1970 = vec4(_1167, 0.0, _1180._m20);
    uint _1978 = _1968;
    vec2 _1988 = SAMPLE_TEXTURE1(SAMPLER_2D(_1300[nonuniformEXT(_1978)], _1305), _1970.xy, _1970.w).xy;
    _1959 = vec3(_1988.x, _1988.y, _1959.z);
    uint _1994 = _1968;
    vec4 _1991 = SAMPLE_TEXTURE1(SAMPLER_2D(_1992[nonuniformEXT(_1994)], _1997), _1970.xy, _1970.w);
    _1960 = _1991.xyz;
    _1961 = _1991.w;
    _1056._m8 = _1959;
    float _2016 = _1961 * _1180._m21;
    float _2011 = _10(_2016);
    vec4 _2024 = vec4(_1960, _2011);
    uint _2025 = _89(_2024);
    _1056._m4 = _2025;
    float _2032 = (1.0 - _2011) * _1180._m22;
    _1056._m10 = _10(_2032);
    _1056._m0 = _1158.xyz;
    _1056._m2 = _1159.xyz;
    _1056._m1 = _1162.xyz;
    _1056._m3 = _1161.w;
    _1056._m6 = _1160.xyz;
    uint _2050 = 0u;
    bool _2051 = true;
    vec2 _2052 = _1056._m6.xy;
    bool _2056 = _2051;
    vec3 _2058 = _154(_2052, _2056);
    _1056._m7 = _2058;
    vec2 _2060 = _1056._m6.xy;
    mat3 _2064 = _1056._m18;
    bool _2067 = _2051;
    _1056._m6 = _165(_2060, _2064, _2067);
    vec2 _2071 = _1056._m8.xy;
    mat3 _2075 = _1056._m18;
    bool _2078 = _2051;
    _1056._m8 = _165(_2071, _2075, _2078);
    vec3 _2082 = dFdx(_1056._m15);
    vec3 _2086 = dFdy(_1056._m15);
    vec2 _2090 = _1056._m17.xy * _802._m6.xy;
    uint _2098 = uint(int(TEXTURE_LOD(SAMPLER_2D(_2099, _2101), vec4(_2090, 0.0, 0.0).xy, vec4(_2090, 0.0, 0.0).w).x * 255.0));
    if ((_2098 > 0u) && (_2098 < 255u))
    {
        int _2126 = _2129._m2;
        if (_2126 > 0)
        {
            _2126--;
            vec4 _2139 = _2143._m0[((uint(_2126) + _2098) - 1u) * 2u];
            vec4 _2153 = _2143._m0[(((uint(_2126) + _2098) - 1u) * 2u) + 1u];
            vec2 _2163 = vec2((_1056._m15.x * _2139.x) + ((_1056._m15.y * _2139.y) + ((_1056._m15.z * _2139.z) + _2139.w)), (_1056._m15.x * _2153.x) + ((_1056._m15.y * _2153.y) + ((_1056._m15.z * _2153.z) + _2153.w)));
            vec2 _2205 = vec2(dot(_2082, _2139.xyz), dot(_2082, _2153.xyz));
            vec2 _2215 = vec2(dot(_2086, _2139.xyz), dot(_2086, _2153.xyz));
            int _2225 = int(_1192._m7);
            vec4 _2229 = vec4(0.0);
            vec4 _2230 = vec4(0.0);
            vec4 _2231 = vec4(0.0);
            uint _2232 = uint(_2225);
            uint _2237 = _2232 + 0u;
            _2229 = TEXTURE_GRAD(SAMPLER_2D(_1457[nonuniformEXT(_2237)], _1282), _2163, _2205, _2215);
            uint _2248 = _2232 + 1u;
            _2230 = TEXTURE_GRAD(SAMPLER_2D(_1457[nonuniformEXT(_2248)], _1305), _2163, _2205, _2215);
            uint _2259 = _2232 + 2u;
            _2231 = TEXTURE_GRAD(SAMPLER_2D(_1457[nonuniformEXT(_2259)], _1317), _2163, _2205, _2215);
            vec2 _2269 = _2230.xy;
            bool _2272 = true;
            vec3 _2273 = _154(_2269, _2272);
            vec3 _2268 = _2273;
            float _2274 = _2230.w;
            float _2277 = _2230.z;
            vec3 _2280 = _2229.xyz;
            float _2283 = _2229.w;
            vec4 _2286 = _2231;
            float _2289 = _1192._m8;
            if (_2098 > _27(_2289))
            {
                _2280 *= _1192._m0.xyz;
                _2277 *= _1192._m0.w;
            }
            _1056._m0 = mix(_1056._m0, _2280, vec3(_2274));
            _1056._m2 = mix(_1056._m2, _2286.xyz, vec3(_2274));
            _1056._m22 = mix(_1056._m22, _2280 * (_2283 * 16.0), vec3(_2283));
            vec3 _2330 = _1056._m18[2];
            float _2333 = sign(dot(cross(_2153.xyz, _2139.xyz), _2330));
            vec3 _2351 = normalize(_2139.xyz + (_2330 * dot(_2139.xyz, _2330)));
            _2139 = vec4(_2351.x, _2351.y, _2351.z, _2139.w);
            vec3 _2360 = normalize(cross(_2330, _2139.xyz)) * _2333;
            _2153 = vec4(_2360.x, _2360.y, _2360.z, _2153.w);
            _2268 = ((_2139.xyz * _2268.x) + (_2153.xyz * _2268.y)) + (_2330 * _2268.z);
            vec3 _2379 = _2268;
            float _2381 = dot(_2379, _2330);
            _2268 = (_1056._m6 * _2381) + ((_2379 - (_2330 * _2381)) * dot(_1056._m6, _2330));
            _1056._m6 = normalize(_2268);
            vec3 _2403 = _2268;
            float _2405 = _2286.w;
            float _2408 = 1.0;
            _1056._m3 = mix(_1056._m3, _2286.w, _2277);
        }
    }
    uvec2 _2417 = uvec2(_1056._m17.xy);
    uint _2422 = _2417.x / 256u;
    uint _2427 = _2417.y / 256u;
    float _2432 = _1056._m17.z;
    bool _2435 = false;
    float _2436 = _145(_2432, _2435);
    float _2431 = _2436;
    float _2437 = log2(max(1.0, _2431 / _802._m7.z)) * _802._m7.w;
    uint _2447 = min(23u, uint(_2437));
    float _2454 = _802._m59;
    float _2460 = _802._m60;
    uint _2452 = (_27(_2454) + ((_2422 + (_27(_2460) * _2427)) * 24u)) + _2447;
    uvec2 _2472 = uvec2(_1056._m17.xy);
    uint _2477 = _2472.x / 32u;
    uint _2482 = _2472.y / 32u;
    float _2490 = _802._m61;
    uint _2486 = _2477 + (_2482 * _27(_2490));
    float _2497 = _1192._m9;
    uint _2496 = _27(_2497);
    uint _2501 = _2505._m0[_2452 * 64u];
    uint _2512 = _2501 & 255u;
    uint _2515 = _2505._m0[_2486 * 64u];
    uint _2520 = _2515 & 255u;
    uint _2528;
    uint _2530;
    uint _2532;
    if (_2512 < _2520)
    {
        _2528 = _2512;
        _2530 = _2501;
        _2532 = _2452;
    }
    else
    {
        _2528 = _2520;
        _2530 = _2515;
        _2532 = _2486;
    }
    vec3 _2538 = dFdx(_1056._m15);
    vec3 _2542 = dFdy(_1056._m15);
    uint _2546 = _2496 & 3u;
    bool _2549 = (_2496 & 4u) != 0u;
    uint _2554 = ((_2546 == 0u) && (!_2549)) ? 0u : _2528;
    uint _2562 = 1u;
    _2592 _2594;
    vec3 _3014;
    while (_2562 <= _2554)
    {
        uint _2571 = (_2532 * 64u) + _2562;
        uint _2576 = _2505._m0[_2571];
        uint _2580 = _2576;
        if (_2580 >= _2576)
        {
            _2562++;
        }
        int _2589 = 2;
        int _2590 = 2;
        int _2591 = 1;
        _2594._m0 = _2599._m0[(uint(_2589) * _2580) + 0u];
        _2594._m1 = _2599._m0[(uint(_2589) * _2580) + 1u];
        _2594._m2 = _2619._m0[(uint(_2590) * _2580) + 0u];
        float _2633 = _2619._m0[(uint(_2590) * _2580) + 1u].x;
        _2594._m3 = _27(_2633);
        float _2643 = _2619._m0[(uint(_2590) * _2580) + 1u].y;
        _2594._m4 = _27(_2643);
        float _2653 = _2619._m0[(uint(_2590) * _2580) + 1u].z;
        _2594._m5 = _27(_2653);
        float _2663 = _2619._m0[(uint(_2590) * _2580) + 1u].w;
        _2594._m6 = _27(_2663);
        float _2678 = _2672._m0[(uint(_2591) * _2580) + 0u].x;
        _2594._m7 = _27(_2678);
        float _2688 = _2672._m0[(uint(_2591) * _2580) + 0u].y;
        _2594._m8 = _27(_2688);
        float _2698 = _2672._m0[(uint(_2591) * _2580) + 0u].z;
        _2594._m9 = _27(_2698);
        vec4 _2703 = _2594._m0;
        vec4 _2706 = _2594._m1;
        vec4 _2709 = _2594._m2;
        vec3 _2712 = vec3(dot(_1056._m15, _2703.xyz) + _2703.w, dot(_1056._m15, _2706.xyz) + _2706.w, dot(_1056._m15, _2709.xyz) + _2709.w);
        float _2738 = 0.0039215688593685626983642578125;
        float _2740 = _2712.x;
        float _2743 = _2712.y;
        float _2746 = _2712.z;
        bool _2751 = _38(_2740, _2743, _2746) <= _2738;
        bool _2768;
        if (!_2751)
        {
            float _2755 = _2712.x;
            float _2758 = _2712.y;
            float _2761 = _2712.z;
            _2768 = _33(_2755, _2758, _2761) >= (1.0 - _2738);
        }
        else
        {
            _2768 = _2751;
        }
        if (_2768)
        {
            continue;
        }
        uint _2772 = _2594._m5;
        uint _2775 = _2594._m9;
        uint _2778 = _2496 & 3u;
        bool _2787 = ((_2775 & 512u) != 0u) && (_2778 != 0u);
        bool _2798;
        if (!_2787)
        {
            _2798 = ((_2775 & 1024u) != 0u) && (_2778 != 1u);
        }
        else
        {
            _2798 = _2787;
        }
        bool _2806;
        if (!_2798)
        {
            _2806 = (_2775 & 16384u) != 0u;
        }
        else
        {
            _2806 = _2798;
        }
        if (_2806)
        {
            continue;
        }
        vec2 _2810 = vec2(dot(_2538, _2703.xyz), dot(_2538, _2706.xyz));
        vec2 _2820 = vec2(dot(_2542, _2703.xyz), dot(_2542, _2706.xyz));
        vec4 _2830 = vec4(0.0);
        vec4 _2831 = vec4(0.0);
        uint _2832 = _2594._m3;
        uint _2838 = _2832 + 1u;
        vec4 _2835 = TEXTURE_GRAD(SAMPLER_2D(_1457[nonuniformEXT(_2838)], _1305), _2712.xy, _2810 * vec2(1.0), _2820 * vec2(1.0));
        if ((_2775 & 32768u) != 0u)
        {
            vec2 _2857 = vec2(1.0 / length(_2703.xyz), 1.0 / length(_2706.xyz));
            vec2 _2888 = TEXTURE_LOD(SAMPLER_2D(_2867, _1462), vec4(_2712.xy * _2857, 0.0, 0.0).xy, vec4(_2712.xy * _2857, 0.0, 0.0).w).xy;
            _2835 = vec4(_2888.x, _2888.y, _2835.z, _2835.w);
            vec2 _2895 = _2835.xy - vec2(0.4980392158031463623046875);
            float _2898 = 1.0 - _138(_2895);
            _2835.z = sqrt(_10(_2898));
        }
        else
        {
            if ((_2775 & 65536u) != 0u)
            {
                vec2 _2909 = vec2(1.0, (1.0 / length(_2706.xyz)) / 2.5);
                vec2 _2917 = TEXTURE_GRAD(SAMPLER_2D(_2918, _1462), _2712.xy * _2909, _2810 * _2909, _2820 * _2909).xy;
                vec2 _2938 = _2835.xy + (_2917 - vec2(0.4980392158031463623046875));
                _2835 = vec4(_2938.x, _2938.y, _2835.z, _2835.w);
                vec2 _2944 = _2835.xy - vec2(0.4980392158031463623046875);
                float _2947 = 1.0 - _138(_2944);
                _2835.z = sqrt(_10(_2947));
            }
        }
        if ((_2772 & 1u) != 0u)
        {
            uint _2958 = _2832 + 0u;
            _2830 = TEXTURE_GRAD(SAMPLER_2D(_1457[nonuniformEXT(_2958)], _1282), _2712.xy, _2810 * vec2(1.0), _2820 * vec2(1.0));
        }
        if ((_2772 & 2u) != 0u)
        {
            uint _2977 = _2832 + 2u;
            _2831 = TEXTURE_GRAD(SAMPLER_2D(_1457[nonuniformEXT(_2977)], _1317), _2712.xy, _2810 * vec2(1.0), _2820 * vec2(1.0));
        }
        float _2989 = 1.0;
        vec3 _2990 = vec3(0.5, 0.5, 1.0);
        vec3 _2992 = vec3(0.0, 0.0, 1.0);
        vec4 _2993 = _2835;
        _2990 = _2993.xyz;
        _2989 = _2993.w;
        _2992 = (_2990 * 2.0) - vec3(1.0);
        if (_2989 <= (4.0 * _2738))
        {
            continue;
        }
        _2990 = _2992;
        if ((_2775 & 128u) != 0u)
        {
            _3014 = vec3(-_2990.x, -_2990.y, _2990.z);
        }
        else
        {
            _3014 = _2990;
        }
        _2990 = _3014;
        uint _3029 = _2594._m6;
        uint _3033 = _3029;
        float _3032 = 1.0 + (_96(_3033).w * 0.062745101749897003173828125);
        uint _3041 = _2772;
        float _3040 = _93(_3041).z;
        uint _3046 = _3029;
        vec3 _3045 = _93(_3046).xyz;
        float _3059 = _3032 - (_3032 * abs((_2712.z * 2.0) - 1.0));
        _2989 *= _10(_3059);
        float _3063 = _2989;
        if ((_2772 & 1u) != 0u)
        {
            _3045 *= _2830.xyz;
            _3063 *= _2830.w;
        }
        vec3 _3078 = _1056._m18[2];
        float _3087 = dot(_3078, normalize(_2709.xyz));
        float _3081 = _10(_3087);
        uint _3089 = _2594._m7;
        uint _3093 = _3089;
        vec4 _3092 = _93(_3093);
        _1056._m22 = mix(_1056._m22, ((_3092.xyz * ((_3063 * _3092.w) * 16.0)) * _3040) * _3081, vec3(_3063));
        uint _3114 = _2594._m8;
        uint _3118 = _3114;
        vec4 _3117 = _93(_3118);
        if ((_2772 & 2u) != 0u)
        {
            _3117 = _2831;
        }
        if ((_2772 & 32u) != 0u)
        {
            uint _3133 = _2772;
            float _3132 = _93(_3133).x;
            uint _3138 = _2772;
            float _3137 = _96(_3138).y;
            float _3158 = dot((_2712.xy + _2992.xy) - vec2(0.5), (_2712.xy + _2992.xy) - vec2(0.5));
            float _3142 = _10(_3158);
            float _3166 = _3137 * (_3132 - _3142);
            float _3168 = _10(_3166);
            float _3160 = _82(_3168);
            _2989 = min(_2989, _3160);
        }
        float _3173 = _2989 * _3081;
        uint _3177 = _2594._m4;
        uint _3181 = _3177;
        vec4 _3180 = _93(_3181) * _3173;
        _1056._m9 = max(_1056._m9, _3180.x);
        _1056._m0 = mix(_1056._m0, _3045, _3180.xxx);
        _1056._m2 = mix(_1056._m2, _3117.xyz, _3180.yyy);
        if (!(_3173 == 0.0))
        {
            float _3211 = 1.0;
            vec3 _3221 = normalize(_2703.xyz + (_3078 * dot(_2703.xyz, _3078)));
            _2703 = vec4(_3221.x, _3221.y, _3221.z, _2703.w);
            vec3 _3230 = normalize(cross(_3078, _2703.xyz)) * _3211;
            _2706 = vec4(_3230.x, _3230.y, _3230.z, _2706.w);
            _2990 = ((_2703.xyz * _2990.x) + (_2706.xyz * _2990.y)) + (_3078 * _2990.z);
            if ((_2775 & 256u) != 0u)
            {
                vec3 _3254 = mix(_3078, _2990, _3180.www);
                float _3260 = dot(_3254, _3078);
                _2990 = (_1056._m6 * _3260) + ((_3254 - (_3078 * _3260)) * dot(_1056._m6, _3078));
            }
            else
            {
                if ((_2775 & 64u) != 0u)
                {
                    _2990 = mix(mix(_1056._m6, _3078, vec3(_3173)), _2990, _3180.www);
                }
                else
                {
                    _2990 = mix(_1056._m6, _2990, _3180.www);
                }
            }
            _1056._m6 = normalize(_2990);
        }
        float _3305 = _3117.w;
        _1056._m3 = mix(_1056._m3, _3305, _3180.z);
    }
    float _3315 = _802._m8.x;
    if (_3315 > 0.0)
    {
        vec2 _3322 = _1056._m17.xy * _802._m6.xy;
        vec3 _3330 = (TEXTURE_LOD(SAMPLER_2D(_3331, _3333), vec4(_3322, 0.0, 0.0).xy, vec4(_3322, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _3355 = dot(_3330, _1056._m6);
        _1056._m11 = _10(_3355);
        float _3363 = 1.0 - pow(_1056._m11, 0.699999988079071044921875);
        _1056._m11 = _10(_3363);
        _1056._m11 *= _1056._m11;
    }
    _1056._m21 = _1056._m22;
    _1056._m25 = 1.0;
    float _3376 = _802._m9.w;
    bool _3379 = _3376 < 0.0;
    _3376 = abs(_3376);
    vec3 _3384 = _1056._m15;
    float _3403 = (1.0 - (length(_3384 - vec3(_802._m40, _802._m41, _802._m42)) / _3376)) / 0.25;
    float _3387 = _10(_3403);
    if ((!_3379) && (_3387 > 0.0))
    {
        vec3 _3412 = _802._m9.xyz;
        vec3 _3416 = _802._m10.xyz;
        float _3420 = _3384.z - _3416.z;
        float _3426 = _802._m11.w;
        float _3429 = _802._m12.w;
        float _3432 = float(_3429 < 0.0);
        _3429 = abs(_3429) - 1.0;
        bool _3439 = _3420 <= 0.0;
        float _3442 = 3.5 * float(!(_3429 == 0.0));
        float _3451;
        if (!(_3426 == 0.0))
        {
            _3451 = _3412.z;
        }
        else
        {
            _3451 = _3416.z;
        }
        float _3448 = _3451;
        float _3460 = min(_3439 ? 2.0 : 1000.0, abs(_3420));
        float _3467 = max(_3412.x - _3384.x, _3384.x - _3416.x);
        float _3479 = max(_3412.y - _3384.y, _3384.y - _3416.y);
        float _3491 = max(_3467, _3479) - _3460;
        _3491 = max(_3491, _3448 - _3384.z);
        _3491 = max(_3491, _3420 - _3442);
        if (_3491 <= 0.0)
        {
            float _3512 = _3439 ? _3426 : _3429;
            vec2 _3517 = _1056._m18[2].xy;
            float _3521 = length(_3517);
            vec3 _3524 = vec3(_3517, (-1.73205077648162841796875) * _3521);
            _3524 /= vec3(2.0 * _3521);
            vec3 _3537 = _802._m12.xyz;
            vec3 _3541 = mix(_3524, _3537, bvec3(_3439));
            vec2 _3548 = _3384.xy - (_3541.xy * (_3420 / _3541.z));
            float _3559 = (_802._m62 / 100.0) * 16.0;
            vec2 _3566 = _3548 * _3559;
            float _3570 = TEXTURE_LOD(SAMPLER_2D(_3571, _3573), vec4(_3566, 0.0, 0.0).xy, vec4(_3566, 0.0, 0.0).w).x;
            float _3588 = min(8.0, _3416.z - _3412.z);
            float _3601 = (-_3420) / _3588;
            float _3596 = _10(_3601);
            float _3608 = dot(_1056._m6, _3541);
            float _3603 = _10(_3608);
            float _3614 = _3467 / _3460;
            float _3610 = 1.0 - _10(_3614);
            float _3620 = _3479 / _3460;
            _3610 *= (1.0 - _10(_3620));
            _3610 *= _3610;
            float _3636 = min(_3420 / 1.0, 1.0 - (_3420 / _3442));
            float _3628 = _10(_3636);
            _3610 *= max(_3628, _3596);
            _3610 *= _3610;
            _3610 *= _3387;
            float _3649 = _3570 - 1.0;
            float _3652 = float(_3439) * _3432;
            float _3657 = max(0.0, _3570 - 0.85000002384185791015625);
            float _3662 = _3439 ? _3649 : _3657;
            float _3667 = (((1.0 - _3652) * _3603) * _3610) * _3512;
            vec3 _3676 = _1056._m0 + (_1056._m2 * (vec3(1.0) - _1056._m0));
            _1056._m21 += ((_3676 * (_3662 * _3667)) * _802._m11.xyz);
            float _3700 = _3652 * _3610;
            _1056._m25 = 1.0 + (_3700 * (_3570 - 1.0));
        }
    }
    else
    {
        if (_3387 > 0.0)
        {
            _3387 *= _802._m63;
            float _3720 = float(_802._m12.w < 0.0);
            vec3 _3725 = _802._m12.xyz;
            float _3734 = dot(_1056._m6, _3725);
            float _3729 = _10(_3734);
            vec2 _3736 = _3384.xy - (_3725.xy * (_3384.z / _3725.z));
            float _3748 = (_802._m62 / 100.0) * 16.0;
            vec2 _3753 = _3736 * _3748;
            float _3757 = TEXTURE_LOD(SAMPLER_2D(_3571, _3573), vec4(_3753, 0.0, 0.0).xy, vec4(_3753, 0.0, 0.0).w).x;
            vec4 _3773 = _802._m11;
            _1056._m21 += (_3773.xyz * (((((1.0 - _3720) * (_3757 - 1.0)) * _3729) * _3387) * _3773.w));
            _1056._m25 = 1.0 + ((_3720 * (_3757 - 1.0)) * _3387);
        }
    }
    _1056._m14 = normalize(vec3(_802._m40, _802._m41, _802._m42) - _1056._m15);
    vec3 _3815 = vec3(0.0);
    vec3 _3816 = vec3(0.0);
    vec3 _3817 = vec3(0.0);
    vec3 _3818 = vec3(0.0);
    vec3 _3819 = vec3(0.0);
    vec4 _3820 = _1056._m29;
    vec4 _3823 = _1056._m30;
    vec4 _3826 = _1056._m31;
    _3816 = vec3(_3820.x, _3820.y, _3820.z);
    _3817 = vec3(_3820.w, _3823.x, _3823.y);
    _3818 = vec3(_3823.z, _3823.w, _3826.x);
    _3819 = vec3(_3826.y, _3826.z, _3826.w);
    vec3 _3857 = ((_3816 - (_3817 * _1056._m6.y)) + (_3818 * _1056._m6.z)) - (_3819 * _1056._m6.x);
    float _3881 = _1192._m10 * _802._m64;
    _3815 += (max(vec3(0.0), _3857 * _10(_3881)) * _1056._m0);
    vec3 _3890 = vec3(0.0);
    vec3 _3891 = vec3(0.0);
    vec3 _3892 = vec3(0.0);
    vec3 _3893 = vec3(0.0);
    vec3 _3894 = vec3(0.0);
    vec4 _3895 = _1056._m29;
    vec4 _3898 = _1056._m30;
    vec4 _3901 = _1056._m31;
    _3891 = vec3(_3895.x, _3895.y, _3895.z);
    _3892 = vec3(_3895.w, _3898.x, _3898.y);
    _3893 = vec3(_3898.z, _3898.w, _3901.x);
    _3894 = vec3(_3901.y, _3901.z, _3901.w);
    vec3 _3932 = ((_3891 - (_3892 * _1056._m8.y)) + (_3893 * _1056._m8.z)) - (_3894 * _1056._m8.x);
    float _3955 = _1192._m10 * _802._m64;
    _3890 += (max(vec3(0.0), _3932 * _10(_3955)) * _1056._m0);
    uint _3966 = _1056._m4;
    _3815 = mix(_3815, _3890, vec3(_93(_3966).w));
    _1056._m21 += _3815;
    bool _3978 = true;
    _3978 = (((_802._m66 & 1u) != 0u) == true) ? false : true;
    if (true && (_3978 == true))
    {
        uint _3991 = _3995._m0[_2452 * 64u];
        uint _4000 = _3991 & 255u;
        uint _4003 = _3995._m0[_2486 * 64u];
        uint _4008 = _4003 & 255u;
        uint _4016;
        uint _4018;
        uint _4020;
        if (_4000 < _4008)
        {
            _4016 = _4000;
            _4018 = _3991;
            _4020 = _2452;
        }
        else
        {
            _4016 = _4008;
            _4018 = _4003;
            _4020 = _2486;
        }
        float _4026 = _1056._m47;
        float _4035 = dot(_1056._m14, _1056._m6);
        float _4029 = _10(_4035);
        float _4037 = _4029;
        float _4039 = _1056._m3;
        vec3 _4042 = _1056._m2;
        _1056._m24 = (_115(_4037, _4039, _4042) * _1056._m11) * _1056._m39;
        float _4053 = _802._m13.x;
        float _4056 = _802._m13.z;
        bool _4060 = _4053 > 0.0;
        bool _4067;
        if (_4060)
        {
            _4067 = _1056._m3 > _4056;
        }
        else
        {
            _4067 = _4060;
        }
        if (_4067)
        {
            float _4070 = 0.0;
            vec3 _4071 = normalize(reflect(-_1056._m14, _1056._m6));
            if (dot(_1056._m14, _4071) <= _4070)
            {
                vec2 _4087 = vec2(1.0);
                uvec2 _4100 = uvec2(_1056._m17.xy * (vec2(1.0) / _4087));
                uint _4101 = uint(_802._m13.w);
                float _4088 = _182(_4100, _4101);
                _4088 -= 1.0;
                vec2 _4105 = _1056._m17.xy * _802._m6.xy;
                vec3 _4120 = vec3(_4105, _1056._m17.z);
                vec4 _4121 = _802._m14;
                vec4 _4124 = _802._m15;
                vec3 _4113 = _176(_4120, _4121, _4124);
                mat3 _4128 = mat3(vec3(_802._m16.xyz), vec3(_802._m17.xyz), vec3(_802._m18.xyz));
                mat3 _4152 = _4128;
                vec3 _4154 = _4071;
                vec3 _4151 = normalize(_71(_4152, _4154));
                float _4158 = 1.0;
                uint _4159 = uint((_4053 == 1.0) ? 8 : 12);
                _4159 = (_4053 == 3.0) ? 16u : _4159;
                vec3 _4169 = _4113;
                float _4174 = _1056._m17.z;
                bool _4177 = true;
                float _4178 = _145(_4174, _4177);
                vec3 _4171 = _4169 + (_4151 * _4178);
                vec4 _4181 = vec4(0.0);
                vec3 _4183 = _4169;
                vec4 _4185 = _802._m19;
                vec3 _4182 = _170(_4183, _4185);
                vec3 _4190 = _4171;
                vec4 _4192 = _802._m19;
                vec3 _4189 = _170(_4190, _4192);
                vec3 _4196 = ((_4189 - _4182) * (_4158 / float(_4159))) / vec3(length(_4189.xy - _4182.xy));
                vec3 _4213 = _4182 + (_4196 * _4088);
                float _4219 = abs(_4196.z) * 1.0;
                uint _4224 = 0u;
                vec3 _4225 = _4213;
                float _4227 = _4182.z;
                float _4414;
                for (uint _4230 = 0u; _4230 < _4159; _4230 += 4u)
                {
                    vec4 _4239 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_4230));
                    vec4 _4245 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_4246, _4248), vec4(_4213.xy + (_4196.xy * _4239.x), 0.0, 0.0).xy, vec4(_4213.xy + (_4196.xy * _4239.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4246, _4248), vec4(_4213.xy + (_4196.xy * _4239.y), 0.0, 0.0).xy, vec4(_4213.xy + (_4196.xy * _4239.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4246, _4248), vec4(_4213.xy + (_4196.xy * _4239.z), 0.0, 0.0).xy, vec4(_4213.xy + (_4196.xy * _4239.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4246, _4248), vec4(_4213.xy + (_4196.xy * _4239.w), 0.0, 0.0).xy, vec4(_4213.xy + (_4196.xy * _4239.w), 0.0, 0.0).w).x);
                    uvec4 _4367 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_4213.zzzz + (_4196.zzzz * _4239)) - _4245) - vec4(_4219)), vec4(_4219)));
                    uint _4387 = (((_4367.x << uint(0)) | (_4367.y << uint(1))) | (_4367.z << uint(2))) | (_4367.w << uint(3));
                    if (_4387 > 0u)
                    {
                        uint _4408 = _4387;
                        uint _4407 = uint(_50(_4408));
                        if (_4407 > 0u)
                        {
                            _4414 = _4245[_4407 - 1u];
                        }
                        else
                        {
                            _4414 = _4227;
                        }
                        _4227 = _4414;
                        _4225 = _4213 + (_4196 * float((_4230 + _4407) + 1u));
                        float _4433 = _4245[_4407] - _4225.z;
                        float _4440 = (_4227 - _4225.z) + _4196.z;
                        float _4454 = _4433 / (_4433 - _4440);
                        float _4448 = _10(_4454);
                        vec3 _4456 = _4225 - _4196;
                        _4225 = (_4456 * _4448) + (_4225 * (1.0 - _4448));
                        _4224 = _4230 + _4407;
                        break;
                    }
                    _4227 = _4245.w;
                }
                if (_4224 > 0u)
                {
                    vec3 _4481 = _4225;
                    vec4 _4483 = _802._m20;
                    vec4 _4486 = _802._m21;
                    vec4 _4489 = _802._m22;
                    vec4 _4492 = _802._m23;
                    vec3 _4480 = _64(_4481, _4483, _4486, _4489, _4492).xyw;
                    vec2 _4502 = _4480.xy / vec2(_4480.z);
                    _4480 = vec3(_4502.x, _4502.y, _4480.z);
                    vec2 _4505 = (_4480.xy * 2.0) - vec2(1.0);
                    float _4519 = (1.0 - (float(_4224) / float(_4159))) * 4.0;
                    float _4511 = _10(_4519);
                    if (false)
                    {
                        float _4523 = _4505.y;
                        float _4528 = 1.0 - _56(_4523);
                        _4511 *= smoothstep(0.0, 0.25, _10(_4528));
                    }
                    else
                    {
                        float _4538 = 1.0 - dot(_4505, _4505);
                        _4511 *= smoothstep(0.0, 0.5, _10(_4538));
                    }
                    vec3 _4543 = TEXTURE_LOD(SAMPLER_2D(_4544, _3333), vec4(_4480.xy, 0.0, 0.0).xy, vec4(_4480.xy, 0.0, 0.0).w).xyz;
                    _4181 = vec4(_4543, _4511);
                }
                float _4576 = 1.0 - ((1.0 - _1056._m3) / (1.0 - _4056));
                float _4568 = _10(_4576);
                float _4578 = (_4181.w * _4568) * _802._m65;
                _1056._m21 += ((_4181.xyz * _4578) * _1056._m24);
                _4026 = 1.0 - _4578;
            }
        }
        uint _4600 = 1u;
        _4637 _4639;
        while (_4600 <= _4016)
        {
            uint _4609 = (_4020 * 64u) + _4600;
            uint _4614 = _3995._m0[_4609];
            uint _4618 = _4614;
            if (_4618 >= _4614)
            {
                _4600++;
            }
            float _4627 = 0.0039215688593685626983642578125;
            if (_4026 <= (_4627 * 4.0))
            {
                break;
            }
            int _4635 = 4;
            int _4636 = 4;
            _4639._m0 = _4643._m0[(uint(_4635) * _4618) + 0u].xyz;
            float _4658 = _4643._m0[(uint(_4635) * _4618) + 0u].w;
            _4639._m1 = _27(_4658);
            _4639._m2 = _4643._m0[(uint(_4635) * _4618) + 1u].xyz;
            _4639._m3 = _4643._m0[(uint(_4635) * _4618) + 1u].w;
            _4639._m4 = _4643._m0[(uint(_4635) * _4618) + 2u];
            float _4693 = _4643._m0[(uint(_4635) * _4618) + 3u].x;
            _4639._m8 = _27(_4693);
            float _4703 = _4643._m0[(uint(_4635) * _4618) + 3u].y;
            _4639._m9 = _27(_4703);
            _4639._m10 = _4643._m0[(uint(_4635) * _4618) + 3u].z;
            _4639._m5 = _4719._m0[(uint(_4636) * _4618) + 0u];
            _4639._m6 = _4719._m0[(uint(_4636) * _4618) + 1u];
            _4639._m7 = _4719._m0[(uint(_4636) * _4618) + 2u];
            _4639._m12 = _4719._m0[(uint(_4636) * _4618) + 3u].xyz;
            _4639._m13 = _4719._m0[(uint(_4636) * _4618) + 3u].w;
            vec3 _4761 = vec3(dot(_1056._m15, _4639._m5.xyz) + _4639._m5.w, dot(_1056._m15, _4639._m6.xyz) + _4639._m6.w, dot(_1056._m15, _4639._m4.xyz) + _4639._m4.w);
            float _4790 = _4761.x;
            float _4793 = _4761.y;
            float _4796 = _4761.z;
            bool _4801 = _38(_4790, _4793, _4796) <= _4627;
            bool _4818;
            if (!_4801)
            {
                float _4805 = _4761.x;
                float _4808 = _4761.y;
                float _4811 = _4761.z;
                _4818 = _33(_4805, _4808, _4811) >= (1.0 - _4627);
            }
            else
            {
                _4818 = _4801;
            }
            if (_4818)
            {
                continue;
            }
            uint _4822 = _4639._m1;
            vec3 _4825 = _4639._m0;
            float _4828 = float(bitfieldExtract(_4639._m8, 20, 12));
            float _4833 = 0.800000011920928955078125;
            vec3 _4834 = (_4761 * 2.0) - vec3(1.0);
            vec3 _4839 = _4834;
            vec3 _4838 = _53(_4839);
            vec3 _4842 = _4834 * sqrt(((vec3(1.0) - (_4838.yzx * 0.5)) - (_4838.zxy * 0.5)) + ((_4838.yzx * _4838.zxy) / vec3(3.0)));
            float _4873 = 1.0 - ((length(_4842) - _4833) / ((1.0 - _4833) + 9.9999999747524270787835121154785e-07));
            float _4862 = _10(_4873);
            _4862 *= _4862;
            _4862 *= _4026;
            float _4881 = _4639._m7.w;
            _4862 *= _4881;
            _4026 *= (1.0 - _4862);
            vec3 _4891 = _4639._m12;
            float _4894 = _4639._m13;
            float _4899 = _4862;
            vec3 _4897 = _4891 * (_10(_4899) * _4894);
            vec3 _4905 = _4639._m2;
            vec3 _4908 = _4639._m7.xyz;
            vec3 _4912 = vec3(0.0);
            vec3 _4913 = reflect(-_1056._m14, _1056._m6);
            vec3 _4920 = (_4908 - _1056._m15) / _4913;
            vec3 _4927 = (_4905 - _1056._m15) / _4913;
            vec3 _4934 = max(_4920, _4927);
            float _4939 = _4934.x;
            float _4942 = _4934.y;
            float _4945 = _4934.z;
            float _4938 = _38(_4939, _4942, _4945);
            vec3 _4949 = _1056._m15 + (_4913 * _4938);
            vec3 _4956 = _4949 - _4825;
            float _4960 = 6.0;
            float _4962 = _4960 - (_4960 * _1056._m3);
            _4912 = textureLod(samplerCubeArray(_4971, _4973), vec4(_4956, _4828), _4962).xyz;
            _1056._m21 += ((_4912 * _4897) * _1056._m24);
        }
    }
    uint _4996 = _5000._m0[_2452 * 64u];
    uint _5005 = _4996 & 255u;
    uint _5008 = _5000._m0[_2486 * 64u];
    uint _5013 = _5008 & 255u;
    uint _5021;
    uint _5023;
    uint _5025;
    if (_5005 < _5013)
    {
        _5021 = _5005;
        _5023 = _4996;
        _5025 = _2452;
    }
    else
    {
        _5021 = _5013;
        _5023 = _5008;
        _5025 = _2486;
    }
    uint _5031 = 1u;
    _4637 _5060;
    vec3 _5187;
    float _5308;
    vec2 _5376;
    _5574 _5576;
    _5574 _5723;
    while (_5031 <= _5021)
    {
        uint _5040 = (_5025 * 64u) + _5031;
        uint _5045 = _5000._m0[_5040];
        uint _5049 = _5045;
        if (_5049 >= _5045)
        {
            _5031++;
        }
        int _5058 = 4;
        int _5059 = 4;
        _5060._m0 = _4643._m0[(uint(_5058) * _5049) + 0u].xyz;
        float _5075 = _4643._m0[(uint(_5058) * _5049) + 0u].w;
        _5060._m1 = _27(_5075);
        _5060._m2 = _4643._m0[(uint(_5058) * _5049) + 1u].xyz;
        _5060._m3 = _4643._m0[(uint(_5058) * _5049) + 1u].w;
        _5060._m4 = _4643._m0[(uint(_5058) * _5049) + 2u];
        float _5110 = _4643._m0[(uint(_5058) * _5049) + 3u].x;
        _5060._m8 = _27(_5110);
        float _5120 = _4643._m0[(uint(_5058) * _5049) + 3u].y;
        _5060._m9 = _27(_5120);
        _5060._m10 = _4643._m0[(uint(_5058) * _5049) + 3u].z;
        _5060._m5 = _4719._m0[(uint(_5059) * _5049) + 0u];
        _5060._m6 = _4719._m0[(uint(_5059) * _5049) + 1u];
        _5060._m7 = _4719._m0[(uint(_5059) * _5049) + 2u];
        _5060._m12 = _4719._m0[(uint(_5059) * _5049) + 3u].xyz;
        _5060._m13 = _4719._m0[(uint(_5059) * _5049) + 3u].w;
        float _5174 = 0.0;
        uint _5175 = _5060._m1;
        vec3 _5178 = _5060._m0;
        vec3 _5181 = _5178;
        if ((_5175 & 7u) == 2u)
        {
            _5187 = _5181;
        }
        else
        {
            _5187 = normalize(_5178 - _1056._m15);
        }
        vec3 _5183 = _5187;
        uint _5198 = uint(((_2496 & 3u) != 0u) ? 16 : 0);
        _5198 |= 32u;
        if ((_5175 & _5198) != 0u)
        {
            continue;
        }
        vec3 _5213 = vec3(dot(_1056._m15, _5060._m5.xyz) + _5060._m5.w, dot(_1056._m15, _5060._m6.xyz) + _5060._m6.w, dot(_1056._m15, _5060._m7.xyz) + _5060._m7.w);
        vec2 _5247 = _5213.xy / vec2(_5213.z);
        _5213 = vec3(_5247.x, _5247.y, _5213.z);
        _5213.z = dot(_1056._m15, _5060._m4.xyz) + _5060._m4.w;
        float _5260 = _5213.x;
        float _5263 = _5213.y;
        float _5266 = _5213.z;
        bool _5271 = _38(_5260, _5263, _5266) <= _5174;
        bool _5288;
        if (!_5271)
        {
            float _5275 = _5213.x;
            float _5278 = _5213.y;
            float _5281 = _5213.z;
            _5288 = _33(_5275, _5278, _5281) >= (1.0 - _5174);
        }
        else
        {
            _5288 = _5271;
        }
        if (_5288)
        {
            continue;
        }
        vec3 _5292 = vec3(1.0);
        uint _5293 = _5175 & 7u;
        vec3 _5296 = _5060._m0 - _1056._m15;
        float _5302 = dot(_5296, _5296);
        if (_5293 != 2u)
        {
            _5308 = 1.0 / (1.0 + _5302);
        }
        else
        {
            _5308 = _1056._m25;
        }
        _5292 = vec3(_5308);
        if (_5293 == 0u)
        {
            float _5328 = _5302 * _5060._m3;
            float _5331 = 1.0 - _56(_5328);
            float _5333 = _10(_5331);
            float _5323 = _56(_5333);
            _5292 *= _5323;
        }
        else
        {
            if (_5293 == 4u)
            {
                float _5349 = length((_5213.xy - vec2(0.5)) * 2.0);
                float _5343 = _10(_5349);
                float _5351 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_5343 * 7.80000019073486328125))));
                _5292 *= _5351;
            }
            else
            {
                if ((_5293 == 1u) || (_5293 == 2u))
                {
                    if (_5293 == 2u)
                    {
                        _5376 = fract((_5213.xy * _802._m24.xy) + _802._m24.zw);
                    }
                    else
                    {
                        _5376 = _5213.xy;
                    }
                    vec2 _5373 = _5376;
                    vec3 _5394 = vec3(0.0);
                    uint _5395 = bitfieldExtract(_5060._m8, 0, 20);
                    uint _5399 = _5395;
                    uint _5403 = _5399 + 0u;
                    vec3 _5419 = TEXTURE_LOD(SAMPLER_2D(_1457[nonuniformEXT(_5403)], _1339), vec4(_5373, 0.0, 0.0).xy, vec4(_5373, 0.0, 0.0).w).xyz;
                    _5394 = _53(_5419);
                    _5292 *= _5394;
                }
            }
        }
        float _5425 = float((_5175 >> uint(8)) & 255u) / 255.0;
        if ((_5293 == 0u) || (_5293 == 2u))
        {
            vec3 _5438 = abs((_5213 * 2.0) - vec3(1.0));
            float _5444 = _5438.x;
            float _5447 = _5438.y;
            float _5450 = _5438.z;
            float _5455 = 1.0 - _33(_5444, _5447, _5450);
            float _5460 = _10(_5455) / (9.9999999392252902907785028219223e-09 + _5425);
            float _5443 = _10(_5460);
            _5292 *= ((_5443 * _5443) * (3.0 - (2.0 * _5443)));
        }
        else
        {
            if ((_5293 == 1u) || (_5293 == 4u))
            {
                float _5480 = _5213.z;
                float _5484 = _56(_5480);
                float _5487 = 1.0 - _56(_5484);
                float _5489 = _10(_5487);
                float _5494 = _56(_5489) / (9.9999999392252902907785028219223e-09 + _5425);
                float _5479 = _10(_5494);
                _5292 *= _5479;
            }
        }
        float _5499 = _5292.x;
        float _5502 = _5292.y;
        float _5505 = _5292.z;
        if (_33(_5499, _5502, _5505) <= _5174)
        {
            continue;
        }
        float _5514 = 1.0;
        if ((_5175 & 8u) != 0u)
        {
            float _5521 = 0.00200000009499490261077880859375;
            vec3 _5523 = _1056._m15 + (_1056._m6 * _5521);
            uint _5531 = 0u;
            if ((_5175 & 7u) == 0u)
            {
                vec3 _5537 = _5523 - _5060._m2;
                float _5542 = _5537.x;
                float _5545 = _5537.y;
                float _5548 = _5537.z;
                _5531 = _44(_5542, _5545, _5548);
            }
            else
            {
                if ((_5175 & 7u) == 2u)
                {
                    float _5558 = 0.0;
                    uint _5559 = uint((_802._m25.w > 0.0) ? 3 : 4);
                    for (; _5531 < _5559; _5531++)
                    {
                        int _5573 = 5;
                        _5576._m0 = _5581._m0[(uint(_5573) * ((_5175 >> uint(22)) + _5531)) + 0u];
                        _5576._m1 = _5581._m0[(uint(_5573) * ((_5175 >> uint(22)) + _5531)) + 1u];
                        _5576._m2 = _5581._m0[(uint(_5573) * ((_5175 >> uint(22)) + _5531)) + 2u];
                        _5576._m3 = _5581._m0[(uint(_5573) * ((_5175 >> uint(22)) + _5531)) + 3u];
                        _5576._m4 = _5581._m0[(uint(_5573) * ((_5175 >> uint(22)) + _5531)) + 4u];
                        vec2 _5637 = vec2(dot(_5523, _5576._m0.xyz) + _5576._m0.w, dot(_5523, _5576._m1.xyz) + _5576._m1.w);
                        _5637 = abs((_5637 * 2.0) - vec2(1.0));
                        bool _5663 = _5637.x < 0.9900000095367431640625;
                        bool _5669;
                        if (_5663)
                        {
                            _5669 = _5637.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _5669 = _5663;
                        }
                        if (_5669)
                        {
                            _5558 = (1.0 - max(_5637.x, _5637.y)) * _802._m26.w;
                            break;
                        }
                    }
                    _1056._m36 = int(_5531);
                    _5531 = min((_5559 - 1u), _5531);
                    if (_802._m25.w > 0.0)
                    {
                        uint _5696 = uint(_1056._m17.x) ^ (uint(_1056._m17.y) << uint(1));
                        _5696 ^= uint(_802._m27.x);
                        _5531 += uint(int(((float(_5696 & 3u) * 0.25) + 0.125) > _5558));
                    }
                }
            }
            int _5722 = 5;
            _5723._m0 = _5581._m0[(uint(_5722) * ((_5175 >> uint(22)) + _5531)) + 0u];
            _5723._m1 = _5581._m0[(uint(_5722) * ((_5175 >> uint(22)) + _5531)) + 1u];
            _5723._m2 = _5581._m0[(uint(_5722) * ((_5175 >> uint(22)) + _5531)) + 2u];
            _5723._m3 = _5581._m0[(uint(_5722) * ((_5175 >> uint(22)) + _5531)) + 3u];
            _5723._m4 = _5581._m0[(uint(_5722) * ((_5175 >> uint(22)) + _5531)) + 4u];
            vec4 _5779 = vec4((_5523.x * _5723._m0.x) + ((_5523.y * _5723._m0.y) + ((_5523.z * _5723._m0.z) + _5723._m0.w)), (_5523.x * _5723._m1.x) + ((_5523.y * _5723._m1.y) + ((_5523.z * _5723._m1.z) + _5723._m1.w)), (_5523.x * _5723._m2.x) + ((_5523.y * _5723._m2.y) + ((_5523.z * _5723._m2.z) + _5723._m2.w)), (_5523.x * _5723._m3.x) + ((_5523.y * _5723._m3.y) + ((_5523.z * _5723._m3.z) + _5723._m3.w)));
            vec3 _5866 = _5779.xyz / vec3(_5779.w);
            _5779 = vec4(_5866.x, _5866.y, _5866.z, _5779.w);
            bool _5874 = min(_5779.x, _5779.y) > 0.0;
            bool _5883;
            if (_5874)
            {
                _5883 = max(_5779.x, _5779.y) < 1.0;
            }
            else
            {
                _5883 = _5874;
            }
            if (_5883)
            {
                vec2 _5895 = (_5779.xy * _5723._m4.xy) + _5723._m4.zw;
                _5779 = vec4(_5895.x, _5895.y, _5779.z, _5779.w);
                if (false)
                {
                    _5514 = textureLod(sampler2DShadow(_5902, _5904), vec3(_5779.xyz.xy, _5779.xyz.z), 0.0);
                }
                else
                {
                    vec2 _5913 = (_5779.xy * _802._m28.xy) + vec2(0.5);
                    vec2 _5922 = floor(_5913);
                    vec2 _5925 = _5913 - _5922;
                    _5922 -= vec2(0.5);
                    vec2 _5932 = vec2(4.0) - (_5925 * 3.0);
                    vec2 _5937 = vec2(7.0);
                    vec2 _5940 = vec2(1.0) + (_5925 * 3.0);
                    vec2 _5945 = (_5922 + (((vec2(3.0) - (_5925 * 2.0)) / _5932) - vec2(2.0))) * _802._m28.zw;
                    vec2 _5960 = (_5922 + ((vec2(3.0) + _5925) / _5937)) * _802._m28.zw;
                    vec2 _5972 = (_5922 + ((_5925 / _5940) + vec2(2.0))) * _802._m28.zw;
                    vec3 _5998 = vec3(_5945.x, _5945.y, _5779.z);
                    _5514 = (_5932.x * _5932.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_5998.xy, _5998.z), 0.0);
                    vec3 _6016 = vec3(_5960.x, _5945.y, _5779.z);
                    _5514 += ((_5937.x * _5932.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6016.xy, _6016.z), 0.0));
                    vec3 _6036 = vec3(_5972.x, _5945.y, _5779.z);
                    _5514 += ((_5940.x * _5932.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6036.xy, _6036.z), 0.0));
                    vec3 _6056 = vec3(_5945.x, _5960.y, _5779.z);
                    _5514 += ((_5932.x * _5937.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6056.xy, _6056.z), 0.0));
                    vec3 _6076 = vec3(_5960.x, _5960.y, _5779.z);
                    _5514 += ((_5937.x * _5937.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6076.xy, _6076.z), 0.0));
                    vec3 _6096 = vec3(_5972.x, _5960.y, _5779.z);
                    _5514 += ((_5940.x * _5937.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6096.xy, _6096.z), 0.0));
                    vec3 _6116 = vec3(_5945.x, _5972.y, _5779.z);
                    _5514 += ((_5932.x * _5940.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6116.xy, _6116.z), 0.0));
                    vec3 _6136 = vec3(_5960.x, _5972.y, _5779.z);
                    _5514 += ((_5937.x * _5940.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6136.xy, _6136.z), 0.0));
                    vec3 _6156 = vec3(_5972.x, _5972.y, _5779.z);
                    _5514 += ((_5940.x * _5940.y) * textureLod(sampler2DShadow(_5902, _5904), vec3(_6156.xy, _6156.z), 0.0));
                    _5514 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _5514 = float((_5175 & 7u) == 2u);
                if ((_5175 & 7u) == 2u)
                {
                    _1056._m36 = -1;
                }
            }
            float _6176 = float((_5175 >> uint(16)) & 63u) / 63.0;
            float _6190 = ((_5514 * _6176) + 1.0) - _6176;
            _5514 = _10(_6190);
        }
        if (_5514 <= _5174)
        {
            continue;
        }
        vec3 _6198 = (_5060._m12 * _5514) * _5292;
        float _6205 = _5060._m13;
        vec3 _6208 = _6198;
        float _6215 = dot(_1056._m6, _5183);
        float _6210 = _10(_6215);
        float _6217 = 1.0;
        vec3 _6219 = _1056._m6;
        vec3 _6222 = _1056._m14;
        vec3 _6225 = _5183;
        vec3 _6227 = _1056._m2;
        float _6230 = _1056._m3;
        vec3 _6218 = _109(_6219, _6222, _6225, _6227, _6230);
        _1056._m21 += ((((_6218 * _6205) * _6208) * _6210) * _6217);
        vec3 _6247 = _6208;
        uint _6250 = _1056._m4;
        vec4 _6249 = _93(_6250);
        vec3 _6254 = _6249.xyz;
        float _6262 = dot(_1056._m8, _5183);
        float _6257 = _10(_6262);
        vec3 _6264 = vec3(mix(_6210, _6257, _1180._m23), mix(_6210, _6257, _1180._m24), mix(_6210, _6257, _1180._m25));
        float _6293 = dot(_1056._m14, -_5183);
        float _6295 = _10(_6293);
        float _6296 = _1180._m10.w;
        vec3 _6303 = ((_1180._m10.xyz + vec3(_1056._m5)) * _79(_6295, _6296)) * _6254;
        _6264 += _16(_6303);
        float _6307 = _6249.w;
        _6264 = mix(vec3(_6210), _6264, vec3(_6307));
        _1056._m21 += ((_6247 * _6264) * _1056._m0);
    }
    _1056._m21 *= _1056._m11;
    _6333 = vec4(_1056._m21, 0.0);
    if (((_802._m66 & 1u) != 0u) == true)
    {
        vec3 _6348 = _1056._m6;
        bool _6351 = false;
        vec2 _6352 = _190(_6348, _6351);
        _6347 = vec4(_6352, 0.0, 0.0);
        float _6362 = dot(_1056._m14, _1056._m6);
        float _6356 = _10(_6362);
        float _6365 = _6356;
        float _6367 = _1056._m3;
        vec3 _6370 = _1056._m2;
        vec3 _6364 = _115(_6365, _6367, _6370);
        float _6375 = _6364.x;
        float _6379 = _6364.y;
        float _6383 = _6364.z;
        float _6387 = _1056._m3;
        _6374 = vec4(_82(_6375), _82(_6379), _82(_6383), _193(_6387));
    }
}

