#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _106
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2041
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _2573
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _587_589
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    uint _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    uint _m52;
    float _m53[3];
} _589;

layout(set = 2, binding = 0, std140) uniform _884_886
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    uint _m16;
    float _m17[2];
} _886;

layout(set = 1, binding = 0, std140) uniform _895_897
{
    int _m0;
    float _m1;
    float _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
} _897;

layout(set = 3, binding = 0, std140) uniform _935_937
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _937;

layout(set = 0, binding = 21, std430) restrict readonly buffer _1976_1978
{
    uint _m0[];
} _1978;

layout(set = 0, binding = 22, std140) uniform _2046_2048
{
    vec4 _m0[4096];
} _2048;

layout(set = 0, binding = 23, std140) uniform _2122_2124
{
    vec4 _m0[4096];
} _2124;

layout(set = 0, binding = 24, std140) uniform _2578_2580
{
    vec4 _m0[4095];
} _2580;

layout(set = 0, binding = 1, std140) uniform _3396_3398
{
    vec4 _m0[64];
} _3398;

layout(push_constant, std430) uniform _3392_3394
{
    int _m0;
    int _m1;
} _3394;

layout(set = 3, binding = 1) uniform TEXTURE_2D _978[5];
layout(set = 0, binding = 11) uniform sampler _986;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1004[5];
layout(set = 0, binding = 12) uniform sampler _1009;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1016[5];
layout(set = 0, binding = 13) uniform sampler _1021;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1038[5];
layout(set = 0, binding = 14) uniform sampler _1043;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1050[5];
layout(set = 0, binding = 15) uniform sampler _1055;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1062[5];
layout(set = 0, binding = 16) uniform sampler _1067;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1074[5];
layout(set = 0, binding = 17) uniform sampler _1079;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1168[5];
layout(set = 0, binding = 18) uniform sampler _1173;
layout(set = 0, binding = 19) uniform TEXTURE_2D _1567;
layout(set = 0, binding = 20) uniform sampler _1569;
layout(set = 4, binding = 0) uniform TEXTURE_2D _2398[34816];
layout(set = 0, binding = 25) uniform texture2D _2901;
layout(set = 0, binding = 26) uniform samplerShadow _2903;
layout(set = 0, binding = 7) uniform texture3D _3401;
layout(set = 0, binding = 8) uniform sampler _3402;
layout(set = 0, binding = 9) uniform texture3D _3403;
layout(set = 0, binding = 10) uniform sampler _3404;

layout(location = 17, component = 3) in float _765;
layout(location = 18, component = 0) in float _767;
layout(location = 18, component = 1) in float _772;
layout(location = 18, component = 2) in float _774;
layout(location = 18, component = 3) in float _776;
layout(location = 19, component = 0) in float _804;
layout(location = 19, component = 1) in float _806;
layout(location = 19, component = 2) in float _808;
layout(location = 19, component = 3) in float _812;
layout(location = 20, component = 0) in float _814;
layout(location = 20, component = 1) in float _816;
layout(location = 20, component = 2) in float _828;
layout(location = 10, component = 0) in vec4 _853;
layout(location = 11, component = 0) in vec4 _856;
layout(location = 12, component = 0) in vec4 _859;
layout(location = 0, component = 0) out vec4 _3332;
layout(location = 1, component = 0) out vec4 _3347;
layout(location = 2, component = 0) out vec4 _3374;
uint _150;
uint _152;
uint _154;
uint _156;
uint _158;
uint _160;
uint _162;
uint _163;
uint _165;
uint _166;
uint _168;
uint _170;
uint _172;
uint _174;
uint _176;
uint _178;
uint _180;
uint _182;
uint _184;

_106 _108()
{
    _106 _478;
    _478._m0 = vec3(0.0);
    _478._m2 = vec3(0.0);
    _478._m3 = 0.0;
    _478._m4 = 0u;
    _478._m5 = 0.0;
    _478._m6 = vec3(0.0);
    _478._m7 = vec3(0.0, 0.0, 1.0);
    _478._m8 = vec3(0.0, 0.0, 1.0);
    _478._m1 = vec3(0.0);
    _478._m9 = 1.0;
    _478._m10 = 1.0;
    _478._m14 = vec3(0.0);
    _478._m15 = vec3(0.0);
    _478._m16 = vec4(0.0);
    _478._m17 = vec4(0.0);
    _478._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _478._m19 = vec3(0.0);
    _478._m20 = vec3(0.0);
    _478._m21 = vec3(0.0);
    _478._m22 = vec3(0.0);
    _478._m23 = vec3(0.0);
    _478._m24 = vec3(0.0);
    _478._m25 = 1.0;
    _478._m26 = uvec4(0u);
    _478._m27 = uvec4(0u);
    _478._m28 = uvec4(0u);
    _478._m29 = vec4(0.0);
    _478._m30 = vec4(0.0);
    _478._m31 = vec4(0.0);
    _478._m32 = vec4(0.0);
    _478._m33 = uvec2(0u);
    _478._m34 = vec2(0.0);
    _478._m35 = 0.0;
    _478._m36 = -1;
    _478._m37 = 0;
    _478._m38 = vec2(0.0);
    _478._m39 = 1.0;
    _478._m41 = -1;
    _478._m45 = 1.0;
    _478._m11 = 1.0;
    _478._m12 = 0u;
    _478._m13 = uvec3(0u);
    _478._m40 = vec3(0.0);
    _478._m46 = 0.0;
    _478._m47 = 1.0;
    return _478;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _75(inout vec4 _74)
{
    vec4 _298 = _74;
    _74 = _22(_298);
    return packUnorm4x8(_74.wzyx);
}

vec2 _120(vec2 _119)
{
    return ((_119 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _125(inout vec2 _123, bool _124)
{
    vec2 _622 = _123;
    _123 = _120(_622);
    float _643 = (1.0 - (_123.x * _123.x)) - (_123.y * _123.y);
    vec3 _625 = vec3(_123.x, _123.y, sqrt(_10(_643)));
    if (_124 == false)
    {
        _625.z = -_625.z;
    }
    return _625;
}

vec3 _57(mat3 _55, vec3 _56)
{
    return _55 * _56;
}

vec3 _130(vec3 _128, mat3 _129)
{
    mat3 _659 = _129;
    vec3 _661 = _128;
    return normalize(_57(_659, _661));
}

vec3 _136(vec2 _133, mat3 _134, bool _135)
{
    vec2 _668 = _133;
    bool _670 = _135;
    vec3 _672 = _125(_668, _670);
    vec3 _667 = _672;
    vec3 _673 = _667;
    mat3 _675 = _134;
    return _130(_673, _675);
}

float _115(inout float _113, bool _114)
{
    if (_114)
    {
        _113 += (float(_113 < _589._m16) * _589._m17);
    }
    float _602 = _113;
    return _589._m0.w / (_10(_602) + _589._m0.z);
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

vec4 _80(uint _79)
{
    return unpackUnorm4x8(_79).wzyx;
}

float _38(float _35, float _36, float _37)
{
    return min(_35, min(_36, _37));
}

float _33(float _30, float _31, float _32)
{
    return max(_30, max(_31, _32));
}

float _50(float _49)
{
    return _49 * _49;
}

vec3 _47(vec3 _46)
{
    return _46 * _46;
}

uint _44(float _41, float _42, float _43)
{
    bool _226 = abs(_43) >= abs(_41);
    bool _234;
    if (_226)
    {
        _234 = abs(_43) >= abs(_42);
    }
    else
    {
        _234 = _226;
    }
    if (_234)
    {
        return uint((_43 < 0.0) ? 5 : 4);
    }
    if (abs(_42) >= abs(_41))
    {
        return uint((_42 < 0.0) ? 3 : 2);
    }
    return uint(int(_41 < 0.0));
}

float _65(float _63, float _64)
{
    return pow(_63, _64);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _85(vec3 _83, float _84)
{
    float _316 = dot(_83, vec3(16.666500091552734375));
    float _311 = _10(_316);
    float _325 = 1.0 - _84;
    float _328 = _10(_325);
    float _329 = 5.0;
    vec3 _333 = _83 + ((vec3(_311) - _83) * _65(_328, _329));
    return _16(_333);
}

vec3 _93(vec3 _88, vec3 _89, vec3 _90, vec3 _91, float _92)
{
    float _341 = dot(_88, _89);
    float _337 = _10(_341);
    vec3 _343 = normalize(_89 + _90);
    float _352 = dot(_88, _343);
    float _348 = _10(_352);
    float _358 = dot(_90, _343);
    float _354 = _10(_358);
    vec3 _361 = _91;
    float _363 = _354;
    vec3 _360 = _85(_361, _363);
    float _370 = dot(_88, _90);
    float _366 = _10(_370);
    float _372 = 1.0 - (_92 * 0.800000011920928955078125);
    _372 *= _372;
    _372 *= _372;
    float _383 = _372 * _372;
    float _387 = ((_348 * _348) * (_383 - 1.0)) + 1.0;
    _387 = _383 / ((_387 * _387) + 9.9999999392252902907785028219223e-09);
    float _402 = (_337 * (1.0 - _372)) + _372;
    float _409 = (_366 * (1.0 - _372)) + _372;
    _387 /= (((4.0 * _402) * _409) + 9.9999999392252902907785028219223e-09);
    return _360 * _387;
}

vec2 _139(vec2 _138)
{
    return (vec2(1.0) - abs(_138.yx)) * vec2((_138.x >= 0.0) ? 1.0 : (-1.0), (_138.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _144(inout vec3 _142, bool _143)
{
    _142 /= vec3((abs(_142.x) + abs(_142.y)) + abs(_142.z));
    vec2 _715;
    if (_142.z >= 0.0)
    {
        _715 = _142.xy;
    }
    else
    {
        vec2 _721 = _142.xy;
        _715 = _139(_721);
    }
    _142 = vec3(_715.x, _715.y, _142.z);
    if (_143)
    {
        vec2 _736 = (_142.xy * 0.5) + vec2(0.5);
        _142 = vec3(_736.x, _736.y, _142.z);
    }
    return _142.xy;
}

float _60(float _59)
{
    return exp2(_59);
}

vec3 _99(float _96, float _97, vec3 _98)
{
    float _429 = 0.0949999988079071044921875 + (_97 * (0.60000002384185791015625 + (4.190000057220458984375 * _97)));
    float _439 = _96 + 0.02500000037252902984619140625;
    float _443 = (9.5 * _97) * _96;
    float _457 = 1.0 - (14.0 * _96);
    float _449 = (_429 * _439) * _60(_457);
    float _464 = -_443;
    float _460 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _60(_464)));
    return mix(vec3(_449), vec3(_460), _98);
}

float _68(float _67)
{
    return sqrt(_67);
}

float _71(float _70)
{
    return sqrt(_70);
}

float _147(float _146)
{
    float _746 = abs(_146);
    float _743 = _71(_746);
    float _750;
    if (_146 > 0.0)
    {
        _750 = _743;
    }
    else
    {
        _750 = -_743;
    }
    return (_750 * 0.5) + 0.5;
}

void main()
{
    _150 = 2147483648u;
    _152 = 1073741824u;
    _154 = 0u;
    _156 = 268435456u;
    _158 = 536870912u;
    _160 = 805306368u;
    _162 = 1073741824u;
    _163 = 1342177280u;
    _165 = 0u;
    _166 = 16777216u;
    _168 = 33554432u;
    _170 = 50331648u;
    _172 = 67108864u;
    _174 = 83886080u;
    _176 = 100663296u;
    _178 = 117440512u;
    _180 = 134217728u;
    _182 = 150994944u;
    _184 = 167772160u;
    _106 _762 = _108();
    _762._m16 = vec4(0.0, 0.0, _765, _767);
    vec3 _771 = vec3(_772, _774, _776);
    _762._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _762._m15 = vec3(_589._m27, _589._m28, _589._m29) + _771;
    vec3 _802 = vec3(0.0);
    vec3 _803 = vec3(0.0);
    _802 = normalize(vec3(_804, _806, _808));
    _803 = normalize(vec3(_812, _814, _816));
    vec3 _820 = _802;
    vec3 _822 = _803;
    vec3 _824 = normalize(cross(_820, _822) * _828);
    _762._m18 = mat3(vec3(_822), vec3(_824), vec3(_820));
    _762._m14 = normalize(-_771);
    _762._m29 = _853;
    _762._m30 = _856;
    _762._m31 = _859;
    uint _862 = 0u;
    vec4 _863 = vec4(0.0);
    vec4 _864 = vec4(0.0);
    vec4 _865 = vec4(0.0);
    vec4 _866 = vec4(0.0);
    vec4 _867 = vec4(0.0);
    float _868 = 0.0;
    uvec2 _869 = uvec2(0u, 65535u);
    vec2 _872 = _762._m16.zw;
    vec2 _876 = _872;
    vec2 _878 = _872;
    float _880 = 0.0009765625;
    vec3 _892;
    if ((_886._m16 & 1u) != 0u)
    {
        _892 = vec3(_897._m2, _897._m3, _897._m4);
    }
    else
    {
        _892 = vec3(1.0);
    }
    vec3 _882 = _892;
    float _908 = 1.0;
    float _909 = _897._m5;
    bool _912 = _909 > 0.0;
    float _915 = 1.0;
    uint _916 = _869.x;
    uint _919 = _916 & 7u;
    uint _923 = _919;
    uint _925 = _923;
    float _927 = 0.0;
    vec2 _928 = _876;
    _928.x *= _937._m1[_925].w;
    _928.y *= _937._m2[_925].x;
    _928.x += (_589._m45 * _937._m2[_925].y);
    _928.y += (_589._m45 * _937._m2[_925].z);
    vec2 _972 = _928;
    uint _980 = _925;
    vec3 _974 = (SAMPLE_TEXTURE(SAMPLER_2D(_978[nonuniformEXT(_980)], _986), _972).xyz * vec3(_937._m0[_925].x)) + vec3(_937._m0[_925].y);
    uint _1006 = _925;
    vec2 _1003 = SAMPLE_TEXTURE(SAMPLER_2D(_1004[nonuniformEXT(_1006)], _1009), _972).xy;
    uint _1018 = _925;
    vec3 _1015 = (SAMPLE_TEXTURE(SAMPLER_2D(_1016[nonuniformEXT(_1018)], _1021), _972).xyz * vec3(_937._m0[_925].z)) + vec3(_937._m0[_925].w);
    uint _1040 = _925;
    float _1037 = SAMPLE_TEXTURE(SAMPLER_2D(_1038[nonuniformEXT(_1040)], _1043), _972).x;
    uint _1052 = _925;
    float _1049 = SAMPLE_TEXTURE(SAMPLER_2D(_1050[nonuniformEXT(_1052)], _1055), _972).x;
    uint _1064 = _925;
    vec3 _1061 = SAMPLE_TEXTURE(SAMPLER_2D(_1062[nonuniformEXT(_1064)], _1067), _972).xyz;
    uint _1076 = _925;
    float _1073 = SAMPLE_TEXTURE(SAMPLER_2D(_1074[nonuniformEXT(_1076)], _1079), _972).x;
    _863 = vec4(_974.x, _974.y, _974.z, _863.w);
    _863.w = 0.0;
    _864 = vec4(_1015.x, _1015.y, _1015.z, _864.w);
    _864.w = _1049;
    _865 = vec4(_1003.x, _1003.y, _865.z, _865.w);
    _866.x = 0.0;
    _866.y = _927;
    _866.z = _1049;
    _866.w = _1037;
    _868 = _1073;
    _915 = _937._m1[_925].x;
    vec3 _1114 = _1061 * _937._m3[_925].xyz;
    _867 = vec4(_1114.x, _1114.y, _1114.z, _867.w);
    float _1117 = _912 ? _909 : _915;
    vec3 _1126 = _867.xyz * vec3(_1117);
    _867 = vec4(_1126.x, _1126.y, _1126.z, _867.w);
    vec2 _1129 = vec2(0.0);
    _762._m22 = _867.xyz * _882;
    vec3 _1135 = vec3(0.0);
    vec3 _1136 = vec3(0.0);
    float _1137 = 0.0;
    uint _1138 = 0u;
    uint _1139 = _1138 & 7u;
    uint _1142 = _1139;
    uint _1144 = _1142;
    vec4 _1146 = vec4(_872, 0.0, _886._m10);
    uint _1154 = _1144;
    vec2 _1164 = SAMPLE_TEXTURE1(SAMPLER_2D(_1004[nonuniformEXT(_1154)], _1009), _1146.xy, _1146.w).xy;
    _1135 = vec3(_1164.x, _1164.y, _1135.z);
    uint _1170 = _1144;
    vec4 _1167 = SAMPLE_TEXTURE1(SAMPLER_2D(_1168[nonuniformEXT(_1170)], _1173), _1146.xy, _1146.w);
    _1136 = _1167.xyz;
    _1137 = _1167.w;
    _762._m8 = _1135;
    float _1192 = _1137 * _886._m11;
    float _1187 = _10(_1192);
    vec4 _1200 = vec4(_1136, _1187);
    uint _1201 = _75(_1200);
    _762._m4 = _1201;
    float _1208 = (1.0 - _1187) * _886._m12;
    _762._m10 = _10(_1208);
    _762._m0 = _863.xyz;
    _762._m2 = _864.xyz;
    _762._m1 = _867.xyz;
    _762._m3 = _866.w;
    _762._m6 = _865.xyz;
    int _1226 = 0;
    int _1228 = _1226;
    _762._m22 = SAMPLE_TEXTURE(SAMPLER_2D(_1062[nonuniformEXT(_1228)], _1067), (vec2(_765, _767) * _886._m1.xy) + (_886._m1.zw * vec2(_589._m45))).xyz;
    uint _1251 = 0u;
    bool _1252 = true;
    vec2 _1254 = _762._m6.xy;
    bool _1258 = _1252;
    vec3 _1260 = _125(_1254, _1258);
    _762._m7 = _1260;
    vec2 _1262 = _762._m6.xy;
    mat3 _1266 = _762._m18;
    bool _1269 = _1252;
    _762._m6 = _136(_1262, _1266, _1269);
    vec2 _1273 = _762._m8.xy;
    mat3 _1277 = _762._m18;
    bool _1280 = _1252;
    _762._m8 = _136(_1273, _1277, _1280);
    uvec2 _1284 = uvec2(_762._m17.xy);
    uint _1289 = _1284.x / 256u;
    uint _1294 = _1284.y / 256u;
    float _1299 = _762._m17.z;
    bool _1302 = false;
    float _1303 = _115(_1299, _1302);
    float _1298 = _1303;
    float _1304 = log2(max(1.0, _1298 / _589._m6.z)) * _589._m6.w;
    uint _1314 = min(23u, uint(_1304));
    float _1320 = _589._m46;
    float _1325 = _589._m47;
    uint _1319 = (_27(_1320) + ((_1289 + (_27(_1325) * _1294)) * 24u)) + _1314;
    uvec2 _1337 = uvec2(_762._m17.xy);
    uint _1342 = _1337.x / 32u;
    uint _1347 = _1337.y / 32u;
    float _1355 = _589._m48;
    uint _1351 = _1342 + (_1347 * _27(_1355));
    float _1362 = _897._m6;
    uint _1361 = _27(_1362);
    _762._m21 = _762._m22;
    _762._m25 = 1.0;
    float _1370 = _589._m7.w;
    bool _1373 = _1370 < 0.0;
    _1370 = abs(_1370);
    vec3 _1378 = _762._m15;
    float _1397 = (1.0 - (length(_1378 - vec3(_589._m27, _589._m28, _589._m29)) / _1370)) / 0.25;
    float _1381 = _10(_1397);
    if ((!_1373) && (_1381 > 0.0))
    {
        vec3 _1406 = _589._m7.xyz;
        vec3 _1410 = _589._m8.xyz;
        float _1414 = _1378.z - _1410.z;
        float _1420 = _589._m9.w;
        float _1423 = _589._m10.w;
        float _1426 = float(_1423 < 0.0);
        _1423 = abs(_1423) - 1.0;
        bool _1433 = _1414 <= 0.0;
        float _1436 = 3.5 * float(!(_1423 == 0.0));
        float _1445;
        if (!(_1420 == 0.0))
        {
            _1445 = _1406.z;
        }
        else
        {
            _1445 = _1410.z;
        }
        float _1442 = _1445;
        float _1454 = min(_1433 ? 2.0 : 1000.0, abs(_1414));
        float _1462 = max(_1406.x - _1378.x, _1378.x - _1410.x);
        float _1474 = max(_1406.y - _1378.y, _1378.y - _1410.y);
        float _1486 = max(_1462, _1474) - _1454;
        _1486 = max(_1486, _1442 - _1378.z);
        _1486 = max(_1486, _1414 - _1436);
        if (_1486 <= 0.0)
        {
            float _1507 = _1433 ? _1420 : _1423;
            vec2 _1512 = _762._m18[2].xy;
            float _1516 = length(_1512);
            vec3 _1519 = vec3(_1512, (-1.73205077648162841796875) * _1516);
            _1519 /= vec3(2.0 * _1516);
            vec3 _1532 = _589._m10.xyz;
            vec3 _1536 = mix(_1519, _1532, bvec3(_1433));
            vec2 _1543 = _1378.xy - (_1536.xy * (_1414 / _1536.z));
            float _1554 = (_589._m49 / 100.0) * 16.0;
            vec2 _1562 = _1543 * _1554;
            float _1566 = TEXTURE_LOD(SAMPLER_2D(_1567, _1569), vec4(_1562, 0.0, 0.0).xy, vec4(_1562, 0.0, 0.0).w).x;
            float _1584 = min(8.0, _1410.z - _1406.z);
            float _1597 = (-_1414) / _1584;
            float _1592 = _10(_1597);
            float _1604 = dot(_762._m6, _1536);
            float _1599 = _10(_1604);
            float _1610 = _1462 / _1454;
            float _1606 = 1.0 - _10(_1610);
            float _1616 = _1474 / _1454;
            _1606 *= (1.0 - _10(_1616));
            _1606 *= _1606;
            float _1632 = min(_1414 / 1.0, 1.0 - (_1414 / _1436));
            float _1624 = _10(_1632);
            _1606 *= max(_1624, _1592);
            _1606 *= _1606;
            _1606 *= _1381;
            float _1645 = _1566 - 1.0;
            float _1648 = float(_1433) * _1426;
            float _1653 = max(0.0, _1566 - 0.85000002384185791015625);
            float _1658 = _1433 ? _1645 : _1653;
            float _1663 = (((1.0 - _1648) * _1599) * _1606) * _1507;
            vec3 _1672 = _762._m0 + (_762._m2 * (vec3(1.0) - _762._m0));
            _762._m21 += ((_1672 * (_1658 * _1663)) * _589._m9.xyz);
            float _1696 = _1648 * _1606;
            _762._m25 = 1.0 + (_1696 * (_1566 - 1.0));
        }
    }
    else
    {
        if (_1381 > 0.0)
        {
            _1381 *= _589._m50;
            float _1716 = float(_589._m10.w < 0.0);
            vec3 _1721 = _589._m10.xyz;
            float _1730 = dot(_762._m6, _1721);
            float _1725 = _10(_1730);
            vec2 _1732 = _1378.xy - (_1721.xy * (_1378.z / _1721.z));
            float _1744 = (_589._m49 / 100.0) * 16.0;
            vec2 _1749 = _1732 * _1744;
            float _1753 = TEXTURE_LOD(SAMPLER_2D(_1567, _1569), vec4(_1749, 0.0, 0.0).xy, vec4(_1749, 0.0, 0.0).w).x;
            vec4 _1769 = _589._m9;
            _762._m21 += (_1769.xyz * (((((1.0 - _1716) * (_1753 - 1.0)) * _1725) * _1381) * _1769.w));
            _762._m25 = 1.0 + ((_1716 * (_1753 - 1.0)) * _1381);
        }
    }
    _762._m14 = normalize(vec3(_589._m27, _589._m28, _589._m29) - _762._m15);
    vec3 _1811 = vec3(0.0);
    vec3 _1812 = vec3(0.0);
    vec3 _1813 = vec3(0.0);
    vec3 _1814 = vec3(0.0);
    vec3 _1815 = vec3(0.0);
    vec4 _1816 = _762._m29;
    vec4 _1819 = _762._m30;
    vec4 _1822 = _762._m31;
    _1812 = vec3(_1816.x, _1816.y, _1816.z);
    _1813 = vec3(_1816.w, _1819.x, _1819.y);
    _1814 = vec3(_1819.z, _1819.w, _1822.x);
    _1815 = vec3(_1822.y, _1822.z, _1822.w);
    vec3 _1853 = ((_1812 - (_1813 * _762._m6.y)) + (_1814 * _762._m6.z)) - (_1815 * _762._m6.x);
    float _1877 = _897._m7 * _589._m51;
    _1811 += (max(vec3(0.0), _1853 * _10(_1877)) * _762._m0);
    vec3 _1886 = vec3(0.0);
    vec3 _1887 = vec3(0.0);
    vec3 _1888 = vec3(0.0);
    vec3 _1889 = vec3(0.0);
    vec3 _1890 = vec3(0.0);
    vec4 _1891 = _762._m29;
    vec4 _1894 = _762._m30;
    vec4 _1897 = _762._m31;
    _1887 = vec3(_1891.x, _1891.y, _1891.z);
    _1888 = vec3(_1891.w, _1894.x, _1894.y);
    _1889 = vec3(_1894.z, _1894.w, _1897.x);
    _1890 = vec3(_1897.y, _1897.z, _1897.w);
    vec3 _1928 = ((_1887 - (_1888 * _762._m8.y)) + (_1889 * _762._m8.z)) - (_1890 * _762._m8.x);
    float _1951 = _897._m7 * _589._m51;
    _1886 += (max(vec3(0.0), _1928 * _10(_1951)) * _762._m0);
    uint _1962 = _762._m4;
    _1811 = mix(_1811, _1886, vec3(_80(_1962).w));
    _762._m21 += _1811;
    uint _1974 = _1978._m0[_1319 * 64u];
    uint _1985 = _1974 & 255u;
    uint _1989 = _1978._m0[_1351 * 64u];
    uint _1994 = _1989 & 255u;
    uint _2002;
    uint _2004;
    uint _2006;
    if (_1985 < _1994)
    {
        _2002 = _1985;
        _2004 = _1974;
        _2006 = _1319;
    }
    else
    {
        _2002 = _1994;
        _2004 = _1989;
        _2006 = _1351;
    }
    uint _2012 = 1u;
    _2041 _2043;
    vec3 _2179;
    float _2300;
    vec2 _2370;
    _2573 _2575;
    _2573 _2722;
    while (_2012 <= _2002)
    {
        uint _2021 = (_2006 * 64u) + _2012;
        uint _2026 = _1978._m0[_2021];
        uint _2030 = _2026;
        if (_2030 >= _2026)
        {
            _2012++;
        }
        int _2039 = 4;
        int _2040 = 4;
        _2043._m0 = _2048._m0[(uint(_2039) * _2030) + 0u].xyz;
        float _2063 = _2048._m0[(uint(_2039) * _2030) + 0u].w;
        _2043._m1 = _27(_2063);
        _2043._m2 = _2048._m0[(uint(_2039) * _2030) + 1u].xyz;
        _2043._m3 = _2048._m0[(uint(_2039) * _2030) + 1u].w;
        _2043._m4 = _2048._m0[(uint(_2039) * _2030) + 2u];
        float _2098 = _2048._m0[(uint(_2039) * _2030) + 3u].x;
        _2043._m8 = _27(_2098);
        float _2108 = _2048._m0[(uint(_2039) * _2030) + 3u].y;
        _2043._m9 = _27(_2108);
        _2043._m10 = _2048._m0[(uint(_2039) * _2030) + 3u].z;
        _2043._m5 = _2124._m0[(uint(_2040) * _2030) + 0u];
        _2043._m6 = _2124._m0[(uint(_2040) * _2030) + 1u];
        _2043._m7 = _2124._m0[(uint(_2040) * _2030) + 2u];
        _2043._m12 = _2124._m0[(uint(_2040) * _2030) + 3u].xyz;
        _2043._m13 = _2124._m0[(uint(_2040) * _2030) + 3u].w;
        float _2166 = 0.0;
        uint _2167 = _2043._m1;
        vec3 _2170 = _2043._m0;
        vec3 _2173 = _2170;
        if ((_2167 & 7u) == 2u)
        {
            _2179 = _2173;
        }
        else
        {
            _2179 = normalize(_2170 - _762._m15);
        }
        vec3 _2175 = _2179;
        uint _2190 = uint(((_1361 & 3u) != 0u) ? 16 : 0);
        _2190 |= 32u;
        if ((_2167 & _2190) != 0u)
        {
            continue;
        }
        vec3 _2205 = vec3(dot(_762._m15, _2043._m5.xyz) + _2043._m5.w, dot(_762._m15, _2043._m6.xyz) + _2043._m6.w, dot(_762._m15, _2043._m7.xyz) + _2043._m7.w);
        vec2 _2239 = _2205.xy / vec2(_2205.z);
        _2205 = vec3(_2239.x, _2239.y, _2205.z);
        _2205.z = dot(_762._m15, _2043._m4.xyz) + _2043._m4.w;
        float _2252 = _2205.x;
        float _2255 = _2205.y;
        float _2258 = _2205.z;
        bool _2263 = _38(_2252, _2255, _2258) <= _2166;
        bool _2280;
        if (!_2263)
        {
            float _2267 = _2205.x;
            float _2270 = _2205.y;
            float _2273 = _2205.z;
            _2280 = _33(_2267, _2270, _2273) >= (1.0 - _2166);
        }
        else
        {
            _2280 = _2263;
        }
        if (_2280)
        {
            continue;
        }
        vec3 _2284 = vec3(1.0);
        uint _2285 = _2167 & 7u;
        vec3 _2288 = _2043._m0 - _762._m15;
        float _2294 = dot(_2288, _2288);
        if (_2285 != 2u)
        {
            _2300 = 1.0 / (1.0 + _2294);
        }
        else
        {
            _2300 = _762._m25;
        }
        _2284 = vec3(_2300);
        if (_2285 == 0u)
        {
            float _2320 = _2294 * _2043._m3;
            float _2323 = 1.0 - _50(_2320);
            float _2325 = _10(_2323);
            float _2315 = _50(_2325);
            _2284 *= _2315;
        }
        else
        {
            if (_2285 == 4u)
            {
                float _2343 = length((_2205.xy - vec2(0.5)) * 2.0);
                float _2336 = _10(_2343);
                float _2345 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_2336 * 7.80000019073486328125))));
                _2284 *= _2345;
            }
            else
            {
                if ((_2285 == 1u) || (_2285 == 2u))
                {
                    if (_2285 == 2u)
                    {
                        _2370 = fract((_2205.xy * _589._m11.xy) + _589._m11.zw);
                    }
                    else
                    {
                        _2370 = _2205.xy;
                    }
                    vec2 _2367 = _2370;
                    vec3 _2388 = vec3(0.0);
                    uint _2389 = bitfieldExtract(_2043._m8, 0, 20);
                    uint _2393 = _2389;
                    uint _2401 = _2393 + 0u;
                    vec3 _2417 = TEXTURE_LOD(SAMPLER_2D(_2398[nonuniformEXT(_2401)], _1043), vec4(_2367, 0.0, 0.0).xy, vec4(_2367, 0.0, 0.0).w).xyz;
                    _2388 = _47(_2417);
                    _2284 *= _2388;
                }
            }
        }
        float _2423 = float((_2167 >> uint(8)) & 255u) / 255.0;
        if ((_2285 == 0u) || (_2285 == 2u))
        {
            vec3 _2436 = abs((_2205 * 2.0) - vec3(1.0));
            float _2442 = _2436.x;
            float _2445 = _2436.y;
            float _2448 = _2436.z;
            float _2453 = 1.0 - _33(_2442, _2445, _2448);
            float _2458 = _10(_2453) / (9.9999999392252902907785028219223e-09 + _2423);
            float _2441 = _10(_2458);
            _2284 *= ((_2441 * _2441) * (3.0 - (2.0 * _2441)));
        }
        else
        {
            if ((_2285 == 1u) || (_2285 == 4u))
            {
                float _2479 = _2205.z;
                float _2483 = _50(_2479);
                float _2486 = 1.0 - _50(_2483);
                float _2488 = _10(_2486);
                float _2493 = _50(_2488) / (9.9999999392252902907785028219223e-09 + _2423);
                float _2478 = _10(_2493);
                _2284 *= _2478;
            }
        }
        float _2498 = _2284.x;
        float _2501 = _2284.y;
        float _2504 = _2284.z;
        if (_33(_2498, _2501, _2504) <= _2166)
        {
            continue;
        }
        float _2513 = 1.0;
        if ((_2167 & 8u) != 0u)
        {
            float _2520 = 0.00200000009499490261077880859375;
            vec3 _2522 = _762._m15 + (_762._m6 * _2520);
            uint _2530 = 0u;
            if ((_2167 & 7u) == 0u)
            {
                vec3 _2536 = _2522 - _2043._m2;
                float _2541 = _2536.x;
                float _2544 = _2536.y;
                float _2547 = _2536.z;
                _2530 = _44(_2541, _2544, _2547);
            }
            else
            {
                if ((_2167 & 7u) == 2u)
                {
                    float _2557 = 0.0;
                    uint _2558 = uint((_589._m12.w > 0.0) ? 3 : 4);
                    for (; _2530 < _2558; _2530++)
                    {
                        int _2572 = 5;
                        _2575._m0 = _2580._m0[(uint(_2572) * ((_2167 >> uint(22)) + _2530)) + 0u];
                        _2575._m1 = _2580._m0[(uint(_2572) * ((_2167 >> uint(22)) + _2530)) + 1u];
                        _2575._m2 = _2580._m0[(uint(_2572) * ((_2167 >> uint(22)) + _2530)) + 2u];
                        _2575._m3 = _2580._m0[(uint(_2572) * ((_2167 >> uint(22)) + _2530)) + 3u];
                        _2575._m4 = _2580._m0[(uint(_2572) * ((_2167 >> uint(22)) + _2530)) + 4u];
                        vec2 _2636 = vec2(dot(_2522, _2575._m0.xyz) + _2575._m0.w, dot(_2522, _2575._m1.xyz) + _2575._m1.w);
                        _2636 = abs((_2636 * 2.0) - vec2(1.0));
                        bool _2662 = _2636.x < 0.9900000095367431640625;
                        bool _2668;
                        if (_2662)
                        {
                            _2668 = _2636.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _2668 = _2662;
                        }
                        if (_2668)
                        {
                            _2557 = (1.0 - max(_2636.x, _2636.y)) * _589._m13.w;
                            break;
                        }
                    }
                    _762._m36 = int(_2530);
                    _2530 = min((_2558 - 1u), _2530);
                    if (_589._m12.w > 0.0)
                    {
                        uint _2695 = uint(_762._m17.x) ^ (uint(_762._m17.y) << uint(1));
                        _2695 ^= uint(_589._m14.x);
                        _2530 += uint(int(((float(_2695 & 3u) * 0.25) + 0.125) > _2557));
                    }
                }
            }
            int _2721 = 5;
            _2722._m0 = _2580._m0[(uint(_2721) * ((_2167 >> uint(22)) + _2530)) + 0u];
            _2722._m1 = _2580._m0[(uint(_2721) * ((_2167 >> uint(22)) + _2530)) + 1u];
            _2722._m2 = _2580._m0[(uint(_2721) * ((_2167 >> uint(22)) + _2530)) + 2u];
            _2722._m3 = _2580._m0[(uint(_2721) * ((_2167 >> uint(22)) + _2530)) + 3u];
            _2722._m4 = _2580._m0[(uint(_2721) * ((_2167 >> uint(22)) + _2530)) + 4u];
            vec4 _2778 = vec4((_2522.x * _2722._m0.x) + ((_2522.y * _2722._m0.y) + ((_2522.z * _2722._m0.z) + _2722._m0.w)), (_2522.x * _2722._m1.x) + ((_2522.y * _2722._m1.y) + ((_2522.z * _2722._m1.z) + _2722._m1.w)), (_2522.x * _2722._m2.x) + ((_2522.y * _2722._m2.y) + ((_2522.z * _2722._m2.z) + _2722._m2.w)), (_2522.x * _2722._m3.x) + ((_2522.y * _2722._m3.y) + ((_2522.z * _2722._m3.z) + _2722._m3.w)));
            vec3 _2865 = _2778.xyz / vec3(_2778.w);
            _2778 = vec4(_2865.x, _2865.y, _2865.z, _2778.w);
            bool _2873 = min(_2778.x, _2778.y) > 0.0;
            bool _2882;
            if (_2873)
            {
                _2882 = max(_2778.x, _2778.y) < 1.0;
            }
            else
            {
                _2882 = _2873;
            }
            if (_2882)
            {
                vec2 _2894 = (_2778.xy * _2722._m4.xy) + _2722._m4.zw;
                _2778 = vec4(_2894.x, _2894.y, _2778.z, _2778.w);
                if (false)
                {
                    _2513 = textureLod(sampler2DShadow(_2901, _2903), vec3(_2778.xyz.xy, _2778.xyz.z), 0.0);
                }
                else
                {
                    vec2 _2912 = (_2778.xy * _589._m15.xy) + vec2(0.5);
                    vec2 _2921 = floor(_2912);
                    vec2 _2924 = _2912 - _2921;
                    _2921 -= vec2(0.5);
                    vec2 _2931 = vec2(4.0) - (_2924 * 3.0);
                    vec2 _2936 = vec2(7.0);
                    vec2 _2939 = vec2(1.0) + (_2924 * 3.0);
                    vec2 _2944 = (_2921 + (((vec2(3.0) - (_2924 * 2.0)) / _2931) - vec2(2.0))) * _589._m15.zw;
                    vec2 _2959 = (_2921 + ((vec2(3.0) + _2924) / _2936)) * _589._m15.zw;
                    vec2 _2971 = (_2921 + ((_2924 / _2939) + vec2(2.0))) * _589._m15.zw;
                    vec3 _2997 = vec3(_2944.x, _2944.y, _2778.z);
                    _2513 = (_2931.x * _2931.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_2997.xy, _2997.z), 0.0);
                    vec3 _3015 = vec3(_2959.x, _2944.y, _2778.z);
                    _2513 += ((_2936.x * _2931.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3015.xy, _3015.z), 0.0));
                    vec3 _3035 = vec3(_2971.x, _2944.y, _2778.z);
                    _2513 += ((_2939.x * _2931.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3035.xy, _3035.z), 0.0));
                    vec3 _3055 = vec3(_2944.x, _2959.y, _2778.z);
                    _2513 += ((_2931.x * _2936.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3055.xy, _3055.z), 0.0));
                    vec3 _3075 = vec3(_2959.x, _2959.y, _2778.z);
                    _2513 += ((_2936.x * _2936.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3075.xy, _3075.z), 0.0));
                    vec3 _3095 = vec3(_2971.x, _2959.y, _2778.z);
                    _2513 += ((_2939.x * _2936.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3095.xy, _3095.z), 0.0));
                    vec3 _3115 = vec3(_2944.x, _2971.y, _2778.z);
                    _2513 += ((_2931.x * _2939.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3115.xy, _3115.z), 0.0));
                    vec3 _3135 = vec3(_2959.x, _2971.y, _2778.z);
                    _2513 += ((_2936.x * _2939.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3135.xy, _3135.z), 0.0));
                    vec3 _3155 = vec3(_2971.x, _2971.y, _2778.z);
                    _2513 += ((_2939.x * _2939.y) * textureLod(sampler2DShadow(_2901, _2903), vec3(_3155.xy, _3155.z), 0.0));
                    _2513 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2513 = float((_2167 & 7u) == 2u);
                if ((_2167 & 7u) == 2u)
                {
                    _762._m36 = -1;
                }
            }
            float _3175 = float((_2167 >> uint(16)) & 63u) / 63.0;
            float _3189 = ((_2513 * _3175) + 1.0) - _3175;
            _2513 = _10(_3189);
        }
        if (_2513 <= _2166)
        {
            continue;
        }
        vec3 _3197 = (_2043._m12 * _2513) * _2284;
        float _3204 = _2043._m13;
        vec3 _3207 = _3197;
        float _3214 = dot(_762._m6, _2175);
        float _3209 = _10(_3214);
        float _3216 = 1.0;
        vec3 _3218 = _762._m6;
        vec3 _3221 = _762._m14;
        vec3 _3224 = _2175;
        vec3 _3226 = _762._m2;
        float _3229 = _762._m3;
        vec3 _3217 = _93(_3218, _3221, _3224, _3226, _3229);
        _762._m21 += ((((_3217 * _3204) * _3207) * _3209) * _3216);
        vec3 _3246 = _3207;
        uint _3249 = _762._m4;
        vec4 _3248 = _80(_3249);
        vec3 _3253 = _3248.xyz;
        float _3261 = dot(_762._m8, _2175);
        float _3256 = _10(_3261);
        vec3 _3263 = vec3(mix(_3209, _3256, _886._m13), mix(_3209, _3256, _886._m14), mix(_3209, _3256, _886._m15));
        float _3292 = dot(_762._m14, -_2175);
        float _3294 = _10(_3292);
        float _3295 = _886._m2.w;
        vec3 _3302 = ((_886._m2.xyz + vec3(_762._m5)) * _65(_3294, _3295)) * _3253;
        _3263 += _16(_3302);
        float _3306 = _3248.w;
        _3263 = mix(vec3(_3209), _3263, vec3(_3306));
        _762._m21 += ((_3246 * _3263) * _762._m0);
    }
    _762._m21 *= _762._m11;
    _3332 = vec4(_762._m21, 0.0);
    if (((_589._m52 & 1u) != 0u) == true)
    {
        vec3 _3348 = _762._m6;
        bool _3351 = false;
        vec2 _3352 = _144(_3348, _3351);
        _3347 = vec4(_3352, 0.0, 0.0);
        float _3362 = dot(_762._m14, _762._m6);
        float _3356 = _10(_3362);
        float _3365 = _3356;
        float _3367 = _762._m3;
        vec3 _3370 = _762._m2;
        vec3 _3364 = _99(_3365, _3367, _3370);
        float _3375 = _3364.x;
        float _3379 = _3364.y;
        float _3383 = _3364.z;
        float _3387 = _762._m3;
        _3374 = vec4(_68(_3375), _68(_3379), _68(_3383), _147(_3387));
    }
}

