//FIX
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
layout(early_fragment_tests) in;
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 0, std140) uniform _200_202
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    uint _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51[1];
} _202;

layout(set = 2, binding = 0, std140) uniform _279_281
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    uint _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    uint _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    uint _m39;
    float _m40;
    uint _m41;
    float _m42;
    float _m43;
    uint _m44;
    float _m45[2];
} _281;

layout(set = 1, binding = 0, std140) uniform _493_495
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    int _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    uint _m13;
    float _m14[3];
} _495;

layout(set = 0, binding = 1, std140) uniform _1398_1400
{
    vec4 _m0[64];
} _1400;

layout(push_constant, std430) uniform _1393_1395
{
    int _m0;
} _1395;

layout(set = 3, binding = 0) uniform texture2D _325[34816];
layout(set = 0, binding = 6) uniform sampler _335;
layout(set = 0, binding = 7) uniform TEXTURE_2D _905;
layout(set = 0, binding = 8) uniform sampler _907;
layout(set = 0, binding = 9) uniform TEXTURE_2D _1072;
layout(set = 0, binding = 10) uniform sampler _1074;
layout(set = 0, binding = 11) uniform TEXTURE_2D _1092;
layout(set = 0, binding = 12) uniform texture3D _1196;
layout(set = 0, binding = 13) uniform sampler _1198;
layout(set = 0, binding = 14) uniform texture3D _1217;
layout(set = 0, binding = 15) uniform texture3D _1311;
layout(set = 0, binding = 16) uniform sampler _1313;

layout(location = 17, component = 3) in float _272;
layout(location = 18, component = 0) in float _274;
layout(location = 0, component = 0) out vec4 _482;
layout(location = 19, component = 0) in float _997;
layout(location = 19, component = 1) in float _999;
layout(location = 19, component = 2) in float _1001;
layout(location = 19, component = 3) in float _1005;
layout(location = 20, component = 0) in float _1007;
layout(location = 20, component = 1) in float _1009;
layout(location = 18, component = 1) in float _1019;
layout(location = 18, component = 2) in float _1021;
layout(location = 18, component = 3) in float _1023;
layout(location = 10, component = 0) in vec4 _1401;
layout(location = 11, component = 0) in vec4 _1402;
layout(location = 12, component = 0) in vec4 _1403;
layout(location = 20, component = 2) in float _1404;
uint _45;
uint _47;
uint _49;
uint _51;
uint _53;
uint _55;
uint _57;
uint _58;
uint _60;
uint _61;
uint _63;
uint _65;
uint _67;
uint _69;
uint _71;
uint _73;
uint _75;
uint _77;
uint _79;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _36(inout float _34, bool _35)
{
    if (_35)
    {
        _34 += (float(_34 < _202._m20) * _202._m21);
    }
    float _220 = _34;
    return _202._m0.w / (_10(_220) + _202._m0.z);
}

uint _15(float _14)
{
    return floatBitsToUint(_14);
}

vec3 _42(vec2 _41)
{
    return (vec3(_202._m22, _202._m23, _202._m24) + (vec3(_202._m25, _202._m26, _202._m27) * _41.x)) + (vec3(_202._m28, _202._m29, _202._m30) * _41.y);
}

float _18(float _17)
{
    float _91 = (((-0.15658299624919891357421875) * abs(_17)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_17));
    float _105;
    if (_17 >= 0.0)
    {
        _105 = _91;
    }
    else
    {
        _105 = 3.1415927410125732421875 - _91;
    }
    return _105;
}

float _21(float _20)
{
    float _119;
    if (_20 < 1.0)
    {
        _119 = _20;
    }
    else
    {
        _119 = 1.0 / _20;
    }
    float _116 = _119;
    float _127 = _116 * _116;
    float _131 = 0.087292902171611785888671875;
    _131 = (-0.3018949925899505615234375) + (_131 * _127);
    _131 = 1.0 + (_131 * _127);
    _131 *= _116;
    float _147;
    if (_20 < 1.0)
    {
        _147 = _131;
    }
    else
    {
        _147 = 1.57079637050628662109375 - _131;
    }
    return _147;
}

float _24(float _23)
{
    float _160 = abs(_23);
    float _157 = _21(_160);
    float _164;
    if (_23 < 0.0)
    {
        _164 = -_157;
    }
    else
    {
        _164 = _157;
    }
    return _164;
}

float _29(float _27, float _28)
{
    float _178 = _27 / _28;
    float _174 = _24(_178);
    if (_28 < 0.0)
    {
        _174 += ((_27 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _174;
}

void main()
{
    _45 = 2147483648u;
    _47 = 1073741824u;
    _49 = 0u;
    _51 = 268435456u;
    _53 = 536870912u;
    _55 = 805306368u;
    _57 = 1073741824u;
    _58 = 1342177280u;
    _60 = 0u;
    _61 = 16777216u;
    _63 = 33554432u;
    _65 = 50331648u;
    _67 = 67108864u;
    _69 = 83886080u;
    _71 = 100663296u;
    _73 = 117440512u;
    _75 = 134217728u;
    _77 = 150994944u;
    _79 = 167772160u;
    vec2 _269 = vec2(0.0);
    _269 = vec2(_272, _274);
    vec2 _277 = vec2(0.0);
    bool _285 = _281._m11 > 0.0;
    bool _293;
    if (!_285)
    {
        _293 = _281._m12 > 0.0;
    }
    else
    {
        _293 = _285;
    }
    if (_293)
    {
        vec2 _296 = vec2(_269.x * _281._m11, _269.y * _281._m12);
        _296 += (vec2(_281._m13, _281._m14) * _202._m49);
        _277 = (texture(sampler2D(_325[_281._m15], _335), _296).xy * 2.0) - vec2(1.0);
        _277.x *= _281._m16;
        _277.y *= _281._m17;
    }
    vec2 _360 = _269 * vec2(_281._m18, _281._m19);
    _360 += (vec2(_281._m20, _281._m21) * _202._m49);
    _360 += _277;
    vec4 _384 = vec4(0.0);
    _384 = texture(sampler2D(_325[_281._m22], _335), _360);
    vec3 _403 = _384.xyz * vec3(_281._m23, _281._m24, _281._m25);
    _384 = vec4(_403.x, _403.y, _403.z, _384.w);
    vec4 _406 = vec4(1.0);
    bool _410 = _281._m26 > 0.0;
    bool _417;
    if (!_410)
    {
        _417 = _281._m27 > 0.0;
    }
    else
    {
        _417 = _410;
    }
    if (_417)
    {
        vec2 _420 = vec2(_269.x * _281._m26, _269.y * _281._m27);
        _420 += (vec2(_281._m28, _281._m29) * _202._m49);
        _420 += _277;
        _406 = texture(sampler2D(_325[_281._m30], _335), _420);
        vec3 _465 = _406.xyz * vec3(_281._m31, _281._m32, _281._m33);
        _406 = vec4(_465.x, _465.y, _465.z, _406.w);
        vec3 _475 = mix(_384.xyz, _406.xyz, vec3(_406.w));
        _384 = vec4(_475.x, _475.y, _475.z, _384.w);
    }
    if (true)
    {
        vec3 _489;
        if ((_281._m44 & 1u) != 0u)
        {
            _489 = vec3(_495._m6, _495._m7, _495._m8);
        }
        else
        {
            _489 = vec3(1.0);
        }
        float _513;
        if (_495._m9 > 0.0)
        {
            _513 = _495._m9;
        }
        else
        {
            _513 = _281._m34;
        }
        vec3 _526 = (_489 * _513) * _384.xyz;
        _482 = vec4(_526.x, _526.y, _526.z, _482.w);
        if (true)
        {
            vec3 _538 = _482.xyz * _495._m3.xyz;
            _482 = vec4(_538.x, _538.y, _538.z, _482.w);
        }
        vec2 _541 = (_269 + _277) * vec2(_281._m35, _281._m36);
        _541 += (vec2(_281._m37, _281._m38) * _202._m49);
        float _565 = 0.0;
        _565 = texture(sampler2D(_325[_281._m39], _335), _541).w;
        float _581;
        if ((_281._m44 & 2u) != 0u)
        {
            _581 = _384.w;
        }
        else
        {
            _581 = 1.0;
        }
        float _576 = _581;
        float _593;
        if ((_281._m44 & 4u) != 0u)
        {
            _593 = _406.w;
        }
        else
        {
            _593 = 1.0;
        }
        _576 *= _593;
        _482.w = _565 * _576;
        if (true)
        {
            _482.w *= _495._m10;
        }
        else
        {
            if (false)
            {
                _482.w *= (_495._m3.w * _495._m10);
            }
            else
            {
                _482.w *= _495._m11;
            }
        }
    }
    else
    {
        float _637 = 4.0;
        float _639 = 4.00010013580322265625;
        float _653 = (fract((_202._m49 * 0.2199999988079071044921875) * _637) * 10.0) / _639;
        float _641 = _10(_653);
        float _666 = (fract((_202._m49 * 0.430000007152557373046875) * _637) * 10.0) / _639;
        float _655 = _10(_666);
        float _679 = (fract((_202._m49 * 0.810000002384185791015625) * _637) * 10.0) / _639;
        float _668 = _10(_679);
        float _689 = ((3.0 - _641) - _655) - _668;
        float _681 = _10(_689);
        vec3 _695;
        if ((_281._m44 & 1u) != 0u)
        {
            _695 = vec3(_495._m6, _495._m7, _495._m8);
        }
        else
        {
            _695 = vec3(1.0);
        }
        float _710;
        if (_495._m9 > 0.0)
        {
            _710 = _495._m9;
        }
        else
        {
            _710 = _281._m34;
        }
        vec3 _726 = ((_695 * _710) * _384.xyz) * _495._m3.xyz;
        _482 = vec4(_726.x, _726.y, _726.z, _482.w);
        if (_281._m40 > 0.0)
        {
            float _741 = (1.0 - _641) + 0.1500000059604644775390625;
            float _746 = (1.0 - _655) + 0.1500000059604644775390625;
            float _751 = (1.0 - _668) + 0.1500000059604644775390625;
            vec3 _765 = mix(((_482.xyz * vec3(_10(_741), _10(_746), _10(_751))) * 5.0) + vec3(0.5), _482.xyz, vec3(_495._m3.w));
            _482 = vec4(_765.x, _765.y, _765.z, _482.w);
        }
        vec4 _768 = vec4(0.0);
        _768 = texture(sampler2D(_325[_281._m41], _335), (_269 + _277) + vec2(0.0, _202._m49));
        float _784 = 0.0;
        _784 = texture(sampler2D(_325[_281._m39], _335), _269 + _277).w;
        float _796 = mix(_784, mix(_768.x, _768.y, _655), _681);
        float _806 = mix(_768.x, mix(_768.y, _768.z, _668), _655);
        _784 = mix(_796, _784, _495._m3.w);
        _784 = (_495._m3.w < 0.25) ? _806 : _784;
        _482.w = _784;
    }
    if (_281._m42 > 0.0)
    {
        vec2 _837 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _202._m16.xy;
        float _855 = _281._m42;
        bool _858 = true;
        if (true)
        {
            bool _865 = (_495._m13 & 2u) != 0u;
            bool _873;
            if (!_865)
            {
                _873 = (_495._m13 & 4u) != 0u;
            }
            else
            {
                _873 = _865;
            }
            bool _861 = _873;
            float _875;
            if (_861)
            {
                _875 = 0.100000001490116119384765625;
            }
            else
            {
                _875 = _281._m42;
            }
            _855 = _875;
            _858 = _861;
        }
        if (false)
        {
            bool _890 = (_495._m13 & 2u) != 0u;
            bool _898;
            if (!_890)
            {
                _898 = (_495._m13 & 4u) != 0u;
            }
            else
            {
                _898 = _890;
            }
            bool _886 = _898;
            _858 = _886 == false;
        }
        float _901 = 1.0;
        float _902 = 1.0;
        float _903 = 0.0;
        float _923 = 1.0 - TEXTURE_LOD(SAMPLER_2D(_905, _907), vec4(_837, 0.0, 0.0).xy, vec4(_837, 0.0, 0.0).w).x;
        bool _924 = _858;
        float _926 = _36(_923, _924);
        float _904 = _926;
        float _931 = 1.0 - gl_FragCoord.z;
        bool _932 = _858;
        float _934 = _36(_931, _932);
        float _927 = _934;
        float _942 = (_904 - (_927 + _903)) / _855;
        _901 = _10(_942);
        float _952 = 1.0 - (_904 - (_927 * _495._m4.x));
        _902 = _10(_952);
        if (false)
        {
            float _960 = _901 * 100.0;
            float _956 = _10(_960);
            vec3 _966 = _482.xyz * mix(5.0, 1.0, _901);
            _482 = vec4(_966.x, _966.y, _966.z, _482.w);
            vec3 _973 = _482.xyz * mix(10.0, 1.0, _956);
            _482 = vec4(_973.x, _973.y, _973.z, _482.w);
        }
        else
        {
            _482.w *= _901;
        }
    }
    float _982 = _495._m12;
    vec3 _985 = vec3(0.0);
    if ((_281._m43 > 0.0) || (_982 > 0.0))
    {
        vec3 _996 = vec3(0.0);
        _985 = normalize(vec3(_997, _999, _1001));
        _996 = normalize(vec3(_1005, _1007, _1009));
    }
    if (_281._m43 > 0.0)
    {
        vec3 _1018 = normalize(vec3(_1019, _1021, _1023));
        float _1032 = dot(_985, -_1018);
        float _1027 = _10(_1032);
        _1027 = pow(_1027, _281._m43);
        _482.w *= _1027;
        float _1043 = _482.w;
        _482.w = _10(_1043);
    }
    if (_982 > 0.0)
    {
        float _1052 = _985.x;
        vec2 _1055 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _202._m16.xy;
        float _1071 = (SAMPLE_TEXTURE(SAMPLER_2D(_1072, _1074), _269 * _281._m1.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_982 > _1071)
        {
            vec3 _1115 = TEXTURE_LOD(SAMPLER_2D(_1092, _1074), vec4(_1055 + vec2(_1052 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_1055 + vec2(_1052 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _482 = vec4(_1115.x, _1115.y, _1115.z, _482.w);
        }
        else
        {
            if (_982 > (_1071 - 0.02500000037252902984619140625))
            {
                _482 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _482.w);
            }
        }
    }
    vec2 _1131 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _202._m16.xy;
    float _1158 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).z;
    bool _1160 = false;
    float _1161 = _36(_1158, _1160);
    float _1147 = _1161;
    vec2 _1162 = _1131 + vec2(0.0);
    float _1165 = 0.119999997317790985107421875;
    float _1167 = _202._m17.y;
    float _1170 = _202._m18.z + 1.0;
    float _1174 = pow(max(0.0, _1147 - _1165) / (_1167 - _1165), 0.5);
    float _1184 = (0.5 / _1170) + (_1174 * (1.0 - (1.0 / _1170)));
_1162.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec3 _1193 = textureLod(sampler3D(_1196, _1198), vec4(_1162, _1184, 0.0).xyz, vec4(_1162, _1184, 0.0).w).xyz;
    vec2 _1216 = textureLod(sampler3D(_1217, _1198), vec4(_1162, _1184, 0.0).xyz, vec4(_1162, _1184, 0.0).w).xy;
    float _1235 = _1216.x;
    float _1238 = _1216.y;
    float _1244 = _202._m50;
    uint _1242 = _15(_1244);
    bool _1248 = (_1242 & 2u) != 0u;
    _1193 *= float(_1248);
    _1235 = _1248 ? _1235 : 1.0;
    vec3 _1259 = vec3(0.0);
    if ((_1242 & 1u) != 0u)
    {
        vec3 _1265 = vec3(_202._m31, _202._m32, _202._m33);
        vec3 _1273 = _42(_1131);
        vec4 _1276 = vec4(0.0);
        vec3 _1277 = normalize(_1273);
        float _1280 = _1277.z;
        _1276.x = clamp(_18(_1280) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _1289 = _1277.y;
        float _1292 = _1277.x;
        _1276.y = _29(_1289, _1292) / 6.283185482025146484375;
        _1276.z = sqrt(_1147 * _202._m19.w);
        _1276.z = clamp(_1276.z, 0.015625, 0.984375);
        _1259 = textureLod(sampler3D(_1311, _1313), _1276.xyz, _1276.w).xyz;
        _1259 *= _1238;
    }
    vec3 _1332 = ((_482.xyz + _1259) * _1235) + _1193;
    _482 = vec4(_1332.x, _1332.y, _1332.z, _482.w);
    if (_281._m2.x == 0.0)
    {
    }
    else
    {
        if (_281._m2.x == 1.0)
        {
            _482.w = 9.9999997473787516355514526367188e-05;
        }
        else
        {
            if (_281._m2.x == 2.0)
            {
                _482.w = 1.0;
            }
            else
            {
                if (_281._m2.x == 3.0)
                {
                    float _1362 = _482.w;
                    _482.w = _10(_1362);
                    vec3 _1371 = _482.xyz * _482.w;
                    _482 = vec4(_1371.x, _1371.y, _1371.z, _482.w);
                }
                else
                {
                    if (_281._m2.x == 4.0)
                    {
                        float _1380 = _482.w;
                        _482.w = _10(_1380);
                        vec3 _1389 = _482.xyz * _482.w;
                        _482 = vec4(_1389.x, _1389.y, _1389.z, _482.w);
                        _482.w = 9.9999997473787516355514526367188e-05;
                    }
                }
            }
        }
    }
}

