// REFLECTION SHADER (SSR) of Geometry! & SHARED 
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_KHR_shader_subgroup_quad : require
#extension GL_KHR_shader_subgroup_basic : require
#extension GL_KHR_shader_subgroup_ballot : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 40, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _119
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _127
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2770
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
};

struct _5112
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _6065
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _811_813
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    uint _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    uint _m64;
    float _m65[2];
} _813;

layout(set = 2, binding = 0, std140) uniform _1282_1284
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    uint _m24;
    uint _m25;
    uint _m26;
    uint _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    uint _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    uint _m57;
    float _m58[2];
} _1284;

layout(set = 1, binding = 0, std140) uniform _1295_1297
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    int _m31;
    uint _m32;
    float _m33[3];
} _1297;

layout(set = 3, binding = 0, std140) uniform _1734_1736
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1736;

layout(set = 0, binding = 14, std430) restrict readonly buffer _2318_2320
{
    vec4 _m0[];
} _2320;

layout(set = 0, binding = 15, std430) restrict readonly buffer _2682_2684
{
    uint _m0[];
} _2684;

layout(set = 0, binding = 16, std140) uniform _2775_2777
{
    vec4 _m0[4096];
} _2777;

layout(set = 0, binding = 17, std140) uniform _2795_2797
{
    vec4 _m0[4096];
} _2797;

layout(set = 0, binding = 18, std140) uniform _2848_2850
{
    vec4 _m0[2048];
} _2850;

layout(set = 0, binding = 27, std430) restrict readonly buffer _4469_4471
{
    uint _m0[];
} _4471;

layout(set = 0, binding = 31, std140) uniform _5116_5118
{
    vec4 _m0[4096];
} _5118;

layout(set = 0, binding = 32, std140) uniform _5192_5194
{
    vec4 _m0[4096];
} _5194;

layout(set = 0, binding = 35, std430) restrict readonly buffer _5472_5474
{
    uint _m0[];
} _5474;

layout(set = 0, binding = 36, std140) uniform _6070_6072
{
    vec4 _m0[4095];
} _6072;

layout(set = 0, binding = 1, std140) uniform _6818_6820
{
    vec4 _m0[64];
} _6820;

layout(push_constant, std430) uniform _2304_2306
{
    int _m0;
    int _m1;
    int _m2;
} _2306;

layout(set = 3, binding = 8) uniform texture2D _1478[5];
layout(set = 0, binding = 5) uniform sampler _1486;
layout(set = 3, binding = 1) uniform texture2D _1775[5];
layout(set = 0, binding = 6) uniform sampler _1780;
layout(set = 3, binding = 3) uniform texture2D _1797[5];
layout(set = 0, binding = 7) uniform sampler _1802;
layout(set = 3, binding = 2) uniform texture2D _1809[5];
layout(set = 0, binding = 8) uniform sampler _1814;
layout(set = 3, binding = 4) uniform texture2D _1831[5];
layout(set = 0, binding = 9) uniform sampler _1836;
layout(set = 3, binding = 5) uniform texture2D _1843[5];
layout(set = 0, binding = 10) uniform sampler _1848;
layout(set = 3, binding = 7) uniform texture2D _1855[5];
layout(set = 0, binding = 11) uniform sampler _1860;
layout(set = 0, binding = 12) uniform TEXTURE_2D _2276;
layout(set = 0, binding = 13) uniform sampler _2278;
layout(set = 4, binding = 0) uniform texture2D _2415[34816];
layout(set = 0, binding = 19) uniform TEXTURE_2D _3044;
layout(set = 0, binding = 20) uniform sampler _3046;
layout(set = 0, binding = 21) uniform TEXTURE_2D _3096;
layout(set = 0, binding = 22) uniform TEXTURE_2D _3509;
layout(set = 0, binding = 23) uniform sampler _3511;
layout(set = 0, binding = 24) uniform TEXTURE_2D _3749;
layout(set = 0, binding = 25) uniform sampler _3751;
layout(set = 0, binding = 26) uniform sampler _4251;
layout(set = 0, binding = 28) uniform TEXTURE_2D _4722;
layout(set = 0, binding = 29) uniform sampler _4724;
layout(set = 0, binding = 30) uniform texture2D _5019;
layout(set = 0, binding = 33) uniform textureCubeArray _5445;
layout(set = 0, binding = 34) uniform sampler _5447;
layout(set = 0, binding = 37) uniform texture2D _6393;
layout(set = 0, binding = 38) uniform samplerShadow _6395;
layout(set = 3, binding = 6) uniform texture2D _6816[5];

layout(location = 17, component = 1) in float _1163;
layout(location = 17, component = 2) in float _1165;
layout(location = 17, component = 3) in float _1172;
layout(location = 18, component = 0) in float _1174;
layout(location = 18, component = 1) in float _1179;
layout(location = 18, component = 2) in float _1181;
layout(location = 18, component = 3) in float _1183;
layout(location = 19, component = 0) in float _1211;
layout(location = 19, component = 1) in float _1213;
layout(location = 19, component = 2) in float _1215;
layout(location = 19, component = 3) in float _1219;
layout(location = 20, component = 0) in float _1221;
layout(location = 20, component = 1) in float _1223;
layout(location = 20, component = 2) in float _1235;
layout(location = 15, component = 0) in vec4 _1316;
layout(location = 0, component = 0) out vec4 _6757;
layout(location = 1, component = 0) out vec4 _6771;
layout(location = 2, component = 0) out vec4 _6798;
uint _216;
uint _218;
uint _220;
uint _222;
uint _224;
uint _226;
uint _228;
uint _229;
uint _231;
uint _232;
uint _234;
uint _236;
uint _238;
uint _240;
uint _242;
uint _244;
uint _246;
uint _248;
uint _250;

_127 _129()
{
    _127 _703;
    _703._m0 = vec3(0.0);
    _703._m2 = vec3(0.0);
    _703._m3 = 0.0;
    _703._m4 = 0u;
    _703._m5 = 0.0;
    _703._m6 = vec3(0.0);
    _703._m7 = vec3(0.0, 0.0, 1.0);
    _703._m8 = vec3(0.0, 0.0, 1.0);
    _703._m1 = vec3(0.0);
    _703._m9 = 1.0;
    _703._m10 = 1.0;
    _703._m14 = vec3(0.0);
    _703._m15 = vec3(0.0);
    _703._m16 = vec4(0.0);
    _703._m17 = vec4(0.0);
    _703._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _703._m19 = vec3(0.0);
    _703._m20 = vec3(0.0);
    _703._m21 = vec3(0.0);
    _703._m22 = vec3(0.0);
    _703._m23 = vec3(0.0);
    _703._m24 = vec3(0.0);
    _703._m25 = 1.0;
    _703._m26 = uvec4(0u);
    _703._m27 = uvec4(0u);
    _703._m28 = uvec4(0u);
    _703._m29 = vec4(0.0);
    _703._m30 = vec4(0.0);
    _703._m31 = vec4(0.0);
    _703._m32 = vec4(0.0);
    _703._m33 = uvec2(0u);
    _703._m34 = vec2(0.0);
    _703._m35 = 0.0;
    _703._m36 = -1;
    _703._m37 = 0;
    _703._m38 = vec2(0.0);
    _703._m39 = 1.0;
    _703._m41 = -1;
    _703._m45 = 1.0;
    _703._m11 = 1.0;
    _703._m12 = 0u;
    _703._m13 = uvec3(0u);
    _703._m40 = vec3(0.0);
    _703._m46 = 0.0;
    _703._m47 = 1.0;
    return _703;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_119 _121()
{
    _119 _691;
    _691._m0 = vec4(0.0);
    _691._m1 = vec4(0.0);
    _691._m2 = vec4(0.0);
    _691._m3 = vec4(0.0);
    _691._m4 = vec4(0.0);
    _691._m5 = 0.0;
    return _691;
}

vec2 _145(vec2 _144)
{
    return ((_144 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _150(inout vec2 _148, bool _149)
{
    vec2 _845 = _148;
    _148 = _145(_845);
    float _865 = (1.0 - (_148.x * _148.x)) - (_148.y * _148.y);
    vec3 _848 = vec3(_148.x, _148.y, sqrt(_10(_865)));
    if (_149 == false)
    {
        _848.z = -_848.z;
    }
    return _848;
}

vec3 _71(mat3 _69, vec3 _70)
{
    return _69 * _70;
}

vec3 _155(vec3 _153, mat3 _154)
{
    mat3 _881 = _154;
    vec3 _883 = _153;
    return normalize(_71(_881, _883));
}

vec3 _161(vec2 _158, mat3 _159, bool _160)
{
    vec2 _890 = _158;
    bool _892 = _160;
    vec3 _894 = _150(_890, _892);
    vec3 _889 = _894;
    vec3 _895 = _889;
    mat3 _897 = _159;
    return _155(_895, _897);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _82(float _81)
{
    return sqrt(_81);
}

float _117(vec3 _114, float _115, float _116)
{
    float _646 = length(_114) * _116;
    if (_646 < 1.0)
    {
        float _655 = 1.0 - _115;
        float _658 = _646 * _646;
        float _662 = ((3.0 * _646) - (_646 * _658)) / (1.0 - _658);
        float _673 = 1.0 / (2.0 * _662);
        float _683 = (_655 * _655) + _673;
        return 1.0 - _82(_683);
    }
    return _115;
}

float _141(inout float _139, bool _140)
{
    if (_140)
    {
        _139 += (float(_139 < _813._m27) * _813._m28);
    }
    float _826 = _139;
    return _813._m0.w / (_10(_826) + _813._m0.z);
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

float _134(vec2 _133)
{
    return dot(_133, _133);
}

vec4 _92(uint _91)
{
    return vec4(float((_91 >> uint(24)) & 255u), float((_91 >> uint(16)) & 255u), float((_91 >> uint(8)) & 255u), float(_91 & 255u));
}

vec4 _89(uint _88)
{
    return unpackUnorm4x8(_88).wzyx;
}

float _192(float _191)
{
    return 0.16666667163372039794921875 * ((_191 * ((_191 * ((-_191) + 3.0)) - 3.0)) + 1.0);
}

float _195(float _194)
{
    return 0.16666667163372039794921875 * (((_194 * _194) * ((3.0 * _194) - 6.0)) + 4.0);
}

float _204(float _203)
{
    float _1113 = _203;
    float _1116 = _203;
    return _192(_1113) + _195(_1116);
}

float _198(float _197)
{
    return 0.16666667163372039794921875 * ((_197 * ((_197 * (((-3.0) * _197) + 3.0)) + 3.0)) + 1.0);
}

float _201(float _200)
{
    return 0.16666667163372039794921875 * ((_200 * _200) * _200);
}

float _207(float _206)
{
    float _1122 = _206;
    float _1125 = _206;
    return _198(_1122) + _201(_1125);
}

float _210(float _209)
{
    float _1131 = _209;
    float _1134 = _209;
    float _1137 = _209;
    return (-1.0) + (_195(_1131) / (_192(_1134) + _195(_1137)));
}

float _213(float _212)
{
    float _1145 = _212;
    float _1148 = _212;
    float _1151 = _212;
    return 1.0 + (_201(_1145) / (_198(_1148) + _201(_1151)));
}

vec4 _50(vec4 _49)
{
    return _49 * _49;
}

float _79(float _77, float _78)
{
    return pow(_77, _78);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _97(vec3 _95, float _96)
{
    float _485 = dot(_95, vec3(16.666500091552734375));
    float _480 = _10(_485);
    float _494 = 1.0 - _96;
    float _497 = _10(_494);
    float _498 = 5.0;
    vec3 _502 = _95 + ((vec3(_480) - _95) * _79(_497, _498));
    return _16(_502);
}

vec3 _105(vec3 _100, vec3 _101, vec3 _102, vec3 _103, float _104)
{
    float _510 = dot(_100, _101);
    float _506 = _10(_510);
    vec3 _512 = normalize(_101 + _102);
    float _521 = dot(_100, _512);
    float _517 = _10(_521);
    float _527 = dot(_102, _512);
    float _523 = _10(_527);
    vec3 _530 = _103;
    float _532 = _523;
    vec3 _529 = _97(_530, _532);
    float _539 = dot(_100, _102);
    float _535 = _10(_539);
    float _541 = 1.0 - (_104 * 0.800000011920928955078125);
    _541 *= _541;
    _541 *= _541;
    float _552 = _541 * _541;
    float _556 = ((_517 * _517) * (_552 - 1.0)) + 1.0;
    _556 = _552 / ((_556 * _556) + 9.9999999392252902907785028219223e-09);
    float _571 = (_506 * (1.0 - _541)) + _541;
    float _578 = (_535 * (1.0 - _541)) + _541;
    _556 /= (((4.0 * _571) * _578) + 9.9999999392252902907785028219223e-09);
    return _529 * _556;
}

float _74(float _73)
{
    return exp2(_73);
}

vec3 _111(float _108, float _109, vec3 _110)
{
    float _598 = 0.0949999988079071044921875 + (_109 * (0.60000002384185791015625 + (4.190000057220458984375 * _109)));
    float _608 = _108 + 0.02500000037252902984619140625;
    float _612 = (9.5 * _109) * _108;
    float _626 = 1.0 - (14.0 * _108);
    float _618 = (_598 * _608) * _74(_626);
    float _633 = -_612;
    float _629 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _74(_633)));
    return mix(vec3(_618), vec3(_629), _110);
}

float _178(uvec2 _176, uint _177)
{
    uvec2 _952 = _176 & uvec2(3u);
    return float(((((2068378560u * (1u - (_952.x >> uint(1)))) + (1500172770u * (_952.x >> uint(1)))) >> ((_952.y + ((_952.x & 1u) << uint(2))) << uint(2))) + _177) & 15u) / 16.0;
}

vec3 _172(vec3 _169, vec4 _170, vec4 _171)
{
    return vec3((_170.xy * _169.xy) + _170.zw, _171.z) / vec3((_171.x * _169.z) + _171.y);
}

vec3 _166(vec3 _164, vec4 _165)
{
    return vec3(vec2(0.5) + (_165.xy * (_164.xy / vec2(_164.z))), (_165.w / _164.z) + _165.z);
}

int _44(uint _43)
{
    return findLSB(_43);
}

vec4 _64(vec3 _59, vec4 _60, vec4 _61, vec4 _62, vec4 _63)
{
    return vec4((_59.x * _60.x) + ((_59.y * _60.y) + ((_59.z * _60.z) + _60.w)), (_59.x * _61.x) + ((_59.y * _61.y) + ((_59.z * _61.z) + _61.w)), (_59.x * _62.x) + ((_59.y * _62.y) + ((_59.z * _62.z) + _62.w)), (_59.x * _63.x) + ((_59.y * _63.y) + ((_59.z * _63.z) + _63.w)));
}

float _56(float _55)
{
    return _55 * _55;
}

vec3 _53(vec3 _52)
{
    return _52 * _52;
}

uint _38(float _35, float _36, float _37)
{
    bool _286 = abs(_37) >= abs(_35);
    bool _294;
    if (_286)
    {
        _294 = abs(_37) >= abs(_36);
    }
    else
    {
        _294 = _286;
    }
    if (_294)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

vec2 _181(vec2 _180)
{
    return (vec2(1.0) - abs(_180.yx)) * vec2((_180.x >= 0.0) ? 1.0 : (-1.0), (_180.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _186(inout vec3 _184, bool _185)
{
    _184 /= vec3((abs(_184.x) + abs(_184.y)) + abs(_184.z));
    vec2 _1021;
    if (_184.z >= 0.0)
    {
        _1021 = _184.xy;
    }
    else
    {
        vec2 _1027 = _184.xy;
        _1021 = _181(_1027);
    }
    _184 = vec3(_1021.x, _1021.y, _184.z);
    if (_185)
    {
        vec2 _1041 = (_184.xy * 0.5) + vec2(0.5);
        _184 = vec3(_1041.x, _1041.y, _184.z);
    }
    return _184.xy;
}

float _85(float _84)
{
    return sqrt(_84);
}

float _189(float _188)
{
    float _1051 = abs(_188);
    float _1048 = _85(_1051);
    float _1055;
    if (_188 > 0.0)
    {
        _1055 = _1048;
    }
    else
    {
        _1055 = -_1048;
    }
    return (_1055 * 0.5) + 0.5;
}

void main()
{
    _216 = 2147483648u;
    _218 = 1073741824u;
    _220 = 0u;
    _222 = 268435456u;
    _224 = 536870912u;
    _226 = 805306368u;
    _228 = 1073741824u;
    _229 = 1342177280u;
    _231 = 0u;
    _232 = 16777216u;
    _234 = 33554432u;
    _236 = 50331648u;
    _238 = 67108864u;
    _240 = 83886080u;
    _242 = 100663296u;
    _244 = 117440512u;
    _246 = 134217728u;
    _248 = 150994944u;
    _250 = 167772160u;
    _127 _1159 = _129();
    vec2 _1161 = vec2(0.0);
    _1161 = vec2(_1163, _1165);
    _1159._m16 = vec4(_1161.x, _1161.y, _1172, _1174);
    vec3 _1178 = vec3(_1179, _1181, _1183);
    _1159._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _1159._m15 = vec3(_813._m38, _813._m39, _813._m40) + _1178;
    vec3 _1209 = vec3(0.0);
    vec3 _1210 = vec3(0.0);
    _1209 = normalize(vec3(_1211, _1213, _1215));
    _1210 = normalize(vec3(_1219, _1221, _1223));
    vec3 _1227 = _1209;
    vec3 _1229 = _1210;
    vec3 _1231 = normalize(cross(_1227, _1229) * _1235);
    _1159._m18 = mat3(vec3(_1229), vec3(_1231), vec3(_1227));
    _1159._m14 = normalize(-_1178);
    uint _1260 = 0u;
    vec4 _1261 = vec4(0.0);
    vec4 _1262 = vec4(0.0);
    vec4 _1263 = vec4(0.0);
    vec4 _1264 = vec4(0.0);
    vec4 _1265 = vec4(0.0);
    float _1266 = 0.0;
    uvec2 _1267 = uvec2(0u, 65535u);
    vec2 _1270 = _1159._m16.zw;
    vec2 _1274 = _1270;
    vec2 _1276 = _1270;
    float _1278 = 0.0009765625;
    vec3 _1291;
    if ((_1284._m57 & 1u) != 0u)
    {
        _1291 = vec3(_1297._m17, _1297._m18, _1297._m19);
    }
    else
    {
        _1291 = vec3(1.0);
    }
    vec3 _1280 = _1291;
    float _1308 = 1.0;
    float _1309 = 0.0;
    vec2 _1312[2] = vec2[](vec2(1.0), vec2(1.0));
    vec4 _1315 = vec4(0.0);
    _1315 = _1316;
    _1309 = 1.0;
    _1267.x = 65535u;
    _1267.y = 65535u;
    _1309 = 0.0;
    float _1320 = 0.0;
    float _1321 = 0.0;
    for (uint _1322 = 0u; _1322 < 4u; _1322++)
    {
        float _1331 = _1315[_1322];
        float _1335 = max(_1331, subgroupQuadSwapHorizontal(_1331));
        _1335 = max(_1335, subgroupQuadSwapVertical(_1335));
        if (_1335 > _1320)
        {
            _1267.y = _1267.x;
            _1267.x = _1322;
            _1321 = _1320;
            _1320 = _1335;
            _1309 = _1331;
        }
        else
        {
            if (_1335 > _1321)
            {
                _1267.y = _1322;
                _1321 = _1335;
            }
        }
    }
    if (_1267.x == 65535u)
    {
        _1267.x = 0u;
        _1309 = 1.0;
    }
    float _1374 = _1309;
    _1309 = _10(_1374);
    switch (_1267.x)
    {
        case 0u:
        {
            _1312[0] = _1284._m1.xx;
            break;
        }
        case 1u:
        {
            _1312[0] = _1284._m1.yy;
            break;
        }
        case 2u:
        {
            _1312[0] = _1284._m1.zz;
            break;
        }
        case 3u:
        {
            _1312[0] = _1284._m1.ww;
            break;
        }
        default:
        {
            _1312[0] = vec2(1.0);
            break;
        }
    }
    switch (_1267.y)
    {
        case 0u:
        {
            _1312[1] = _1284._m1.xx;
            break;
        }
        case 1u:
        {
            _1312[1] = _1284._m1.yy;
            break;
        }
        case 2u:
        {
            _1312[1] = _1284._m1.zz;
            break;
        }
        case 3u:
        {
            _1312[1] = _1284._m1.ww;
            break;
        }
        default:
        {
            _1312[1] = vec2(1.0);
            break;
        }
    }
    _1274 = _1270 * _1312[0];
    _1276 = _1270 * _1312[1];
    if (_1309 < _1278)
    {
        _1308 = 0.0;
    }
    else
    {
        if (_1309 > (1.0 - _1278))
        {
            _1308 = 1.0;
        }
        else
        {
            float _1461 = 0.0;
            float _1462 = 0.0;
            uint _1463 = _1267.x;
            uint _1466 = _1463 & 7u;
            uint _1470 = _1466;
            uint _1472 = _1470;
            uint _1480 = _1472;
            _1461 = texture(sampler2D(_1478[nonuniformEXT(_1480)], _1486), _1274).x;
            uint _1493 = _1267.y;
            uint _1496 = _1493 & 7u;
            uint _1499 = _1496;
            uint _1501 = _1499;
            uint _1504 = _1501;
            _1462 = texture(sampler2D(_1478[nonuniformEXT(_1504)], _1486), _1276).x;
            _1308 = 0.0;
            float _1520;
            switch (_1267.x)
            {
                case 0u:
                {
                    _1520 = _1284._m0.x;
                    break;
                }
                case 1u:
                {
                    _1520 = _1284._m0.y;
                    break;
                }
                case 2u:
                {
                    _1520 = _1284._m0.z;
                    break;
                }
                case 3u:
                {
                    _1520 = _1284._m0.w;
                    break;
                }
                default:
                {
                    _1520 = 0.0;
                    break;
                }
            }
            float _1543;
            switch (_1267.y)
            {
                case 0u:
                {
                    _1543 = _1284._m0.x;
                    break;
                }
                case 1u:
                {
                    _1543 = _1284._m0.y;
                    break;
                }
                case 2u:
                {
                    _1543 = _1284._m0.z;
                    break;
                }
                case 3u:
                {
                    _1543 = _1284._m0.w;
                    break;
                }
                default:
                {
                    _1543 = 0.0;
                    break;
                }
            }
            float _1558 = (((_1461 - 0.4980392158031463623046875) + 0.0) + _1309) * _1520;
            float _1567 = (((_1462 - 0.4980392158031463623046875) + 1.0) - _1309) * _1543;
            float _1575 = _1558 - _1567;
            float _1579 = (clamp(_1575 / _1284._m18, -1.0, 1.0) / 2.0) + 0.5;
            float _1587 = 0.100000001490116119384765625;
            float _1589 = abs(0.5 - _1309);
            float _1600 = (_1589 - (0.5 - _1587)) / _1587;
            float _1593 = _10(_1600);
            if ((_1309 < _1587) && (_1579 > _1309))
            {
                _1308 = mix(_1579, _1309, _1593);
            }
            else
            {
                if ((_1309 > (1.0 - _1587)) && (_1579 < _1309))
                {
                    _1308 = mix(_1579, _1309, _1593);
                }
                else
                {
                    _1308 = _1579;
                }
            }
            float _1632 = _1308;
            _1308 = _10(_1632);
        }
    }
    uint _1635 = gl_SubgroupInvocationID;
    uint _1639 = gl_SubgroupInvocationID & 4294967292u;
    uvec4 _1643 = subgroupBallot(_1308 < _1278);
    uvec4 _1648 = subgroupBallot(_1308 > (1.0 - _1278));
    int _1658;
    if (_1639 < 32u)
    {
        _1658 = 15 << int(_1639);
    }
    else
    {
        _1658 = 0;
    }
    uint _1654 = uint(_1658);
    int _1669;
    if (32u <= _1639)
    {
        _1669 = 15 << int(_1639 - 32u);
    }
    else
    {
        _1669 = 0;
    }
    uint _1666 = uint(_1669);
    uvec4 _1678 = uvec4(_1654, _1666, 0u, 0u);
    bool _1682 = all(equal((_1643 & _1678), _1678));
    bool _1690 = all(equal((_1648 & _1678), _1678));
    if (_1682)
    {
        _1308 = 1.0;
        _1274 = _1276;
        _1267.x = _1267.y;
        _1267.y = 65535u;
    }
    else
    {
        if (_1690)
        {
            _1308 = 1.0;
            _1267.y = 65535u;
        }
    }
    float _1710 = _1297._m20;
    bool _1713 = _1710 > 0.0;
    float _1716 = 1.0;
    uint _1717 = _1267.x;
    uint _1720 = _1717 & 7u;
    uint _1723 = _1720;
    uint _1725 = _1723;
    float _1727 = 0.0;
    vec2 _1728 = _1274;
    _1728.x *= _1736._m1[_1725].w;
    _1728.y *= _1736._m2[_1725].x;
    _1728.x += (_813._m56 * _1736._m2[_1725].y);
    _1728.y += (_813._m56 * _1736._m2[_1725].z);
    vec2 _1772 = _1728;
    uint _1777 = _1725;
    vec3 _1774 = (texture(sampler2D(_1775[nonuniformEXT(_1777)], _1780), _1772).xyz * vec3(_1736._m0[_1725].x)) + vec3(_1736._m0[_1725].y);
    uint _1799 = _1725;
    vec2 _1796 = texture(sampler2D(_1797[nonuniformEXT(_1799)], _1802), _1772).xy;
    uint _1811 = _1725;
    vec3 _1808 = (texture(sampler2D(_1809[nonuniformEXT(_1811)], _1814), _1772).xyz * vec3(_1736._m0[_1725].z)) + vec3(_1736._m0[_1725].w);
    uint _1833 = _1725;
    float _1830 = texture(sampler2D(_1831[nonuniformEXT(_1833)], _1836), _1772).x;
    uint _1845 = _1725;
    float _1842 = texture(sampler2D(_1843[nonuniformEXT(_1845)], _1848), _1772).x;
    uint _1857 = _1725;
    vec3 _1854 = texture(sampler2D(_1855[nonuniformEXT(_1857)], _1860), _1772).xyz;
    uint _1868 = _1725;
    float _1866 = texture(sampler2D(_1478[nonuniformEXT(_1868)], _1486), _1772).x;
    _1261 = vec4(_1774.x, _1774.y, _1774.z, _1261.w);
    _1261.w = 0.0;
    _1262 = vec4(_1808.x, _1808.y, _1808.z, _1262.w);
    _1262.w = _1842;
    _1263 = vec4(_1796.x, _1796.y, _1263.z, _1263.w);
    _1264.x = 0.0;
    _1264.y = _1727;
    _1264.z = _1842;
    _1264.w = _1830;
    _1266 = _1866;
    _1716 = _1736._m1[_1725].x;
    vec3 _1904 = _1854 * _1736._m3[_1725].xyz;
    _1265 = vec4(_1904.x, _1904.y, _1904.z, _1265.w);
    float _1907 = _1713 ? _1710 : _1716;
    vec3 _1916 = _1265.xyz * vec3(_1907);
    _1265 = vec4(_1916.x, _1916.y, _1916.z, _1265.w);
    vec2 _1919 = vec2(0.0);
    _119 _1920;
    _1920._m0 = _1261;
    _1920._m1 = _1262;
    _1920._m2 = _1264;
    _1920._m3 = _1263;
    _1920._m4 = _1265;
    _1920._m5 = _1266;
    _119 _1933 = _1920;
    if (_1267.y != 65535u)
    {
        float _1940 = 1.0 - _1308;
        _119 _1943 = _121();
        float _1945 = _1297._m20;
        bool _1948 = _1945 > 0.0;
        float _1951 = 1.0;
        uint _1952 = _1267.y;
        uint _1955 = _1952 & 7u;
        uint _1958 = _1955;
        uint _1960 = _1958;
        float _1962 = 0.0;
        vec2 _1963 = _1276;
        _1963.x *= _1736._m1[_1960].w;
        _1963.y *= _1736._m2[_1960].x;
        _1963.x += (_813._m56 * _1736._m2[_1960].y);
        _1963.y += (_813._m56 * _1736._m2[_1960].z);
        vec2 _1999 = _1963;
        uint _2003 = _1960;
        vec3 _2001 = (texture(sampler2D(_1775[nonuniformEXT(_2003)], _1780), _1999).xyz * vec3(_1736._m0[_1960].x)) + vec3(_1736._m0[_1960].y);
        uint _2023 = _1960;
        vec2 _2021 = texture(sampler2D(_1797[nonuniformEXT(_2023)], _1802), _1999).xy;
        uint _2033 = _1960;
        vec3 _2031 = (texture(sampler2D(_1809[nonuniformEXT(_2033)], _1814), _1999).xyz * vec3(_1736._m0[_1960].z)) + vec3(_1736._m0[_1960].w);
        uint _2053 = _1960;
        float _2051 = texture(sampler2D(_1831[nonuniformEXT(_2053)], _1836), _1999).x;
        uint _2063 = _1960;
        float _2061 = texture(sampler2D(_1843[nonuniformEXT(_2063)], _1848), _1999).x;
        uint _2073 = _1960;
        vec3 _2071 = texture(sampler2D(_1855[nonuniformEXT(_2073)], _1860), _1999).xyz;
        uint _2083 = _1960;
        float _2081 = texture(sampler2D(_1478[nonuniformEXT(_2083)], _1486), _1999).x;
        _1943._m0 = vec4(_2001.x, _2001.y, _2001.z, _1943._m0.w);
        _1943._m0.w = 0.0;
        _1943._m1 = vec4(_2031.x, _2031.y, _2031.z, _1943._m1.w);
        _1943._m1.w = _2061;
        _1943._m3 = vec4(_2021.x, _2021.y, _1943._m3.z, _1943._m3.w);
        _1943._m2.x = 0.0;
        _1943._m2.y = _1962;
        _1943._m2.z = _2061;
        _1943._m2.w = _2051;
        _1943._m5 = _2081;
        _1951 = _1736._m1[_1960].x;
        vec3 _2123 = _2071 * _1736._m3[_1960].xyz;
        _1943._m4 = vec4(_2123.x, _2123.y, _2123.z, _1943._m4.w);
        float _2127 = _1948 ? _1945 : _1951;
        vec3 _2137 = _1943._m4.xyz * vec3(_2127);
        _1943._m4 = vec4(_2137.x, _2137.y, _2137.z, _1943._m4.w);
        _1933._m0 = mix(_1933._m0, _1943._m0, vec4(_1940 * 1.0));
        _1933._m1 = mix(_1933._m1, _1943._m1, vec4(_1940 * 1.0));
        _1933._m2.w = mix(_1933._m2.w, _1943._m2.w, _1940 * 1.0);
        vec3 _2175 = mix(_1933._m2.xyz, _1943._m2.xyz, vec3(_1940));
        _1933._m2 = vec4(_2175.x, _2175.y, _2175.z, _1933._m2.w);
        _1933._m3 = mix(_1933._m3, _1943._m3, vec4(_1940 * 1.0));
        _1933._m4 = mix(_1933._m4, _1943._m4, vec4(_1940 * 1.0));
        _1933._m5 = mix(_1933._m5, _1943._m5, _1940);
    }
    _1261 = _1933._m0;
    _1262 = _1933._m1;
    _1264.w = _1933._m2.w;
    _1263 = _1933._m3;
    _1265 = _1933._m4;
    _1266 = _1933._m5;
    _1159._m22 = _1265.xyz * _1280;
    _1159._m0 = _1261.xyz;
    _1159._m2 = _1262.xyz;
    _1159._m1 = _1265.xyz;
    _1159._m3 = _1264.w;
    _1159._m6 = _1263.xyz;
    uint _2237 = 0u;
    bool _2238 = true;
    vec2 _2240 = _1159._m6.xy;
    bool _2244 = _2238;
    vec3 _2246 = _150(_2240, _2244);
    _1159._m7 = _2246;
    vec2 _2248 = _1159._m6.xy;
    mat3 _2252 = _1159._m18;
    bool _2255 = _2238;
    _1159._m6 = _161(_2248, _2252, _2255);
    vec3 _2259 = dFdx(_1159._m15);
    vec3 _2263 = dFdy(_1159._m15);
    vec2 _2267 = _1159._m17.xy * _813._m4.xy;
    uint _2275 = uint(int(TEXTURE_LOD(SAMPLER_2D(_2276, _2278), vec4(_2267, 0.0, 0.0).xy, vec4(_2267, 0.0, 0.0).w).x * 255.0));
    if ((_2275 > 0u) && (_2275 < 255u))
    {
        int _2303 = _2306._m2;
        if (_2303 > 0)
        {
            _2303--;
            vec4 _2316 = _2320._m0[((uint(_2303) + _2275) - 1u) * 2u];
            vec4 _2330 = _2320._m0[(((uint(_2303) + _2275) - 1u) * 2u) + 1u];
            vec2 _2340 = vec2((_1159._m15.x * _2316.x) + ((_1159._m15.y * _2316.y) + ((_1159._m15.z * _2316.z) + _2316.w)), (_1159._m15.x * _2330.x) + ((_1159._m15.y * _2330.y) + ((_1159._m15.z * _2330.z) + _2330.w)));
            vec2 _2382 = vec2(dot(_2259, _2316.xyz), dot(_2259, _2330.xyz));
            vec2 _2392 = vec2(dot(_2263, _2316.xyz), dot(_2263, _2330.xyz));
            int _2402 = int(_1297._m15);
            vec4 _2406 = vec4(0.0);
            vec4 _2407 = vec4(0.0);
            vec4 _2408 = vec4(0.0);
            uint _2409 = uint(_2402);
            uint _2418 = _2409 + 0u;
            _2406 = textureGrad(sampler2D(_2415[nonuniformEXT(_2418)], _1780), _2340, _2382, _2392);
            uint _2429 = _2409 + 1u;
            _2407 = textureGrad(sampler2D(_2415[nonuniformEXT(_2429)], _1802), _2340, _2382, _2392);
            uint _2440 = _2409 + 2u;
            _2408 = textureGrad(sampler2D(_2415[nonuniformEXT(_2440)], _1814), _2340, _2382, _2392);
            vec2 _2450 = _2407.xy;
            bool _2453 = true;
            vec3 _2454 = _150(_2450, _2453);
            vec3 _2449 = _2454;
            float _2455 = _2407.w;
            float _2458 = _2407.z;
            vec3 _2461 = _2406.xyz;
            float _2464 = _2406.w;
            vec4 _2467 = _2408;
            float _2470 = _1297._m16;
            if (_2275 > _21(_2470))
            {
                _2461 *= _1297._m3.xyz;
                _2458 *= _1297._m3.w;
            }
            _1159._m0 = mix(_1159._m0, _2461, vec3(_2455));
            _1159._m2 = mix(_1159._m2, _2467.xyz, vec3(_2455));
            _1159._m22 = mix(_1159._m22, _2461 * (_2464 * 16.0), vec3(_2464));
            vec3 _2511 = _1159._m18[2];
            float _2514 = sign(dot(cross(_2330.xyz, _2316.xyz), _2511));
            vec3 _2532 = normalize(_2316.xyz + (_2511 * dot(_2316.xyz, _2511)));
            _2316 = vec4(_2532.x, _2532.y, _2532.z, _2316.w);
            vec3 _2541 = normalize(cross(_2511, _2316.xyz)) * _2514;
            _2330 = vec4(_2541.x, _2541.y, _2541.z, _2330.w);
            _2449 = ((_2316.xyz * _2449.x) + (_2330.xyz * _2449.y)) + (_2511 * _2449.z);
            vec3 _2560 = _2449;
            float _2562 = dot(_2560, _2511);
            _2449 = (_1159._m6 * _2562) + ((_2560 - (_2511 * _2562)) * dot(_1159._m6, _2511));
            _1159._m6 = normalize(_2449);
            vec3 _2584 = _2449;
            float _2586 = _2467.w;
            float _2589 = 1.0;
            _1159._m3 = mix(_1159._m3, _2467.w, _2458);
        }
    }
    uvec2 _2598 = uvec2(_1159._m17.xy);
    uint _2603 = _2598.x / 256u;
    uint _2608 = _2598.y / 256u;
    float _2613 = _1159._m17.z;
    bool _2616 = false;
    float _2617 = _141(_2613, _2616);
    float _2612 = _2617;
    float _2618 = log2(max(1.0, _2612 / _813._m5.z)) * _813._m5.w;
    uint _2628 = min(23u, uint(_2618));
    float _2634 = _813._m57;
    float _2640 = _813._m58;
    uint _2633 = (_21(_2634) + ((_2603 + (_21(_2640) * _2608)) * 24u)) + _2628;
    uvec2 _2652 = uvec2(_1159._m17.xy);
    uint _2657 = _2652.x / 32u;
    uint _2661 = _2652.y / 32u;
    float _2669 = _813._m59;
    uint _2665 = _2657 + (_2661 * _21(_2669));
    float _2676 = _1297._m30;
    uint _2675 = _21(_2676);
    uint _2680 = _2684._m0[_2633 * 64u];
    uint _2691 = _2680 & 255u;
    uint _2694 = _2684._m0[_2665 * 64u];
    uint _2699 = _2694 & 255u;
    uint _2707;
    uint _2709;
    uint _2711;
    if (_2691 < _2699)
    {
        _2707 = _2691;
        _2709 = _2680;
        _2711 = _2633;
    }
    else
    {
        _2707 = _2699;
        _2709 = _2694;
        _2711 = _2665;
    }
    vec3 _2717 = dFdx(_1159._m15);
    vec3 _2721 = dFdy(_1159._m15);
    uint _2725 = _2675 & 3u;
    bool _2728 = (_2675 & 4u) != 0u;
    uint _2732 = ((_2725 == 0u) && (!_2728)) ? 0u : _2707;
    uint _2740 = 1u;
    _2770 _2772;
    vec3 _3192;
    while (_2740 <= _2732)
    {
        uint _2749 = (_2711 * 64u) + _2740;
        uint _2754 = _2684._m0[_2749];
        uint _2758 = _2754;
        if (_2758 >= _2754)
        {
            _2740++;
        }
        int _2767 = 2;
        int _2768 = 2;
        int _2769 = 1;
        _2772._m0 = _2777._m0[(uint(_2767) * _2758) + 0u];
        _2772._m1 = _2777._m0[(uint(_2767) * _2758) + 1u];
        _2772._m2 = _2797._m0[(uint(_2768) * _2758) + 0u];
        float _2811 = _2797._m0[(uint(_2768) * _2758) + 1u].x;
        _2772._m3 = _21(_2811);
        float _2821 = _2797._m0[(uint(_2768) * _2758) + 1u].y;
        _2772._m4 = _21(_2821);
        float _2831 = _2797._m0[(uint(_2768) * _2758) + 1u].z;
        _2772._m5 = _21(_2831);
        float _2841 = _2797._m0[(uint(_2768) * _2758) + 1u].w;
        _2772._m6 = _21(_2841);
        float _2856 = _2850._m0[(uint(_2769) * _2758) + 0u].x;
        _2772._m7 = _21(_2856);
        float _2866 = _2850._m0[(uint(_2769) * _2758) + 0u].y;
        _2772._m8 = _21(_2866);
        float _2876 = _2850._m0[(uint(_2769) * _2758) + 0u].z;
        _2772._m9 = _21(_2876);
        vec4 _2881 = _2772._m0;
        vec4 _2884 = _2772._m1;
        vec4 _2887 = _2772._m2;
        vec3 _2890 = vec3(dot(_1159._m15, _2881.xyz) + _2881.w, dot(_1159._m15, _2884.xyz) + _2884.w, dot(_1159._m15, _2887.xyz) + _2887.w);
        float _2916 = 0.0039215688593685626983642578125;
        float _2918 = _2890.x;
        float _2921 = _2890.y;
        float _2924 = _2890.z;
        bool _2929 = _32(_2918, _2921, _2924) <= _2916;
        bool _2946;
        if (!_2929)
        {
            float _2933 = _2890.x;
            float _2936 = _2890.y;
            float _2939 = _2890.z;
            _2946 = _27(_2933, _2936, _2939) >= (1.0 - _2916);
        }
        else
        {
            _2946 = _2929;
        }
        if (_2946)
        {
            continue;
        }
        uint _2950 = _2772._m5;
        uint _2953 = _2772._m9;
        uint _2956 = _2675 & 3u;
        bool _2965 = ((_2953 & 512u) != 0u) && (_2956 != 0u);
        bool _2976;
        if (!_2965)
        {
            _2976 = ((_2953 & 1024u) != 0u) && (_2956 != 1u);
        }
        else
        {
            _2976 = _2965;
        }
        bool _2984;
        if (!_2976)
        {
            _2984 = (_2953 & 16384u) != 0u;
        }
        else
        {
            _2984 = _2976;
        }
        if (_2984)
        {
            continue;
        }
        vec2 _2988 = vec2(dot(_2717, _2881.xyz), dot(_2717, _2884.xyz));
        vec2 _2998 = vec2(dot(_2721, _2881.xyz), dot(_2721, _2884.xyz));
        vec4 _3008 = vec4(0.0);
        vec4 _3009 = vec4(0.0);
        uint _3010 = _2772._m3;
        uint _3016 = _3010 + 1u;
        vec4 _3013 = textureGrad(sampler2D(_2415[nonuniformEXT(_3016)], _1802), _2890.xy, _2988 * vec2(1.0), _2998 * vec2(1.0));
        if ((_2953 & 32768u) != 0u)
        {
            vec2 _3034 = vec2(1.0 / length(_2881.xyz), 1.0 / length(_2884.xyz));
            vec2 _3066 = TEXTURE_LOD(SAMPLER_2D(_3044, _3046), vec4(_2890.xy * _3034, 0.0, 0.0).xy, vec4(_2890.xy * _3034, 0.0, 0.0).w).xy;
            _3013 = vec4(_3066.x, _3066.y, _3013.z, _3013.w);
            vec2 _3073 = _3013.xy - vec2(0.4980392158031463623046875);
            float _3076 = 1.0 - _134(_3073);
            _3013.z = sqrt(_10(_3076));
        }
        else
        {
            if ((_2953 & 65536u) != 0u)
            {
                vec2 _3087 = vec2(1.0, (1.0 / length(_2884.xyz)) / 2.5);
                vec2 _3095 = TEXTURE_GRAD(SAMPLER_2D(_3096, _3046), _2890.xy * _3087, _2988 * _3087, _2998 * _3087).xy;
                vec2 _3116 = _3013.xy + (_3095 - vec2(0.4980392158031463623046875));
                _3013 = vec4(_3116.x, _3116.y, _3013.z, _3013.w);
                vec2 _3122 = _3013.xy - vec2(0.4980392158031463623046875);
                float _3125 = 1.0 - _134(_3122);
                _3013.z = sqrt(_10(_3125));
            }
        }
        if ((_2950 & 1u) != 0u)
        {
            uint _3136 = _3010 + 0u;
            _3008 = textureGrad(sampler2D(_2415[nonuniformEXT(_3136)], _1780), _2890.xy, _2988 * vec2(1.0), _2998 * vec2(1.0));
        }
        if ((_2950 & 2u) != 0u)
        {
            uint _3155 = _3010 + 2u;
            _3009 = textureGrad(sampler2D(_2415[nonuniformEXT(_3155)], _1814), _2890.xy, _2988 * vec2(1.0), _2998 * vec2(1.0));
        }
        float _3167 = 1.0;
        vec3 _3168 = vec3(0.5, 0.5, 1.0);
        vec3 _3170 = vec3(0.0, 0.0, 1.0);
        vec4 _3171 = _3013;
        _3168 = _3171.xyz;
        _3167 = _3171.w;
        _3170 = (_3168 * 2.0) - vec3(1.0);
        if (_3167 <= (4.0 * _2916))
        {
            continue;
        }
        _3168 = _3170;
        if ((_2953 & 128u) != 0u)
        {
            _3192 = vec3(-_3168.x, -_3168.y, _3168.z);
        }
        else
        {
            _3192 = _3168;
        }
        _3168 = _3192;
        uint _3207 = _2772._m6;
        uint _3211 = _3207;
        float _3210 = 1.0 + (_92(_3211).w * 0.062745101749897003173828125);
        uint _3219 = _2950;
        float _3218 = _89(_3219).z;
        uint _3224 = _3207;
        vec3 _3223 = _89(_3224).xyz;
        float _3237 = _3210 - (_3210 * abs((_2890.z * 2.0) - 1.0));
        _3167 *= _10(_3237);
        float _3241 = _3167;
        if ((_2950 & 1u) != 0u)
        {
            _3223 *= _3008.xyz;
            _3241 *= _3008.w;
        }
        vec3 _3256 = _1159._m18[2];
        float _3265 = dot(_3256, normalize(_2887.xyz));
        float _3259 = _10(_3265);
        uint _3267 = _2772._m7;
        uint _3271 = _3267;
        vec4 _3270 = _89(_3271);
        _1159._m22 = mix(_1159._m22, ((_3270.xyz * ((_3241 * _3270.w) * 16.0)) * _3218) * _3259, vec3(_3241));
        uint _3292 = _2772._m8;
        uint _3296 = _3292;
        vec4 _3295 = _89(_3296);
        if ((_2950 & 2u) != 0u)
        {
            _3295 = _3009;
        }
        if ((_2950 & 32u) != 0u)
        {
            uint _3311 = _2950;
            float _3310 = _89(_3311).x;
            uint _3316 = _2950;
            float _3315 = _92(_3316).y;
            float _3336 = dot((_2890.xy + _3170.xy) - vec2(0.5), (_2890.xy + _3170.xy) - vec2(0.5));
            float _3320 = _10(_3336);
            float _3344 = _3315 * (_3310 - _3320);
            float _3346 = _10(_3344);
            float _3338 = _82(_3346);
            _3167 = min(_3167, _3338);
        }
        float _3351 = _3167 * _3259;
        uint _3355 = _2772._m4;
        uint _3359 = _3355;
        vec4 _3358 = _89(_3359) * _3351;
        _1159._m9 = max(_1159._m9, _3358.x);
        _1159._m0 = mix(_1159._m0, _3223, _3358.xxx);
        _1159._m2 = mix(_1159._m2, _3295.xyz, _3358.yyy);
        if (!(_3351 == 0.0))
        {
            float _3389 = 1.0;
            vec3 _3399 = normalize(_2881.xyz + (_3256 * dot(_2881.xyz, _3256)));
            _2881 = vec4(_3399.x, _3399.y, _3399.z, _2881.w);
            vec3 _3408 = normalize(cross(_3256, _2881.xyz)) * _3389;
            _2884 = vec4(_3408.x, _3408.y, _3408.z, _2884.w);
            _3168 = ((_2881.xyz * _3168.x) + (_2884.xyz * _3168.y)) + (_3256 * _3168.z);
            if ((_2953 & 256u) != 0u)
            {
                vec3 _3432 = mix(_3256, _3168, _3358.www);
                float _3438 = dot(_3432, _3256);
                _3168 = (_1159._m6 * _3438) + ((_3432 - (_3256 * _3438)) * dot(_1159._m6, _3256));
            }
            else
            {
                if ((_2953 & 64u) != 0u)
                {
                    _3168 = mix(mix(_1159._m6, _3256, vec3(_3351)), _3168, _3358.www);
                }
                else
                {
                    _3168 = mix(_1159._m6, _3168, _3358.www);
                }
            }
            _1159._m6 = normalize(_3168);
        }
        float _3483 = _3295.w;
        _1159._m3 = mix(_1159._m3, _3483, _3358.z);
    }
    float _3493 = _813._m6.x;
    if (_3493 > 0.0)
    {
        vec2 _3500 = _1159._m17.xy * _813._m4.xy;
        vec3 _3508 = (TEXTURE_LOD(SAMPLER_2D(_3509, _3511), vec4(_3500, 0.0, 0.0).xy, vec4(_3500, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _3533 = dot(_3508, _1159._m6);
        _1159._m11 = _10(_3533);
        float _3541 = 1.0 - pow(_1159._m11, 0.699999988079071044921875);
        _1159._m11 = _10(_3541);
        _1159._m11 *= _1159._m11;
    }
    _1159._m21 = _1159._m22;
    _1159._m25 = 1.0;
    float _3554 = _813._m7.w;
    bool _3557 = _3554 < 0.0;
    _3554 = abs(_3554);
    vec3 _3562 = _1159._m15;
    float _3581 = (1.0 - (length(_3562 - vec3(_813._m38, _813._m39, _813._m40)) / _3554)) / 0.25;
    float _3565 = _10(_3581);
    if ((!_3557) && (_3565 > 0.0))
    {
        vec3 _3590 = _813._m7.xyz;
        vec3 _3594 = _813._m8.xyz;
        float _3598 = _3562.z - _3594.z;
        float _3604 = _813._m9.w;
        float _3607 = _813._m10.w;
        float _3610 = float(_3607 < 0.0);
        _3607 = abs(_3607) - 1.0;
        bool _3617 = _3598 <= 0.0;
        float _3620 = 3.5 * float(!(_3607 == 0.0));
        float _3629;
        if (!(_3604 == 0.0))
        {
            _3629 = _3590.z;
        }
        else
        {
            _3629 = _3594.z;
        }
        float _3626 = _3629;
        float _3638 = min(_3617 ? 2.0 : 1000.0, abs(_3598));
        float _3645 = max(_3590.x - _3562.x, _3562.x - _3594.x);
        float _3657 = max(_3590.y - _3562.y, _3562.y - _3594.y);
        float _3669 = max(_3645, _3657) - _3638;
        _3669 = max(_3669, _3626 - _3562.z);
        _3669 = max(_3669, _3598 - _3620);
        if (_3669 <= 0.0)
        {
            float _3690 = _3617 ? _3604 : _3607;
            vec2 _3695 = _1159._m18[2].xy;
            float _3699 = length(_3695);
            vec3 _3702 = vec3(_3695, (-1.73205077648162841796875) * _3699);
            _3702 /= vec3(2.0 * _3699);
            vec3 _3715 = _813._m10.xyz;
            vec3 _3719 = mix(_3702, _3715, bvec3(_3617));
            vec2 _3726 = _3562.xy - (_3719.xy * (_3598 / _3719.z));
            float _3737 = (_813._m60 / 100.0) * 16.0;
            vec2 _3744 = _3726 * _3737;
            float _3748 = TEXTURE_LOD(SAMPLER_2D(_3749, _3751), vec4(_3744, 0.0, 0.0).xy, vec4(_3744, 0.0, 0.0).w).x;
            float _3766 = min(8.0, _3594.z - _3590.z);
            float _3779 = (-_3598) / _3766;
            float _3774 = _10(_3779);
            float _3786 = dot(_1159._m6, _3719);
            float _3781 = _10(_3786);
            float _3792 = _3645 / _3638;
            float _3788 = 1.0 - _10(_3792);
            float _3798 = _3657 / _3638;
            _3788 *= (1.0 - _10(_3798));
            _3788 *= _3788;
            float _3814 = min(_3598 / 1.0, 1.0 - (_3598 / _3620));
            float _3806 = _10(_3814);
            _3788 *= max(_3806, _3774);
            _3788 *= _3788;
            _3788 *= _3565;
            float _3827 = _3748 - 1.0;
            float _3830 = float(_3617) * _3610;
            float _3835 = max(0.0, _3748 - 0.85000002384185791015625);
            float _3840 = _3617 ? _3827 : _3835;
            float _3845 = (((1.0 - _3830) * _3781) * _3788) * _3690;
            vec3 _3854 = _1159._m0 + (_1159._m2 * (vec3(1.0) - _1159._m0));
            _1159._m21 += ((_3854 * (_3840 * _3845)) * _813._m9.xyz);
            float _3878 = _3830 * _3788;
            _1159._m25 = 1.0 + (_3878 * (_3748 - 1.0));
        }
    }
    else
    {
        if (_3565 > 0.0)
        {
            _3565 *= _813._m61;
            float _3898 = float(_813._m10.w < 0.0);
            vec3 _3903 = _813._m10.xyz;
            float _3912 = dot(_1159._m6, _3903);
            float _3907 = _10(_3912);
            vec2 _3914 = _3562.xy - (_3903.xy * (_3562.z / _3903.z));
            float _3926 = (_813._m60 / 100.0) * 16.0;
            vec2 _3931 = _3914 * _3926;
            float _3935 = TEXTURE_LOD(SAMPLER_2D(_3749, _3751), vec4(_3931, 0.0, 0.0).xy, vec4(_3931, 0.0, 0.0).w).x;
            vec4 _3951 = _813._m9;
            _1159._m21 += (_3951.xyz * (((((1.0 - _3898) * (_3935 - 1.0)) * _3907) * _3565) * _3951.w));
            _1159._m25 = 1.0 + ((_3898 * (_3935 - 1.0)) * _3565);
        }
    }
    _1159._m14 = normalize(vec3(_813._m38, _813._m39, _813._m40) - _1159._m15);
    vec3 _3993 = vec3(0.0);
    bool _3994 = true;
    vec4 _4220;
    if (_3994 == true)
    {
        vec2 _3999 = vec2(_1297._m26, _1297._m27);
        vec4 _4005 = _1297._m5;
        vec2 _4008 = (_1159._m16.xy * _3999) + vec2(0.5);
        vec2 _4016 = floor(_4008);
        vec2 _4019 = fract(_4008);
        float _4023 = _4019.x;
        float _4022 = _204(_4023);
        float _4028 = _4019.x;
        float _4027 = _207(_4028);
        float _4033 = _4019.x;
        float _4032 = _210(_4033);
        float _4038 = _4019.x;
        float _4037 = _213(_4038);
        float _4043 = _4019.y;
        float _4042 = _210(_4043);
        float _4048 = _4019.y;
        float _4047 = _213(_4048);
        vec2 _4052 = (vec2(_4016.x + _4032, _4016.y + _4042) - vec2(0.5)) / _3999;
        vec2 _4066 = (vec2(_4016.x + _4037, _4016.y + _4042) - vec2(0.5)) / _3999;
        vec2 _4080 = (vec2(_4016.x + _4032, _4016.y + _4047) - vec2(0.5)) / _3999;
        vec2 _4094 = (vec2(_4016.x + _4037, _4016.y + _4047) - vec2(0.5)) / _3999;
        vec4 _4108 = textureLod(sampler2D(_2415[_1297._m22], _3511), vec4(clamp(_4052, _4005.xy, _4005.zw), 0.0, 0.0).xy, vec4(clamp(_4052, _4005.xy, _4005.zw), 0.0, 0.0).w);
        vec4 _4136 = textureLod(sampler2D(_2415[_1297._m22], _3511), vec4(clamp(_4066, _4005.xy, _4005.zw), 0.0, 0.0).xy, vec4(clamp(_4066, _4005.xy, _4005.zw), 0.0, 0.0).w);
        vec4 _4164 = textureLod(sampler2D(_2415[_1297._m22], _3511), vec4(clamp(_4080, _4005.xy, _4005.zw), 0.0, 0.0).xy, vec4(clamp(_4080, _4005.xy, _4005.zw), 0.0, 0.0).w);
        vec4 _4192 = textureLod(sampler2D(_2415[_1297._m22], _3511), vec4(clamp(_4094, _4005.xy, _4005.zw), 0.0, 0.0).xy, vec4(clamp(_4094, _4005.xy, _4005.zw), 0.0, 0.0).w);
        float _4221 = _4019.y;
        float _4233 = _4019.y;
        _4220 = (((_4108 * _4022) + (_4136 * _4027)) * _204(_4221)) + (((_4164 * _4022) + (_4192 * _4027)) * _207(_4233));
    }
    else
    {
        _4220 = texture(sampler2D(_2415[_1297._m22], _4251), _1159._m16.xy);
    }
    vec3 _4258 = texture(sampler2D(_2415[_1297._m23], _4251), _1159._m16.xy).xyz;
    vec3 _4270 = texture(sampler2D(_2415[_1297._m24], _4251), _1159._m16.xy).xyz;
    vec3 _4282 = texture(sampler2D(_2415[_1297._m25], _4251), _1159._m16.xy).xyz;
    vec4 _4294 = _4220;
    _4220 = _50(_4294);
    vec3 _4301 = _4220.xyz * _4220.w;
    _4220 = vec4(_4301.x, _4301.y, _4301.z, _4220.w);
    float _4306 = _4220.x;
    float _4309 = _4220.y;
    float _4312 = _4220.z;
    vec3 _4319 = _4220.xyz / vec3(max(9.9999999392252902907785028219223e-09, 1.0 - _27(_4306, _4309, _4312)));
    _4220 = vec4(_4319.x, _4319.y, _4319.z, _4220.w);
    _4258 = (_4258 * 2.0) - vec3(1.0);
    _4258 *= _4220.xyz;
    _4270 = (_4270 * 2.0) - vec3(1.0);
    _4270 *= _4220.xyz;
    _4282 = (_4282 * 2.0) - vec3(1.0);
    _4282 *= _4220.xyz;
    _4258 = -_4258;
    _4282 = -_4282;
    float _4373 = _1297._m21 * _813._m62;
    _3993 += (max(vec3(0.0), (((_4220.xyz + (_4258 * _1159._m6.y)) + (_4270 * _1159._m6.z)) + (_4282 * _1159._m6.x)) * _10(_4373)) * _1159._m0);
    vec3 _4382;
    _4382.x = dot(_4282, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375));
    _4382.y = dot(_4258, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375));
    _4382.z = dot(_4270, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375));
    float _4396 = length(_4382);
    if (_4396 > 9.9999997473787516355514526367188e-05)
    {
        _4382 /= vec3(_4396);
        vec3 _4408 = (((_4220.xyz + (_4258 * _4382.y)) + (_4270 * _4382.z)) + (_4282 * _4382.x)) / vec3(3.1415927410125732421875);
        vec3 _4430 = _1159._m6;
        vec3 _4433 = _1159._m14;
        vec3 _4436 = _4382;
        vec3 _4438 = _1159._m2;
        float _4441 = _1159._m3;
        _3993 += max(vec3(0.0), _4408 * _105(_4430, _4433, _4436, _4438, _4441));
    }
    _1159._m21 += _3993;
    bool _4454 = true;
    _4454 = (((_813._m64 & 1u) != 0u) == true) ? false : true;
    if (true && (_4454 == true))
    {
        uint _4467 = _4471._m0[_2633 * 64u];
        uint _4476 = _4467 & 255u;
        uint _4479 = _4471._m0[_2665 * 64u];
        uint _4484 = _4479 & 255u;
        uint _4492;
        uint _4494;
        uint _4496;
        if (_4476 < _4484)
        {
            _4492 = _4476;
            _4494 = _4467;
            _4496 = _2633;
        }
        else
        {
            _4492 = _4484;
            _4494 = _4479;
            _4496 = _2665;
        }
        float _4502 = _1159._m47;
        float _4511 = dot(_1159._m14, _1159._m6);
        float _4505 = _10(_4511);
        float _4513 = _4505;
        float _4515 = _1159._m3;
        vec3 _4518 = _1159._m2;
        _1159._m24 = (_111(_4513, _4515, _4518) * _1159._m11) * _1159._m39;
        float _4529 = _813._m11.x;
        float _4532 = _813._m11.z;
        bool _4536 = _4529 > 0.0;
        bool _4543;
        if (_4536)
        {
            _4543 = _1159._m3 > _4532;
        }
        else
        {
            _4543 = _4536;
        }
        if (_4543)
        {
            float _4546 = 0.0;
            vec3 _4547 = normalize(reflect(-_1159._m14, _1159._m6));
            if (dot(_1159._m14, _4547) <= _4546)
            {
                vec2 _4563 = vec2(1.0);
                uvec2 _4576 = uvec2(_1159._m17.xy * (vec2(1.0) / _4563));
                uint _4577 = uint(_813._m11.w);
                float _4564 = _178(_4576, _4577);
                _4564 -= 1.0;
                vec2 _4581 = _1159._m17.xy * _813._m4.xy;
                vec3 _4596 = vec3(_4581, _1159._m17.z);
                vec4 _4597 = _813._m12;
                vec4 _4600 = _813._m13;
                vec3 _4589 = _172(_4596, _4597, _4600);
                mat3 _4604 = mat3(vec3(_813._m14.xyz), vec3(_813._m15.xyz), vec3(_813._m16.xyz));
                mat3 _4628 = _4604;
                vec3 _4630 = _4547;
                vec3 _4627 = normalize(_71(_4628, _4630));
                float _4634 = 1.0;
                uint _4635 = uint((_4529 == 1.0) ? 8 : 12);
                _4635 = (_4529 == 3.0) ? 16u : _4635;
                vec3 _4645 = _4589;
                float _4650 = _1159._m17.z;
                bool _4653 = true;
                float _4654 = _141(_4650, _4653);
                vec3 _4647 = _4645 + (_4627 * _4654);
                vec4 _4657 = vec4(0.0);
                vec3 _4659 = _4645;
                vec4 _4661 = _813._m17;
                vec3 _4658 = _166(_4659, _4661);
                vec3 _4666 = _4647;
                vec4 _4668 = _813._m17;
                vec3 _4665 = _166(_4666, _4668);
                vec3 _4672 = ((_4665 - _4658) * (_4634 / float(_4635))) / vec3(length(_4665.xy - _4658.xy));
                vec3 _4689 = _4658 + (_4672 * _4564);
                float _4695 = abs(_4672.z) * 1.0;
                uint _4700 = 0u;
                vec3 _4701 = _4689;
                float _4703 = _4658.z;
                float _4889;
                for (uint _4706 = 0u; _4706 < _4635; _4706 += 4u)
                {
                    vec4 _4715 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_4706));
                    
                    vec4 _4721 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_4722, _4724), vec4(_4689.xy + (_4672.xy * _4715.x), 0.0, 0.0).xy, 
                    vec4(_4689.xy + (_4672.xy * _4715.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4722, _4724), vec4(_4689.xy + (_4672.xy * _4715.y), 0.0, 0.0).xy, 
                    vec4(_4689.xy + (_4672.xy * _4715.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4722, _4724), vec4(_4689.xy + (_4672.xy * _4715.z), 0.0, 0.0).xy,  
                    vec4(_4689.xy + (_4672.xy * _4715.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_4722, _4724), vec4(_4689.xy + (_4672.xy * _4715.w), 0.0, 0.0).xy, 
                    vec4(_4689.xy + (_4672.xy * _4715.w), 0.0, 0.0).w).x);
                    
                    uvec4 _4843 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_4689.zzzz + (_4672.zzzz * _4715)) - _4721) - vec4(_4695)), vec4(_4695)));
                    uint _4862 = (((_4843.x << uint(0)) | (_4843.y << uint(1))) | (_4843.z << uint(2))) | (_4843.w << uint(3));
                    if (_4862 > 0u)
                    {
                        uint _4883 = _4862;
                        uint _4882 = uint(_44(_4883));
                        if (_4882 > 0u)
                        {
                            _4889 = _4721[_4882 - 1u];
                        }
                        else
                        {
                            _4889 = _4703;
                        }
                        _4703 = _4889;
                        _4701 = _4689 + (_4672 * float((_4706 + _4882) + 1u));
                        float _4908 = _4721[_4882] - _4701.z;
                        float _4915 = (_4703 - _4701.z) + _4672.z;
                        float _4929 = _4908 / (_4908 - _4915);
                        float _4923 = _10(_4929);
                        vec3 _4931 = _4701 - _4672;
                        _4701 = (_4931 * _4923) + (_4701 * (1.0 - _4923));
                        _4700 = _4706 + _4882;
                        break;
                    }
                    _4703 = _4721.w;
                }
                if (_4700 > 0u)
                {
                    vec3 _4956 = _4701;
                    vec4 _4958 = _813._m18;
                    vec4 _4961 = _813._m19;
                    vec4 _4964 = _813._m20;
                    vec4 _4967 = _813._m21;
                    vec3 _4955 = _64(_4956, _4958, _4961, _4964, _4967).xyw;
                    vec2 _4977 = _4955.xy / vec2(_4955.z);
                    _4955 = vec3(_4977.x, _4977.y, _4955.z);
                    vec2 _4980 = (_4955.xy * 2.0) - vec2(1.0);
                    float _4994 = (1.0 - (float(_4700) / float(_4635))) * 4.0;
                    float _4986 = _10(_4994);
                    if (false)
                    {
                        float _4998 = _4980.y;
                        float _5003 = 1.0 - _56(_4998);
                        _4986 *= smoothstep(0.0, 0.25, _10(_5003));
                    }
                    else
                    {
                        float _5013 = 1.0 - dot(_4980, _4980);
                        _4986 *= smoothstep(0.0, 0.5, _10(_5013));
                    }
					// SSR IS HERE!
					// FIX
                    vec3 _5018 = textureLod(sampler2D(_5019, _3511), vec4(_4955.xy, 0.0, 0.0).xy, vec4(_4955.xy, 0.0, 0.0).w).xyz;
                    _4657 = vec4(_5018, _4986);
                }
                float _5051 = 1.0 - ((1.0 - _1159._m3) / (1.0 - _4532));
                float _5043 = _10(_5051);
                float _5053 = (_4657.w * _5043) * _813._m63;
                _1159._m21 += ((_4657.xyz * _5053) * _1159._m24);
                _4502 = 1.0 - _5053;
            }
        }
        uint _5075 = 1u;
        _5112 _5114;
        while (_5075 <= _4492)
        {
            uint _5084 = (_4496 * 64u) + _5075;
            uint _5089 = _4471._m0[_5084];
            uint _5093 = _5089;
            if (_5093 >= _5089)
            {
                _5075++;
            }
            float _5102 = 0.0039215688593685626983642578125;
            if (_4502 <= (_5102 * 4.0))
            {
                break;
            }
            int _5110 = 4;
            int _5111 = 4;
            _5114._m0 = _5118._m0[(uint(_5110) * _5093) + 0u].xyz;
            float _5133 = _5118._m0[(uint(_5110) * _5093) + 0u].w;
            _5114._m1 = _21(_5133);
            _5114._m2 = _5118._m0[(uint(_5110) * _5093) + 1u].xyz;
            _5114._m3 = _5118._m0[(uint(_5110) * _5093) + 1u].w;
            _5114._m4 = _5118._m0[(uint(_5110) * _5093) + 2u];
            float _5168 = _5118._m0[(uint(_5110) * _5093) + 3u].x;
            _5114._m8 = _21(_5168);
            float _5178 = _5118._m0[(uint(_5110) * _5093) + 3u].y;
            _5114._m9 = _21(_5178);
            _5114._m10 = _5118._m0[(uint(_5110) * _5093) + 3u].z;
            _5114._m5 = _5194._m0[(uint(_5111) * _5093) + 0u];
            _5114._m6 = _5194._m0[(uint(_5111) * _5093) + 1u];
            _5114._m7 = _5194._m0[(uint(_5111) * _5093) + 2u];
            _5114._m12 = _5194._m0[(uint(_5111) * _5093) + 3u].xyz;
            _5114._m13 = _5194._m0[(uint(_5111) * _5093) + 3u].w;
            vec3 _5236 = vec3(dot(_1159._m15, _5114._m5.xyz) + _5114._m5.w, dot(_1159._m15, _5114._m6.xyz) + _5114._m6.w, dot(_1159._m15, _5114._m4.xyz) + _5114._m4.w);
            float _5265 = _5236.x;
            float _5268 = _5236.y;
            float _5271 = _5236.z;
            bool _5276 = _32(_5265, _5268, _5271) <= _5102;
            bool _5293;
            if (!_5276)
            {
                float _5280 = _5236.x;
                float _5283 = _5236.y;
                float _5286 = _5236.z;
                _5293 = _27(_5280, _5283, _5286) >= (1.0 - _5102);
            }
            else
            {
                _5293 = _5276;
            }
            if (_5293)
            {
                continue;
            }
            uint _5297 = _5114._m1;
            vec3 _5300 = _5114._m0;
            float _5303 = float(bitfieldExtract(_5114._m8, 20, 12));
            float _5308 = 0.800000011920928955078125;
            vec3 _5309 = (_5236 * 2.0) - vec3(1.0);
            vec3 _5314 = _5309;
            vec3 _5313 = _53(_5314);
            vec3 _5317 = _5309 * sqrt(((vec3(1.0) - (_5313.yzx * 0.5)) - (_5313.zxy * 0.5)) + ((_5313.yzx * _5313.zxy) / vec3(3.0)));
            float _5348 = 1.0 - ((length(_5317) - _5308) / ((1.0 - _5308) + 9.9999999747524270787835121154785e-07));
            float _5337 = _10(_5348);
            _5337 *= _5337;
            _5337 *= _4502;
            float _5356 = _5114._m7.w;
            _5337 *= _5356;
            _4502 *= (1.0 - _5337);
            vec3 _5366 = _5114._m12;
            float _5369 = _5114._m13;
            float _5374 = _5337;
            vec3 _5372 = _5366 * (_10(_5374) * _5369);
            vec3 _5380 = _5114._m2;
            vec3 _5383 = _5114._m7.xyz;
            vec3 _5387 = vec3(0.0);
            vec3 _5388 = reflect(-_1159._m14, _1159._m6);
            vec3 _5395 = (_5383 - _1159._m15) / _5388;
            vec3 _5402 = (_5380 - _1159._m15) / _5388;
            vec3 _5409 = max(_5395, _5402);
            float _5414 = _5409.x;
            float _5417 = _5409.y;
            float _5420 = _5409.z;
            float _5413 = _32(_5414, _5417, _5420);
            vec3 _5424 = _1159._m15 + (_5388 * _5413);
            vec3 _5431 = _5424 - _5300;
            float _5435 = 6.0;
            float _5436 = _5435 - (_5435 * _1159._m3);
            _5387 = textureLod(samplerCubeArray(_5445, _5447), vec4(_5431, _5303), _5436).xyz;
            _1159._m21 += ((_5387 * _5372) * _1159._m24);
        }
    }
    uint _5470 = _5474._m0[_2633 * 64u];
    uint _5479 = _5470 & 255u;
    uint _5482 = _5474._m0[_2665 * 64u];
    uint _5487 = _5482 & 255u;
    uint _5495;
    uint _5497;
    uint _5499;
    if (_5479 < _5487)
    {
        _5495 = _5479;
        _5497 = _5470;
        _5499 = _2633;
    }
    else
    {
        _5495 = _5487;
        _5497 = _5482;
        _5499 = _2665;
    }
    uint _5505 = 1u;
    _5112 _5534;
    vec3 _5661;
    float _5799;
    vec2 _5867;
    _6065 _6067;
    _6065 _6214;
    while (_5505 <= _5495)
    {
        uint _5514 = (_5499 * 64u) + _5505;
        uint _5519 = _5474._m0[_5514];
        uint _5523 = _5519;
        if (_5523 >= _5519)
        {
            _5505++;
        }
        int _5532 = 4;
        int _5533 = 4;
        _5534._m0 = _5118._m0[(uint(_5532) * _5523) + 0u].xyz;
        float _5549 = _5118._m0[(uint(_5532) * _5523) + 0u].w;
        _5534._m1 = _21(_5549);
        _5534._m2 = _5118._m0[(uint(_5532) * _5523) + 1u].xyz;
        _5534._m3 = _5118._m0[(uint(_5532) * _5523) + 1u].w;
        _5534._m4 = _5118._m0[(uint(_5532) * _5523) + 2u];
        float _5584 = _5118._m0[(uint(_5532) * _5523) + 3u].x;
        _5534._m8 = _21(_5584);
        float _5594 = _5118._m0[(uint(_5532) * _5523) + 3u].y;
        _5534._m9 = _21(_5594);
        _5534._m10 = _5118._m0[(uint(_5532) * _5523) + 3u].z;
        _5534._m5 = _5194._m0[(uint(_5533) * _5523) + 0u];
        _5534._m6 = _5194._m0[(uint(_5533) * _5523) + 1u];
        _5534._m7 = _5194._m0[(uint(_5533) * _5523) + 2u];
        _5534._m12 = _5194._m0[(uint(_5533) * _5523) + 3u].xyz;
        _5534._m13 = _5194._m0[(uint(_5533) * _5523) + 3u].w;
        float _5648 = 0.0;
        uint _5649 = _5534._m1;
        vec3 _5652 = _5534._m0;
        vec3 _5655 = _5652;
        if ((_5649 & 7u) == 2u)
        {
            _5661 = _5655;
        }
        else
        {
            _5661 = normalize(_5652 - _1159._m15);
        }
        vec3 _5657 = _5661;
        uint _5672 = uint(((_2675 & 3u) != 0u) ? 16 : 0);
        _5672 |= 32u;
        float _5685 = dot(_1159._m6, _5657);
        float _5680 = _10(_5685);
        bool _5687 = _5680 <= _5648;
        bool _5692 = _5687 == true;
        bool _5700;
        if (!_5692)
        {
            _5700 = (_5649 & _5672) != 0u;
        }
        else
        {
            _5700 = _5692;
        }
        if (_5700)
        {
            continue;
        }
        vec3 _5704 = vec3(dot(_1159._m15, _5534._m5.xyz) + _5534._m5.w, dot(_1159._m15, _5534._m6.xyz) + _5534._m6.w, dot(_1159._m15, _5534._m7.xyz) + _5534._m7.w);
        vec2 _5738 = _5704.xy / vec2(_5704.z);
        _5704 = vec3(_5738.x, _5738.y, _5704.z);
        _5704.z = dot(_1159._m15, _5534._m4.xyz) + _5534._m4.w;
        float _5751 = _5704.x;
        float _5754 = _5704.y;
        float _5757 = _5704.z;
        bool _5762 = _32(_5751, _5754, _5757) <= _5648;
        bool _5779;
        if (!_5762)
        {
            float _5766 = _5704.x;
            float _5769 = _5704.y;
            float _5772 = _5704.z;
            _5779 = _27(_5766, _5769, _5772) >= (1.0 - _5648);
        }
        else
        {
            _5779 = _5762;
        }
        if (_5779)
        {
            continue;
        }
        vec3 _5783 = vec3(1.0);
        uint _5784 = _5649 & 7u;
        vec3 _5787 = _5534._m0 - _1159._m15;
        float _5793 = dot(_5787, _5787);
        if (_5784 != 2u)
        {
            _5799 = 1.0 / (1.0 + _5793);
        }
        else
        {
            _5799 = _1159._m25;
        }
        _5783 = vec3(_5799);
        if (_5784 == 0u)
        {
            float _5819 = _5793 * _5534._m3;
            float _5822 = 1.0 - _56(_5819);
            float _5824 = _10(_5822);
            float _5814 = _56(_5824);
            _5783 *= _5814;
        }
        else
        {
            if (_5784 == 4u)
            {
                float _5840 = length((_5704.xy - vec2(0.5)) * 2.0);
                float _5834 = _10(_5840);
                float _5842 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_5834 * 7.80000019073486328125))));
                _5783 *= _5842;
            }
            else
            {
                if ((_5784 == 1u) || (_5784 == 2u))
                {
                    if (_5784 == 2u)
                    {
                        _5867 = fract((_5704.xy * _813._m22.xy) + _813._m22.zw);
                    }
                    else
                    {
                        _5867 = _5704.xy;
                    }
                    vec2 _5864 = _5867;
                    vec3 _5885 = vec3(0.0);
                    uint _5886 = bitfieldExtract(_5534._m8, 0, 20);
                    uint _5890 = _5886;
                    uint _5894 = _5890 + 0u;
                    vec3 _5910 = textureLod(sampler2D(_2415[nonuniformEXT(_5894)], _1836), vec4(_5864, 0.0, 0.0).xy, vec4(_5864, 0.0, 0.0).w).xyz;
                    _5885 = _53(_5910);
                    _5783 *= _5885;
                }
            }
        }
        float _5916 = float((_5649 >> uint(8)) & 255u) / 255.0;
        if ((_5784 == 0u) || (_5784 == 2u))
        {
            vec3 _5929 = abs((_5704 * 2.0) - vec3(1.0));
            float _5935 = _5929.x;
            float _5938 = _5929.y;
            float _5941 = _5929.z;
            float _5946 = 1.0 - _27(_5935, _5938, _5941);
            float _5951 = _10(_5946) / (9.9999999392252902907785028219223e-09 + _5916);
            float _5934 = _10(_5951);
            _5783 *= ((_5934 * _5934) * (3.0 - (2.0 * _5934)));
        }
        else
        {
            if ((_5784 == 1u) || (_5784 == 4u))
            {
                float _5971 = _5704.z;
                float _5975 = _56(_5971);
                float _5978 = 1.0 - _56(_5975);
                float _5980 = _10(_5978);
                float _5985 = _56(_5980) / (9.9999999392252902907785028219223e-09 + _5916);
                float _5970 = _10(_5985);
                _5783 *= _5970;
            }
        }
        float _5990 = _5783.x;
        float _5993 = _5783.y;
        float _5996 = _5783.z;
        if (_27(_5990, _5993, _5996) <= _5648)
        {
            continue;
        }
        float _6005 = 1.0;
        if ((_5649 & 8u) != 0u)
        {
            float _6012 = 0.00999999977648258209228515625;
            vec3 _6014 = _1159._m15 + (_1159._m6 * _6012);
            uint _6022 = 0u;
            if ((_5649 & 7u) == 0u)
            {
                vec3 _6028 = _6014 - _5534._m2;
                float _6033 = _6028.x;
                float _6036 = _6028.y;
                float _6039 = _6028.z;
                _6022 = _38(_6033, _6036, _6039);
            }
            else
            {
                if ((_5649 & 7u) == 2u)
                {
                    float _6049 = 0.0;
                    uint _6050 = uint((_813._m23.w > 0.0) ? 3 : 4);
                    for (; _6022 < _6050; _6022++)
                    {
                        int _6064 = 5;
                        _6067._m0 = _6072._m0[(uint(_6064) * ((_5649 >> uint(22)) + _6022)) + 0u];
                        _6067._m1 = _6072._m0[(uint(_6064) * ((_5649 >> uint(22)) + _6022)) + 1u];
                        _6067._m2 = _6072._m0[(uint(_6064) * ((_5649 >> uint(22)) + _6022)) + 2u];
                        _6067._m3 = _6072._m0[(uint(_6064) * ((_5649 >> uint(22)) + _6022)) + 3u];
                        _6067._m4 = _6072._m0[(uint(_6064) * ((_5649 >> uint(22)) + _6022)) + 4u];
                        vec2 _6128 = vec2(dot(_6014, _6067._m0.xyz) + _6067._m0.w, dot(_6014, _6067._m1.xyz) + _6067._m1.w);
                        _6128 = abs((_6128 * 2.0) - vec2(1.0));
                        bool _6154 = _6128.x < 0.9900000095367431640625;
                        bool _6160;
                        if (_6154)
                        {
                            _6160 = _6128.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _6160 = _6154;
                        }
                        if (_6160)
                        {
                            _6049 = (1.0 - max(_6128.x, _6128.y)) * _813._m24.w;
                            break;
                        }
                    }
                    _1159._m36 = int(_6022);
                    _6022 = min((_6050 - 1u), _6022);
                    if (_813._m23.w > 0.0)
                    {
                        uint _6187 = uint(_1159._m17.x) ^ (uint(_1159._m17.y) << uint(1));
                        _6187 ^= uint(_813._m25.x);
                        _6022 += uint(int(((float(_6187 & 3u) * 0.25) + 0.125) > _6049));
                    }
                }
            }
            int _6213 = 5;
            _6214._m0 = _6072._m0[(uint(_6213) * ((_5649 >> uint(22)) + _6022)) + 0u];
            _6214._m1 = _6072._m0[(uint(_6213) * ((_5649 >> uint(22)) + _6022)) + 1u];
            _6214._m2 = _6072._m0[(uint(_6213) * ((_5649 >> uint(22)) + _6022)) + 2u];
            _6214._m3 = _6072._m0[(uint(_6213) * ((_5649 >> uint(22)) + _6022)) + 3u];
            _6214._m4 = _6072._m0[(uint(_6213) * ((_5649 >> uint(22)) + _6022)) + 4u];
            vec4 _6270 = vec4((_6014.x * _6214._m0.x) + ((_6014.y * _6214._m0.y) + ((_6014.z * _6214._m0.z) + _6214._m0.w)), (_6014.x * _6214._m1.x) + ((_6014.y * _6214._m1.y) + ((_6014.z * _6214._m1.z) + _6214._m1.w)), (_6014.x * _6214._m2.x) + ((_6014.y * _6214._m2.y) + ((_6014.z * _6214._m2.z) + _6214._m2.w)), (_6014.x * _6214._m3.x) + ((_6014.y * _6214._m3.y) + ((_6014.z * _6214._m3.z) + _6214._m3.w)));
            vec3 _6357 = _6270.xyz / vec3(_6270.w);
            _6270 = vec4(_6357.x, _6357.y, _6357.z, _6270.w);
            bool _6365 = min(_6270.x, _6270.y) > 0.0;
            bool _6374;
            if (_6365)
            {
                _6374 = max(_6270.x, _6270.y) < 1.0;
            }
            else
            {
                _6374 = _6365;
            }
            if (_6374)
            {
                vec2 _6386 = (_6270.xy * _6214._m4.xy) + _6214._m4.zw;
                _6270 = vec4(_6386.x, _6386.y, _6270.z, _6270.w);
                if (false)
                {
                    _6005 = textureLod(sampler2DShadow(_6393, _6395), vec3(_6270.xyz.xy, _6270.xyz.z), 0.0);
                }
                else
                {
                    vec2 _6404 = (_6270.xy * _813._m26.xy) + vec2(0.5);
                    vec2 _6413 = floor(_6404);
                    vec2 _6416 = _6404 - _6413;
                    _6413 -= vec2(0.5);
                    vec2 _6423 = vec2(4.0) - (_6416 * 3.0);
                    vec2 _6428 = vec2(7.0);
                    vec2 _6431 = vec2(1.0) + (_6416 * 3.0);
                    vec2 _6436 = (_6413 + (((vec2(3.0) - (_6416 * 2.0)) / _6423) - vec2(2.0))) * _813._m26.zw;
                    vec2 _6451 = (_6413 + ((vec2(3.0) + _6416) / _6428)) * _813._m26.zw;
                    vec2 _6463 = (_6413 + ((_6416 / _6431) + vec2(2.0))) * _813._m26.zw;
                    vec3 _6489 = vec3(_6436.x, _6436.y, _6270.z);
                    _6005 = (_6423.x * _6423.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6489.xy, _6489.z), 0.0);
                    vec3 _6507 = vec3(_6451.x, _6436.y, _6270.z);
                    _6005 += ((_6428.x * _6423.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6507.xy, _6507.z), 0.0));
                    vec3 _6527 = vec3(_6463.x, _6436.y, _6270.z);
                    _6005 += ((_6431.x * _6423.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6527.xy, _6527.z), 0.0));
                    vec3 _6547 = vec3(_6436.x, _6451.y, _6270.z);
                    _6005 += ((_6423.x * _6428.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6547.xy, _6547.z), 0.0));
                    vec3 _6567 = vec3(_6451.x, _6451.y, _6270.z);
                    _6005 += ((_6428.x * _6428.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6567.xy, _6567.z), 0.0));
                    vec3 _6587 = vec3(_6463.x, _6451.y, _6270.z);
                    _6005 += ((_6431.x * _6428.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6587.xy, _6587.z), 0.0));
                    vec3 _6607 = vec3(_6436.x, _6463.y, _6270.z);
                    _6005 += ((_6423.x * _6431.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6607.xy, _6607.z), 0.0));
                    vec3 _6627 = vec3(_6451.x, _6463.y, _6270.z);
                    _6005 += ((_6428.x * _6431.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6627.xy, _6627.z), 0.0));
                    vec3 _6647 = vec3(_6463.x, _6463.y, _6270.z);
                    _6005 += ((_6431.x * _6431.y) * textureLod(sampler2DShadow(_6393, _6395), vec3(_6647.xy, _6647.z), 0.0));
                    _6005 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _6005 = float((_5649 & 7u) == 2u);
                if ((_5649 & 7u) == 2u)
                {
                    _1159._m36 = -1;
                }
            }
            float _6667 = float((_5649 >> uint(16)) & 63u) / 63.0;
            float _6681 = ((_6005 * _6667) + 1.0) - _6667;
            _6005 = _10(_6681);
        }
        if (_6005 <= _5648)
        {
            continue;
        }
        vec3 _6689 = (_5534._m12 * _6005) * _5783;
        float _6696 = _5534._m13;
        vec3 _6699 = _6689;
        float _6706 = dot(_1159._m6, _5657);
        float _6701 = _10(_6706);
        float _6708 = 1.0;
        vec3 _6710 = _1159._m6;
        vec3 _6713 = _1159._m14;
        vec3 _6716 = _5657;
        vec3 _6718 = _1159._m2;
        float _6721 = _1159._m3;
        vec3 _6709 = _105(_6710, _6713, _6716, _6718, _6721);
        _1159._m21 += ((((_6709 * _6696) * _6699) * _6701) * _6708);
        vec3 _6738 = _6699;
        _1159._m21 += ((_6738 * _6701) * _1159._m0);
    }
    _1159._m21 *= _1159._m11;
    _6757 = vec4(_1159._m21, 0.0);
    if (((_813._m64 & 1u) != 0u) == true)
    {
        vec3 _6772 = _1159._m6;
        bool _6775 = false;
        vec2 _6776 = _186(_6772, _6775);
        _6771 = vec4(_6776, 0.0, 0.0);
        float _6786 = dot(_1159._m14, _1159._m6);
        float _6780 = _10(_6786);
        float _6789 = _6780;
        float _6791 = _1159._m3;
        vec3 _6794 = _1159._m2;
        vec3 _6788 = _111(_6789, _6791, _6794);
        float _6799 = _6788.x;
        float _6803 = _6788.y;
        float _6807 = _6788.z;
        float _6811 = _1159._m3;
        _6798 = vec4(_82(_6799), _82(_6803), _82(_6807), _189(_6811));
    }
}





