// Self Shadow Mask Fix
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _113
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _122
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _3564
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _4510
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _709_711
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    uint _m61;
    float _m62[2];
} _711;

layout(set = 2, binding = 0, std140) uniform _1040_1042
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    uint _m23;
    uint _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    uint _m29;
    float _m30;
    uint _m31;
    uint _m32;
    float _m33;
    uint _m34;
    uint _m35;
    uint _m36;
    uint _m37;
    uint _m38;
    float _m39;
    uint _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    uint _m61;
    uint _m62;
    uint _m63;
    int _m64;
    uint _m65;
    float _m66[3];
} _1042;

layout(set = 1, binding = 0, std140) uniform _1052_1054
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    uint _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    int _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    uint _m68;
} _1054;

layout(set = 3, binding = 0, std140) uniform _1094_1096
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _1096;

layout(set = 0, binding = 30, std430) restrict readonly buffer _3470_3472
{
    uint _m0[];
} _3472;

layout(set = 0, binding = 31, std140) uniform _3569_3571
{
    vec4 _m0[4096];
} _3571;

layout(set = 0, binding = 32, std140) uniform _3645_3647
{
    vec4 _m0[4096];
} _3647;

layout(set = 0, binding = 34, std430) restrict readonly buffer _3934_3936
{
    uint _m0[];
} _3936;

layout(set = 0, binding = 35, std140) uniform _4515_4517
{
    vec4 _m0[4095];
} _4517;

layout(set = 0, binding = 1, std140) uniform _6316_6318
{
    vec4 _m0[64];
} _6318;

layout(push_constant, std430) uniform _6312_6314
{
    int _m0;
    int _m1;
    int _m2;
} _6314;

layout(set = 3, binding = 1) uniform texture2D _1138[5];
layout(set = 0, binding = 12) uniform sampler _1146;
layout(set = 3, binding = 3) uniform texture2D _1164[5];
layout(set = 0, binding = 13) uniform sampler _1169;
layout(set = 3, binding = 2) uniform texture2D _1176[5];
layout(set = 0, binding = 14) uniform sampler _1181;
layout(set = 3, binding = 4) uniform texture2D _1198[5];
layout(set = 0, binding = 15) uniform sampler _1203;
layout(set = 3, binding = 5) uniform texture2D _1210[5];
layout(set = 0, binding = 16) uniform sampler _1215;
layout(set = 3, binding = 7) uniform texture2D _1222[5];
layout(set = 0, binding = 17) uniform sampler _1227;
layout(set = 3, binding = 8) uniform texture2D _1234[5];
layout(set = 0, binding = 18) uniform sampler _1239;
layout(set = 4, binding = 0) uniform texture2D _1323[34816];
layout(set = 0, binding = 19) uniform sampler _1328;
layout(set = 3, binding = 6) uniform texture2D _1860[5];
layout(set = 0, binding = 20) uniform sampler _1865;
layout(set = 0, binding = 21) uniform TEXTURE_2D _2360;
layout(set = 0, binding = 22) uniform TEXTURE_2D _2476;
layout(set = 0, binding = 23) uniform TEXTURE_2D _2507;
layout(set = 0, binding = 24) uniform TEXTURE_2D _2596;
layout(set = 0, binding = 25) uniform TEXTURE_2D _2629;
layout(set = 0, binding = 26) uniform TEXTURE_2D _2814;
layout(set = 0, binding = 27) uniform sampler _2816;
layout(set = 0, binding = 28) uniform TEXTURE_2D _3051;
layout(set = 0, binding = 29) uniform sampler _3053;
layout(set = 0, binding = 33) uniform textureCubeArray _3900;
layout(set = 0, binding = 10) uniform sampler _3902;
layout(set = 0, binding = 36) uniform texture2D _4838;
layout(set = 0, binding = 37) uniform samplerShadow _4840;
layout(set = 0, binding = 38) uniform TEXTURE_2D _5259;
layout(set = 0, binding = 39) uniform sampler _5261;
layout(set = 0, binding = 40) uniform TEXTURE_2D _5524;
layout(set = 0, binding = 41) uniform TEXTURE_2D _6207;
layout(set = 0, binding = 7) uniform texture3D _6321;
layout(set = 0, binding = 8) uniform sampler _6322;
layout(set = 0, binding = 9) uniform texture3D _6323;

layout(location = 17, component = 3) in float _921;
layout(location = 18, component = 0) in float _923;
layout(location = 18, component = 1) in float _928;
layout(location = 18, component = 2) in float _930;
layout(location = 18, component = 3) in float _932;
layout(location = 19, component = 0) in float _960;
layout(location = 19, component = 1) in float _962;
layout(location = 19, component = 2) in float _964;
layout(location = 19, component = 3) in float _968;
layout(location = 20, component = 0) in float _970;
layout(location = 20, component = 1) in float _972;
layout(location = 20, component = 2) in float _984;
layout(location = 10, component = 0) in vec4 _1009;
layout(location = 11, component = 0) in vec4 _1012;
layout(location = 12, component = 0) in vec4 _1015;
layout(location = 21, component = 1) in float _1983;
layout(location = 17, component = 2) in float _2212;
layout(location = 23, component = 0) in float _2448;
layout(location = 22, component = 3) in float _2473;
layout(location = 21, component = 3) in float _5465;
layout(location = 22, component = 0) in float _5468;
layout(location = 22, component = 1) in float _5471;
layout(location = 22, component = 2) in float _5474;
layout(location = 21, component = 2) in float _5905;
layout(location = 17, component = 1) in float _5954;
layout(location = 0, component = 0) out vec4 _6126;
layout(location = 1, component = 0) out vec4 _6140;
layout(location = 2, component = 0) out vec4 _6167;
uint _172;
uint _174;
uint _176;
uint _178;
uint _180;
uint _182;
uint _184;
uint _185;
uint _187;
uint _188;
uint _190;
uint _192;
uint _194;
uint _196;
uint _198;
uint _200;
uint _202;
uint _204;
uint _206;

_122 _124()
{
    _122 _603;
    _603._m0 = vec3(0.0);
    _603._m2 = vec3(0.0);
    _603._m3 = 0.0;
    _603._m4 = 0u;
    _603._m5 = 0.0;
    _603._m6 = vec3(0.0);
    _603._m7 = vec3(0.0, 0.0, 1.0);
    _603._m8 = vec3(0.0, 0.0, 1.0);
    _603._m1 = vec3(0.0);
    _603._m9 = 1.0;
    _603._m10 = 1.0;
    _603._m14 = vec3(0.0);
    _603._m15 = vec3(0.0);
    _603._m16 = vec4(0.0);
    _603._m17 = vec4(0.0);
    _603._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _603._m19 = vec3(0.0);
    _603._m20 = vec3(0.0);
    _603._m21 = vec3(0.0);
    _603._m22 = vec3(0.0);
    _603._m23 = vec3(0.0);
    _603._m24 = vec3(0.0);
    _603._m25 = 1.0;
    _603._m26 = uvec4(0u);
    _603._m27 = uvec4(0u);
    _603._m28 = uvec4(0u);
    _603._m29 = vec4(0.0);
    _603._m30 = vec4(0.0);
    _603._m31 = vec4(0.0);
    _603._m32 = vec4(0.0);
    _603._m33 = uvec2(0u);
    _603._m34 = vec2(0.0);
    _603._m35 = 0.0;
    _603._m36 = -1;
    _603._m37 = 0;
    _603._m38 = vec2(0.0);
    _603._m39 = 1.0;
    _603._m41 = -1;
    _603._m45 = 1.0;
    _603._m11 = 1.0;
    _603._m12 = 0u;
    _603._m13 = uvec3(0u);
    _603._m40 = vec3(0.0);
    _603._m46 = 0.0;
    _603._m47 = 1.0;
    return _603;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_113 _115()
{
    _113 _591;
    _591._m0 = vec4(0.0);
    _591._m1 = vec4(0.0);
    _591._m2 = vec4(0.0);
    _591._m3 = vec4(0.0);
    _591._m4 = vec4(0.0);
    _591._m5 = 0.0;
    return _591;
}

vec2 _136(vec2 _135)
{
    return ((_135 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _141(inout vec2 _139, bool _140)
{
    vec2 _743 = _139;
    _139 = _136(_743);
    float _763 = (1.0 - (_139.x * _139.x)) - (_139.y * _139.y);
    vec3 _746 = vec3(_139.x, _139.y, sqrt(_10(_763)));
    if (_140 == false)
    {
        _746.z = -_746.z;
    }
    return _746;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _87(inout vec4 _86)
{
    vec4 _411 = _86;
    _86 = _22(_411);
    return packUnorm4x8(_86.wzyx);
}

float _27(vec3 _25, vec3 _26)
{
    return dot(_25, _26);
}

vec4 _92(uint _91)
{
    return unpackUnorm4x8(_91).wzyx;
}

vec3 _69(mat3 _67, vec3 _68)
{
    return _67 * _68;
}

vec3 _146(vec3 _144, mat3 _145)
{
    mat3 _779 = _145;
    vec3 _781 = _144;
    return normalize(_69(_779, _781));
}

vec3 _152(vec2 _149, mat3 _150, bool _151)
{
    vec2 _788 = _149;
    bool _790 = _151;
    vec3 _792 = _141(_788, _790);
    vec3 _787 = _792;
    vec3 _793 = _787;
    mat3 _795 = _150;
    return _146(_793, _795);
}

float _131(inout float _129, bool _130)
{
    if (_130)
    {
        _129 += (float(_129 < _711._m24) * _711._m25);
    }
    float _724 = _129;
    return _711._m0.w / (_10(_724) + _711._m0.z);
}

uint _32(float _31)
{
    return floatBitsToUint(_31);
}

float _72(float _71)
{
    return exp2(_71);
}

vec3 _111(float _108, float _109, vec3 _110)
{
    float _542 = 0.0949999988079071044921875 + (_109 * (0.60000002384185791015625 + (4.190000057220458984375 * _109)));
    float _552 = _108 + 0.02500000037252902984619140625;
    float _556 = (9.5 * _109) * _108;
    float _570 = 1.0 - (14.0 * _108);
    float _562 = (_542 * _552) * _72(_570);
    float _577 = -_556;
    float _573 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _72(_577)));
    return mix(vec3(_562), vec3(_573), _110);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec3 _52(vec3 _51)
{
    return _51 * _51;
}

float _55(float _54)
{
    return _54 * _54;
}

uint _49(float _46, float _47, float _48)
{
    bool _253 = abs(_48) >= abs(_46);
    bool _261;
    if (_253)
    {
        _261 = abs(_48) >= abs(_47);
    }
    else
    {
        _261 = _253;
    }
    if (_261)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

vec4 _62(vec3 _60, mat4 _61)
{
    return vec4((_60.x * _61[0].x) + ((_60.y * _61[0].y) + ((_60.z * _61[0].z) + _61[0].w)), (_60.x * _61[1].x) + ((_60.y * _61[1].y) + ((_60.z * _61[1].z) + _61[1].w)), (_60.x * _61[2].x) + ((_60.y * _61[2].y) + ((_60.z * _61[2].z) + _61[2].w)), (_60.x * _61[3].x) + ((_60.y * _61[3].y) + ((_60.z * _61[3].z) + _61[3].w)));
}

float _158(uvec2 _156, uint _157)
{
    uvec2 _800 = _156 & uvec2(3u);
    return float(((((2068378560u * (1u - (_800.x >> uint(1)))) + (1500172770u * (_800.x >> uint(1)))) >> ((_800.y + ((_800.x & 1u) << uint(2))) << uint(2))) + _157) & 15u) / 16.0;
}

float _77(float _75, float _76)
{
    return pow(_75, _76);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _97(vec3 _95, float _96)
{
    float _429 = dot(_95, vec3(16.666500091552734375));
    float _424 = _10(_429);
    float _438 = 1.0 - _96;
    float _441 = _10(_438);
    float _442 = 5.0;
    vec3 _446 = _95 + ((vec3(_424) - _95) * _77(_441, _442));
    return _16(_446);
}

vec3 _105(vec3 _100, vec3 _101, vec3 _102, vec3 _103, float _104)
{
    float _454 = dot(_100, _101);
    float _450 = _10(_454);
    vec3 _456 = normalize(_101 + _102);
    float _465 = dot(_100, _456);
    float _461 = _10(_465);
    float _471 = dot(_102, _456);
    float _467 = _10(_471);
    vec3 _474 = _103;
    float _476 = _467;
    vec3 _473 = _97(_474, _476);
    float _483 = dot(_100, _102);
    float _479 = _10(_483);
    float _485 = 1.0 - (_104 * 0.800000011920928955078125);
    _485 *= _485;
    _485 *= _485;
    float _496 = _485 * _485;
    float _500 = ((_461 * _461) * (_496 - 1.0)) + 1.0;
    _500 = _496 / ((_500 * _500) + 9.9999999392252902907785028219223e-09);
    float _515 = (_450 * (1.0 - _485)) + _485;
    float _522 = (_479 * (1.0 - _485)) + _485;
    _500 /= (((4.0 * _515) * _522) + 9.9999999392252902907785028219223e-09);
    return _473 * _500;
}

vec2 _161(vec2 _160)
{
    return (vec2(1.0) - abs(_160.yx)) * vec2((_160.x >= 0.0) ? 1.0 : (-1.0), (_160.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _166(inout vec3 _164, bool _165)
{
    _164 /= vec3((abs(_164.x) + abs(_164.y)) + abs(_164.z));
    vec2 _869;
    if (_164.z >= 0.0)
    {
        _869 = _164.xy;
    }
    else
    {
        vec2 _875 = _164.xy;
        _869 = _161(_875);
    }
    _164 = vec3(_869.x, _869.y, _164.z);
    if (_165)
    {
        vec2 _890 = (_164.xy * 0.5) + vec2(0.5);
        _164 = vec3(_890.x, _890.y, _164.z);
    }
    return _164.xy;
}

float _80(float _79)
{
    return sqrt(_79);
}

float _83(float _82)
{
    return sqrt(_82);
}

float _169(float _168)
{
    float _900 = abs(_168);
    float _897 = _83(_900);
    float _904;
    if (_168 > 0.0)
    {
        _904 = _897;
    }
    else
    {
        _904 = -_897;
    }
    return (_904 * 0.5) + 0.5;
}

void main()
{
    _172 = 2147483648u;
    _174 = 1073741824u;
    _176 = 0u;
    _178 = 268435456u;
    _180 = 536870912u;
    _182 = 805306368u;
    _184 = 1073741824u;
    _185 = 1342177280u;
    _187 = 0u;
    _188 = 16777216u;
    _190 = 33554432u;
    _192 = 50331648u;
    _194 = 67108864u;
    _196 = 83886080u;
    _198 = 100663296u;
    _200 = 117440512u;
    _202 = 134217728u;
    _204 = 150994944u;
    _206 = 167772160u;
    float _916 = 0.0;
    float _917 = 1.0;
    _122 _918 = _124();
    _918._m16 = vec4(0.0, 0.0, _921, _923);
    vec3 _927 = vec3(_928, _930, _932);
    _918._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _918._m15 = vec3(_711._m35, _711._m36, _711._m37) + _927;
    vec3 _958 = vec3(0.0);
    vec3 _959 = vec3(0.0);
    _958 = normalize(vec3(_960, _962, _964));
    _959 = normalize(vec3(_968, _970, _972));
    vec3 _976 = _958;
    vec3 _978 = _959;
    vec3 _980 = normalize(cross(_976, _978) * _984);
    _918._m18 = mat3(vec3(_978), vec3(_980), vec3(_976));
    _918._m14 = normalize(-_927);
    _918._m29 = _1009;
    _918._m30 = _1012;
    _918._m31 = _1015;
    uint _1018 = 0u;
    vec4 _1019 = vec4(0.0);
    vec4 _1020 = vec4(0.0);
    vec4 _1021 = vec4(0.0);
    vec4 _1022 = vec4(0.0);
    vec4 _1023 = vec4(0.0);
    float _1024 = 0.0;
    uvec2 _1025 = uvec2(0u, 65535u);
    vec2 _1028 = _918._m16.zw;
    vec2 _1032 = _1028;
    vec2 _1034 = _1028;
    float _1036 = 0.0009765625;
    vec3 _1049;
    if ((_1042._m65 & 1u) != 0u)
    {
        _1049 = vec3(_1054._m46, _1054._m47, _1054._m48);
    }
    else
    {
        _1049 = vec3(1.0);
    }
    vec3 _1038 = _1049;
    float _1066 = 1.0;
    float _1067 = _1054._m49;
    bool _1071 = _1067 > 0.0;
    float _1074 = 1.0;
    uint _1075 = _1025.x;
    uint _1078 = _1075 & 7u;
    uint _1082 = _1078;
    uint _1084 = _1082;
    float _1086 = 0.0;
    vec2 _1087 = _1032;
    _1087.x *= _1096._m1[_1084].w;
    _1087.y *= _1096._m2[_1084].x;
    _1087.x += (_711._m53 * _1096._m2[_1084].y);
    _1087.y += (_711._m53 * _1096._m2[_1084].z);
    vec2 _1132 = _1087;
    uint _1140 = _1084;
    vec3 _1134 = (texture(sampler2D(_1138[nonuniformEXT(_1140)], _1146), _1132).xyz * vec3(_1096._m0[_1084].x)) + vec3(_1096._m0[_1084].y);
    uint _1166 = _1084;
    vec2 _1163 = texture(sampler2D(_1164[nonuniformEXT(_1166)], _1169), _1132).xy;
    uint _1178 = _1084;
    vec3 _1175 = (texture(sampler2D(_1176[nonuniformEXT(_1178)], _1181), _1132).xyz * vec3(_1096._m0[_1084].z)) + vec3(_1096._m0[_1084].w);
    uint _1200 = _1084;
    float _1197 = texture(sampler2D(_1198[nonuniformEXT(_1200)], _1203), _1132).x;
    uint _1212 = _1084;
    float _1209 = texture(sampler2D(_1210[nonuniformEXT(_1212)], _1215), _1132).x;
    uint _1224 = _1084;
    vec3 _1221 = texture(sampler2D(_1222[nonuniformEXT(_1224)], _1227), _1132).xyz;
    uint _1236 = _1084;
    float _1233 = texture(sampler2D(_1234[nonuniformEXT(_1236)], _1239), _1132).x;
    _1019 = vec4(_1134.x, _1134.y, _1134.z, _1019.w);
    _1019.w = 0.0;
    _1020 = vec4(_1175.x, _1175.y, _1175.z, _1020.w);
    _1020.w = _1209;
    _1021 = vec4(_1163.x, _1163.y, _1021.z, _1021.w);
    _1022.x = 0.0;
    _1022.y = _1086;
    _1022.z = _1209;
    _1022.w = _1197;
    _1024 = _1233;
    _1074 = _1096._m1[_1084].x;
    vec3 _1274 = _1221 * _1096._m3[_1084].xyz;
    _1023 = vec4(_1274.x, _1274.y, _1274.z, _1023.w);
    float _1277 = _1071 ? _1067 : _1074;
    vec3 _1286 = _1023.xyz * vec3(_1277);
    _1023 = vec4(_1286.x, _1286.y, _1286.z, _1023.w);
    vec2 _1289 = vec2(0.0);
    _113 _1290;
    _1290._m0 = _1019;
    _1290._m1 = _1020;
    _1290._m2 = _1022;
    _1290._m3 = _1021;
    _1290._m4 = _1023;
    _1290._m5 = _1024;
    _1289 = _1290._m3.xy;
    _1290._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1290._m3.z, _1290._m3.w);
    bool _1310 = (_1042._m65 & 4u) != 0u;
    if (_1310)
    {
        vec4 _1319 = vec4(0.0);
        _1319 = texture(sampler2D(_1323[_1042._m40], _1328), _1032);
        _1319 *= _1042._m7;
        _1319 = min(_1319, vec4(1.0));
        float _1340 = (_1024 - 0.4980392158031463623046875) * _1042._m17;
        for (int _1347 = 0; _1347 < 4; _1347++)
        {
            float _1355 = _1319[_1347];
            if (!(_1355 == 0.0))
            {
                float _1363 = 0.0;
                vec2 _1364 = vec2(_1042._m3[_1347]);
                uint _1369 = uint(_1347 + 1);
                uint _1373 = _1369 & 7u;
                uint _1376 = _1373;
                uint _1378 = _1376;
                uint _1381 = _1378;
                _1363 = texture(sampler2D(_1234[nonuniformEXT(_1381)], _1239), _1028 * _1364).x;
                _1363 -= 0.4980392158031463623046875;
                _1363 *= _1042._m6[_1347];
                float _1398 = (_1340 + 1.0) - _1355;
                float _1403 = (_1363 + 0.0) + _1355;
                float _1408 = _1403 - _1398;
                float _1412 = (clamp(_1408 / _1042._m10[_1347], -1.0, 1.0) / 2.0) + 0.5;
                float _1422 = 0.100000001490116119384765625;
                float _1424 = abs(0.5 - _1355);
                float _1435 = (_1424 - (0.5 - _1422)) / _1422;
                float _1428 = _10(_1435);
                float _1437 = 0.0;
                if ((_1355 < _1422) && (_1412 > _1355))
                {
                    _1437 = mix(_1412, _1355, _1428);
                }
                else
                {
                    if ((_1355 > (1.0 - _1422)) && (_1412 < _1355))
                    {
                        _1437 = mix(_1412, _1355, _1428);
                    }
                    else
                    {
                        _1437 = _1412;
                    }
                }
                float _1468 = _1042._m4[_1347];
                float _1472 = _1042._m8[_1347];
                float _1476 = _1042._m11[_1347];
                float _1480 = _1042._m9[_1347];
                float _1484 = _1042._m5[_1347];
                _113 _1488 = _115();
                float _1490 = _1054._m49;
                bool _1493 = _1490 > 0.0;
                float _1496 = 1.0;
                uint _1497 = uint(_1347 + 1);
                uint _1501 = _1497 & 7u;
                uint _1504 = _1501;
                uint _1506 = _1504;
                float _1508 = 0.0;
                vec2 _1509 = _1028 * _1364;
                _1509.x *= _1096._m1[_1506].w;
                _1509.y *= _1096._m2[_1506].x;
                _1509.x += (_711._m53 * _1096._m2[_1506].y);
                _1509.y += (_711._m53 * _1096._m2[_1506].z);
                vec2 _1547 = _1509;
                uint _1551 = _1506;
                vec3 _1549 = (texture(sampler2D(_1138[nonuniformEXT(_1551)], _1146), _1547).xyz * vec3(_1096._m0[_1506].x)) + vec3(_1096._m0[_1506].y);
                uint _1571 = _1506;
                vec2 _1569 = texture(sampler2D(_1164[nonuniformEXT(_1571)], _1169), _1547).xy;
                uint _1581 = _1506;
                vec3 _1579 = (texture(sampler2D(_1176[nonuniformEXT(_1581)], _1181), _1547).xyz * vec3(_1096._m0[_1506].z)) + vec3(_1096._m0[_1506].w);
                uint _1601 = _1506;
                float _1599 = texture(sampler2D(_1198[nonuniformEXT(_1601)], _1203), _1547).x;
                uint _1611 = _1506;
                float _1609 = texture(sampler2D(_1210[nonuniformEXT(_1611)], _1215), _1547).x;
                uint _1621 = _1506;
                vec3 _1619 = texture(sampler2D(_1222[nonuniformEXT(_1621)], _1227), _1547).xyz;
                uint _1631 = _1506;
                float _1629 = texture(sampler2D(_1234[nonuniformEXT(_1631)], _1239), _1547).x;
                _1488._m0 = vec4(_1549.x, _1549.y, _1549.z, _1488._m0.w);
                _1488._m0.w = 0.0;
                _1488._m1 = vec4(_1579.x, _1579.y, _1579.z, _1488._m1.w);
                _1488._m1.w = _1609;
                _1488._m3 = vec4(_1569.x, _1569.y, _1488._m3.z, _1488._m3.w);
                _1488._m2.x = 0.0;
                _1488._m2.y = _1508;
                _1488._m2.z = _1609;
                _1488._m2.w = _1599;
                _1488._m5 = _1629;
                _1496 = _1096._m1[_1506].x;
                vec3 _1671 = _1619 * _1096._m3[_1506].xyz;
                _1488._m4 = vec4(_1671.x, _1671.y, _1671.z, _1488._m4.w);
                float _1675 = _1493 ? _1490 : _1496;
                vec3 _1685 = _1488._m4.xyz * vec3(_1675);
                _1488._m4 = vec4(_1685.x, _1685.y, _1685.z, _1488._m4.w);
                _1290._m0 = mix(_1290._m0, _1488._m0, vec4(_1437 * _1468));
                _1290._m1 = mix(_1290._m1, _1488._m1, vec4(_1437 * _1476));
                _1290._m2.w = mix(_1290._m2.w, _1488._m2.w, _1437 * _1480);
                vec3 _1726 = mix(_1290._m2.xyz, _1488._m2.xyz, vec3(_1437));
                _1290._m2 = vec4(_1726.x, _1726.y, _1726.z, _1290._m2.w);
                _1290._m3 = mix(_1290._m3, _1488._m3, vec4(_1437 * _1472));
                _1290._m4 = mix(_1290._m4, _1488._m4, vec4(_1437 * _1484));
                _1290._m5 = mix(_1290._m5, _1488._m5, _1437);
            }
        }
    }
    _1019 = _1290._m0;
    _1020 = _1290._m1;
    _1022.w = _1290._m2.w;
    _1021 = _1290._m3;
    _1023 = _1290._m4;
    _1024 = _1290._m5;
    vec2 _1774 = _1289;
    bool _1776 = true;
    vec3 _1777 = _141(_1774, _1776);
    vec3 _1772 = _1777;
    vec2 _1779 = _1021.xy;
    bool _1782 = true;
    vec3 _1783 = _141(_1779, _1782);
    vec3 _1778 = _1783;
    vec3 _1784 = _1772 + vec3(0.0, 0.0, 1.0);
    vec3 _1787 = vec3(-_1778.xy, _1778.z);
    vec3 _1796 = (_1784 * dot(_1784, _1787)) - (_1787 * _1784.z);
    vec3 _1808 = normalize(_1796);
    _1021 = vec4(_1808.x, _1808.y, _1808.z, _1021.w);
    vec3 _1813 = _1021.xyz + vec3(1.0);
    _1021 = vec4(_1813.x, _1813.y, _1813.z, _1021.w);
    vec3 _1818 = _1021.xyz * 0.5;
    _1021 = vec4(_1818.x, _1818.y, _1818.z, _1021.w);
    _918._m22 = _1023.xyz * _1038;
    vec3 _1826 = vec3(0.0);
    vec3 _1827 = vec3(0.0);
    float _1828 = 0.0;
    uint _1829 = 0u;
    uint _1830 = _1829 & 7u;
    uint _1833 = _1830;
    uint _1835 = _1833;
    vec4 _1837 = vec4(_1028, 0.0, _1042._m42);
    uint _1846 = _1835;
    vec2 _1856 = texture(sampler2D(_1164[nonuniformEXT(_1846)], _1169), _1837.xy, _1837.w).xy;
    _1826 = vec3(_1856.x, _1856.y, _1826.z);
    uint _1862 = _1835;
    vec4 _1859 =texture(sampler2D(_1860[nonuniformEXT(_1862)], _1865), _1837.xy, _1837.w);
    _1827 = _1859.xyz;
    _1828 = _1859.w;
    _918._m8 = _1826;
    float _1884 = _1828 * _1042._m46;
    float _1879 = _10(_1884);
    vec4 _1892 = vec4(_1827, _1879);
    uint _1893 = _87(_1892);
    _918._m4 = _1893;
    float _1900 = (1.0 - _1879) * _1042._m41;
    _918._m10 = _10(_1900);
    _918._m0 = _1019.xyz;
    _918._m2 = _1020.xyz;
    _918._m1 = _1023.xyz;
    _918._m3 = _1022.w;
    _918._m6 = _1021.xyz;
    float _1918 = 0.0;
    vec3 _1919 = vec3(0.0);
    bool _1922 = _1042._m12.x < 1.0;
    bool _1930;
    if (!_1922)
    {
        _1930 = _1054._m52 < 1.0;
    }
    else
    {
        _1930 = _1922;
    }
    if (_1930)
    {
        vec4 _1933 = texture(sampler2D(_1323[_1042._m63], _1328), vec2(_921, _923) * _1042._m14.xy);
        vec3 _1949 = vec3((_1933.xy * 2.0) - vec2(1.0), 0.0);
        vec3 _1958 = _1949;
        vec3 _1960 = _1949;
        _1949.z = sqrt(1.0 - min(_27(_1958, _1960), 1.0));
        _1949 = normalize(_1949);
        _1949.z *= 1.0;
        _1949.z *= (_1949.z * _1949.z);
        float _1982 = _1983;
        float _1985 = 1.0 - _1982;
        vec4 _1988 = vec4(1.0);
        if (_1042._m60 > 0.0)
        {
            _1988 = texture(sampler2D(_1323[_1042._m61], _1328), vec2(_921, _923));
            _1985 = _1988.y;
        }
        float _2013 = 1.0 - (_1985 * _1985);
        float _2008 = _10(_2013);
        float _2015 = _2008 * _2008;
        float _2019 = (_2008 * _2008) * _2008;
        float _2025 = 1.0 - _2008;
        float _2028 = _2008 * _1933.z;
        vec4 _2033 = vec4(0.0);
        _2033 = texture(sampler2D(_1323[_1042._m24], _1328), vec2(_921, _923) * _1042._m14.xy);
        if ((_1042._m65 & 2u) != 0u)
        {
            _2028 = ((_2008 * _2008) * _2008) * _2033.z;
        }
        float _2068 = (_2015 * 8.0) - 7.0;
        float _2062 = _10(_2068);
        float _2079 = ((_2028 * (1.0 + _2025)) - (1.0 - _2019)) + _2062;
        _2028 = _10(_2079);
        float _2083 = _2028 * 16.0;
        _2028 = _10(_2083);
        float _2085 = _2028 * _2028;
        float _2089 = _2085 * mix(1.0, 0.25, _2008);
        float _2098 = _1933.z;
        float _2095 = _1949.z * _10(_2098);
        if (((_1042._m65 & 2u) != 0u) == false)
        {
            _918._m0 = mix(_918._m0, _918._m0 * mix(mix(_1042._m0.xyz, vec3(_1042._m18, _1042._m19, _1042._m20), vec3(_2095, _2095, _2095)), _1042._m0.xyz, vec3(_2019 * _2085)), vec3(_2028 * mix(1.0, _2019, _1042._m22)));
            float _2147 = _2085 * _1042._m21;
            _918._m0 = mix(_918._m0, mix(_1042._m0.xyz, vec3(_1042._m18, _1042._m19, _1042._m20), vec3(_2008)), vec3((_2147 * _2095) * _2008));
            _1918 = _1933.z;
            _1919 = mix(_918._m6, mix(_918._m6, _1933.xyz, vec3(0.1500000059604644775390625)), vec3((_1933.z * _1933.z) * _1054._m66));
            _918._m2 = mix(_918._m2, vec3(0.0199999995529651641845703125), vec3(_2085));
            _918._m3 = mix(_918._m3, 0.75, _2085);
        }
        float _2211 = _2212;
        if ((_1042._m65 & 2u) != 0u)
        {
            vec2 _2228 = mix(_918._m6.xy, _2033.xy, vec2(1.0 - _1985));
            _918._m6 = vec3(_2228.x, _2228.y, _918._m6.z);
        }
        else
        {
            vec2 _2240 = mix(_918._m6.xy, _1933.xy, vec2(_2089));
            _918._m6 = vec3(_2240.x, _2240.y, _918._m6.z);
            vec2 _2251 = mix(_918._m6.xy, _2033.xy, vec2(_2211));
            _918._m6 = vec3(_2251.x, _2251.y, _918._m6.z);
        }
        vec3 _2255 = mix(vec3(0.00999999977648258209228515625), vec3(0.119999997317790985107421875, 0.10999999940395355224609375, 0.100000001490116119384765625), vec3(_2033.z));
        float _2265 = mix(0.100000001490116119384765625, 0.699999988079071044921875, _2033.z);
        _918._m0 = mix(_918._m0, _2255, vec3(_2211));
        _918._m3 = mix(_918._m3, _2265, _2211);
        _918._m2 = mix(_918._m2, vec3(0.048000000417232513427734375), vec3(_2211));
        if ((_1042._m65 & 2u) != 0u)
        {
            vec3 _2297 = vec3(0.0);
            _918._m0 = mix(_918._m0, _2255, vec3(1.0 - _1985));
            _918._m3 = mix(_918._m3, _2265, 1.0 - _1985);
            _918._m2 = mix(_918._m2, vec3(0.048000000417232513427734375), vec3(1.0 - _1985));
            _918._m22 = mix(vec3(_2033.z * _2033.z) * vec3(1.0, 0.070000000298023223876953125, 0.0), _918._m22, vec3(_1985));
            _2297 = (((mix(vec3(mix(mix(_2033.w, _2033.z, 1.0 - _1985), 0.0, _1985)), _918._m22, vec3(_1985)) * vec3(1.0, 0.070000000298023223876953125, 0.0)) * 25.0) * _918._m6.x) * _918._m6.y;
            float _2359 = SAMPLE_TEXTURE(SAMPLER_2D(_2360, _1328), (vec2(_921, _923) * vec2(_1042._m1.x)) + vec2(0.0, _711._m53 * _1042._m1.z)).x;
            float _2380 = SAMPLE_TEXTURE(SAMPLER_2D(_2360, _1328), (vec2(_921, _923) * vec2(_1042._m1.y)) - vec2(0.0, _711._m53 * _1042._m1.w)).x;
            _2359 *= _2359;
            _2380 *= _2380;
            float _2406 = _2359 * _2380;
            float _2412 = _2406 + 0.119999997317790985107421875;
            _2406 = _10(_2412);
            _918._m22 += (_2297 * _2406);
        }
    }
    if (_1054._m45 > 0.0)
    {
        uint _2426 = 0u;
        uint _2427 = _2426 & 7u;
        uint _2430 = _2427;
        vec3 _2432 = vec3(_928, _930, _932);
        vec3 _2437 = vec3(_711._m35, _711._m36, _711._m37) + _2432;
        float _2447 = _2448;
        vec2 _2450 = _2437.yz + vec2(_2447);
        vec2 _2456 = _2437.xz + vec2(_2447);
        _2450 *= _1042._m14.zw;
        _2456 *= _1042._m14.zw;
        float _2472 = _2473;
        vec3 _2475 = SAMPLE_TEXTURE(SAMPLER_2D(_2476, _1328), _2450).xyz;
        vec3 _2483 = SAMPLE_TEXTURE(SAMPLER_2D(_2476, _1328), _2456).xyz;
        vec3 _2490 = mix(_2483, _2475, vec3(_2472));
        float _2496 = _1054._m45;
        _918._m0 = mix(_918._m0, _2490, vec3(_2496));
        vec3 _2506 = SAMPLE_TEXTURE(SAMPLER_2D(_2507, _1328), _2450).xyw;
        vec3 _2514 = SAMPLE_TEXTURE(SAMPLER_2D(_2507, _1328), _2456).xyw;
        vec3 _2521 = mix(_2514, _2506, vec3(_2472));
        vec2 _2534 = mix(_918._m6.xy, _2521.xy, vec2(_2496));
        _918._m6 = vec3(_2534.x, _2534.y, _918._m6.z);
        _918._m8 = vec3(_918._m6.xy.x, _918._m6.xy.y, _918._m8.z);
        _918._m2 = (_918._m2 * (1.0 - _2496)) + vec3(0.017999999225139617919921875 * _2496);
        _918._m3 = mix(_918._m3, 0.699999988079071044921875, _2496);
        _918._m5 = _1054._m45;
        uint _2564 = _918._m4;
        vec4 _2563 = _92(_2564);
        vec4 _2586 = vec4(mix(_2563.xyz, vec3(_2521.z) * vec3(0.36000001430511474609375, 0.86000001430511474609375, 1.0), vec3(_2496)), _2563.w);
        uint _2587 = _87(_2586);
        _918._m4 = _2587;
    }
    if ((_711._m61 & 1u) != 0u)
    {
        vec4 _2595 = TEXTURE_LOD(SAMPLER_2D(_2596, _1328), vec4(_918._m17.xy * _711._m6.xy, 0.0, 0.0).xy, vec4(_918._m17.xy * _711._m6.xy, 0.0, 0.0).w);
        if (_2595.w > 0.0)
        {
            vec4 _2628 = SAMPLE_TEXTURE(SAMPLER_2D(_2629, _1328), _918._m16.zw * _1042._m58);
            float _2642 = _2628.w;
            float _2641 = _10(_2642);
            _918._m6 = mix(_1919, _2628.xyz, vec3(_2641));
            _918._m3 = mix(_918._m3, 0.87999999523162841796875, max(_1918, _2641));
            _918._m3 = max(_1042._m59, _918._m3);
            _918._m0 = mix(_918._m0, _918._m0 * _1042._m57, vec3(max(_1918, _2641)));
        }
    }
    uint _2682 = 0u;
    bool _2683 = true;
    vec2 _2684 = _918._m6.xy;
    bool _2688 = _2683;
    vec3 _2690 = _141(_2684, _2688);
    _918._m7 = _2690;
    vec2 _2692 = _918._m6.xy;
    mat3 _2696 = _918._m18;
    bool _2699 = _2683;
    _918._m6 = _152(_2692, _2696, _2699);
    vec2 _2703 = _918._m8.xy;
    mat3 _2707 = _918._m18;
    bool _2710 = _2683;
    _918._m8 = _152(_2703, _2707, _2710);
    uvec2 _2714 = uvec2(_918._m17.xy);
    uint _2719 = _2714.x / 256u;
    uint _2724 = _2714.y / 256u;
    float _2729 = _918._m17.z;
    bool _2732 = false;
    float _2733 = _131(_2729, _2732);
    float _2728 = _2733;
    float _2734 = log2(max(1.0, _2728 / _711._m7.z)) * _711._m7.w;
    uint _2744 = min(23u, uint(_2734));
    float _2751 = _711._m54;
    float _2757 = _711._m55;
    uint _2749 = (_32(_2751) + ((_2719 + (_32(_2757) * _2724)) * 24u)) + _2744;
    uvec2 _2769 = uvec2(_918._m17.xy);
    uint _2774 = _2769.x / 32u;
    uint _2779 = _2769.y / 32u;
    float _2787 = _711._m56;
    uint _2783 = _2774 + (_2779 * _32(_2787));
    float _2794 = _1054._m53;
    uint _2793 = _32(_2794);
    float _2798 = _711._m8.x;
    if (_2798 > 0.0)
    {
        vec2 _2805 = _918._m17.xy * _711._m6.xy;
        vec3 _2813 = (TEXTURE_LOD(SAMPLER_2D(_2814, _2816), vec4(_2805, 0.0, 0.0).xy, vec4(_2805, 0.0, 0.0).w).xyz * 2.0) - vec3(1.0);
        float _2838 = dot(_2813, _918._m6);
        _918._m11 = _10(_2838);
        float _2845 = 1.0 - pow(_918._m11, 0.699999988079071044921875);
        _918._m11 = _10(_2845);
        _918._m11 *= _918._m11;
    }
    _918._m21 = _918._m22;
    _918._m25 = 1.0;
    float _2858 = _711._m9.w;
    bool _2861 = _2858 < 0.0;
    _2858 = abs(_2858);
    vec3 _2866 = _918._m15;
    float _2884 = (1.0 - (length(_2866 - vec3(_711._m35, _711._m36, _711._m37)) / _2858)) / 0.25;
    float _2869 = _10(_2884);
    if ((!_2861) && (_2869 > 0.0))
    {
        vec3 _2893 = _711._m9.xyz;
        vec3 _2897 = _711._m10.xyz;
        float _2901 = _2866.z - _2897.z;
        float _2907 = _711._m11.w;
        float _2910 = _711._m12.w;
        float _2913 = float(_2910 < 0.0);
        _2910 = abs(_2910) - 1.0;
        bool _2920 = _2901 <= 0.0;
        float _2923 = 3.5 * float(!(_2910 == 0.0));
        float _2932;
        if (!(_2907 == 0.0))
        {
            _2932 = _2893.z;
        }
        else
        {
            _2932 = _2897.z;
        }
        float _2929 = _2932;
        float _2941 = min(_2920 ? 2.0 : 1000.0, abs(_2901));
        float _2948 = max(_2893.x - _2866.x, _2866.x - _2897.x);
        float _2960 = max(_2893.y - _2866.y, _2866.y - _2897.y);
        float _2972 = max(_2948, _2960) - _2941;
        _2972 = max(_2972, _2929 - _2866.z);
        _2972 = max(_2972, _2901 - _2923);
        if (_2972 <= 0.0)
        {
            float _2993 = _2920 ? _2907 : _2910;
            vec2 _2998 = _918._m18[2].xy;
            float _3002 = length(_2998);
            vec3 _3005 = vec3(_2998, (-1.73205077648162841796875) * _3002);
            _3005 /= vec3(2.0 * _3002);
            vec3 _3018 = _711._m12.xyz;
            vec3 _3022 = mix(_3005, _3018, bvec3(_2920));
            vec2 _3029 = _2866.xy - (_3022.xy * (_2901 / _3022.z));
            float _3040 = (_711._m57 / 100.0) * 16.0;
            vec2 _3046 = _3029 * _3040;
            float _3050 = TEXTURE_LOD(SAMPLER_2D(_3051, _3053), vec4(_3046, 0.0, 0.0).xy, vec4(_3046, 0.0, 0.0).w).x;
            float _3068 = min(8.0, _2897.z - _2893.z);
            float _3080 = (-_2901) / _3068;
            float _3075 = _10(_3080);
            float _3087 = dot(_918._m6, _3022);
            float _3082 = _10(_3087);
            float _3093 = _2948 / _2941;
            float _3089 = 1.0 - _10(_3093);
            float _3099 = _2960 / _2941;
            _3089 *= (1.0 - _10(_3099));
            _3089 *= _3089;
            float _3115 = min(_2901 / 1.0, 1.0 - (_2901 / _2923));
            float _3107 = _10(_3115);
            _3089 *= max(_3107, _3075);
            _3089 *= _3089;
            _3089 *= _2869;
            float _3128 = _3050 - 1.0;
            float _3131 = float(_2920) * _2913;
            float _3136 = max(0.0, _3050 - 0.85000002384185791015625);
            float _3141 = _2920 ? _3128 : _3136;
            float _3146 = (((1.0 - _3131) * _3082) * _3089) * _2993;
            vec3 _3155 = _918._m0 + (_918._m2 * (vec3(1.0) - _918._m0));
            _918._m21 += ((_3155 * (_3141 * _3146)) * _711._m11.xyz);
            float _3179 = _3131 * _3089;
            _918._m25 = 1.0 + (_3179 * (_3050 - 1.0));
        }
    }
    else
    {
        if (_2869 > 0.0)
        {
            _2869 *= _711._m58;
            float _3198 = float(_711._m12.w < 0.0);
            vec3 _3203 = _711._m12.xyz;
            float _3212 = dot(_918._m6, _3203);
            float _3207 = _10(_3212);
            vec2 _3214 = _2866.xy - (_3203.xy * (_2866.z / _3203.z));
            float _3226 = (_711._m57 / 100.0) * 16.0;
            vec2 _3231 = _3214 * _3226;
            float _3235 = TEXTURE_LOD(SAMPLER_2D(_3051, _3053), vec4(_3231, 0.0, 0.0).xy, vec4(_3231, 0.0, 0.0).w).x;
            vec4 _3251 = _711._m11;
            _918._m21 += (_3251.xyz * (((((1.0 - _3198) * (_3235 - 1.0)) * _3207) * _2869) * _3251.w));
            _918._m25 = 1.0 + ((_3198 * (_3235 - 1.0)) * _2869);
        }
    }
    _918._m14 = normalize(vec3(_711._m35, _711._m36, _711._m37) - _918._m15);
    vec3 _3293 = vec3(0.0);
    vec3 _3294 = vec3(0.0);
    vec3 _3295 = vec3(0.0);
    vec3 _3296 = vec3(0.0);
    vec3 _3297 = vec3(0.0);
    vec4 _3298 = _918._m29;
    vec4 _3301 = _918._m30;
    vec4 _3304 = _918._m31;
    _3294 = vec3(_3298.x, _3298.y, _3298.z);
    _3295 = vec3(_3298.w, _3301.x, _3301.y);
    _3296 = vec3(_3301.z, _3301.w, _3304.x);
    _3297 = vec3(_3304.y, _3304.z, _3304.w);
    vec3 _3335 = ((_3294 - (_3295 * _918._m6.y)) + (_3296 * _918._m6.z)) - (_3297 * _918._m6.x);
    float _3359 = _1054._m50 * _711._m59;
    _3293 += (max(vec3(0.0), _3335 * _10(_3359)) * _918._m0);
    vec3 _3368 = vec3(0.0);
    vec3 _3369 = vec3(0.0);
    vec3 _3370 = vec3(0.0);
    vec3 _3371 = vec3(0.0);
    vec3 _3372 = vec3(0.0);
    vec4 _3373 = _918._m29;
    vec4 _3376 = _918._m30;
    vec4 _3379 = _918._m31;
    _3369 = vec3(_3373.x, _3373.y, _3373.z);
    _3370 = vec3(_3373.w, _3376.x, _3376.y);
    _3371 = vec3(_3376.z, _3376.w, _3379.x);
    _3372 = vec3(_3379.y, _3379.z, _3379.w);
    vec3 _3410 = ((_3369 - (_3370 * _918._m8.y)) + (_3371 * _918._m8.z)) - (_3372 * _918._m8.x);
    float _3433 = _1054._m50 * _711._m59;
    _3368 += (max(vec3(0.0), _3410 * _10(_3433)) * _918._m0);
    uint _3444 = _918._m4;
    _3293 = mix(_3293, _3368, vec3(_92(_3444).w));
    _918._m21 += _3293;
    bool _3456 = true;
    _3456 = (((_711._m61 & 2u) != 0u) == true) ? false : true;
    if (true && (_3456 == true))
    {
        uint _3468 = _3472._m0[_2749 * 64u];
        uint _3479 = _3468 & 255u;
        uint _3483 = _3472._m0[_2783 * 64u];
        uint _3488 = _3483 & 255u;
        uint _3496;
        uint _3498;
        uint _3500;
        if (_3479 < _3488)
        {
            _3496 = _3479;
            _3498 = _3468;
            _3500 = _2749;
        }
        else
        {
            _3496 = _3488;
            _3498 = _3483;
            _3500 = _2783;
        }
        float _3506 = _918._m47;
        float _3515 = dot(_918._m14, _918._m6);
        float _3509 = _10(_3515);
        float _3517 = _3509;
        float _3519 = _918._m3;
        vec3 _3522 = _918._m2;
        _918._m24 = (_111(_3517, _3519, _3522) * _918._m11) * _918._m39;
        uint _3533 = 1u;
        _3564 _3566;
        while (_3533 <= _3496)
        {
            uint _3542 = (_3500 * 64u) + _3533;
            uint _3547 = _3472._m0[_3542];
            uint _3551 = _3547;
            if (_3551 >= _3547)
            {
                _3533++;
            }
            float _3560 = 0.0039215688593685626983642578125;
            int _3562 = 4;
            int _3563 = 4;
            _3566._m0 = _3571._m0[(uint(_3562) * _3551) + 0u].xyz;
            float _3586 = _3571._m0[(uint(_3562) * _3551) + 0u].w;
            _3566._m1 = _32(_3586);
            _3566._m2 = _3571._m0[(uint(_3562) * _3551) + 1u].xyz;
            _3566._m3 = _3571._m0[(uint(_3562) * _3551) + 1u].w;
            _3566._m4 = _3571._m0[(uint(_3562) * _3551) + 2u];
            float _3621 = _3571._m0[(uint(_3562) * _3551) + 3u].x;
            _3566._m8 = _32(_3621);
            float _3631 = _3571._m0[(uint(_3562) * _3551) + 3u].y;
            _3566._m9 = _32(_3631);
            _3566._m10 = _3571._m0[(uint(_3562) * _3551) + 3u].z;
            _3566._m5 = _3647._m0[(uint(_3563) * _3551) + 0u];
            _3566._m6 = _3647._m0[(uint(_3563) * _3551) + 1u];
            _3566._m7 = _3647._m0[(uint(_3563) * _3551) + 2u];
            _3566._m12 = _3647._m0[(uint(_3563) * _3551) + 3u].xyz;
            _3566._m13 = _3647._m0[(uint(_3563) * _3551) + 3u].w;
            vec3 _3689 = vec3(dot(_918._m15, _3566._m5.xyz) + _3566._m5.w, dot(_918._m15, _3566._m6.xyz) + _3566._m6.w, dot(_918._m15, _3566._m4.xyz) + _3566._m4.w);
            float _3718 = _3689.x;
            float _3721 = _3689.y;
            float _3724 = _3689.z;
            bool _3729 = _43(_3718, _3721, _3724) <= _3560;
            bool _3746;
            if (!_3729)
            {
                float _3733 = _3689.x;
                float _3736 = _3689.y;
                float _3739 = _3689.z;
                _3746 = _38(_3733, _3736, _3739) >= (1.0 - _3560);
            }
            else
            {
                _3746 = _3729;
            }
            if (_3746)
            {
                continue;
            }
            uint _3750 = _3566._m1;
            vec3 _3753 = _3566._m0;
            float _3756 = float(bitfieldExtract(_3566._m8, 20, 12));
            float _3761 = 0.800000011920928955078125;
            vec3 _3762 = (_3689 * 2.0) - vec3(1.0);
            vec3 _3767 = _3762;
            vec3 _3766 = _52(_3767);
            vec3 _3770 = _3762 * sqrt(((vec3(1.0) - (_3766.yzx * 0.5)) - (_3766.zxy * 0.5)) + ((_3766.yzx * _3766.zxy) / vec3(3.0)));
            float _3802 = 1.0 - ((length(_3770) - _3761) / ((1.0 - _3761) + 9.9999999747524270787835121154785e-07));
            float _3791 = _10(_3802);
            _3791 *= _3791;
            _3791 *= _3506;
            float _3810 = _3566._m7.w;
            _3791 *= _3810;
            _3506 *= (1.0 - _3791);
            vec3 _3820 = _3566._m12;
            float _3823 = _3566._m13;
            float _3828 = _3791;
            vec3 _3826 = _3820 * (_10(_3828) * _3823);
            vec3 _3834 = _3566._m2;
            vec3 _3837 = _3566._m7.xyz;
            vec3 _3841 = vec3(0.0);
            vec3 _3842 = reflect(-_918._m14, _918._m6);
            vec3 _3849 = (_3837 - _918._m15) / _3842;
            vec3 _3856 = (_3834 - _918._m15) / _3842;
            vec3 _3863 = max(_3849, _3856);
            float _3868 = _3863.x;
            float _3871 = _3863.y;
            float _3874 = _3863.z;
            float _3867 = _43(_3868, _3871, _3874);
            vec3 _3878 = _918._m15 + (_3842 * _3867);
            vec3 _3885 = _3878 - _3753;
            float _3889 = 6.0;
            float _3891 = _3889 - (_3889 * _918._m3);
            _3841 = textureLod(samplerCubeArray(_3900, _3902), vec4(_3885, _3756), _3891).xyz;
            _918._m21 += ((_3841 * _3826) * _918._m24);
            if (_3506 <= (_3560 * 4.0))
            {
                break;
            }
        }
    }
    uint _3932 = _3936._m0[_2749 * 64u];
    uint _3941 = _3932 & 255u;
    uint _3944 = _3936._m0[_2783 * 64u];
    uint _3949 = _3944 & 255u;
    uint _3957;
    uint _3959;
    uint _3961;
    if (_3941 < _3949)
    {
        _3957 = _3941;
        _3959 = _3932;
        _3961 = _2749;
    }
    else
    {
        _3957 = _3949;
        _3959 = _3944;
        _3961 = _2783;
    }
    uint _3967 = 1u;
    _3564 _3996;
    vec3 _4123;
    float _4244;
    vec2 _4312;
    _4510 _4512;
    _4510 _4659;
    while (_3967 <= _3957)
    {
        uint _3976 = (_3961 * 64u) + _3967;
        uint _3981 = _3936._m0[_3976];
        uint _3985 = _3981;
        if (_3985 >= _3981)
        {
            _3967++;
        }
        int _3994 = 4;
        int _3995 = 4;
        _3996._m0 = _3571._m0[(uint(_3994) * _3985) + 0u].xyz;
        float _4011 = _3571._m0[(uint(_3994) * _3985) + 0u].w;
        _3996._m1 = _32(_4011);
        _3996._m2 = _3571._m0[(uint(_3994) * _3985) + 1u].xyz;
        _3996._m3 = _3571._m0[(uint(_3994) * _3985) + 1u].w;
        _3996._m4 = _3571._m0[(uint(_3994) * _3985) + 2u];
        float _4046 = _3571._m0[(uint(_3994) * _3985) + 3u].x;
        _3996._m8 = _32(_4046);
        float _4056 = _3571._m0[(uint(_3994) * _3985) + 3u].y;
        _3996._m9 = _32(_4056);
        _3996._m10 = _3571._m0[(uint(_3994) * _3985) + 3u].z;
        _3996._m5 = _3647._m0[(uint(_3995) * _3985) + 0u];
        _3996._m6 = _3647._m0[(uint(_3995) * _3985) + 1u];
        _3996._m7 = _3647._m0[(uint(_3995) * _3985) + 2u];
        _3996._m12 = _3647._m0[(uint(_3995) * _3985) + 3u].xyz;
        _3996._m13 = _3647._m0[(uint(_3995) * _3985) + 3u].w;
        float _4110 = 0.0;
        uint _4111 = _3996._m1;
        vec3 _4114 = _3996._m0;
        vec3 _4117 = _4114;
        if ((_4111 & 7u) == 2u)
        {
            _4123 = _4117;
        }
        else
        {
            _4123 = normalize(_4114 - _918._m15);
        }
        vec3 _4119 = _4123;
        uint _4134 = uint(((_2793 & 3u) != 0u) ? 16 : 0);
        _4134 |= 32u;
        if ((_4111 & _4134) != 0u)
        {
            continue;
        }
        vec3 _4149 = vec3(dot(_918._m15, _3996._m5.xyz) + _3996._m5.w, dot(_918._m15, _3996._m6.xyz) + _3996._m6.w, dot(_918._m15, _3996._m7.xyz) + _3996._m7.w);
        vec2 _4183 = _4149.xy / vec2(_4149.z);
        _4149 = vec3(_4183.x, _4183.y, _4149.z);
        _4149.z = dot(_918._m15, _3996._m4.xyz) + _3996._m4.w;
        float _4196 = _4149.x;
        float _4199 = _4149.y;
        float _4202 = _4149.z;
        bool _4207 = _43(_4196, _4199, _4202) <= _4110;
        bool _4224;
        if (!_4207)
        {
            float _4211 = _4149.x;
            float _4214 = _4149.y;
            float _4217 = _4149.z;
            _4224 = _38(_4211, _4214, _4217) >= (1.0 - _4110);
        }
        else
        {
            _4224 = _4207;
        }
        if (_4224)
        {
            continue;
        }
        vec3 _4228 = vec3(1.0);
        uint _4229 = _4111 & 7u;
        vec3 _4232 = _3996._m0 - _918._m15;
        float _4238 = dot(_4232, _4232);
        if (_4229 != 2u)
        {
            _4244 = 1.0 / (1.0 + _4238);
        }
        else
        {
            _4244 = _918._m25;
        }
        _4228 = vec3(_4244);
        if (_4229 == 0u)
        {
            float _4264 = _4238 * _3996._m3;
            float _4267 = 1.0 - _55(_4264);
            float _4269 = _10(_4267);
            float _4259 = _55(_4269);
            _4228 *= _4259;
        }
        else
        {
            if (_4229 == 4u)
            {
                float _4285 = length((_4149.xy - vec2(0.5)) * 2.0);
                float _4279 = _10(_4285);
                float _4287 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_4279 * 7.80000019073486328125))));
                _4228 *= _4287;
            }
            else
            {
                if ((_4229 == 1u) || (_4229 == 2u))
                {
                    if (_4229 == 2u)
                    {
                        _4312 = fract((_4149.xy * _711._m13.xy) + _711._m13.zw);
                    }
                    else
                    {
                        _4312 = _4149.xy;
                    }
                    vec2 _4309 = _4312;
                    vec3 _4330 = vec3(0.0);
                    uint _4331 = bitfieldExtract(_3996._m8, 0, 20);
                    uint _4335 = _4331;
                    uint _4339 = _4335 + 0u;
                    vec3 _4355 = textureLod(sampler2D(_1323[nonuniformEXT(_4339)], _1203), vec4(_4309, 0.0, 0.0).xy, vec4(_4309, 0.0, 0.0).w).xyz;
                    _4330 = _52(_4355);
                    _4228 *= _4330;
                }
            }
        }
        float _4361 = float((_4111 >> uint(8)) & 255u) / 255.0;
        if ((_4229 == 0u) || (_4229 == 2u))
        {
            vec3 _4374 = abs((_4149 * 2.0) - vec3(1.0));
            float _4380 = _4374.x;
            float _4383 = _4374.y;
            float _4386 = _4374.z;
            float _4391 = 1.0 - _38(_4380, _4383, _4386);
            float _4396 = _10(_4391) / (9.9999999392252902907785028219223e-09 + _4361);
            float _4379 = _10(_4396);
            _4228 *= ((_4379 * _4379) * (3.0 - (2.0 * _4379)));
        }
        else
        {
            if ((_4229 == 1u) || (_4229 == 4u))
            {
                float _4416 = _4149.z;
                float _4420 = _55(_4416);
                float _4423 = 1.0 - _55(_4420);
                float _4425 = _10(_4423);
                float _4430 = _55(_4425) / (9.9999999392252902907785028219223e-09 + _4361);
                float _4415 = _10(_4430);
                _4228 *= _4415;
            }
        }
        float _4435 = _4228.x;
        float _4438 = _4228.y;
        float _4441 = _4228.z;
        if (_38(_4435, _4438, _4441) <= _4110)
        {
            continue;
        }
        float _4450 = 1.0;
        if ((_4111 & 8u) != 0u)
        {
            float _4457 = 0.00200000009499490261077880859375;
            vec3 _4459 = _918._m15 + (_918._m6 * _4457);
            uint _4467 = 0u;
            if ((_4111 & 7u) == 0u)
            {
                vec3 _4473 = _4459 - _3996._m2;
                float _4478 = _4473.x;
                float _4481 = _4473.y;
                float _4484 = _4473.z;
                _4467 = _49(_4478, _4481, _4484);
            }
            else
            {
                if ((_4111 & 7u) == 2u)
                {
                    float _4494 = 0.0;
                    uint _4495 = uint((_711._m14.w > 0.0) ? 3 : 4);
                    for (; _4467 < _4495; _4467++)
                    {
                        int _4509 = 5;
                        _4512._m0 = _4517._m0[(uint(_4509) * ((_4111 >> uint(22)) + _4467)) + 0u];
                        _4512._m1 = _4517._m0[(uint(_4509) * ((_4111 >> uint(22)) + _4467)) + 1u];
                        _4512._m2 = _4517._m0[(uint(_4509) * ((_4111 >> uint(22)) + _4467)) + 2u];
                        _4512._m3 = _4517._m0[(uint(_4509) * ((_4111 >> uint(22)) + _4467)) + 3u];
                        _4512._m4 = _4517._m0[(uint(_4509) * ((_4111 >> uint(22)) + _4467)) + 4u];
                        vec2 _4573 = vec2(dot(_4459, _4512._m0.xyz) + _4512._m0.w, dot(_4459, _4512._m1.xyz) + _4512._m1.w);
                        _4573 = abs((_4573 * 2.0) - vec2(1.0));
                        bool _4599 = _4573.x < 0.9900000095367431640625;
                        bool _4605;
                        if (_4599)
                        {
                            _4605 = _4573.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _4605 = _4599;
                        }
                        if (_4605)
                        {
                            _4494 = (1.0 - max(_4573.x, _4573.y)) * _711._m15.w;
                            break;
                        }
                    }
                    _918._m36 = int(_4467);
                    _4467 = min((_4495 - 1u), _4467);
                    if (_711._m14.w > 0.0)
                    {
                        uint _4632 = uint(_918._m17.x) ^ (uint(_918._m17.y) << uint(1));
                        _4632 ^= uint(_711._m16.x);
                        _4467 += uint(int(((float(_4632 & 3u) * 0.25) + 0.125) > _4494));
                    }
                }
            }
            int _4658 = 5;
            _4659._m0 = _4517._m0[(uint(_4658) * ((_4111 >> uint(22)) + _4467)) + 0u];
            _4659._m1 = _4517._m0[(uint(_4658) * ((_4111 >> uint(22)) + _4467)) + 1u];
            _4659._m2 = _4517._m0[(uint(_4658) * ((_4111 >> uint(22)) + _4467)) + 2u];
            _4659._m3 = _4517._m0[(uint(_4658) * ((_4111 >> uint(22)) + _4467)) + 3u];
            _4659._m4 = _4517._m0[(uint(_4658) * ((_4111 >> uint(22)) + _4467)) + 4u];
            vec4 _4715 = vec4((_4459.x * _4659._m0.x) + ((_4459.y * _4659._m0.y) + ((_4459.z * _4659._m0.z) + _4659._m0.w)), (_4459.x * _4659._m1.x) + ((_4459.y * _4659._m1.y) + ((_4459.z * _4659._m1.z) + _4659._m1.w)), (_4459.x * _4659._m2.x) + ((_4459.y * _4659._m2.y) + ((_4459.z * _4659._m2.z) + _4659._m2.w)), (_4459.x * _4659._m3.x) + ((_4459.y * _4659._m3.y) + ((_4459.z * _4659._m3.z) + _4659._m3.w)));
            vec3 _4802 = _4715.xyz / vec3(_4715.w);
            _4715 = vec4(_4802.x, _4802.y, _4802.z, _4715.w);
            bool _4810 = min(_4715.x, _4715.y) > 0.0;
            bool _4819;
            if (_4810)
            {
                _4819 = max(_4715.x, _4715.y) < 1.0;
            }
            else
            {
                _4819 = _4810;
            }
            if (_4819)
            {
                vec2 _4831 = (_4715.xy * _4659._m4.xy) + _4659._m4.zw;
                _4715 = vec4(_4831.x, _4831.y, _4715.z, _4715.w);
                if (false)
                {
                    _4450 = textureLod(sampler2DShadow(_4838, _4840), vec3(_4715.xyz.xy, _4715.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4849 = (_4715.xy * _711._m17.xy) + vec2(0.5);
                    vec2 _4858 = floor(_4849);
                    vec2 _4861 = _4849 - _4858;
                    _4858 -= vec2(0.5);
                    vec2 _4868 = vec2(4.0) - (_4861 * 3.0);
                    vec2 _4873 = vec2(7.0);
                    vec2 _4875 = vec2(1.0) + (_4861 * 3.0);
                    vec2 _4880 = (_4858 + (((vec2(3.0) - (_4861 * 2.0)) / _4868) - vec2(2.0))) * _711._m17.zw;
                    vec2 _4895 = (_4858 + ((vec2(3.0) + _4861) / _4873)) * _711._m17.zw;
                    vec2 _4907 = (_4858 + ((_4861 / _4875) + vec2(2.0))) * _711._m17.zw;
                    vec3 _4933 = vec3(_4880.x, _4880.y, _4715.z);
                    _4450 = (_4868.x * _4868.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_4933.xy, _4933.z), 0.0);
                    vec3 _4951 = vec3(_4895.x, _4880.y, _4715.z);
                    _4450 += ((_4873.x * _4868.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_4951.xy, _4951.z), 0.0));
                    vec3 _4971 = vec3(_4907.x, _4880.y, _4715.z);
                    _4450 += ((_4875.x * _4868.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_4971.xy, _4971.z), 0.0));
                    vec3 _4991 = vec3(_4880.x, _4895.y, _4715.z);
                    _4450 += ((_4868.x * _4873.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_4991.xy, _4991.z), 0.0));
                    vec3 _5011 = vec3(_4895.x, _4895.y, _4715.z);
                    _4450 += ((_4873.x * _4873.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_5011.xy, _5011.z), 0.0));
                    vec3 _5031 = vec3(_4907.x, _4895.y, _4715.z);
                    _4450 += ((_4875.x * _4873.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_5031.xy, _5031.z), 0.0));
                    vec3 _5051 = vec3(_4880.x, _4907.y, _4715.z);
                    _4450 += ((_4868.x * _4875.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_5051.xy, _5051.z), 0.0));
                    vec3 _5071 = vec3(_4895.x, _4907.y, _4715.z);
                    _4450 += ((_4873.x * _4875.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_5071.xy, _5071.z), 0.0));
                    vec3 _5091 = vec3(_4907.x, _4907.y, _4715.z);
                    _4450 += ((_4875.x * _4875.y) * textureLod(sampler2DShadow(_4838, _4840), vec3(_5091.xy, _5091.z), 0.0));
                    _4450 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4450 = float((_4111 & 7u) == 2u);
                if ((_4111 & 7u) == 2u)
                {
                    _918._m36 = -1;
                }
            }
            float _5111 = float((_4111 >> uint(16)) & 63u) / 63.0;
            float _5125 = ((_4450 * _5111) + 1.0) - _5111;
            _4450 = _10(_5125);
            if ((_711._m60 > 0.0) && (_4450 > 0.0))
            {
                vec4 _5135 = vec4(_918._m17.xy * _711._m6.xy, _918._m17.z, 1.0);
                float _5148 = _5135.z;
                bool _5151 = false;
                float _5152 = _131(_5148, _5151);
                _5135.z = _5152;
                vec3 _5189 = _918._m15 + (_4119 * 0.100000001490116119384765625);
                mat4 _5190 = mat4(vec4(_711._m18), vec4(_711._m19), vec4(_711._m20), vec4(_711._m21));
                vec4 _5154 = _62(_5189, _5190);
                vec3 _5197 = _5154.xyz / vec3(_5154.w);
                _5154 = vec4(_5197.x, _5197.y, _5197.z, _5154.w);
                float _5200 = _5154.z;
                bool _5203 = false;
                float _5204 = _131(_5200, _5203);
                _5154.z = _5204;
                int _5206 = 4;
                vec3 _5207 = vec3(_5154.xyz - _5135.xyz) / vec3(float(_5206));
                float _5221 = 0.100000001490116119384765625;
                float _5222 = 0.001000000047497451305389404296875 * _5135.z;
                uvec2 _5235 = uvec2(_918._m17.xy);
                uint _5236 = uint(_711._m22.w);
                float _5227 = _158(_5235, _5236) - 0.5;
                vec3 _5239 = _5135.xyz + (_5207 * _5227);
                for (int _5246 = 0; _5246 < _5206; _5246++)
                {
                    _5239 += _5207;
                    float _5258 = 1.0 - TEXTURE_LOD(SAMPLER_2D(_5259, _5261), vec4(_5239.xy, 0.0, 0.0).xy, vec4(_5239.xy, 0.0, 0.0).w).x;
                    float _5280 = _5258;
                    bool _5282 = false;
                    float _5283 = _131(_5280, _5282);
                    float _5279 = _5283 + _5222;
                    bool _5290 = (_5239.z - _5279) > 0.001000000047497451305389404296875;
                    bool _5299;
                    if (_5290)
                    {
                        _5299 = (_5239.z - _5279) <= _5221;
                    }
                    else
                    {
                        _5299 = _5290;
                    }
                    if (_5299)
                    {
                        uint _5303 = _918._m4;
                        vec3 _5302 = _92(_5303).xyz;
                        // SHADOW FIX AGAIN
                        //_4450 *= dot(_5302, vec3(0.333000004291534423828125));
                        break;
                    }
                }
            }
        }
        if (_4450 <= _4110)
        {
            continue;
        }
        vec3 _5323 = (_3996._m12 * _4450) * _4228;
        float _5330 = _3996._m13;
        vec3 _5333 = _5323;
        float _5340 = dot(_918._m6, _4119);
        float _5335 = _10(_5340);
        float _5342 = 1.0;
        vec3 _5344 = _918._m6;
        vec3 _5347 = _918._m14;
        vec3 _5350 = _4119;
        vec3 _5352 = _918._m2;
        float _5355 = _918._m3;
        vec3 _5343 = _105(_5344, _5347, _5350, _5352, _5355);
        _918._m21 += ((((_5343 * _5330) * _5333) * _5335) * _5342);
        vec3 _5372 = _5333;
        uint _5375 = _918._m4;
        vec4 _5374 = _92(_5375);
        vec3 _5379 = _5374.xyz;
        float _5387 = dot(_918._m8, _4119);
        float _5382 = _10(_5387);
        vec3 _5389 = vec3(mix(_5335, _5382, _1042._m45), mix(_5335, _5382, _1042._m44), mix(_5335, _5382, _1042._m43));
        float _5420 = dot(_918._m14, -_4119);
        float _5422 = _10(_5420);
        float _5423 = _1042._m13.w;
        vec3 _5430 = ((_1042._m13.xyz + vec3(_918._m5)) * _77(_5422, _5423)) * _5379;
        _5389 += _16(_5430);
        float _5434 = _5374.w;
        _5389 = mix(vec3(_5335), _5389, vec3(_5434));
        _918._m21 += ((_5372 * _5389) * _918._m0);
    }
    _918._m21 *= _918._m11;
    vec3 _5459 = vec3(_928, _930, _932);
    float _5464 = _5465;
    float _5467 = _5468;
    float _5470 = _5471;
    float _5473 = _5474;
    if (_1054._m52 < 1.0)
    {
        if (vec3(_1054._m60, _1054._m61, _1054._m62).x > 0.0)
        {
            vec2 _5493 = abs(vec2(1.0) / _711._m6.xy);
            vec2 _5500 = ((vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * 1.5) * _711._m6.xy) * (_5493 / vec2(32.0));
            vec4 _5523 = TEXTURE_LOD(SAMPLER_2D(_5524, _1328), vec4(_5500 * vec2(0.699999988079071044921875), 0.0, 0.0).xy, vec4(_5500 * vec2(0.699999988079071044921875), 0.0, 0.0).w);
            float _5542 = 1.0 - dot(_918._m6, normalize(-_5459));
            float _5550 = 1.0;
            float _5551 = vec3(_1054._m54, _1054._m55, _1054._m56).x;
            if (vec3(_1054._m60, _1054._m61, _1054._m62).y >= vec3(_1054._m54, _1054._m55, _1054._m56).z)
            {
                _5551 = vec3(_1054._m54, _1054._m55, _1054._m56).y;
            }
            float _5587 = mix(vec3(_1054._m57, _1054._m58, _1054._m59).x, vec3(_1054._m57, _1054._m58, _1054._m59).y, vec3(_1054._m60, _1054._m61, _1054._m62).y);
            float _5613 = _5459.z * _5587;
            float _5618 = (sin(_5613 + (_711._m53 * _5551)) * _5550) + _5550;
            float _5630 = vec3(_1054._m57, _1054._m58, _1054._m59).z;
            _5618 = pow(_5618, _5630);
            _5618 *= _5542;
            float _5645 = pow(_5542, 4.0);
            float _5655 = (_5523.x * _5542) + _5645;
            vec3 _5648 = (_1054._m10.xyz * _10(_5655)) * 2.0;
            _5648 /= _711._m23.xyz;
            vec3 _5667 = _5648 * _5618;
            _918._m21 += max(vec3(0.0), _5667);
        }
        if (_1054._m16.w > 0.0)
        {
            vec2 _5682 = abs(vec2(1.0) / _711._m6.xy);
            vec2 _5688 = ((vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * 1.5) * _711._m6.xy) * (_5682 / vec2(32.0));
            vec4 _5709 = TEXTURE_LOD(SAMPLER_2D(_5524, _1328), vec4(_5688 * vec2(0.699999988079071044921875), 0.0, 0.0).xy, vec4(_5688 * vec2(0.699999988079071044921875), 0.0, 0.0).w);
            float _5726 = 1.0 - dot(_918._m6, normalize(-_5459));
            float _5734 = pow(_5726, 4.0);
            float _5744 = (_5709.x * _5726) + _5734;
            vec3 _5737 = (_1054._m16.xyz * _10(_5744)) * 6.0;
            _5737 /= _711._m23.xyz;
            _918._m21 += (max(vec3(0.0), _5737) * _5464);
        }
        bool _5766 = _1042._m28 > 0.0;
        bool _5772;
        if (_5766)
        {
            _5772 = _1054._m36 > 0.0;
        }
        else
        {
            _5772 = _5766;
        }
        if (_5772)
        {
            float _5775 = SAMPLE_TEXTURE(SAMPLER_2D(_2360, _1328), vec2(_5470, _5470) + vec2(_711._m53 * 1.0)).x;
            _5775 *= (_5775 * _5775);
            vec3 _5794 = mix(vec3(1.0, 0.5, 0.00999999977648258209228515625), vec3(1.0, 0.0500000007450580596923828125, 0.00999999977648258209228515625), vec3(_5470));
            vec3 _5801 = mix(vec3(0.01200000010430812835693359375, 0.100000001490116119384765625, 0.60000002384185791015625), vec3(0.0, 0.0, 0.60000002384185791015625), vec3(_5470));
            vec3 _5815;
            if (((_1042._m65 & 8u) != 0u) == true)
            {
                _5815 = _5801;
            }
            else
            {
                _5815 = _5794;
            }
            float _5819 = 1.0 - dot(_918._m6, normalize(-_5459));
            float _5827 = pow(_5819, 4.0);
            float _5837 = (1.0 * (_5819 * _5819)) + _5827;
            vec3 _5830 = (((_5815 * _10(_5837)) * _5467) * (_5775 * 10.0)) * 3.0;
            _5830 *= mix(1.0, 0.0, _1054._m16.w);
            _918._m21 += (_5830 * _1054._m36);
        }
        if (_1054._m11.w > 0.0)
        {
            float _5866 = dot(_918._m6, normalize(-_5459));
            _5866 *= (_5866 * _5866);
            vec3 _5878 = vec3(_5866) * _1054._m11.xyz;
            _918._m21 += _5878;
        }
        vec2 _5890 = vec2(_921, _923);
        float _5894 = texture(sampler2D(_1323[_1042._m62], _1328), _5890).x;
        float _5904 = _5905;
        float _5915 = 1.0 - _5904;
        vec3 _5907 = ((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.100000001490116119384765625, 0.0), vec3(_5894)) * _10(_5915)) * _5894) * _1054._m67;
        vec4 _5924 = vec4(0.0);
        _5924 = texture(sampler2D(_1323[_1042._m24], _1328), _5890 * _1042._m14.xy);
        float _5937 = _2212;
        vec3 _5939 = ((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.3499999940395355224609375, 0.0), vec3(_5924.w)) * _5924.w) * 20.0) * _5937;
        float _5953 = _5954;
        float _5959 = (_5953 * 10.0) - 3.0;
        _5939 += (((((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.3499999940395355224609375, 0.0), vec3((_5924.z * _5924.z) * _5924.z)) * _10(_5959)) * _5924.z) * _5924.z) * _5924.z) * 12.0);
        _918._m21 += (_5907 + _5939);
        if (_1054._m44 > 0.0)
        {
            vec3 _5997 = texture(sampler2D(_1323[_1042._m38], _1328), _918._m16.zw).xyz;
            vec3 _6009 = mix(_1054._m0.xyz, _1054._m1.xyz, _5997);
            _918._m21 += ((_5997 * _6009) * mix(0.0, 10.0, _1054._m44));
        }
        if (_1054._m8.w > 0.0)
        {
            float _6034 = 1.0 - dot(_918._m6, _918._m14);
            _6034 = pow(_6034, 42.0);
            vec3 _6044 = mix(vec3(1.0), vec3(0.0), vec3(_918._m7.z));
            _6044 *= (_6044 * _6044);
            vec3 _6054 = vec3(_6034);
            _6054 = clamp(_6054, vec3(0.0), vec3(0.100000001490116119384765625));
            _918._m21 += ((_6044 + (_6054 * vec3(15.0))) * _1054._m8.xyz);
        }
        if (_1054._m4.w > 0.0)
        {
            float _6080 = 1.0 - (0.85000002384185791015625 * dot(_918._m6, _918._m14));
            float _6088 = _1054._m4.w * _6080;
            _918._m21 = mix(_918._m21, _1054._m4.xyz, vec3(_6088));
        }
    }
    _916 = _918._m6.x;
    _917 = dot(_918._m6, normalize(-_5459));
    _917 = 1.0 - _917;
    _917 *= _917;
    _918._m21 = mix(_918._m21, _1054._m9.xyz * 10.0, vec3(_5473));
    _6126 = vec4(_918._m21, 0.0);
    if (((_711._m61 & 2u) != 0u) == true)
    {
        vec3 _6141 = _918._m6;
        bool _6144 = false;
        vec2 _6145 = _166(_6141, _6144);
        _6140 = vec4(_6145, 0.0, 0.0);
        float _6155 = dot(_918._m14, _918._m6);
        float _6149 = _10(_6155);
        float _6158 = _6149;
        float _6160 = _918._m3;
        vec3 _6163 = _918._m2;
        vec3 _6157 = _111(_6158, _6160, _6163);
        float _6168 = _6157.x;
        float _6172 = _6157.y;
        float _6176 = _6157.z;
        float _6180 = _918._m3;
        _6167 = vec4(_80(_6168), _80(_6172), _80(_6176), _169(_6180));
    }
    vec2 _6185 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _711._m6.xy;
    if (_1054._m65 < 1.0)
    {
        vec3 _6206 = TEXTURE_LOD(SAMPLER_2D(_6207, _1328), vec4(_6185 + vec2(_916 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_6185 + vec2(_916 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
        vec3 _6233 = _6206 * vec3(1.0, 0.25, 0.0);
        _6126 = vec4(_6233.x, _6233.y, _6233.z, _6126.w);
        vec3 _6245 = _6126.xyz + ((vec3(_917 * _917) * 10.0) * vec3(1.0, 0.0500000007450580596923828125, 0.0));
        _6126 = vec4(_6245.x, _6245.y, _6245.z, _6126.w);
    }
    float _6248 = _1054._m52;
    if (_6248 > 0.0)
    {
        vec2 _6255 = vec2(_921, _923);
        float _6259 = (SAMPLE_TEXTURE(SAMPLER_2D(_2360, _1328), _6255 * _1042._m14.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_6248 > _6259)
        {
            vec3 _6299 = TEXTURE_LOD(SAMPLER_2D(_6207, _1328), vec4(_6185 + vec2(_916 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_6185 + vec2(_916 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _6126 = vec4(_6299.x, _6299.y, _6299.z, _6126.w);
        }
        else
        {
            if (_6248 > (_6259 - 0.02500000037252902984619140625))
            {
                _6126 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _6126.w);
            }
        }
    }
}

