// Reflection Shader
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////
#define STEREO 1
#define VIEW gl_ViewIndex
// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
layout(early_fragment_tests) in;
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 70, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

struct _152
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _1923
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
};

struct _3253
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _4182
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _5833
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    float _m3;
    float _m4;
    float _m5;
    float _m6;
    vec3 _m7;
    float _m8;
    vec2 _m9;
    vec4 _m10;
    vec3 _m11;
    vec3 _m12;
};

struct _5915
{
    float _m0;
    int _m1;
    int _m2;
    int _m3;
    int _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    vec4 _m16;
    vec4 _m17;
    float _m18;
    int _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    int _m26;
    float _m27;
    float _m28;
    float _m29;
    int _m30;
    int _m31;
    int _m32;
    int _m33;
    vec2 _m34;
    float _m35;
    float _m36;
};

struct _5918
{
    float _m0;
    int _m1;
    int _m2;
    int _m3;
    int _m4;
    float _m5;
    float _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    vec4 _m16;
    vec4 _m17;
    float _m18;
    int _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    int _m26;
    float _m27;
    float _m28;
    float _m29;
    int _m30;
    int _m31;
    int _m32;
    int _m33;
    vec2 _m34;
    float _m35;
    float _m36;
};

struct _7387
{
    vec3 _m0;
    float _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec3 _m7;
    float _m8;
    vec3 _m9;
    float _m10;
    vec3 _m11;
    uint _m12;
    ivec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    float _m17;
    uint _m18[3];
};

layout(set = 0, binding = 0, std140) uniform _958_960
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    vec4 _m37;
    vec4 _m38;
    vec4 _m39;
    vec4 _m40;
    vec4 _m41;
    vec4 _m42;
    vec4 _m43;
    vec4 _m44;
    vec4 _m45;
    vec4 _m46;
    vec4 _m47;
    vec4 _m48;
    vec4 _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    uint _m68;
    float _m69;
    float _m70;
    float _m71;
    float _m72;
    float _m73;
    float _m74;
    float _m75;
    float _m76;
    float _m77;
    float _m78;
    float _m79;
    float _m80;
    float _m81;
    float _m82;
    float _m83;
    float _m84;
    float _m85;
    float _m86;
    float _m87;
    uint _m88;
    float _m89[1];
} _960;

layout(set = 2, binding = 0, std140) uniform _1256_1258
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    float _m13;
    float _m14;
    uint _m15;
    uint _m16;
    uint _m17;
    uint _m18;
    float _m19;
    uint _m20;
    uint _m21;
    float _m22;
    float _m23;
    uint _m24;
    float _m25;
    uint _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    uint _m45;
    float _m46[3];
} _1258;

layout(set = 1, binding = 0, std140) uniform _1274_1276
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    float _m4;
    float _m5;
    uint _m6;
    float _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    int _m12;
    uint _m13;
    float _m14[2];
} _1276;

layout(set = 0, binding = 24, std430) restrict readonly buffer _1851_1853
{
    uint _m0[];
} _1853;

layout(set = 0, binding = 25, std140) uniform _1928_1930
{
    vec4 _m0[4096];
} _1930;

layout(set = 0, binding = 26, std140) uniform _1948_1950
{
    vec4 _m0[4096];
} _1950;

layout(set = 0, binding = 27, std140) uniform _2001_2003
{
    vec4 _m0[2048];
} _2003;

layout(set = 0, binding = 34, std430) restrict readonly buffer _3180_3182
{
    uint _m0[];
} _3182;

layout(set = 0, binding = 35, std140) uniform _3257_3259
{
    vec4 _m0[4096];
} _3259;

layout(set = 0, binding = 36, std140) uniform _3333_3335
{
    vec4 _m0[4096];
} _3335;

layout(set = 0, binding = 38, std430) restrict readonly buffer _3620_3622
{
    uint _m0[];
} _3622;

layout(set = 0, binding = 40, std140) uniform _4187_4189
{
    vec4 _m0[4095];
} _4189;

layout(set = 0, binding = 4, std430) restrict readonly buffer _5920_5922
{
    _5918 _m0[];
} _5922;

layout(set = 0, binding = 1, std140) uniform _7382_7384
{
    vec4 _m0[64];
} _7384;

layout(set = 0, binding = 2, std430) restrict readonly buffer _7389_7391
{
    _7387 _m0[];
} _7391;

layout(push_constant, std430) uniform _6013_6015
{
    int _m0;
    int _m1;
    int _m2;
} _6015;

layout(set = 3, binding = 0) uniform texture2D _1442[34816];
layout(set = 0, binding = 19) uniform sampler _1450;
layout(set = 0, binding = 20) uniform TEXTURE_2D _1535;
layout(set = 0, binding = 21) uniform TEXTURE_2D _1675;
layout(set = 0, binding = 22) uniform sampler _1677;
layout(set = 0, binding = 23) uniform TEXTURE_2D _1694;
layout(set = 0, binding = 28) uniform sampler _2172;
layout(set = 0, binding = 29) uniform TEXTURE_2D _2199;
layout(set = 0, binding = 30) uniform sampler _2291;
layout(set = 0, binding = 31) uniform sampler _2311;
layout(set = 0, binding = 32) uniform TEXTURE_2D _2848;
layout(set = 0, binding = 33) uniform sampler _2850;
layout(set = 0, binding = 37) uniform textureCubeArray _3586;
layout(set = 0, binding = 18) uniform sampler _3588;
layout(set = 0, binding = 39) uniform sampler _4013;
layout(set = 0, binding = 41) uniform texture2D _4510;
layout(set = 0, binding = 42) uniform samplerShadow _4512;
layout(set = 0, binding = 43) uniform TEXTURE_2D _4929;
layout(set = 0, binding = 44) uniform sampler _4931;
layout(set = 0, binding = 45) uniform TEXTURE_2D _5062;
layout(set = 0, binding = 46) uniform TEXTURE_2D _5096;
layout(set = 0, binding = 47) uniform TEXTURE_2D _5120;
layout(set = 0, binding = 48) uniform TEXTURE_2D _5163;
layout(set = 0, binding = 49) uniform TEXTURE_2D _5206;
layout(set = 0, binding = 50) uniform TEXTURE_2D _5245;
layout(set = 0, binding = 51) uniform texture3D _5325;
layout(set = 0, binding = 52) uniform texture3D _5345;
layout(set = 0, binding = 53) uniform texture3D _5439;
layout(set = 0, binding = 54) uniform TEXTURE_2D _5726;
layout(set = 0, binding = 55) uniform sampler _6104;
layout(set = 0, binding = 56) uniform TEXTURE_2D _6201;
layout(set = 0, binding = 57) uniform TEXTURE_2D _6378;
layout(set = 0, binding = 58) uniform TEXTURE_2D _6574;
layout(set = 0, binding = 59) uniform TEXTURE_2D _6779;
layout(set = 0, binding = 60) uniform TEXTURE_2D _6797;
layout(set = 0, binding = 61) uniform TEXTURE_2D _6947;
layout(set = 0, binding = 15) uniform texture3D _7392;
layout(set = 0, binding = 16) uniform sampler _7393;
layout(set = 0, binding = 17) uniform texture3D _7394;

layout(location = 17, component = 3) in float _1303;
layout(location = 18, component = 0) in float _1305;
layout(location = 18, component = 1) in float _1310;
layout(location = 18, component = 2) in float _1312;
layout(location = 18, component = 3) in float _1314;
layout(location = 19, component = 0) in float _1345;
layout(location = 19, component = 1) in float _1347;
layout(location = 19, component = 2) in float _1349;
layout(location = 19, component = 3) in float _1353;
layout(location = 20, component = 0) in float _1355;
layout(location = 20, component = 1) in float _1357;
layout(location = 20, component = 2) in float _1369;
layout(location = 10, component = 0) in vec4 _1394;
layout(location = 11, component = 0) in vec4 _1397;
layout(location = 12, component = 0) in vec4 _1400;
layout(location = 0, component = 0) out vec4 _5486;
layout(location = 1, component = 0) out vec4 _5696;
layout(location = 2, component = 0) out vec4 _5697;
layout(location = 0, component = 0) in vec4 _5847;
layout(location = 2, component = 0) in vec4 _5850;
layout(location = 3, component = 0) in vec4 _5853;
layout(location = 4, component = 0) in vec4 _5866;
layout(location = 5, component = 0) in vec4 _5873;
layout(location = 6, component = 0) in vec4 _5879;
layout(location = 7, component = 0) in vec4 _5882;
layout(location = 8, component = 0) in vec4 _7395;
uint _219;
uint _221;
uint _223;
uint _225;
uint _227;
uint _229;
uint _231;
uint _232;
uint _234;
uint _235;
uint _237;
uint _239;
uint _241;
uint _243;
uint _245;
uint _247;
uint _249;
uint _251;
uint _253;

_152 _154()
{
    _152 _848;
    _848._m0 = vec3(0.0);
    _848._m2 = vec3(0.0);
    _848._m3 = 0.0;
    _848._m4 = 0u;
    _848._m5 = 0.0;
    _848._m6 = vec3(0.0);
    _848._m7 = vec3(0.0, 0.0, 1.0);
    _848._m8 = vec3(0.0, 0.0, 1.0);
    _848._m1 = vec3(0.0);
    _848._m9 = 1.0;
    _848._m10 = 1.0;
    _848._m14 = vec3(0.0);
    _848._m15 = vec3(0.0);
    _848._m16 = vec4(0.0);
    _848._m17 = vec4(0.0);
    _848._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _848._m19 = vec3(0.0);
    _848._m20 = vec3(0.0);
    _848._m21 = vec3(0.0);
    _848._m22 = vec3(0.0);
    _848._m23 = vec3(0.0);
    _848._m24 = vec3(0.0);
    _848._m25 = 1.0;
    _848._m26 = uvec4(0u);
    _848._m27 = uvec4(0u);
    _848._m28 = uvec4(0u);
    _848._m29 = vec4(0.0);
    _848._m30 = vec4(0.0);
    _848._m31 = vec4(0.0);
    _848._m32 = vec4(0.0);
    _848._m33 = uvec2(0u);
    _848._m34 = vec2(0.0);
    _848._m35 = 0.0;
    _848._m36 = -1;
    _848._m37 = 0;
    _848._m38 = vec2(0.0);
    _848._m39 = 1.0;
    _848._m41 = -1;
    _848._m45 = 1.0;
    _848._m11 = 1.0;
    _848._m12 = 0u;
    _848._m13 = uvec3(0u);
    _848._m40 = vec3(0.0);
    _848._m46 = 0.0;
    _848._m47 = 1.0;
    return _848;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _110(inout vec4 _109)
{
    vec4 _600 = _109;
    _109 = _22(_600);
    return packUnorm4x8(_109.wzyx);
}

vec2 _168(vec2 _167)
{
    return ((_167 * 255.0) / vec2(128.0)) - vec2(1.0);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _173(inout vec2 _171, bool _172)
{
    vec2 _994 = _171;
    _171 = _168(_994);
    float _1014 = (1.0 - (_171.x * _171.x)) - (_171.y * _171.y);
    vec3 _997 = vec3(_171.x, _171.y, sqrt(_10(_1014)));
    if (_172 == false)
    {
        _997.z = -_997.z;
    }
    return _997;
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _82(mat3 _80, vec3 _81)
{
    return _80 * _81;
}

vec3 _178(vec3 _176, mat3 _177)
{
    mat3 _1030 = _177;
    vec3 _1032 = _176;
    return normalize(_82(_1030, _1032));
}

vec3 _184(vec2 _181, mat3 _182, bool _183)
{
    vec2 _1039 = _181;
    bool _1041 = _183;
    vec3 _1043 = _173(_1039, _1041);
    vec3 _1038 = _1043;
    vec3 _1044 = _1038;
    mat3 _1046 = _182;
    return _178(_1044, _1046);
}

float _165(inout float _163, bool _164)
{
    if (_164)
    {
        _163 += (float(_163 < _960._m50) * _960._m51);
    }
    float _975 = _163;
    return _960._m0.w / (_10(_975) + _960._m0.z);
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _47(float _44, float _45, float _46)
{
    return min(_44, min(_45, _46));
}

float _42(float _39, float _40, float _41)
{
    return max(_39, max(_40, _41));
}

float _158(vec2 _157)
{
    return dot(_157, _157);
}

vec4 _118(uint _117)
{
    return vec4(float((_117 >> uint(24)) & 255u), float((_117 >> uint(16)) & 255u), float((_117 >> uint(8)) & 255u), float(_117 & 255u));
}

vec4 _115(uint _114)
{
    return unpackUnorm4x8(_114).wzyx;
}

float _93(float _92)
{
    return sqrt(_92);
}

float _85(float _84)
{
    return exp2(_84);
}

vec3 _147(float _144, float _145, vec3 _146)
{
    float _799 = 0.0949999988079071044921875 + (_145 * (0.60000002384185791015625 + (4.190000057220458984375 * _145)));
    float _809 = _144 + 0.02500000037252902984619140625;
    float _813 = (9.5 * _145) * _144;
    float _827 = 1.0 - (14.0 * _144);
    float _819 = (_799 * _809) * _85(_827);
    float _834 = -_813;
    float _830 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _85(_834)));
    return mix(vec3(_819), vec3(_830), _146);
}

vec3 _65(vec3 _64)
{
    return _64 * _64;
}

float _68(float _67)
{
    return _67 * _67;
}

uint _53(float _50, float _51, float _52)
{
    bool _304 = abs(_52) >= abs(_50);
    bool _312;
    if (_304)
    {
        _312 = abs(_52) >= abs(_51);
    }
    else
    {
        _312 = _304;
    }
    if (_312)
    {
        return uint((_52 < 0.0) ? 5 : 4);
    }
    if (abs(_51) >= abs(_50))
    {
        return uint((_51 < 0.0) ? 3 : 2);
    }
    return uint(int(_50 < 0.0));
}

float _90(float _88, float _89)
{
    return pow(_88, _89);
}

vec3 _133(vec3 _131, float _132)
{
    float _686 = dot(_131, vec3(16.666500091552734375));
    float _681 = _10(_686);
    float _695 = 1.0 - _132;
    float _698 = _10(_695);
    float _699 = 5.0;
    vec3 _703 = _131 + ((vec3(_681) - _131) * _90(_698, _699));
    return _16(_703);
}

vec3 _141(vec3 _136, vec3 _137, vec3 _138, vec3 _139, float _140)
{
    float _711 = dot(_136, _137);
    float _707 = _10(_711);
    vec3 _713 = normalize(_137 + _138);
    float _722 = dot(_136, _713);
    float _718 = _10(_722);
    float _728 = dot(_138, _713);
    float _724 = _10(_728);
    vec3 _731 = _139;
    float _733 = _724;
    vec3 _730 = _133(_731, _733);
    float _740 = dot(_136, _138);
    float _736 = _10(_740);
    float _742 = 1.0 - (_140 * 0.800000011920928955078125);
    _742 *= _742;
    _742 *= _742;
    float _753 = _742 * _742;
    float _757 = ((_718 * _718) * (_753 - 1.0)) + 1.0;
    _757 = _753 / ((_757 * _757) + 9.9999999392252902907785028219223e-09);
    float _772 = (_707 * (1.0 - _742)) + _742;
    float _779 = (_736 * (1.0 - _742)) + _742;
    _757 /= (((4.0 * _772) * _779) + 9.9999999392252902907785028219223e-09);
    return _730 * _757;
}

vec4 _75(vec3 _73, mat4 _74)
{
    return vec4((_73.x * _74[0].x) + ((_73.y * _74[0].y) + ((_73.z * _74[0].z) + _74[0].w)), (_73.x * _74[1].x) + ((_73.y * _74[1].y) + ((_73.z * _74[1].z) + _74[1].w)), (_73.x * _74[2].x) + ((_73.y * _74[2].y) + ((_73.z * _74[2].z) + _74[2].w)), (_73.x * _74[3].x) + ((_73.y * _74[3].y) + ((_73.z * _74[3].z) + _74[3].w)));
}

vec3 _188(vec2 _187)
{
    return (vec3(_960._m52, _960._m53, _960._m54) + (vec3(_960._m55, _960._m56, _960._m57) * _187.x)) + (vec3(_960._m58, _960._m59, _960._m60) * _187.y);
}

float _96(float _95)
{
    float _498 = (((-0.15658299624919891357421875) * abs(_95)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_95));
    float _512;
    if (_95 >= 0.0)
    {
        _512 = _498;
    }
    else
    {
        _512 = 3.1415927410125732421875 - _498;
    }
    return _512;
}

float _99(float _98)
{
    float _526;
    if (_98 < 1.0)
    {
        _526 = _98;
    }
    else
    {
        _526 = 1.0 / _98;
    }
    float _523 = _526;
    float _534 = _523 * _523;
    float _538 = 0.087292902171611785888671875;
    _538 = (-0.3018949925899505615234375) + (_538 * _534);
    _538 = 1.0 + (_538 * _534);
    _538 *= _523;
    float _554;
    if (_98 < 1.0)
    {
        _554 = _538;
    }
    else
    {
        _554 = 1.57079637050628662109375 - _538;
    }
    return _554;
}

float _102(float _101)
{
    float _567 = abs(_101);
    float _564 = _99(_567);
    float _571;
    if (_101 < 0.0)
    {
        _571 = -_564;
    }
    else
    {
        _571 = _564;
    }
    return _571;
}

float _106(float _104, float _105)
{
    float _585 = _104 / _105;
    float _581 = _102(_585);
    if (_105 < 0.0)
    {
        _581 += ((_104 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _581;
}

int _36(float _35)
{
    return floatBitsToInt(_35);
}

float _56(float _55)
{
    return _55 * ((_55 * ((_55 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _59(vec3 _58)
{
    float _357 = _58.x;
    float _361 = _58.y;
    float _366 = _58.z;
    return vec3(_56(_357), _56(_361), _56(_366));
}

vec4 _62(vec4 _61)
{
    vec3 _374 = _61.xyz;
    return vec4(_59(_374), _61.w);
}

void _26(float _25)
{
    if (_25 < 0.0)
    {
        discard;
    }
}

float _195(float _194)
{
    return 0.16666667163372039794921875 * ((_194 * ((_194 * ((-_194) + 3.0)) - 3.0)) + 1.0);
}

float _198(float _197)
{
    return 0.16666667163372039794921875 * (((_197 * _197) * ((3.0 * _197) - 6.0)) + 4.0);
}

float _207(float _206)
{
    float _1208 = _206;
    float _1211 = _206;
    return _195(_1208) + _198(_1211);
}

float _201(float _200)
{
    return 0.16666667163372039794921875 * ((_200 * ((_200 * (((-3.0) * _200) + 3.0)) + 3.0)) + 1.0);
}

float _204(float _203)
{
    return 0.16666667163372039794921875 * ((_203 * _203) * _203);
}

float _210(float _209)
{
    float _1217 = _209;
    float _1220 = _209;
    return _201(_1217) + _204(_1220);
}

float _213(float _212)
{
    float _1226 = _212;
    float _1229 = _212;
    float _1232 = _212;
    return (-1.0) + (_198(_1226) / (_195(_1229) + _198(_1232)));
}

float _216(float _215)
{
    float _1240 = _215;
    float _1243 = _215;
    float _1246 = _215;
    return 1.0 + (_204(_1240) / (_201(_1243) + _204(_1246)));
}

vec2 _124(vec2 _123)
{
    return vec2((_123.x >= 0.0) ? 1.0 : (-1.0), (_123.y >= 0.0) ? 1.0 : (-1.0));
}

vec3 _128(vec2 _127)
{
    vec3 _647 = vec3(_127, (1.0 - abs(_127.x)) - abs(_127.y));
    if (_647.z < 0.0)
    {
        vec2 _670 = _647.xy;
        vec2 _674 = (vec2(1.0) - abs(_647.yx)) * _124(_670);
        _647 = vec3(_674.x, _674.y, _647.z);
    }
    return normalize(_647);
}

mat3 _192(vec3 _191)
{
    float _1089 = (_191.z >= 0.0) ? 1.0 : (-1.0);
    float _1094 = (-1.0) / (_1089 + _191.z);
    float _1100 = (_191.x * _191.y) * _1094;
    vec3 _1108 = vec3(1.0 + (((_1089 * _191.x) * _191.x) * _1094), _1089 * _1100, (-_1089) * _191.x);
    vec3 _1128 = vec3(_1100, _1089 + ((_191.y * _191.y) * _1094), -_191.y);
    return mat3(vec3(_1108), vec3(_1128), vec3(_191));
}

void main()
{
    _219 = 2147483648u;
    _221 = 1073741824u;
    _223 = 0u;
    _225 = 268435456u;
    _227 = 536870912u;
    _229 = 805306368u;
    _231 = 1073741824u;
    _232 = 1342177280u;
    _234 = 0u;
    _235 = 16777216u;
    _237 = 33554432u;
    _239 = 50331648u;
    _241 = 67108864u;
    _243 = 83886080u;
    _245 = 100663296u;
    _247 = 117440512u;
    _249 = 134217728u;
    _251 = 150994944u;
    _253 = 167772160u;
    float _1254 = _1258._m3.x;
    if ((_1254 == 6.0) || (_1254 == 7.0))
    {
        bool _1283 = int(gl_FrontFacing) == int((_1276._m13 & 1u) != 0u);
        bool _1291;
        if (_1283)
        {
            _1291 = ((_1258._m45 & 2u) != 0u) == false;
        }
        else
        {
            _1291 = _1283;
        }
        if (_1291)
        {
            discard;
        }
        bool _1295 = _1254 == 7.0;
        vec3 _1298 = vec3(0.0);
        vec3 _1299 = vec3(0.0);
        _152 _1300 = _154();
        _1300._m16 = vec4(0.0, 0.0, _1303, _1305);
        vec3 _1309 = vec3(_1310, _1312, _1314);
        _1300._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
        _1300._m15 = vec3(_960._m61, _960._m62, _960._m63) + _1309;
        vec3 _1343 = vec3(0.0);
        vec3 _1344 = vec3(0.0);
        _1343 = normalize(vec3(_1345, _1347, _1349));
        _1344 = normalize(vec3(_1353, _1355, _1357));
        vec3 _1361 = _1343;
        vec3 _1363 = _1344;
        vec3 _1365 = normalize(cross(_1361, _1363) * _1369);
        _1300._m18 = mat3(vec3(_1363), vec3(_1365), vec3(_1361));
        _1300._m14 = normalize(-_1309);
        _1300._m29 = _1394;
        _1300._m30 = _1397;
        _1300._m31 = _1400;
        uint _1403 = 0u;
        vec4 _1404 = vec4(0.0);
        vec4 _1405 = vec4(0.0);
        vec4 _1406 = vec4(0.0);
        vec4 _1407 = vec4(0.0);
        vec4 _1408 = vec4(0.0);
        float _1409 = 0.0;
        uvec2 _1410 = uvec2(0u, 65535u);
        _1300._m0 = _1404.xyz;
        _1300._m2 = _1405.xyz;
        _1300._m1 = _1408.xyz;
        _1300._m3 = _1407.w;
        _1300._m6 = _1406.xyz;
        vec2 _1428 = vec2(_1303, _1305) * _1258._m11.xy;
        vec4 _1437 = texture(sampler2D(_1442[_1258._m16], _1450), _1428);
        vec3 _1456 = texture(sampler2D(_1442[_1258._m21], _1450), _1428).xyz;
        vec2 _1466 = texture(sampler2D(_1442[_1258._m18], _1450), _1428).xy;
        float _1476 = texture(sampler2D(_1442[_1258._m20], _1450), _1428).x;
        float _1486 = texture(sampler2D(_1442[_1258._m17], _1450), _1428).x;
        _1300._m0 = _1258._m0.xyz * _1437.xyz;
        vec4 _1510 = vec4(vec3(_1437.w), 0.0);
        uint _1511 = _110(_1510);
        _1300._m4 = _1511;
        _1300._m9 = _1486;
        _1300._m2 = _1456;
        _1300._m3 = _1476;
        _1300._m6 = vec3(_1466, 0.0);
        if ((_1258._m45 & 1u) != 0u)
        {
            vec2 _1530 = _1428 * 2.0;
            vec2 _1534 = SAMPLE_TEXTURE(SAMPLER_2D(_1535, _1450), _1530).xy;
            vec2 _1544 = _1466;
            bool _1546 = true;
            vec3 _1547 = _173(_1544, _1546);
            vec3 _1542 = _1547;
            vec2 _1549 = _1534;
            bool _1551 = true;
            vec3 _1552 = _173(_1549, _1551);
            vec3 _1548 = _1552;
            vec3 _1553 = _1542 + vec3(0.0, 0.0, 1.0);
            vec3 _1556 = vec3(-_1548.xy, _1548.z);
            vec3 _1565 = (_1553 * dot(_1553, _1556)) - (_1556 * _1553.z);
            _1300._m6 = normalize(_1565);
            _1300._m6 += vec3(1.0);
            _1300._m6 *= 0.5;
            _1300._m6 = vec3(_1534, 0.0);
            float _1594 = length((_1534 - vec2(0.4980392158031463623046875)) * 1.0);
            _1594 -= 0.0313725508749485015869140625;
            float _1604 = _1594;
            _1594 = _10(_1604);
            float _1607 = 2.0;
            float _1608 = -1.5;
            float _1610 = 3.0;
            _1300._m9 += (_1594 * _1607);
            float _1618 = _1300._m9;
            _1300._m9 = _10(_1618);
            _1300._m3 += (_1594 * _1608);
            float _1630 = _1300._m3;
            _1300._m3 = _10(_1630);
            _1300._m2 += vec3(_1594 * _1610);
            vec3 _1643 = _1300._m2;
            _1300._m2 = _16(_1643);
        }
        _1298 = _1300._m0;
        if (((_960._m88 & 1u) != 0u) == true)
        {
            vec2 _1658 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
            float _1674 = 1.0 - TEXTURE_LOD(SAMPLER_2D(_1675, _1677), vec4(_1658, 0.0, 0.0).xy, vec4(_1658, 0.0, 0.0).w).x;
            vec2 _1693 = TEXTURE_LOD(SAMPLER_2D(_1694, _1677), vec4(_1658, 0.0, 0.0).xy, vec4(_1658, 0.0, 0.0).w).xy;
            uint _1710 = uint((_1693.y * 255.0) + 0.5);
            bool _1717 = _1710 == 2u;
            bool _1728;
            if (_1717)
            {
                _1728 = abs((1.0 - gl_FragCoord.z) - _1674) <= 9.9999997473787516355514526367188e-05;
            }
            else
            {
                _1728 = _1717;
            }
            if (_1728)
            {
                float _1731 = _1693.x;
                _1300._m47 = 1.0 - _1731;
            }
        }
        if (_1295)
        {
            float _1740 = _1437.w;
            _1299 = _1300._m0 * (1.0 - _1740);
            _1300._m0 *= _1740;
        }
        else
        {
            _1300._m0 *= _1300._m9;
        }
        uint _1760 = 0u;
        bool _1761 = true;
        vec2 _1762 = _1300._m6.xy;
        bool _1766 = _1761;
        vec3 _1768 = _173(_1762, _1766);
        _1300._m7 = _1768;
        vec2 _1770 = _1300._m6.xy;
        mat3 _1774 = _1300._m18;
        bool _1777 = _1761;
        _1300._m6 = _184(_1770, _1774, _1777);
        vec3 _1781 = dFdx(_1300._m15);
        vec3 _1785 = dFdy(_1300._m15);
        uvec2 _1789 = uvec2(_1300._m17.xy);
        uint _1794 = _1789.x / 256u;
        uint _1799 = _1789.y / 256u;
        float _1804 = _1300._m17.z;
        bool _1807 = false;
        float _1808 = _165(_1804, _1807);
        float _1803 = _1808;
        float _1809 = log2(max(1.0, _1803 / _960._m32.z)) * _960._m32.w;
        uint _1819 = min(23u, uint(_1809));
        float _1826 = _960._m82;
        float _1832 = _960._m83;
        uint _1824 = (_31(_1826) + ((_1794 + (_31(_1832) * _1799)) * 24u)) + _1819;
        float _1845 = _1276._m10;
        uint _1844 = _31(_1845);
        uint _1849 = _1853._m0[_1824 * 64u];
        uint _1860 = _1849 & 255u;
        uint _1863 = _1860;
        uint _1865 = _1849;
        uint _1867 = _1824;
        vec3 _1869 = dFdx(_1300._m15);
        vec3 _1873 = dFdy(_1300._m15);
        uint _1877 = _1844 & 3u;
        bool _1880 = (_1844 & 4u) != 0u;
        uint _1885 = ((_1877 == 0u) && (!_1880)) ? 0u : _1863;
        uint _1893 = 1u;
        _1923 _1925;
        vec3 _2346;
        while (_1893 <= _1885)
        {
            uint _1902 = (_1867 * 64u) + _1893;
            uint _1907 = _1853._m0[_1902];
            uint _1911 = _1907;
            if (_1911 >= _1907)
            {
                _1893++;
            }
            int _1920 = 2;
            int _1921 = 2;
            int _1922 = 1;
            _1925._m0 = _1930._m0[(uint(_1920) * _1911) + 0u];
            _1925._m1 = _1930._m0[(uint(_1920) * _1911) + 1u];
            _1925._m2 = _1950._m0[(uint(_1921) * _1911) + 0u];
            float _1964 = _1950._m0[(uint(_1921) * _1911) + 1u].x;
            _1925._m3 = _31(_1964);
            float _1974 = _1950._m0[(uint(_1921) * _1911) + 1u].y;
            _1925._m4 = _31(_1974);
            float _1984 = _1950._m0[(uint(_1921) * _1911) + 1u].z;
            _1925._m5 = _31(_1984);
            float _1994 = _1950._m0[(uint(_1921) * _1911) + 1u].w;
            _1925._m6 = _31(_1994);
            float _2009 = _2003._m0[(uint(_1922) * _1911) + 0u].x;
            _1925._m7 = _31(_2009);
            float _2019 = _2003._m0[(uint(_1922) * _1911) + 0u].y;
            _1925._m8 = _31(_2019);
            float _2029 = _2003._m0[(uint(_1922) * _1911) + 0u].z;
            _1925._m9 = _31(_2029);
            vec4 _2034 = _1925._m0;
            vec4 _2037 = _1925._m1;
            vec4 _2040 = _1925._m2;
            vec3 _2043 = vec3(dot(_1300._m15, _2034.xyz) + _2034.w, dot(_1300._m15, _2037.xyz) + _2037.w, dot(_1300._m15, _2040.xyz) + _2040.w);
            float _2069 = 0.0039215688593685626983642578125;
            float _2071 = _2043.x;
            float _2074 = _2043.y;
            float _2077 = _2043.z;
            bool _2082 = _47(_2071, _2074, _2077) <= _2069;
            bool _2099;
            if (!_2082)
            {
                float _2086 = _2043.x;
                float _2089 = _2043.y;
                float _2092 = _2043.z;
                _2099 = _42(_2086, _2089, _2092) >= (1.0 - _2069);
            }
            else
            {
                _2099 = _2082;
            }
            if (_2099)
            {
                continue;
            }
            uint _2103 = _1925._m5;
            uint _2106 = _1925._m9;
            uint _2109 = _1844 & 3u;
            bool _2118 = ((_2106 & 512u) != 0u) && (_2109 != 0u);
            bool _2129;
            if (!_2118)
            {
                _2129 = ((_2106 & 1024u) != 0u) && (_2109 != 1u);
            }
            else
            {
                _2129 = _2118;
            }
            bool _2137;
            if (!_2129)
            {
                _2137 = (_2106 & 16384u) != 0u;
            }
            else
            {
                _2137 = _2129;
            }
            if (_2137)
            {
                continue;
            }
            vec2 _2141 = vec2(dot(_1869, _2034.xyz), dot(_1869, _2037.xyz));
            vec2 _2151 = vec2(dot(_1873, _2034.xyz), dot(_1873, _2037.xyz));
            vec4 _2161 = vec4(0.0);
            vec4 _2162 = vec4(0.0);
            uint _2163 = _1925._m3;
            uint _2169 = _2163 + 1u;
            vec4 _2166 = textureGrad(sampler2D(_1442[nonuniformEXT(_2169)], _2172), _2043.xy, _2141 * vec2(1.0), _2151 * vec2(1.0));
            if ((_2106 & 32768u) != 0u)
            {
                vec2 _2189 = vec2(1.0 / length(_2034.xyz), 1.0 / length(_2037.xyz));
                vec2 _2220 = TEXTURE_LOD(SAMPLER_2D(_2199, _1450), vec4(_2043.xy * _2189, 0.0, 0.0).xy, vec4(_2043.xy * _2189, 0.0, 0.0).w).xy;
                _2166 = vec4(_2220.x, _2220.y, _2166.z, _2166.w);
                vec2 _2226 = _2166.xy - vec2(0.4980392158031463623046875);
                float _2229 = 1.0 - _158(_2226);
                _2166.z = sqrt(_10(_2229));
            }
            else
            {
                if ((_2106 & 65536u) != 0u)
                {
                    vec2 _2240 = vec2(1.0, (1.0 / length(_2037.xyz)) / 2.5);
                    vec2 _2248 = TEXTURE_GRAD(SAMPLER_2D(_1535, _1450), _2043.xy * _2240, _2141 * _2240, _2151 * _2240).xy;
                    vec2 _2268 = _2166.xy + (_2248 - vec2(0.4980392158031463623046875));
                    _2166 = vec4(_2268.x, _2268.y, _2166.z, _2166.w);
                    vec2 _2274 = _2166.xy - vec2(0.4980392158031463623046875);
                    float _2277 = 1.0 - _158(_2274);
                    _2166.z = sqrt(_10(_2277));
                }
            }
            if ((_2103 & 1u) != 0u)
            {
                uint _2288 = _2163 + 0u;
                _2161 = textureGrad(sampler2D(_1442[nonuniformEXT(_2288)], _2291), _2043.xy, _2141 * vec2(1.0), _2151 * vec2(1.0));
            }
            if ((_2103 & 2u) != 0u)
            {
                uint _2308 = _2163 + 2u;
                _2162 = textureGrad(sampler2D(_1442[nonuniformEXT(_2308)], _2311), _2043.xy, _2141 * vec2(1.0), _2151 * vec2(1.0));
            }
            float _2321 = 1.0;
            vec3 _2322 = vec3(0.5, 0.5, 1.0);
            vec3 _2324 = vec3(0.0, 0.0, 1.0);
            vec4 _2325 = _2166;
            _2322 = _2325.xyz;
            _2321 = _2325.w;
            _2324 = (_2322 * 2.0) - vec3(1.0);
            if (_2321 <= (4.0 * _2069))
            {
                continue;
            }
            _2322 = _2324;
            if ((_2106 & 128u) != 0u)
            {
                _2346 = vec3(-_2322.x, -_2322.y, _2322.z);
            }
            else
            {
                _2346 = _2322;
            }
            _2322 = _2346;
            uint _2361 = _1925._m6;
            uint _2365 = _2361;
            float _2364 = 1.0 + (_118(_2365).w * 0.062745101749897003173828125);
            uint _2373 = _2103;
            float _2372 = _115(_2373).z;
            uint _2378 = _2361;
            vec3 _2377 = _115(_2378).xyz;
            float _2391 = _2364 - (_2364 * abs((_2043.z * 2.0) - 1.0));
            _2321 *= _10(_2391);
            float _2395 = _2321;
            if ((_2103 & 1u) != 0u)
            {
                _2377 *= _2161.xyz;
                _2395 *= _2161.w;
            }
            vec3 _2410 = _1300._m18[2];
            float _2419 = dot(_2410, normalize(_2040.xyz));
            float _2413 = _10(_2419);
            uint _2421 = _1925._m7;
            uint _2425 = _2421;
            vec4 _2424 = _115(_2425);
            _1300._m22 = mix(_1300._m22, ((_2424.xyz * ((_2395 * _2424.w) * 16.0)) * _2372) * _2413, vec3(_2395));
            uint _2447 = _1925._m8;
            uint _2451 = _2447;
            vec4 _2450 = _115(_2451);
            if ((_2103 & 2u) != 0u)
            {
                _2450 = _2162;
            }
            if ((_2103 & 32u) != 0u)
            {
                uint _2467 = _2103;
                float _2466 = _115(_2467).x;
                uint _2472 = _2103;
                float _2471 = _118(_2472).y;
                float _2492 = dot((_2043.xy + _2324.xy) - vec2(0.5), (_2043.xy + _2324.xy) - vec2(0.5));
                float _2476 = _10(_2492);
                float _2500 = _2471 * (_2466 - _2476);
                float _2502 = _10(_2500);
                float _2494 = _93(_2502);
                _2321 = min(_2321, _2494);
            }
            float _2507 = _2321 * _2413;
            uint _2511 = _1925._m4;
            uint _2515 = _2511;
            vec4 _2514 = _115(_2515) * _2507;
            _1300._m9 = max(_1300._m9, _2514.x);
            _1300._m0 = mix(_1300._m0, _2377, _2514.xxx);
            _1300._m2 = mix(_1300._m2, _2450.xyz, _2514.yyy);
            if (!(_2507 == 0.0))
            {
                float _2545 = 1.0;
                vec3 _2555 = normalize(_2034.xyz + (_2410 * dot(_2034.xyz, _2410)));
                _2034 = vec4(_2555.x, _2555.y, _2555.z, _2034.w);
                vec3 _2564 = normalize(cross(_2410, _2034.xyz)) * _2545;
                _2037 = vec4(_2564.x, _2564.y, _2564.z, _2037.w);
                _2322 = ((_2034.xyz * _2322.x) + (_2037.xyz * _2322.y)) + (_2410 * _2322.z);
                if ((_2106 & 256u) != 0u)
                {
                    vec3 _2588 = mix(_2410, _2322, _2514.www);
                    float _2594 = dot(_2588, _2410);
                    _2322 = (_1300._m6 * _2594) + ((_2588 - (_2410 * _2594)) * dot(_1300._m6, _2410));
                }
                else
                {
                    if ((_2106 & 64u) != 0u)
                    {
                        _2322 = mix(mix(_1300._m6, _2410, vec3(_2507)), _2322, _2514.www);
                    }
                    else
                    {
                        _2322 = mix(_1300._m6, _2322, _2514.www);
                    }
                }
                _1300._m6 = normalize(_2322);
            }
            float _2639 = _2450.w;
            _1300._m3 = mix(_1300._m3, _2639, _2514.z);
        }
        _1300._m21 = _1300._m22;
        _1300._m25 = 1.0;
        float _2653 = _960._m33.w;
        bool _2656 = _2653 < 0.0;
        _2653 = abs(_2653);
        vec3 _2661 = _1300._m15;
        float _2680 = (1.0 - (length(_2661 - vec3(_960._m61, _960._m62, _960._m63)) / _2653)) / 0.25;
        float _2664 = _10(_2680);
        if ((!_2656) && (_2664 > 0.0))
        {
            vec3 _2689 = _960._m33.xyz;
            vec3 _2693 = _960._m34.xyz;
            float _2697 = _2661.z - _2693.z;
            float _2703 = _960._m35.w;
            float _2706 = _960._m36.w;
            float _2709 = float(_2706 < 0.0);
            _2706 = abs(_2706) - 1.0;
            bool _2716 = _2697 <= 0.0;
            float _2719 = 3.5 * float(!(_2706 == 0.0));
            float _2728;
            if (!(_2703 == 0.0))
            {
                _2728 = _2689.z;
            }
            else
            {
                _2728 = _2693.z;
            }
            float _2725 = _2728;
            float _2737 = min(_2716 ? 2.0 : 1000.0, abs(_2697));
            float _2744 = max(_2689.x - _2661.x, _2661.x - _2693.x);
            float _2756 = max(_2689.y - _2661.y, _2661.y - _2693.y);
            float _2768 = max(_2744, _2756) - _2737;
            _2768 = max(_2768, _2725 - _2661.z);
            _2768 = max(_2768, _2697 - _2719);
            if (_2768 <= 0.0)
            {
                float _2789 = _2716 ? _2703 : _2706;
                vec2 _2794 = _1300._m18[2].xy;
                float _2798 = length(_2794);
                vec3 _2801 = vec3(_2794, (-1.73205077648162841796875) * _2798);
                _2801 /= vec3(2.0 * _2798);
                vec3 _2814 = _960._m36.xyz;
                vec3 _2818 = mix(_2801, _2814, bvec3(_2716));
                vec2 _2825 = _2661.xy - (_2818.xy * (_2697 / _2818.z));
                float _2836 = (_960._m84 / 100.0) * 16.0;
                vec2 _2843 = _2825 * _2836;
                float _2847 = TEXTURE_LOD(SAMPLER_2D(_2848, _2850), vec4(_2843, 0.0, 0.0).xy, vec4(_2843, 0.0, 0.0).w).x;
                float _2865 = min(8.0, _2693.z - _2689.z);
                float _2878 = (-_2697) / _2865;
                float _2873 = _10(_2878);
                float _2885 = dot(_1300._m6, _2818);
                float _2880 = _10(_2885);
                float _2891 = _2744 / _2737;
                float _2887 = 1.0 - _10(_2891);
                float _2897 = _2756 / _2737;
                _2887 *= (1.0 - _10(_2897));
                _2887 *= _2887;
                float _2913 = min(_2697 / 1.0, 1.0 - (_2697 / _2719));
                float _2905 = _10(_2913);
                _2887 *= max(_2905, _2873);
                _2887 *= _2887;
                _2887 *= _2664;
                float _2926 = _2847 - 1.0;
                float _2929 = float(_2716) * _2709;
                float _2934 = max(0.0, _2847 - 0.85000002384185791015625);
                float _2939 = _2716 ? _2926 : _2934;
                float _2944 = (((1.0 - _2929) * _2880) * _2887) * _2789;
                vec3 _2953 = _1300._m0 + (_1300._m2 * (vec3(1.0) - _1300._m0));
                _1300._m21 += ((_2953 * (_2939 * _2944)) * _960._m35.xyz);
                float _2977 = _2929 * _2887;
                _1300._m25 = 1.0 + (_2977 * (_2847 - 1.0));
            }
        }
        else
        {
            if (_2664 > 0.0)
            {
                _2664 *= _960._m85;
                float _2997 = float(_960._m36.w < 0.0);
                vec3 _3002 = _960._m36.xyz;
                float _3011 = dot(_1300._m6, _3002);
                float _3006 = _10(_3011);
                vec2 _3013 = _2661.xy - (_3002.xy * (_2661.z / _3002.z));
                float _3025 = (_960._m84 / 100.0) * 16.0;
                vec2 _3030 = _3013 * _3025;
                float _3034 = TEXTURE_LOD(SAMPLER_2D(_2848, _2850), vec4(_3030, 0.0, 0.0).xy, vec4(_3030, 0.0, 0.0).w).x;
                vec4 _3050 = _960._m35;
                _1300._m21 += (_3050.xyz * (((((1.0 - _2997) * (_3034 - 1.0)) * _3006) * _2664) * _3050.w));
                _1300._m25 = 1.0 + ((_2997 * (_3034 - 1.0)) * _2664);
            }
        }
        _1300._m14 = normalize(vec3(_960._m61, _960._m62, _960._m63) - _1300._m15);
        vec3 _3092 = vec3(0.0);
        vec3 _3093 = vec3(0.0);
        vec3 _3094 = vec3(0.0);
        vec3 _3095 = vec3(0.0);
        vec3 _3096 = vec3(0.0);
        vec4 _3097 = _1300._m29;
        vec4 _3100 = _1300._m30;
        vec4 _3103 = _1300._m31;
        _3093 = vec3(_3097.x, _3097.y, _3097.z);
        _3094 = vec3(_3097.w, _3100.x, _3100.y);
        _3095 = vec3(_3100.z, _3100.w, _3103.x);
        _3096 = vec3(_3103.y, _3103.z, _3103.w);
        vec3 _3134 = ((_3093 - (_3094 * _1300._m6.y)) + (_3095 * _1300._m6.z)) - (_3096 * _1300._m6.x);
        float _3158 = _1276._m8 * _960._m86;
        _3092 += (max(vec3(0.0), _3134 * _10(_3158)) * _1300._m0);
        _1300._m21 += _3092;
        bool _3172 = true;
        if (true && (_3172 == true))
        {
            uint _3178 = _3182._m0[_1824 * 64u];
            uint _3187 = _3178 & 255u;
            uint _3190 = _3187;
            uint _3192 = _3178;
            uint _3194 = _1824;
            float _3196 = _1300._m47;
            float _3205 = dot(_1300._m14, _1300._m6);
            float _3199 = _10(_3205);
            float _3207 = _3199;
            float _3209 = _1300._m3;
            vec3 _3212 = _1300._m2;
            _1300._m24 = (_147(_3207, _3209, _3212) * _1300._m11) * _1300._m39;
            uint _3223 = 1u;
            _3253 _3255;
            while (_3223 <= _3190)
            {
                uint _3232 = (_3194 * 64u) + _3223;
                uint _3237 = _3182._m0[_3232];
                uint _3241 = _3237;
                if (_3241 >= _3237)
                {
                    _3223++;
                }
                float _3250 = 0.0039215688593685626983642578125;
                int _3251 = 4;
                int _3252 = 4;
                _3255._m0 = _3259._m0[(uint(_3251) * _3241) + 0u].xyz;
                float _3274 = _3259._m0[(uint(_3251) * _3241) + 0u].w;
                _3255._m1 = _31(_3274);
                _3255._m2 = _3259._m0[(uint(_3251) * _3241) + 1u].xyz;
                _3255._m3 = _3259._m0[(uint(_3251) * _3241) + 1u].w;
                _3255._m4 = _3259._m0[(uint(_3251) * _3241) + 2u];
                float _3309 = _3259._m0[(uint(_3251) * _3241) + 3u].x;
                _3255._m8 = _31(_3309);
                float _3319 = _3259._m0[(uint(_3251) * _3241) + 3u].y;
                _3255._m9 = _31(_3319);
                _3255._m10 = _3259._m0[(uint(_3251) * _3241) + 3u].z;
                _3255._m5 = _3335._m0[(uint(_3252) * _3241) + 0u];
                _3255._m6 = _3335._m0[(uint(_3252) * _3241) + 1u];
                _3255._m7 = _3335._m0[(uint(_3252) * _3241) + 2u];
                _3255._m12 = _3335._m0[(uint(_3252) * _3241) + 3u].xyz;
                _3255._m13 = _3335._m0[(uint(_3252) * _3241) + 3u].w;
                vec3 _3377 = vec3(dot(_1300._m15, _3255._m5.xyz) + _3255._m5.w, dot(_1300._m15, _3255._m6.xyz) + _3255._m6.w, dot(_1300._m15, _3255._m4.xyz) + _3255._m4.w);
                float _3406 = _3377.x;
                float _3409 = _3377.y;
                float _3412 = _3377.z;
                bool _3417 = _47(_3406, _3409, _3412) <= _3250;
                bool _3434;
                if (!_3417)
                {
                    float _3421 = _3377.x;
                    float _3424 = _3377.y;
                    float _3427 = _3377.z;
                    _3434 = _42(_3421, _3424, _3427) >= (1.0 - _3250);
                }
                else
                {
                    _3434 = _3417;
                }
                if (_3434)
                {
                    continue;
                }
                uint _3438 = _3255._m1;
                vec3 _3441 = _3255._m0;
                float _3444 = float(bitfieldExtract(_3255._m8, 20, 12));
                float _3449 = 0.800000011920928955078125;
                vec3 _3450 = (_3377 * 2.0) - vec3(1.0);
                vec3 _3455 = _3450;
                vec3 _3454 = _65(_3455);
                vec3 _3458 = _3450 * sqrt(((vec3(1.0) - (_3454.yzx * 0.5)) - (_3454.zxy * 0.5)) + ((_3454.yzx * _3454.zxy) / vec3(3.0)));
                float _3489 = 1.0 - ((length(_3458) - _3449) / ((1.0 - _3449) + 9.9999999747524270787835121154785e-07));
                float _3478 = _10(_3489);
                _3478 *= _3478;
                _3478 *= _3196;
                float _3497 = _3255._m7.w;
                _3478 *= _3497;
                _3196 *= (1.0 - _3478);
                vec3 _3507 = _3255._m12;
                float _3510 = _3255._m13;
                float _3515 = _3478;
                vec3 _3513 = _3507 * (_10(_3515) * _3510);
                vec3 _3521 = _3255._m2;
                vec3 _3524 = _3255._m7.xyz;
                vec3 _3528 = vec3(0.0);
                vec3 _3529 = reflect(-_1300._m14, _1300._m6);
                vec3 _3536 = (_3524 - _1300._m15) / _3529;
                vec3 _3543 = (_3521 - _1300._m15) / _3529;
                vec3 _3550 = max(_3536, _3543);
                float _3555 = _3550.x;
                float _3558 = _3550.y;
                float _3561 = _3550.z;
                float _3554 = _47(_3555, _3558, _3561);
                vec3 _3565 = _1300._m15 + (_3529 * _3554);
                vec3 _3572 = _3565 - _3441;
                float _3576 = 6.0;
                float _3577 = _3576 - (_3576 * _1300._m3);
                _3528 = textureLod(samplerCubeArray(_3586, _3588), vec4(_3572, _3444), _3577).xyz;
                _1300._m21 += ((_3528 * _3513) * _1300._m24);
                if (_3196 <= (_3250 * 4.0))
                {
                    break;
                }
            }
        }
        uint _3618 = _3622._m0[_1824 * 64u];
        uint _3627 = _3618 & 255u;
        uint _3630 = _3627;
        uint _3632 = _3618;
        uint _3634 = _1824;
        uint _3636 = 1u;
        _3253 _3665;
        vec3 _3793;
        float _3914;
        vec2 _3983;
        _4182 _4184;
        _4182 _4331;
        vec3 _4827;
        while (_3636 <= _3630)
        {
            uint _3645 = (_3634 * 64u) + _3636;
            uint _3650 = _3622._m0[_3645];
            uint _3654 = _3650;
            if (_3654 >= _3650)
            {
                _3636++;
            }
            int _3663 = 4;
            int _3664 = 4;
            _3665._m0 = _3259._m0[(uint(_3663) * _3654) + 0u].xyz;
            float _3680 = _3259._m0[(uint(_3663) * _3654) + 0u].w;
            _3665._m1 = _31(_3680);
            _3665._m2 = _3259._m0[(uint(_3663) * _3654) + 1u].xyz;
            _3665._m3 = _3259._m0[(uint(_3663) * _3654) + 1u].w;
            _3665._m4 = _3259._m0[(uint(_3663) * _3654) + 2u];
            float _3715 = _3259._m0[(uint(_3663) * _3654) + 3u].x;
            _3665._m8 = _31(_3715);
            float _3725 = _3259._m0[(uint(_3663) * _3654) + 3u].y;
            _3665._m9 = _31(_3725);
            _3665._m10 = _3259._m0[(uint(_3663) * _3654) + 3u].z;
            _3665._m5 = _3335._m0[(uint(_3664) * _3654) + 0u];
            _3665._m6 = _3335._m0[(uint(_3664) * _3654) + 1u];
            _3665._m7 = _3335._m0[(uint(_3664) * _3654) + 2u];
            _3665._m12 = _3335._m0[(uint(_3664) * _3654) + 3u].xyz;
            _3665._m13 = _3335._m0[(uint(_3664) * _3654) + 3u].w;
            float _3779 = 0.0;
            uint _3780 = _3665._m1;
            vec3 _3783 = _3665._m0;
            vec3 _3786 = _3783;
            if ((_3780 & 7u) == 2u)
            {
                _3793 = _3786;
            }
            else
            {
                _3793 = normalize(_3783 - _1300._m15);
            }
            vec3 _3788 = _3793;
            uint _3804 = uint(((_1844 & 3u) != 0u) ? 16 : 0);
            _3804 |= 32u;
            if ((_3780 & _3804) != 0u)
            {
                continue;
            }
            vec3 _3819 = vec3(dot(_1300._m15, _3665._m5.xyz) + _3665._m5.w, dot(_1300._m15, _3665._m6.xyz) + _3665._m6.w, dot(_1300._m15, _3665._m7.xyz) + _3665._m7.w);
            vec2 _3853 = _3819.xy / vec2(_3819.z);
            _3819 = vec3(_3853.x, _3853.y, _3819.z);
            _3819.z = dot(_1300._m15, _3665._m4.xyz) + _3665._m4.w;
            float _3866 = _3819.x;
            float _3869 = _3819.y;
            float _3872 = _3819.z;
            bool _3877 = _47(_3866, _3869, _3872) <= _3779;
            bool _3894;
            if (!_3877)
            {
                float _3881 = _3819.x;
                float _3884 = _3819.y;
                float _3887 = _3819.z;
                _3894 = _42(_3881, _3884, _3887) >= (1.0 - _3779);
            }
            else
            {
                _3894 = _3877;
            }
            if (_3894)
            {
                continue;
            }
            vec3 _3898 = vec3(1.0);
            uint _3899 = _3780 & 7u;
            vec3 _3902 = _3665._m0 - _1300._m15;
            float _3908 = dot(_3902, _3902);
            if (_3899 != 2u)
            {
                _3914 = 1.0 / (1.0 + _3908);
            }
            else
            {
                _3914 = _1300._m25;
            }
            _3898 = vec3(_3914);
            if (_3899 == 0u)
            {
                float _3934 = _3908 * _3665._m3;
                float _3937 = 1.0 - _68(_3934);
                float _3939 = _10(_3937);
                float _3929 = _68(_3939);
                _3898 *= _3929;
            }
            else
            {
                if (_3899 == 4u)
                {
                    float _3956 = length((_3819.xy - vec2(0.5)) * 2.0);
                    float _3949 = _10(_3956);
                    float _3958 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_3949 * 7.80000019073486328125))));
                    _3898 *= _3958;
                }
                else
                {
                    if ((_3899 == 1u) || (_3899 == 2u))
                    {
                        if (_3899 == 2u)
                        {
                            _3983 = fract((_3819.xy * _960._m37.xy) + _960._m37.zw);
                        }
                        else
                        {
                            _3983 = _3819.xy;
                        }
                        vec2 _3980 = _3983;
                        vec3 _4001 = vec3(0.0);
                        uint _4002 = bitfieldExtract(_3665._m8, 0, 20);
                        uint _4006 = _4002;
                        uint _4010 = _4006 + 0u;
                        vec3 _4027 = textureLod(sampler2D(_1442[nonuniformEXT(_4010)], _4013), vec4(_3980, 0.0, 0.0).xy, vec4(_3980, 0.0, 0.0).w).xyz;
                        _4001 = _65(_4027);
                        _3898 *= _4001;
                    }
                }
            }
            float _4033 = float((_3780 >> uint(8)) & 255u) / 255.0;
            if ((_3899 == 0u) || (_3899 == 2u))
            {
                vec3 _4046 = abs((_3819 * 2.0) - vec3(1.0));
                float _4052 = _4046.x;
                float _4055 = _4046.y;
                float _4058 = _4046.z;
                float _4063 = 1.0 - _42(_4052, _4055, _4058);
                float _4068 = _10(_4063) / (9.9999999392252902907785028219223e-09 + _4033);
                float _4051 = _10(_4068);
                _3898 *= ((_4051 * _4051) * (3.0 - (2.0 * _4051)));
            }
            else
            {
                if ((_3899 == 1u) || (_3899 == 4u))
                {
                    float _4088 = _3819.z;
                    float _4092 = _68(_4088);
                    float _4095 = 1.0 - _68(_4092);
                    float _4097 = _10(_4095);
                    float _4102 = _68(_4097) / (9.9999999392252902907785028219223e-09 + _4033);
                    float _4087 = _10(_4102);
                    _3898 *= _4087;
                }
            }
            float _4107 = _3898.x;
            float _4110 = _3898.y;
            float _4113 = _3898.z;
            if (_42(_4107, _4110, _4113) <= _3779)
            {
                continue;
            }
            float _4122 = 1.0;
            if ((_3780 & 8u) != 0u)
            {
                float _4129 = 0.00999999977648258209228515625;
                vec3 _4131 = _1300._m15 + (_1300._m6 * _4129);
                uint _4139 = 0u;
                if ((_3780 & 7u) == 0u)
                {
                    vec3 _4145 = _4131 - _3665._m2;
                    float _4150 = _4145.x;
                    float _4153 = _4145.y;
                    float _4156 = _4145.z;
                    _4139 = _53(_4150, _4153, _4156);
                }
                else
                {
                    if ((_3780 & 7u) == 2u)
                    {
                        float _4166 = 0.0;
                        uint _4167 = uint((_960._m38.w > 0.0) ? 3 : 4);
                        for (; _4139 < _4167; _4139++)
                        {
                            int _4181 = 5;
                            _4184._m0 = _4189._m0[(uint(_4181) * ((_3780 >> uint(22)) + _4139)) + 0u];
                            _4184._m1 = _4189._m0[(uint(_4181) * ((_3780 >> uint(22)) + _4139)) + 1u];
                            _4184._m2 = _4189._m0[(uint(_4181) * ((_3780 >> uint(22)) + _4139)) + 2u];
                            _4184._m3 = _4189._m0[(uint(_4181) * ((_3780 >> uint(22)) + _4139)) + 3u];
                            _4184._m4 = _4189._m0[(uint(_4181) * ((_3780 >> uint(22)) + _4139)) + 4u];
                            vec2 _4245 = vec2(dot(_4131, _4184._m0.xyz) + _4184._m0.w, dot(_4131, _4184._m1.xyz) + _4184._m1.w);
                            _4245 = abs((_4245 * 2.0) - vec2(1.0));
                            bool _4271 = _4245.x < 0.9900000095367431640625;
                            bool _4277;
                            if (_4271)
                            {
                                _4277 = _4245.y < 0.9900000095367431640625;
                            }
                            else
                            {
                                _4277 = _4271;
                            }
                            if (_4277)
                            {
                                _4166 = (1.0 - max(_4245.x, _4245.y)) * _960._m39.w;
                                break;
                            }
                        }
                        _1300._m36 = int(_4139);
                        _4139 = min((_4167 - 1u), _4139);
                        if (_960._m38.w > 0.0)
                        {
                            uint _4304 = uint(_1300._m17.x) ^ (uint(_1300._m17.y) << uint(1));
                            _4304 ^= uint(_960._m40.x);
                            _4139 += uint(int(((float(_4304 & 3u) * 0.25) + 0.125) > _4166));
                        }
                    }
                }
                int _4330 = 5;
                _4331._m0 = _4189._m0[(uint(_4330) * ((_3780 >> uint(22)) + _4139)) + 0u];
                _4331._m1 = _4189._m0[(uint(_4330) * ((_3780 >> uint(22)) + _4139)) + 1u];
                _4331._m2 = _4189._m0[(uint(_4330) * ((_3780 >> uint(22)) + _4139)) + 2u];
                _4331._m3 = _4189._m0[(uint(_4330) * ((_3780 >> uint(22)) + _4139)) + 3u];
                _4331._m4 = _4189._m0[(uint(_4330) * ((_3780 >> uint(22)) + _4139)) + 4u];
                vec4 _4387 = vec4((_4131.x * _4331._m0.x) + ((_4131.y * _4331._m0.y) + ((_4131.z * _4331._m0.z) + _4331._m0.w)), (_4131.x * _4331._m1.x) + ((_4131.y * _4331._m1.y) + ((_4131.z * _4331._m1.z) + _4331._m1.w)), (_4131.x * _4331._m2.x) + ((_4131.y * _4331._m2.y) + ((_4131.z * _4331._m2.z) + _4331._m2.w)), (_4131.x * _4331._m3.x) + ((_4131.y * _4331._m3.y) + ((_4131.z * _4331._m3.z) + _4331._m3.w)));
                vec3 _4474 = _4387.xyz / vec3(_4387.w);
                _4387 = vec4(_4474.x, _4474.y, _4474.z, _4387.w);
                bool _4482 = min(_4387.x, _4387.y) > 0.0;
                bool _4491;
                if (_4482)
                {
                    _4491 = max(_4387.x, _4387.y) < 1.0;
                }
                else
                {
                    _4491 = _4482;
                }
                if (_4491)
                {
                    vec2 _4503 = (_4387.xy * _4331._m4.xy) + _4331._m4.zw;
                    _4387 = vec4(_4503.x, _4503.y, _4387.z, _4387.w);
                    if (false)
                    {
                        _4122 = textureLod(sampler2DShadow(_4510, _4512), vec3(_4387.xyz.xy, _4387.xyz.z), 0.0);
                    }
                    else
                    {
                        vec2 _4521 = (_4387.xy * _960._m41.xy) + vec2(0.5);
                        vec2 _4530 = floor(_4521);
                        vec2 _4533 = _4521 - _4530;
                        _4530 -= vec2(0.5);
                        vec2 _4540 = vec2(4.0) - (_4533 * 3.0);
                        vec2 _4545 = vec2(7.0);
                        vec2 _4547 = vec2(1.0) + (_4533 * 3.0);
                        vec2 _4552 = (_4530 + (((vec2(3.0) - (_4533 * 2.0)) / _4540) - vec2(2.0))) * _960._m41.zw;
                        vec2 _4567 = (_4530 + ((vec2(3.0) + _4533) / _4545)) * _960._m41.zw;
                        vec2 _4579 = (_4530 + ((_4533 / _4547) + vec2(2.0))) * _960._m41.zw;
                        vec3 _4605 = vec3(_4552.x, _4552.y, _4387.z);
                        _4122 = (_4540.x * _4540.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4605.xy, _4605.z), 0.0);
                        vec3 _4623 = vec3(_4567.x, _4552.y, _4387.z);
                        _4122 += ((_4545.x * _4540.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4623.xy, _4623.z), 0.0));
                        vec3 _4643 = vec3(_4579.x, _4552.y, _4387.z);
                        _4122 += ((_4547.x * _4540.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4643.xy, _4643.z), 0.0));
                        vec3 _4663 = vec3(_4552.x, _4567.y, _4387.z);
                        _4122 += ((_4540.x * _4545.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4663.xy, _4663.z), 0.0));
                        vec3 _4683 = vec3(_4567.x, _4567.y, _4387.z);
                        _4122 += ((_4545.x * _4545.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4683.xy, _4683.z), 0.0));
                        vec3 _4703 = vec3(_4579.x, _4567.y, _4387.z);
                        _4122 += ((_4547.x * _4545.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4703.xy, _4703.z), 0.0));
                        vec3 _4723 = vec3(_4552.x, _4579.y, _4387.z);
                        _4122 += ((_4540.x * _4547.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4723.xy, _4723.z), 0.0));
                        vec3 _4743 = vec3(_4567.x, _4579.y, _4387.z);
                        _4122 += ((_4545.x * _4547.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4743.xy, _4743.z), 0.0));
                        vec3 _4763 = vec3(_4579.x, _4579.y, _4387.z);
                        _4122 += ((_4547.x * _4547.y) * textureLod(sampler2DShadow(_4510, _4512), vec3(_4763.xy, _4763.z), 0.0));
                        _4122 *= 0.0069444444961845874786376953125;
                    }
                }
                else
                {
                    _4122 = float((_3780 & 7u) == 2u);
                    if ((_3780 & 7u) == 2u)
                    {
                        _1300._m36 = -1;
                    }
                }
                float _4783 = float((_3780 >> uint(16)) & 63u) / 63.0;
                float _4797 = ((_4122 * _4783) + 1.0) - _4783;
                _4122 = _10(_4797);
            }
            if (_4122 <= _3779)
            {
                continue;
            }
            vec3 _4805 = (_3665._m12 * _4122) * _3898;
            float _4812 = _3665._m13;
            vec3 _4815 = _4805;
            float _4817 = dot(_1300._m6, _3788);
            float _4822 = sign(_4817);
            if (_4822 >= 0.0)
            {
                _4827 = _3788;
            }
            else
            {
                _4827 = reflect(_3788, _1300._m6);
            }
            _3788 = _4827;
            vec3 _4837 = mix(_1298, vec3(1.0), bvec3(_4822 >= 0.0));
            float _4847 = dot(_1300._m6, _3788);
            float _4849 = _4817;
            _4817 = mix(_10(_4847), _10(_4849), _1300._m9);
            _1300._m21 += ((_4815 * _4817) * _1300._m0);
            vec3 _4866 = _1300._m6;
            vec3 _4869 = _1300._m14;
            vec3 _4872 = _3788;
            vec3 _4874 = _1300._m2;
            float _4877 = _1300._m3;
            vec3 _4865 = _141(_4866, _4869, _4872, _4874, _4877);
            _1300._m21 += ((((_4815 * _4817) * _4865) * _4812) * _4837);
        }
        _1300._m21 *= _1300._m11;
        if (((_960._m88 & 1u) != 0u) == true)
        {
            if (_1300._m47 < 1.0)
            {
                vec2 _4912 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
                vec3 _4928 = TEXTURE_LOD(SAMPLER_2D(_4929, _4931), vec4(_4912, 0.0, 0.0).xy, vec4(_4912, 0.0, 0.0).w).xyz;
                vec3 _4946 = _1300._m24;
                _1300._m21 += (_4928 * _4946);
            }
        }
        if (_1295)
        {
            vec2 _4959 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
            float _4975 = 0.89999997615814208984375;
            vec3 _4977 = normalize(refract(_1300._m6, -_1300._m14, _4975));
            float _4992 = dot(_1300._m6, _1300._m18[2]);
            float _4986 = 1.0 - _10(_4992);
            float _4995 = _1258._m19 * (0.070000000298023223876953125 + _4986);
            vec3 _5041 = _1300._m15 + (_4977 * _4995);
            mat4 _5042 = mat4(vec4(_960._m42), vec4(_960._m43), vec4(_960._m44), vec4(_960._m45));
            vec4 _5002 = _75(_5041, _5042);
// FIX
            _5002.x += vk3d_params[VIEW].stereo.x * (_5002.w - vk3d_params[VIEW].stereo.y)*0.5;
            vec2 _5049 = _5002.xy / vec2(_5002.w);
            _5002 = vec4(_5049.x, _5049.y, _5002.z, _5002.w);
            float _5052 = min(_1300._m3, 0.99989998340606689453125);
            float _5057 = fract(_5052 * 4.0);
            uint _5061 = uint(TEXTURE_LOD(SAMPLER_2D(_5062, _1677), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).x * 255.0);
            if (float(_5061) == 0.0)
            {
                _5002 = vec4(_4959.x, _4959.y, _5002.z, _5002.w);
            }
            vec3 _5090 = vec3(0.0);
            if (_5052 > 0.97500002384185791015625)
            {
                _5090 = TEXTURE_LOD(SAMPLER_2D(_5096, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz;
            }
            else
            {
                if (_5052 > 0.75)
                {
                    _5090 = mix(TEXTURE_LOD(SAMPLER_2D(_5120, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(SAMPLER_2D(_5096, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, vec3(_5057));
                }
                else
                {
                    if (_5052 > 0.5)
                    {
                        _5090 = mix(TEXTURE_LOD(SAMPLER_2D(_5163, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(SAMPLER_2D(_5120, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, vec3(_5057));
                    }
                    else
                    {
                        if (_5052 > 0.25)
                        {
                            _5090 = mix(TEXTURE_LOD(SAMPLER_2D(_5206, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(SAMPLER_2D(_5163, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, vec3(_5057));
                        }
                        else
                        {
                            _5090 = mix(TEXTURE_LOD(SAMPLER_2D(_5245, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(SAMPLER_2D(_5206, _4931), vec4(_5002.xy, 0.0, 0.0).xy, vec4(_5002.xy, 0.0, 0.0).w).xyz, vec3(_5057));
                        }
                    }
                }
            }
            float _5283 = _1300._m17.z;
            float _5287 = _5283;
            bool _5289 = false;
            float _5290 = _165(_5287, _5289);
            float _5286 = _5290;
            vec2 _5291 = _4959 + vec2(0.0);
            float _5294 = 0.119999997317790985107421875;
            float _5296 = _960._m46.y;
            float _5299 = _960._m47.z + 1.0;
            float _5303 = pow(max(0.0, _5286 - _5294) / (_5296 - _5294), 0.5);
            float _5313 = (0.5 / _5299) + (_5303 * (1.0 - (1.0 / _5299)));
            
            // FIX 2
            _5291.x -= vk3d_params[VIEW].stereo.x * 0.5;
            
            vec3 _5322 = textureLod(sampler3D(_5325, _4931), vec4(_5291, _5313, 0.0).xyz, vec4(_5291, _5313, 0.0).w).xyz;
            vec2 _5344 = textureLod(sampler3D(_5345, _4931), vec4(_5291, _5313, 0.0).xyz, vec4(_5291, _5313, 0.0).w).xy;
            float _5363 = _5344.x;
            float _5366 = _5344.y;
            float _5371 = _960._m87;
            uint _5369 = _31(_5371);
            bool _5375 = (_5369 & 2u) != 0u;
            _5322 *= float(_5375);
            _5363 = _5375 ? _5363 : 1.0;
            vec3 _5386 = vec3(0.0);
            if ((_5369 & 1u) != 0u)
            {
                vec3 _5392 = vec3(_960._m61, _960._m62, _960._m63);
                vec3 _5400 = _188(_4959);
                vec4 _5403 = vec4(0.0);
                vec3 _5404 = normalize(_5400);
                float _5407 = _5404.z;
                _5403.x = clamp(_96(_5407) / 3.1415927410125732421875, 0.00390625, 0.99609375);
                float _5416 = _5404.y;
                float _5419 = _5404.x;
                _5403.y = _106(_5416, _5419) / 6.283185482025146484375;
                _5403.z = sqrt(_5286 * _960._m48.w);
                _5403.z = clamp(_5403.z, 0.015625, 0.984375);
                _5386 = textureLod(sampler3D(_5439, _2850), _5403.xyz, _5403.w).xyz;
                _5386 *= _5366;
            }
            float _5452 = 1.0 / (_5363 + 9.9999999747524270787835121154785e-07);
            _5090 = ((_5090 - _5322) * _5452) - _5386;
            _5090 = max(vec3(0.0), _5090);
            _1300._m21 = (_1299 * _5090) + _1300._m21;
            _1300._m21 = ((_1300._m21 + _5386) * _5363) + _5322;
        }
        else
        {
            _1300._m21 = _1300._m21;
        }
        _5486 = vec4(_1300._m21, _1300._m9);
        if (_1254 == 6.0)
        {
            vec2 _5499 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
            float _5526 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).z;
            bool _5528 = false;
            float _5529 = _165(_5526, _5528);
            float _5515 = _5529;
            vec2 _5530 = _5499 + vec2(0.0);
            float _5533 = 0.119999997317790985107421875;
            float _5534 = _960._m46.y;
            float _5537 = _960._m47.z + 1.0;
            float _5541 = pow(max(0.0, _5515 - _5533) / (_5534 - _5533), 0.5);
            float _5551 = (0.5 / _5537) + (_5541 * (1.0 - (1.0 / _5537)));
            
            // FIX 3
            _5530.x -= vk3d_params[VIEW].stereo.x * 0.5;
            
            vec3 _5560 = textureLod(sampler3D(_5325, _4931), vec4(_5530, _5551, 0.0).xyz, vec4(_5530, _5551, 0.0).w).xyz;
            vec2 _5578 = textureLod(sampler3D(_5345, _4931), vec4(_5530, _5551, 0.0).xyz, vec4(_5530, _5551, 0.0).w).xy;
            float _5596 = _5578.x;
            float _5599 = _5578.y;
            float _5603 = _960._m87;
            uint _5602 = _31(_5603);
            bool _5607 = (_5602 & 2u) != 0u;
            _5560 *= float(_5607);
            _5596 = _5607 ? _5596 : 1.0;
            vec3 _5618 = vec3(0.0);
            if ((_5602 & 1u) != 0u)
            {
                vec3 _5624 = vec3(_960._m61, _960._m62, _960._m63);
                vec3 _5632 = _188(_5499);
                vec4 _5635 = vec4(0.0);
                vec3 _5636 = normalize(_5632);
                float _5639 = _5636.z;
                _5635.x = clamp(_96(_5639) / 3.1415927410125732421875, 0.00390625, 0.99609375);
                float _5646 = _5636.y;
                float _5649 = _5636.x;
                _5635.y = _106(_5646, _5649) / 6.283185482025146484375;
                _5635.z = sqrt(_5515 * _960._m48.w);
                _5635.z = clamp(_5635.z, 0.015625, 0.984375);
                
                //_5635.x -= vk3d_params[VIEW].stereo.x * 0.5;
                _5618 = textureLod(sampler3D(_5439, _2850), _5635.xyz, _5635.w).xyz;
                _5618 *= _5599;
            }
            _5618 *= _5486.w;
            _5560 *= _5486.w;
            vec3 _5693 = ((_5486.xyz + _5618) * _5596) + _5560;
            _5486 = vec4(_5693.x, _5693.y, _5693.z, _5486.w);
            _5696 = vec4(0.0);
            _5697 = vec4(0.0);
            float _5698 = _960._m34.w;
            if (!(_5698 == 0.0))
            {
                vec2 _5705 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
                bool _5721 = ((1.0 - gl_FragCoord.z) - 0.0) < (1.0 - TEXTURE_LOD(SAMPLER_2D(_5726, _1677), vec4(_5705, 0.0, 0.0).xy, vec4(_5705, 0.0, 0.0).w).x);
                _5696 = _5486 * float(!_5721);
                _5486 *= float(_5721);
                _5697 = vec4(_5486.w);
            }
        }
        else
        {
            _5696 = vec4(0.0);
            _5697 = vec4(0.0);
            float _5757 = _960._m34.w;
            if (!(_5757 == 0.0))
            {
                vec2 _5764 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
                bool _5780 = ((1.0 - gl_FragCoord.z) - 0.0) < (1.0 - TEXTURE_LOD(SAMPLER_2D(_5726, _1677), vec4(_5764, 0.0, 0.0).xy, vec4(_5764, 0.0, 0.0).w).x);
                _5696 = _5486 * float(!_5780);
                _5486 *= float(_5780);
                _5697 = vec4(_5486.w);
            }
            _5486.w *= _1276._m9;
            float _5820 = _5486.w;
            _5486.w = _10(_5820);
            vec3 _5829 = _5486.xyz * _5486.w;
            _5486 = vec4(_5829.x, _5829.y, _5829.z, _5486.w);
        }
        return;
    }
    _5833 _5835;
    _5835._m0 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _5835._m1 = _5847;
    _5835._m2 = _5850;
    _5835._m3 = _5853.x;
    _5835._m4 = _5853.y;
    _5835._m5 = _5853.z;
    _5835._m6 = _5853.w;
    _5835._m7 = _5866.xyz;
    _5835._m8 = _5866.w;
    _5835._m9 = _5873.xy;
    _5835._m10 = vec4(_5873.zw, _5879.w, _5882.w);
    _5835._m11 = _5879.xyz;
    _5835._m12 = _5882.xyz;
    bool _5895 = _1254 == 5.0;
    bool _5898 = false;
    bool _5899 = false;
    float _5900 = 1.0;
    float _5901 = 0.0;
    float _5902 = 1.0;
    float _5903 = 0.0;
    int _5904 = 0;
    int _5905 = 0;
    bool _5906 = true;
    bool _5907 = false;
    if (_5895)
    {
        int _5911 = int(_1258._m25);
        _5915 _5917;
        _5917._m0 = _5922._m0[_5911]._m0;
        _5917._m1 = _5922._m0[_5911]._m1;
        _5917._m2 = _5922._m0[_5911]._m2;
        _5917._m3 = _5922._m0[_5911]._m3;
        _5917._m4 = _5922._m0[_5911]._m4;
        _5917._m5 = _5922._m0[_5911]._m5;
        _5917._m6 = _5922._m0[_5911]._m6;
        _5917._m7 = _5922._m0[_5911]._m7;
        _5917._m8 = _5922._m0[_5911]._m8;
        _5917._m9 = _5922._m0[_5911]._m9;
        _5917._m10 = _5922._m0[_5911]._m10;
        _5917._m11 = _5922._m0[_5911]._m11;
        _5917._m12 = _5922._m0[_5911]._m12;
        _5917._m13 = _5922._m0[_5911]._m13;
        _5917._m14 = _5922._m0[_5911]._m14;
        _5917._m15 = _5922._m0[_5911]._m15;
        _5917._m16 = _5922._m0[_5911]._m16;
        _5917._m17 = _5922._m0[_5911]._m17;
        _5917._m18 = _5922._m0[_5911]._m18;
        _5917._m19 = _5922._m0[_5911]._m19;
        _5917._m20 = _5922._m0[_5911]._m20;
        _5917._m21 = _5922._m0[_5911]._m21;
        _5917._m22 = _5922._m0[_5911]._m22;
        _5917._m23 = _5922._m0[_5911]._m23;
        _5917._m24 = _5922._m0[_5911]._m24;
        _5917._m25 = _5922._m0[_5911]._m25;
        _5917._m26 = _5922._m0[_5911]._m26;
        _5917._m27 = _5922._m0[_5911]._m27;
        _5917._m28 = _5922._m0[_5911]._m28;
        _5917._m29 = _5922._m0[_5911]._m29;
        _5917._m30 = _5922._m0[_5911]._m30;
        _5917._m31 = _5922._m0[_5911]._m31;
        _5917._m32 = _5922._m0[_5911]._m32;
        _5917._m33 = _5922._m0[_5911]._m33;
        _5917._m34 = _5922._m0[_5911]._m34;
        _5917._m35 = _5922._m0[_5911]._m35;
        _5917._m36 = _5922._m0[_5911]._m36;
        _5900 = _5917._m15;
        _5898 = !(_5917._m11 == 0.0);
        _5902 = _5917._m28;
        _5903 = _5917._m13;
        _5904 = _1276._m12;
        _5905 = _6015._m0;
        _5906 = (_5917._m19 & 1) != 0;
        _5901 = 1.0;
        int _6023 = _5917._m4;
        if (_6023 == 0)
        {
            _1254 = 1.0;
        }
        else
        {
            if (_6023 == 1)
            {
                _1254 = 0.0;
            }
            else
            {
                if (_6023 == 4)
                {
                    _1254 = 4.0;
                }
                else
                {
                    if (_6023 == 2)
                    {
                        _1254 = 2.0;
                    }
                    else
                    {
                        if (_6023 == 3)
                        {
                            _5907 = true;
                            _1254 = 2.0;
                        }
                    }
                }
            }
        }
    }
    else
    {
        _5898 = !(_1258._m3.y == 0.0);
        _5901 = _1258._m3.z;
        _5902 = _1258._m4.w;
        _5903 = _1258._m38;
        _5900 = _1258._m5.x;
        _5899 = !(_1258._m6.x == 0.0);
        _5904 = _1276._m12;
        float _6067 = _1258._m14;
        _5905 = _36(_6067);
    }
    bool _6071 = _5898;
    float _6076;
    if (_1254 == 3.0)
    {
        _6076 = 1.0;
    }
    else
    {
        _6076 = _5835._m6;
    }
    float _6073 = _6076;
    vec2 _6083 = _5835._m0.xy * _960._m31.xy;
    vec2 _6091 = _5835._m2.xy;
    vec2 _6095 = _5835._m2.zw;
    vec4 _6099 = texture(sampler2D(_1442[_1258._m26], _6104), _6091);
    vec4 _6109 = texture(sampler2D(_1442[_1258._m26], _6104), _6095);
    vec3 _6118 = vec3(0.0);
    vec2 _6119 = vec2(0.0);
    if (((_1254 == 0.0) || (_1254 == 1.0)) || (_1254 == 4.0))
    {
        vec4 _6130 = _6099;
        _6099 = _62(_6130);
        vec4 _6133 = _6109;
        _6109 = _62(_6133);
        _6118 = mix(_6099.xxx, _6109.xxx, vec3(_5835._m5)) * _5835._m1.xyz;
    }
    else
    {
        _6119 = mix(_6099.xy, _6109.xy, vec2(_5835._m5));
    }
    float _6160;
    if (_1254 == 2.0)
    {
        _6160 = 1.0;
    }
    else
    {
        _6160 = mix(_6099.y, _6109.y, _5835._m5);
    }
    float _6157 = _6160;
    float _6174;
    if (_1254 == 2.0)
    {
        float _6181 = _6119.y * 32.0;
        _6174 = _10(_6181) - _5901;
    }
    else
    {
        _6174 = _6157 - 9.9999999747524270787835121154785e-07;
    }
    float _6188 = _6174;
    _26(_6188);
    float _6194 = 1.0 - _6157;
    float _6191 = _10(_6194) * _5900;
    float _6198 = 1.0;
    float _6199 = 1.0;
    float _6218 = 1.0 - TEXTURE_LOD(SAMPLER_2D(_6201, _1677), vec4(_6083, 0.0, 0.0).xy, vec4(_6083, 0.0, 0.0).w).x;
    bool _6219 = _6071;
    float _6221 = _165(_6218, _6219);
    float _6200 = _6221;
    float _6226 = 1.0 - gl_FragCoord.z;
    bool _6227 = _6071;
    float _6229 = _165(_6226, _6227);
    float _6222 = _6229;
    float _6238 = (_6200 - (_6222 + _6191)) / _5835._m4;
    _6198 = _10(_6238);
    float _6247 = 1.0 - (_6200 - (_6222 * _1276._m2.x));
    _6199 = _10(_6247);
    vec3 _6249 = vec3(1.0);
    if (((_1254 == 1.0) || (_1254 == 2.0)) || (_1254 == 4.0))
    {
        if (_5906)
        {
            vec4 _6263 = vec4(0.0);
            if (_5895)
            {
                vec2 _6267 = (_5835._m9 * _960._m49.xy) + vec2(0.5);
                vec2 _6277 = floor(_6267);
                vec2 _6280 = fract(_6267);
                float _6284 = _6280.x;
                float _6283 = _207(_6284);
                float _6289 = _6280.x;
                float _6288 = _210(_6289);
                float _6294 = _6280.x;
                float _6293 = _213(_6294);
                float _6299 = _6280.x;
                float _6298 = _216(_6299);
                float _6304 = _6280.y;
                float _6303 = _213(_6304);
                float _6309 = _6280.y;
                float _6308 = _216(_6309);
                vec2 _6313 = (vec2(_6277.x + _6293, _6277.y + _6303) - vec2(0.5)) / _960._m49.xy;
                vec2 _6329 = (vec2(_6277.x + _6298, _6277.y + _6303) - vec2(0.5)) / _960._m49.xy;
                vec2 _6345 = (vec2(_6277.x + _6293, _6277.y + _6308) - vec2(0.5)) / _960._m49.xy;
                vec2 _6361 = (vec2(_6277.x + _6298, _6277.y + _6308) - vec2(0.5)) / _960._m49.xy;
                vec4 _6377 = TEXTURE_LOD(SAMPLER_2D(_6378, _1450), vec4(_6313, 0.0, 0.0).xy, vec4(_6313, 0.0, 0.0).w);
                vec4 _6393 = TEXTURE_LOD(SAMPLER_2D(_6378, _1450), vec4(_6329, 0.0, 0.0).xy, vec4(_6329, 0.0, 0.0).w);
                vec4 _6408 = TEXTURE_LOD(SAMPLER_2D(_6378, _1450), vec4(_6345, 0.0, 0.0).xy, vec4(_6345, 0.0, 0.0).w);
                vec4 _6423 = TEXTURE_LOD(SAMPLER_2D(_6378, _1450), vec4(_6361, 0.0, 0.0).xy, vec4(_6361, 0.0, 0.0).w);
                float _6438 = _6280.y;
                float _6450 = _6280.y;
                _6263 = (((_6377 * _6283) + (_6393 * _6288)) * _207(_6438)) + (((_6408 * _6283) + (_6423 * _6288)) * _210(_6450));
            }
            else
            {
                vec2 _6464 = (_5835._m9 * _960._m49.xy) + vec2(0.5);
                vec2 _6473 = floor(_6464);
                vec2 _6476 = fract(_6464);
                float _6480 = _6476.x;
                float _6479 = _207(_6480);
                float _6485 = _6476.x;
                float _6484 = _210(_6485);
                float _6490 = _6476.x;
                float _6489 = _213(_6490);
                float _6495 = _6476.x;
                float _6494 = _216(_6495);
                float _6500 = _6476.y;
                float _6499 = _213(_6500);
                float _6505 = _6476.y;
                float _6504 = _216(_6505);
                vec2 _6509 = (vec2(_6473.x + _6489, _6473.y + _6499) - vec2(0.5)) / _960._m49.xy;
                vec2 _6525 = (vec2(_6473.x + _6494, _6473.y + _6499) - vec2(0.5)) / _960._m49.xy;
                vec2 _6541 = (vec2(_6473.x + _6489, _6473.y + _6504) - vec2(0.5)) / _960._m49.xy;
                vec2 _6557 = (vec2(_6473.x + _6494, _6473.y + _6504) - vec2(0.5)) / _960._m49.xy;
                vec4 _6573 = TEXTURE_LOD(SAMPLER_2D(_6574, _1450), vec4(_6509, 0.0, 0.0).xy, vec4(_6509, 0.0, 0.0).w);
                vec4 _6589 = TEXTURE_LOD(SAMPLER_2D(_6574, _1450), vec4(_6525, 0.0, 0.0).xy, vec4(_6525, 0.0, 0.0).w);
                vec4 _6604 = TEXTURE_LOD(SAMPLER_2D(_6574, _1450), vec4(_6541, 0.0, 0.0).xy, vec4(_6541, 0.0, 0.0).w);
                vec4 _6619 = TEXTURE_LOD(SAMPLER_2D(_6574, _1450), vec4(_6557, 0.0, 0.0).xy, vec4(_6557, 0.0, 0.0).w);
                float _6634 = _6476.y;
                float _6646 = _6476.y;
                _6263 = (((_6573 * _6479) + (_6589 * _6484)) * _207(_6634)) + (((_6604 * _6479) + (_6619 * _6484)) * _210(_6646));
            }
            _6249 = _6263.xyz;
        }
    }
    _6157 = mix(sqrt(_6157), _6157, _6073) * _5835._m1.w;
    if (_1254 == 0.0)
    {
        _6157 *= _5835._m8;
    }
    vec3 _6677 = vec3(0.0);
    float _6678 = 0.0;
    if (!(_5903 == 0.0))
    {
        float _6683 = texture(sampler2D(_1442[_1258._m24], _6104), _6091).x;
        float _6693 = texture(sampler2D(_1442[_1258._m24], _6104), _6095).x;
        _6678 = mix(_6683, _6693, _5835._m5);
        _6677 = mix(vec3(_1258._m32, _1258._m33, _1258._m34), vec3(_1258._m35, _1258._m36, _1258._m37), vec3(_6678)) * _5903;
    }
    vec3 _6727 = vec3(0.0);
    if (_1254 == 1.0)
    {
        float _6732 = _5835._m3;
        _6727 = (_6249 + vec3(_6732)) * _6118;
        _6727 += (_6677 * _6678);
    }
    else
    {
        if (_1254 == 0.0)
        {
            _6727 = (((_6118 * (_5835._m3 + 1.0)) * _5902) * _5835._m1.w) * _5835._m1.w;
        }
        else
        {
            if (_1254 == 2.0)
            {
                uint _6769 = 0u;
                vec3 _6773;
                vec4 _6778;
                if (_5906)
                {
                    _6773 = _6249;
                    if (_5895)
                    {
                        _6778 = TEXTURE_LOD(SAMPLER_2D(_6779, _1677), vec4(_5835._m9, 0.0, 0.0).xy, vec4(_5835._m9, 0.0, 0.0).w);
                    }
                    else
                    {
                        _6778 = TEXTURE_LOD(SAMPLER_2D(_6797, _1677), vec4(_5835._m9, 0.0, 0.0).xy, vec4(_5835._m9, 0.0, 0.0).w);
                    }
                    _6769 = uint(_6778.w * 255.0);
                    _6769 |= (uint(_6778.z * 255.0) << uint(8));
                    vec2 _6825 = (_6778.xy * 2.0) - vec2(1.0);
                    vec2 _6831 = _6825;
                    vec3 _6833 = _128(_6831);
                    _6778 = vec4(_6833.x, _6833.y, _6833.z, _6778.w);
                }
                else
                {
                    _6773 = _5835._m12;
                    _6778 = _5835._m10;
                    vec3 _6845 = (_6778.xyz * 2.0) - vec3(1.0);
                    _6778 = vec4(_6845.x, _6845.y, _6845.z, _6778.w);
                    _6769 = uint(_6778.w * 255.0);
                }
                if (_5907)
                {
                    _6773 = vec3(0.0);
                }
                vec3 _6859 = normalize(_5835._m11);
                mat3 _6855 = _192(_6859);
                vec2 _6862 = _6119;
                mat3 _6864 = _6855;
                bool _6866 = true;
                vec3 _6861 = _184(_6862, _6864, _6866);
                vec3 _6868 = normalize(_6778.xyz);
                float _6876 = dot(_6861, _6868);
                float _6872 = _10(_6876);
                vec3 _6878 = _6773 + (vec3(_6872) * _6773);
                vec3 _6887;
                if (_5907)
                {
                    _6887 = _5835._m1.xyz * _5835._m3;
                }
                else
                {
                    vec3 _6899 = _5835._m1.xyz;
                    _6887 = min(vec3(0.100000001490116119384765625), _16(_6899) * _5835._m3);
                }
                vec3 _6885 = _6887;
                _6878 += _6885;
                vec3 _6917 = _5835._m1.xyz * 0.5;
                vec3 _6912 = _16(_6917);
                _6727 = _6878 * _6912;
                float _6922 = 0.0500000007450580596923828125;
                float _6924 = clamp(_1258._m13, 0.0, 0.89999997615814208984375);
                vec3 _6928 = normalize(vec3(_960._m61, _960._m62, _960._m63) - _5835._m7);
                vec3 _6941 = _5835._m1.xyz;
                vec3 _6940 = _16(_6941);
                vec3 _6946 = TEXTURE_LOD(SAMPLER_2D(_6947, _4931), vec4(_6083 + ((_6119 - vec2(0.5)) * 0.100000001490116119384765625), 0.0, 0.0).xy, vec4(_6083 + ((_6119 - vec2(0.5)) * 0.100000001490116119384765625), 0.0, 0.0).w).xyz;
                _6727 += (_6946 * _6940);
                vec3 _6980 = _6861;
                vec3 _6982 = _6928;
                vec3 _6984 = _6868;
                vec3 _6986 = vec3(_6922);
                float _6987 = _6924;
                _6727 += ((_141(_6980, _6982, _6984, _6986, _6987) * _6872) * _6773);
                vec3 _6998 = _6861;
                vec3 _7000 = _6928;
                vec3 _7002 = _6928;
                vec3 _7004 = vec3(_6922);
                float _7005 = _6924;
                _6727 += (_141(_6998, _7000, _7002, _7004, _7005) * 0.100000001490116119384765625);
                float _7011 = 6.0;
                float _7012 = _7011 - (_7011 * abs(_6924));
                vec3 _7019 = reflect(-_6928, _6861);
                vec3 _7024 = textureLod(samplerCubeArray(_3586, _3588), vec4(_7019, 1.0 * float(_6769)), _7012).xyz;
                float _7043 = dot(_6861, _6928);
                float _7039 = _10(_7043);
                float _7048 = _7039;
                float _7050 = _6924;
                vec3 _7052 = vec3(_6922);
                vec3 _7045 = _147(_7048, _7050, _7052);
                _6727 += (_7024 * _7045);
            }
            else
            {
                if (_1254 == 3.0)
                {
                    _6727 = _5835._m1.xyz + (vec3(_6119.x * _6119.x) * vec3(_6119.y * _6119.y));
                    _6727 *= ((_5902 * _5835._m3) + 1.0);
                }
                else
                {
                    if (_1254 == 4.0)
                    {
                        vec3 _7093 = _6249 * _6118;
                        _6727 = mix(_7093, _6677 * _5902, vec3(_6678));
                        _6157 = mix(sqrt(_6157), _6157, _6073) * _5835._m1.w;
                    }
                }
            }
        }
    }
    _6157 *= ((_1258._m1.x > 0.0) ? _6199 : 1.0);
    vec2 _7119 = _5835._m0.xy * _960._m31.xy;
    float _7128 = _5835._m0.z;
    bool _7131 = false;
    float _7132 = _165(_7128, _7131);
    float _7127 = _7132;
    vec2 _7133 = _7119 + vec2(0.0);
    float _7136 = 0.119999997317790985107421875;
    float _7137 = _960._m46.y;
    float _7140 = _960._m47.z + 1.0;
    float _7144 = pow(max(0.0, _7127 - _7136) / (_7137 - _7136), 0.5);
    float _7154 = (0.5 / _7140) + (_7144 * (1.0 - (1.0 / _7140)));
    
    // FIX 4
    _7133.x -= vk3d_params[VIEW].stereo.x * 0.5;
    vec3 _7163 = textureLod(sampler3D(_5325, _4931), vec4(_7133, _7154, 0.0).xyz, vec4(_7133, _7154, 0.0).w).xyz;
    vec2 _7181 = textureLod(sampler3D(_5345, _4931), vec4(_7133, _7154, 0.0).xyz, vec4(_7133, _7154, 0.0).w).xy;
    float _7199 = _7181.x;
    float _7202 = _7181.y;
    float _7206 = _960._m87;
    uint _7205 = _31(_7206);
    bool _7210 = (_7205 & 2u) != 0u;
    _7163 *= float(_7210);
    _7199 = _7210 ? _7199 : 1.0;
    vec3 _7221 = vec3(0.0);
    if ((_7205 & 1u) != 0u)
    {
        vec3 _7227 = vec3(_960._m61, _960._m62, _960._m63);
        vec3 _7235 = _188(_7119);
        vec4 _7238 = vec4(0.0);
        vec3 _7239 = normalize(_7235);
        float _7242 = _7239.z;
        _7238.x = clamp(_96(_7242) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _7249 = _7239.y;
        float _7252 = _7239.x;
        _7238.y = _106(_7249, _7252) / 6.283185482025146484375;
        _7238.z = sqrt(_7127 * _960._m48.w);
        _7238.z = clamp(_7238.z, 0.015625, 0.984375);
        _7221 = textureLod(sampler3D(_5439, _2850), _7238.xyz, _7238.w).xyz;
        _7221 *= _7202;
    }
    _6727 = ((_6727 + _7221) * _7199) + _7163;
    float _7289;
    if (_1254 == 2.0)
    {
        float _7295 = _6119.y * 5.0;
        _7289 = (_10(_7295) * _5835._m1.w) * _6198;
    }
    else
    {
        _7289 = _6157 * _6198;
    }
    _6157 = _7289;
    _5486 = vec4(_6727.x, _6727.y, _6727.z, _5486.w);
    _5486.w = _6157;
    float _7312 = _5486.w;
    _5486.w = _10(_7312);
    vec3 _7321 = _5486.xyz * _5486.w;
    _5486 = vec4(_7321.x, _7321.y, _7321.z, _5486.w);
    _5696 = vec4(0.0);
    _5697 = vec4(0.0);
    float _7324 = _960._m34.w;
    if (!(_7324 == 0.0))
    {
        vec2 _7331 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _960._m31.xy;
        bool _7347 = ((1.0 - gl_FragCoord.z) - 0.0) < (1.0 - TEXTURE_LOD(SAMPLER_2D(_5726, _1677), vec4(_7331, 0.0, 0.0).xy, vec4(_7331, 0.0, 0.0).w).x);
        _5696 = _5486 * float(!_7347);
        _5486 *= float(_7347);
        _5697 = vec4(_5486.w);
    }
}




