#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 50, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _107
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    float _m5;
};

struct _116
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _3357
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _4287
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _684_686
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    uint _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    uint _m59;
    float _m60[3];
} _686;

layout(set = 2, binding = 0, std140) uniform _933_935
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    float _m22;
    uint _m23;
    uint _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    uint _m29;
    float _m30;
    uint _m31;
    uint _m32;
    float _m33;
    uint _m34;
    uint _m35;
    uint _m36;
    uint _m37;
    uint _m38;
    float _m39;
    uint _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    uint _m61;
    uint _m62;
    uint _m63;
    int _m64;
    uint _m65;
    float _m66[3];
} _935;

layout(set = 1, binding = 0, std140) uniform _945_947
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    uint _m42;
    uint _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    int _m63;
    float _m64;
    float _m65;
    float _m66;
    float _m67;
    uint _m68;
} _947;

layout(set = 3, binding = 0, std140) uniform _987_989
{
    vec4 _m0[5];
    vec4 _m1[5];
    vec4 _m2[5];
    vec4 _m3[5];
} _989;

layout(set = 0, binding = 28, std430) restrict readonly buffer _3280_3282
{
    uint _m0[];
} _3282;

layout(set = 0, binding = 29, std140) uniform _3362_3364
{
    vec4 _m0[4096];
} _3364;

layout(set = 0, binding = 30, std140) uniform _3438_3440
{
    vec4 _m0[4096];
} _3440;

layout(set = 0, binding = 32, std430) restrict readonly buffer _3727_3729
{
    uint _m0[];
} _3729;

layout(set = 0, binding = 33, std140) uniform _4292_4294
{
    vec4 _m0[4095];
} _4294;

layout(set = 0, binding = 1, std140) uniform _6060_6062
{
    vec4 _m0[64];
} _6062;

layout(push_constant, std430) uniform _6056_6058
{
    int _m0;
    int _m1;
    int _m2;
} _6058;

layout(set = 3, binding = 1) uniform TEXTURE_2D _1031[5];
layout(set = 0, binding = 12) uniform sampler _1039;
layout(set = 3, binding = 3) uniform TEXTURE_2D _1057[5];
layout(set = 0, binding = 13) uniform sampler _1062;
layout(set = 3, binding = 2) uniform TEXTURE_2D _1069[5];
layout(set = 0, binding = 14) uniform sampler _1074;
layout(set = 3, binding = 4) uniform TEXTURE_2D _1091[5];
layout(set = 0, binding = 15) uniform sampler _1096;
layout(set = 3, binding = 5) uniform TEXTURE_2D _1103[5];
layout(set = 0, binding = 16) uniform sampler _1108;
layout(set = 3, binding = 7) uniform TEXTURE_2D _1115[5];
layout(set = 0, binding = 17) uniform sampler _1120;
layout(set = 3, binding = 8) uniform TEXTURE_2D _1127[5];
layout(set = 0, binding = 18) uniform sampler _1132;
layout(set = 4, binding = 0) uniform TEXTURE_2D _1217[34816];
layout(set = 0, binding = 19) uniform sampler _1222;
layout(set = 3, binding = 6) uniform TEXTURE_2D _1755[5];
layout(set = 0, binding = 20) uniform sampler _1760;
layout(set = 0, binding = 21) uniform TEXTURE_2D _2254;
layout(set = 0, binding = 22) uniform TEXTURE_2D _2370;
layout(set = 0, binding = 23) uniform TEXTURE_2D _2401;
layout(set = 0, binding = 24) uniform TEXTURE_2D _2491;
layout(set = 0, binding = 25) uniform TEXTURE_2D _2524;
layout(set = 0, binding = 26) uniform TEXTURE_2D _2866;
layout(set = 0, binding = 27) uniform sampler _2868;
layout(set = 0, binding = 31) uniform textureCubeArray _3693;
layout(set = 0, binding = 10) uniform sampler _3695;
layout(set = 0, binding = 34) uniform texture2D _4615;
layout(set = 0, binding = 35) uniform samplerShadow _4617;
layout(set = 0, binding = 36) uniform TEXTURE_2D _5036;
layout(set = 0, binding = 37) uniform sampler _5038;
layout(set = 0, binding = 38) uniform TEXTURE_2D _5301;
layout(set = 0, binding = 39) uniform TEXTURE_2D _5934;
layout(set = 0, binding = 7) uniform texture3D _6065;
layout(set = 0, binding = 8) uniform sampler _6066;
layout(set = 0, binding = 9) uniform texture3D _6067;

layout(location = 17, component = 3) in float _814;
layout(location = 18, component = 0) in float _816;
layout(location = 18, component = 1) in float _821;
layout(location = 18, component = 2) in float _823;
layout(location = 18, component = 3) in float _825;
layout(location = 19, component = 0) in float _853;
layout(location = 19, component = 1) in float _855;
layout(location = 19, component = 2) in float _857;
layout(location = 19, component = 3) in float _861;
layout(location = 20, component = 0) in float _863;
layout(location = 20, component = 1) in float _865;
layout(location = 20, component = 2) in float _877;
layout(location = 10, component = 0) in vec4 _902;
layout(location = 11, component = 0) in vec4 _905;
layout(location = 12, component = 0) in vec4 _908;
layout(location = 21, component = 1) in float _1877;
layout(location = 17, component = 2) in float _2106;
layout(location = 23, component = 0) in float _2342;
layout(location = 22, component = 3) in float _2367;
layout(location = 21, component = 3) in float _5242;
layout(location = 22, component = 0) in float _5245;
layout(location = 22, component = 1) in float _5248;
layout(location = 22, component = 2) in float _5251;
layout(location = 21, component = 2) in float _5682;
layout(location = 17, component = 1) in float _5731;
layout(location = 0, component = 0) out vec4 _5903;
uint _155;
uint _157;
uint _159;
uint _161;
uint _163;
uint _165;
uint _167;
uint _168;
uint _170;
uint _171;
uint _173;
uint _175;
uint _177;
uint _179;
uint _181;
uint _183;
uint _185;
uint _187;
uint _189;

_116 _118()
{
    _116 _578;
    _578._m0 = vec3(0.0);
    _578._m2 = vec3(0.0);
    _578._m3 = 0.0;
    _578._m4 = 0u;
    _578._m5 = 0.0;
    _578._m6 = vec3(0.0);
    _578._m7 = vec3(0.0, 0.0, 1.0);
    _578._m8 = vec3(0.0, 0.0, 1.0);
    _578._m1 = vec3(0.0);
    _578._m9 = 1.0;
    _578._m10 = 1.0;
    _578._m14 = vec3(0.0);
    _578._m15 = vec3(0.0);
    _578._m16 = vec4(0.0);
    _578._m17 = vec4(0.0);
    _578._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _578._m19 = vec3(0.0);
    _578._m20 = vec3(0.0);
    _578._m21 = vec3(0.0);
    _578._m22 = vec3(0.0);
    _578._m23 = vec3(0.0);
    _578._m24 = vec3(0.0);
    _578._m25 = 1.0;
    _578._m26 = uvec4(0u);
    _578._m27 = uvec4(0u);
    _578._m28 = uvec4(0u);
    _578._m29 = vec4(0.0);
    _578._m30 = vec4(0.0);
    _578._m31 = vec4(0.0);
    _578._m32 = vec4(0.0);
    _578._m33 = uvec2(0u);
    _578._m34 = vec2(0.0);
    _578._m35 = 0.0;
    _578._m36 = -1;
    _578._m37 = 0;
    _578._m38 = vec2(0.0);
    _578._m39 = 1.0;
    _578._m41 = -1;
    _578._m45 = 1.0;
    _578._m11 = 1.0;
    _578._m12 = 0u;
    _578._m13 = uvec3(0u);
    _578._m40 = vec3(0.0);
    _578._m46 = 0.0;
    _578._m47 = 1.0;
    return _578;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

_107 _109()
{
    _107 _566;
    _566._m0 = vec4(0.0);
    _566._m1 = vec4(0.0);
    _566._m2 = vec4(0.0);
    _566._m3 = vec4(0.0);
    _566._m4 = vec4(0.0);
    _566._m5 = 0.0;
    return _566;
}

vec2 _130(vec2 _129)
{
    return ((_129 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _135(inout vec2 _133, bool _134)
{
    vec2 _718 = _133;
    _133 = _130(_718);
    float _738 = (1.0 - (_133.x * _133.x)) - (_133.y * _133.y);
    vec3 _721 = vec3(_133.x, _133.y, sqrt(_10(_738)));
    if (_134 == false)
    {
        _721.z = -_721.z;
    }
    return _721;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

uint _81(inout vec4 _80)
{
    vec4 _386 = _80;
    _80 = _22(_386);
    return packUnorm4x8(_80.wzyx);
}

float _27(vec3 _25, vec3 _26)
{
    return dot(_25, _26);
}

vec4 _86(uint _85)
{
    return unpackUnorm4x8(_85).wzyx;
}

vec3 _69(mat3 _67, vec3 _68)
{
    return _67 * _68;
}

vec3 _140(vec3 _138, mat3 _139)
{
    mat3 _754 = _139;
    vec3 _756 = _138;
    return normalize(_69(_754, _756));
}

vec3 _146(vec2 _143, mat3 _144, bool _145)
{
    vec2 _763 = _143;
    bool _765 = _145;
    vec3 _767 = _135(_763, _765);
    vec3 _762 = _767;
    vec3 _768 = _762;
    mat3 _770 = _144;
    return _140(_768, _770);
}

float _125(inout float _123, bool _124)
{
    if (_124)
    {
        _123 += (float(_123 < _686._m23) * _686._m24);
    }
    float _699 = _123;
    return _686._m0.w / (_10(_699) + _686._m0.z);
}

uint _32(float _31)
{
    return floatBitsToUint(_31);
}

float _72(float _71)
{
    return exp2(_71);
}

vec3 _105(float _102, float _103, vec3 _104)
{
    float _517 = 0.0949999988079071044921875 + (_103 * (0.60000002384185791015625 + (4.190000057220458984375 * _103)));
    float _527 = _102 + 0.02500000037252902984619140625;
    float _531 = (9.5 * _103) * _102;
    float _545 = 1.0 - (14.0 * _102);
    float _537 = (_517 * _527) * _72(_545);
    float _552 = -_531;
    float _548 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _72(_552)));
    return mix(vec3(_537), vec3(_548), _104);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec3 _52(vec3 _51)
{
    return _51 * _51;
}

float _55(float _54)
{
    return _54 * _54;
}

uint _49(float _46, float _47, float _48)
{
    bool _236 = abs(_48) >= abs(_46);
    bool _244;
    if (_236)
    {
        _244 = abs(_48) >= abs(_47);
    }
    else
    {
        _244 = _236;
    }
    if (_244)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

vec4 _62(vec3 _60, mat4 _61)
{
    return vec4((_60.x * _61[0].x) + ((_60.y * _61[0].y) + ((_60.z * _61[0].z) + _61[0].w)), (_60.x * _61[1].x) + ((_60.y * _61[1].y) + ((_60.z * _61[1].z) + _61[1].w)), (_60.x * _61[2].x) + ((_60.y * _61[2].y) + ((_60.z * _61[2].z) + _61[2].w)), (_60.x * _61[3].x) + ((_60.y * _61[3].y) + ((_60.z * _61[3].z) + _61[3].w)));
}

float _152(uvec2 _150, uint _151)
{
    uvec2 _775 = _150 & uvec2(3u);
    return float(((((2068378560u * (1u - (_775.x >> uint(1)))) + (1500172770u * (_775.x >> uint(1)))) >> ((_775.y + ((_775.x & 1u) << uint(2))) << uint(2))) + _151) & 15u) / 16.0;
}

float _77(float _75, float _76)
{
    return pow(_75, _76);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _91(vec3 _89, float _90)
{
    float _404 = dot(_89, vec3(16.666500091552734375));
    float _399 = _10(_404);
    float _413 = 1.0 - _90;
    float _416 = _10(_413);
    float _417 = 5.0;
    vec3 _421 = _89 + ((vec3(_399) - _89) * _77(_416, _417));
    return _16(_421);
}

vec3 _99(vec3 _94, vec3 _95, vec3 _96, vec3 _97, float _98)
{
    float _429 = dot(_94, _95);
    float _425 = _10(_429);
    vec3 _431 = normalize(_95 + _96);
    float _440 = dot(_94, _431);
    float _436 = _10(_440);
    float _446 = dot(_96, _431);
    float _442 = _10(_446);
    vec3 _449 = _97;
    float _451 = _442;
    vec3 _448 = _91(_449, _451);
    float _458 = dot(_94, _96);
    float _454 = _10(_458);
    float _460 = 1.0 - (_98 * 0.800000011920928955078125);
    _460 *= _460;
    _460 *= _460;
    float _471 = _460 * _460;
    float _475 = ((_436 * _436) * (_471 - 1.0)) + 1.0;
    _475 = _471 / ((_475 * _475) + 9.9999999392252902907785028219223e-09);
    float _490 = (_425 * (1.0 - _460)) + _460;
    float _497 = (_454 * (1.0 - _460)) + _460;
    _475 /= (((4.0 * _490) * _497) + 9.9999999392252902907785028219223e-09);
    return _448 * _475;
}

void main()
{
    _155 = 2147483648u;
    _157 = 1073741824u;
    _159 = 0u;
    _161 = 268435456u;
    _163 = 536870912u;
    _165 = 805306368u;
    _167 = 1073741824u;
    _168 = 1342177280u;
    _170 = 0u;
    _171 = 16777216u;
    _173 = 33554432u;
    _175 = 50331648u;
    _177 = 67108864u;
    _179 = 83886080u;
    _181 = 100663296u;
    _183 = 117440512u;
    _185 = 134217728u;
    _187 = 150994944u;
    _189 = 167772160u;
    float _809 = 0.0;
    float _810 = 1.0;
    _116 _811 = _118();
    _811._m16 = vec4(0.0, 0.0, _814, _816);
    vec3 _820 = vec3(_821, _823, _825);
    _811._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    _811._m15 = vec3(_686._m34, _686._m35, _686._m36) + _820;
    vec3 _851 = vec3(0.0);
    vec3 _852 = vec3(0.0);
    _851 = normalize(vec3(_853, _855, _857));
    _852 = normalize(vec3(_861, _863, _865));
    vec3 _869 = _851;
    vec3 _871 = _852;
    vec3 _873 = normalize(cross(_869, _871) * _877);
    _811._m18 = mat3(vec3(_871), vec3(_873), vec3(_869));
    _811._m14 = normalize(-_820);
    _811._m29 = _902;
    _811._m30 = _905;
    _811._m31 = _908;
    uint _911 = 0u;
    vec4 _912 = vec4(0.0);
    vec4 _913 = vec4(0.0);
    vec4 _914 = vec4(0.0);
    vec4 _915 = vec4(0.0);
    vec4 _916 = vec4(0.0);
    float _917 = 0.0;
    uvec2 _918 = uvec2(0u, 65535u);
    vec2 _921 = _811._m16.zw;
    vec2 _925 = _921;
    vec2 _927 = _921;
    float _929 = 0.0009765625;
    vec3 _942;
    if ((_935._m65 & 1u) != 0u)
    {
        _942 = vec3(_947._m46, _947._m47, _947._m48);
    }
    else
    {
        _942 = vec3(1.0);
    }
    vec3 _931 = _942;
    float _959 = 1.0;
    float _960 = _947._m49;
    bool _964 = _960 > 0.0;
    float _967 = 1.0;
    uint _968 = _918.x;
    uint _971 = _968 & 7u;
    uint _975 = _971;
    uint _977 = _975;
    float _979 = 0.0;
    vec2 _980 = _925;
    _980.x *= _989._m1[_977].w;
    _980.y *= _989._m2[_977].x;
    _980.x += (_686._m52 * _989._m2[_977].y);
    _980.y += (_686._m52 * _989._m2[_977].z);
    vec2 _1025 = _980;
    uint _1033 = _977;
    vec3 _1027 = (SAMPLE_TEXTURE(SAMPLER_2D(_1031[nonuniformEXT(_1033)], _1039), _1025).xyz * vec3(_989._m0[_977].x)) + vec3(_989._m0[_977].y);
    uint _1059 = _977;
    vec2 _1056 = SAMPLE_TEXTURE(SAMPLER_2D(_1057[nonuniformEXT(_1059)], _1062), _1025).xy;
    uint _1071 = _977;
    vec3 _1068 = (SAMPLE_TEXTURE(SAMPLER_2D(_1069[nonuniformEXT(_1071)], _1074), _1025).xyz * vec3(_989._m0[_977].z)) + vec3(_989._m0[_977].w);
    uint _1093 = _977;
    float _1090 = SAMPLE_TEXTURE(SAMPLER_2D(_1091[nonuniformEXT(_1093)], _1096), _1025).x;
    uint _1105 = _977;
    float _1102 = SAMPLE_TEXTURE(SAMPLER_2D(_1103[nonuniformEXT(_1105)], _1108), _1025).x;
    uint _1117 = _977;
    vec3 _1114 = SAMPLE_TEXTURE(SAMPLER_2D(_1115[nonuniformEXT(_1117)], _1120), _1025).xyz;
    uint _1129 = _977;
    float _1126 = SAMPLE_TEXTURE(SAMPLER_2D(_1127[nonuniformEXT(_1129)], _1132), _1025).x;
    _912 = vec4(_1027.x, _1027.y, _1027.z, _912.w);
    _912.w = 0.0;
    _913 = vec4(_1068.x, _1068.y, _1068.z, _913.w);
    _913.w = _1102;
    _914 = vec4(_1056.x, _1056.y, _914.z, _914.w);
    _915.x = 0.0;
    _915.y = _979;
    _915.z = _1102;
    _915.w = _1090;
    _917 = _1126;
    _967 = _989._m1[_977].x;
    vec3 _1167 = _1114 * _989._m3[_977].xyz;
    _916 = vec4(_1167.x, _1167.y, _1167.z, _916.w);
    float _1170 = _964 ? _960 : _967;
    vec3 _1179 = _916.xyz * vec3(_1170);
    _916 = vec4(_1179.x, _1179.y, _1179.z, _916.w);
    vec2 _1182 = vec2(0.0);
    _107 _1183;
    _1183._m0 = _912;
    _1183._m1 = _913;
    _1183._m2 = _915;
    _1183._m3 = _914;
    _1183._m4 = _916;
    _1183._m5 = _917;
    _1182 = _1183._m3.xy;
    _1183._m3 = vec4(vec2(0.5).x, vec2(0.5).y, _1183._m3.z, _1183._m3.w);
    bool _1204 = (_935._m65 & 4u) != 0u;
    if (_1204)
    {
        vec4 _1213 = vec4(0.0);
        _1213 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m40], _1222), _925);
        _1213 *= _935._m7;
        _1213 = min(_1213, vec4(1.0));
        float _1234 = (_917 - 0.4980392158031463623046875) * _935._m17;
        for (int _1241 = 0; _1241 < 4; _1241++)
        {
            float _1249 = _1213[_1241];
            if (!(_1249 == 0.0))
            {
                float _1257 = 0.0;
                vec2 _1258 = vec2(_935._m3[_1241]);
                uint _1263 = uint(_1241 + 1);
                uint _1267 = _1263 & 7u;
                uint _1270 = _1267;
                uint _1272 = _1270;
                uint _1275 = _1272;
                _1257 = SAMPLE_TEXTURE(SAMPLER_2D(_1127[nonuniformEXT(_1275)], _1132), _921 * _1258).x;
                _1257 -= 0.4980392158031463623046875;
                _1257 *= _935._m6[_1241];
                float _1292 = (_1234 + 1.0) - _1249;
                float _1297 = (_1257 + 0.0) + _1249;
                float _1302 = _1297 - _1292;
                float _1306 = (clamp(_1302 / _935._m10[_1241], -1.0, 1.0) / 2.0) + 0.5;
                float _1317 = 0.100000001490116119384765625;
                float _1319 = abs(0.5 - _1249);
                float _1330 = (_1319 - (0.5 - _1317)) / _1317;
                float _1323 = _10(_1330);
                float _1332 = 0.0;
                if ((_1249 < _1317) && (_1306 > _1249))
                {
                    _1332 = mix(_1306, _1249, _1323);
                }
                else
                {
                    if ((_1249 > (1.0 - _1317)) && (_1306 < _1249))
                    {
                        _1332 = mix(_1306, _1249, _1323);
                    }
                    else
                    {
                        _1332 = _1306;
                    }
                }
                float _1363 = _935._m4[_1241];
                float _1367 = _935._m8[_1241];
                float _1371 = _935._m11[_1241];
                float _1375 = _935._m9[_1241];
                float _1379 = _935._m5[_1241];
                _107 _1383 = _109();
                float _1385 = _947._m49;
                bool _1388 = _1385 > 0.0;
                float _1391 = 1.0;
                uint _1392 = uint(_1241 + 1);
                uint _1396 = _1392 & 7u;
                uint _1399 = _1396;
                uint _1401 = _1399;
                float _1403 = 0.0;
                vec2 _1404 = _921 * _1258;
                _1404.x *= _989._m1[_1401].w;
                _1404.y *= _989._m2[_1401].x;
                _1404.x += (_686._m52 * _989._m2[_1401].y);
                _1404.y += (_686._m52 * _989._m2[_1401].z);
                vec2 _1442 = _1404;
                uint _1446 = _1401;
                vec3 _1444 = (SAMPLE_TEXTURE(SAMPLER_2D(_1031[nonuniformEXT(_1446)], _1039), _1442).xyz * vec3(_989._m0[_1401].x)) + vec3(_989._m0[_1401].y);
                uint _1466 = _1401;
                vec2 _1464 = SAMPLE_TEXTURE(SAMPLER_2D(_1057[nonuniformEXT(_1466)], _1062), _1442).xy;
                uint _1476 = _1401;
                vec3 _1474 = (SAMPLE_TEXTURE(SAMPLER_2D(_1069[nonuniformEXT(_1476)], _1074), _1442).xyz * vec3(_989._m0[_1401].z)) + vec3(_989._m0[_1401].w);
                uint _1496 = _1401;
                float _1494 = SAMPLE_TEXTURE(SAMPLER_2D(_1091[nonuniformEXT(_1496)], _1096), _1442).x;
                uint _1506 = _1401;
                float _1504 = SAMPLE_TEXTURE(SAMPLER_2D(_1103[nonuniformEXT(_1506)], _1108), _1442).x;
                uint _1516 = _1401;
                vec3 _1514 = SAMPLE_TEXTURE(SAMPLER_2D(_1115[nonuniformEXT(_1516)], _1120), _1442).xyz;
                uint _1526 = _1401;
                float _1524 = SAMPLE_TEXTURE(SAMPLER_2D(_1127[nonuniformEXT(_1526)], _1132), _1442).x;
                _1383._m0 = vec4(_1444.x, _1444.y, _1444.z, _1383._m0.w);
                _1383._m0.w = 0.0;
                _1383._m1 = vec4(_1474.x, _1474.y, _1474.z, _1383._m1.w);
                _1383._m1.w = _1504;
                _1383._m3 = vec4(_1464.x, _1464.y, _1383._m3.z, _1383._m3.w);
                _1383._m2.x = 0.0;
                _1383._m2.y = _1403;
                _1383._m2.z = _1504;
                _1383._m2.w = _1494;
                _1383._m5 = _1524;
                _1391 = _989._m1[_1401].x;
                vec3 _1566 = _1514 * _989._m3[_1401].xyz;
                _1383._m4 = vec4(_1566.x, _1566.y, _1566.z, _1383._m4.w);
                float _1570 = _1388 ? _1385 : _1391;
                vec3 _1580 = _1383._m4.xyz * vec3(_1570);
                _1383._m4 = vec4(_1580.x, _1580.y, _1580.z, _1383._m4.w);
                _1183._m0 = mix(_1183._m0, _1383._m0, vec4(_1332 * _1363));
                _1183._m1 = mix(_1183._m1, _1383._m1, vec4(_1332 * _1371));
                _1183._m2.w = mix(_1183._m2.w, _1383._m2.w, _1332 * _1375);
                vec3 _1621 = mix(_1183._m2.xyz, _1383._m2.xyz, vec3(_1332));
                _1183._m2 = vec4(_1621.x, _1621.y, _1621.z, _1183._m2.w);
                _1183._m3 = mix(_1183._m3, _1383._m3, vec4(_1332 * _1367));
                _1183._m4 = mix(_1183._m4, _1383._m4, vec4(_1332 * _1379));
                _1183._m5 = mix(_1183._m5, _1383._m5, _1332);
            }
        }
    }
    _912 = _1183._m0;
    _913 = _1183._m1;
    _915.w = _1183._m2.w;
    _914 = _1183._m3;
    _916 = _1183._m4;
    _917 = _1183._m5;
    vec2 _1669 = _1182;
    bool _1671 = true;
    vec3 _1672 = _135(_1669, _1671);
    vec3 _1667 = _1672;
    vec2 _1674 = _914.xy;
    bool _1677 = true;
    vec3 _1678 = _135(_1674, _1677);
    vec3 _1673 = _1678;
    vec3 _1679 = _1667 + vec3(0.0, 0.0, 1.0);
    vec3 _1682 = vec3(-_1673.xy, _1673.z);
    vec3 _1691 = (_1679 * dot(_1679, _1682)) - (_1682 * _1679.z);
    vec3 _1703 = normalize(_1691);
    _914 = vec4(_1703.x, _1703.y, _1703.z, _914.w);
    vec3 _1708 = _914.xyz + vec3(1.0);
    _914 = vec4(_1708.x, _1708.y, _1708.z, _914.w);
    vec3 _1713 = _914.xyz * 0.5;
    _914 = vec4(_1713.x, _1713.y, _1713.z, _914.w);
    _811._m22 = _916.xyz * _931;
    vec3 _1721 = vec3(0.0);
    vec3 _1722 = vec3(0.0);
    float _1723 = 0.0;
    uint _1724 = 0u;
    uint _1725 = _1724 & 7u;
    uint _1728 = _1725;
    uint _1730 = _1728;
    vec4 _1732 = vec4(_921, 0.0, _935._m42);
    uint _1741 = _1730;
    vec2 _1751 = SAMPLE_TEXTURE1(SAMPLER_2D(_1057[nonuniformEXT(_1741)], _1062), _1732.xy, _1732.w).xy;
    _1721 = vec3(_1751.x, _1751.y, _1721.z);
    uint _1757 = _1730;
    vec4 _1754 = SAMPLE_TEXTURE1(SAMPLER_2D(_1755[nonuniformEXT(_1757)], _1760), _1732.xy, _1732.w);
    _1722 = _1754.xyz;
    _1723 = _1754.w;
    _811._m8 = _1721;
    float _1779 = _1723 * _935._m46;
    float _1774 = _10(_1779);
    vec4 _1787 = vec4(_1722, _1774);
    uint _1788 = _81(_1787);
    _811._m4 = _1788;
    float _1795 = (1.0 - _1774) * _935._m41;
    _811._m10 = _10(_1795);
    _811._m0 = _912.xyz;
    _811._m2 = _913.xyz;
    _811._m1 = _916.xyz;
    _811._m3 = _915.w;
    _811._m6 = _914.xyz;
    float _1813 = 0.0;
    vec3 _1814 = vec3(0.0);
    bool _1817 = _935._m12.x < 1.0;
    bool _1824;
    if (!_1817)
    {
        _1824 = _947._m52 < 1.0;
    }
    else
    {
        _1824 = _1817;
    }
    if (_1824)
    {
        vec4 _1827 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m63], _1222), vec2(_814, _816) * _935._m14.xy);
        vec3 _1843 = vec3((_1827.xy * 2.0) - vec2(1.0), 0.0);
        vec3 _1852 = _1843;
        vec3 _1854 = _1843;
        _1843.z = sqrt(1.0 - min(_27(_1852, _1854), 1.0));
        _1843 = normalize(_1843);
        _1843.z *= 1.0;
        _1843.z *= (_1843.z * _1843.z);
        float _1876 = _1877;
        float _1879 = 1.0 - _1876;
        vec4 _1882 = vec4(1.0);
        if (_935._m60 > 0.0)
        {
            _1882 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m61], _1222), vec2(_814, _816));
            _1879 = _1882.y;
        }
        float _1907 = 1.0 - (_1879 * _1879);
        float _1902 = _10(_1907);
        float _1909 = _1902 * _1902;
        float _1913 = (_1902 * _1902) * _1902;
        float _1919 = 1.0 - _1902;
        float _1922 = _1902 * _1827.z;
        vec4 _1927 = vec4(0.0);
        _1927 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m24], _1222), vec2(_814, _816) * _935._m14.xy);
        if ((_935._m65 & 2u) != 0u)
        {
            _1922 = ((_1902 * _1902) * _1902) * _1927.z;
        }
        float _1962 = (_1909 * 8.0) - 7.0;
        float _1956 = _10(_1962);
        float _1973 = ((_1922 * (1.0 + _1919)) - (1.0 - _1913)) + _1956;
        _1922 = _10(_1973);
        float _1977 = _1922 * 16.0;
        _1922 = _10(_1977);
        float _1979 = _1922 * _1922;
        float _1983 = _1979 * mix(1.0, 0.25, _1902);
        float _1992 = _1827.z;
        float _1989 = _1843.z * _10(_1992);
        if (((_935._m65 & 2u) != 0u) == false)
        {
            _811._m0 = mix(_811._m0, _811._m0 * mix(mix(_935._m0.xyz, vec3(_935._m18, _935._m19, _935._m20), vec3(_1989, _1989, _1989)), _935._m0.xyz, vec3(_1913 * _1979)), vec3(_1922 * mix(1.0, _1913, _935._m22)));
            float _2041 = _1979 * _935._m21;
            _811._m0 = mix(_811._m0, mix(_935._m0.xyz, vec3(_935._m18, _935._m19, _935._m20), vec3(_1902)), vec3((_2041 * _1989) * _1902));
            _1813 = _1827.z;
            _1814 = mix(_811._m6, mix(_811._m6, _1827.xyz, vec3(0.1500000059604644775390625)), vec3((_1827.z * _1827.z) * _947._m66));
            _811._m2 = mix(_811._m2, vec3(0.0199999995529651641845703125), vec3(_1979));
            _811._m3 = mix(_811._m3, 0.75, _1979);
        }
        float _2105 = _2106;
        if ((_935._m65 & 2u) != 0u)
        {
            vec2 _2122 = mix(_811._m6.xy, _1927.xy, vec2(1.0 - _1879));
            _811._m6 = vec3(_2122.x, _2122.y, _811._m6.z);
        }
        else
        {
            vec2 _2134 = mix(_811._m6.xy, _1827.xy, vec2(_1983));
            _811._m6 = vec3(_2134.x, _2134.y, _811._m6.z);
            vec2 _2145 = mix(_811._m6.xy, _1927.xy, vec2(_2105));
            _811._m6 = vec3(_2145.x, _2145.y, _811._m6.z);
        }
        vec3 _2149 = mix(vec3(0.00999999977648258209228515625), vec3(0.119999997317790985107421875, 0.10999999940395355224609375, 0.100000001490116119384765625), vec3(_1927.z));
        float _2159 = mix(0.100000001490116119384765625, 0.699999988079071044921875, _1927.z);
        _811._m0 = mix(_811._m0, _2149, vec3(_2105));
        _811._m3 = mix(_811._m3, _2159, _2105);
        _811._m2 = mix(_811._m2, vec3(0.048000000417232513427734375), vec3(_2105));
        if ((_935._m65 & 2u) != 0u)
        {
            vec3 _2191 = vec3(0.0);
            _811._m0 = mix(_811._m0, _2149, vec3(1.0 - _1879));
            _811._m3 = mix(_811._m3, _2159, 1.0 - _1879);
            _811._m2 = mix(_811._m2, vec3(0.048000000417232513427734375), vec3(1.0 - _1879));
            _811._m22 = mix(vec3(_1927.z * _1927.z) * vec3(1.0, 0.070000000298023223876953125, 0.0), _811._m22, vec3(_1879));
            _2191 = (((mix(vec3(mix(mix(_1927.w, _1927.z, 1.0 - _1879), 0.0, _1879)), _811._m22, vec3(_1879)) * vec3(1.0, 0.070000000298023223876953125, 0.0)) * 25.0) * _811._m6.x) * _811._m6.y;
            float _2253 = SAMPLE_TEXTURE(SAMPLER_2D(_2254, _1222), (vec2(_814, _816) * vec2(_935._m1.x)) + vec2(0.0, _686._m52 * _935._m1.z)).x;
            float _2274 = SAMPLE_TEXTURE(SAMPLER_2D(_2254, _1222), (vec2(_814, _816) * vec2(_935._m1.y)) - vec2(0.0, _686._m52 * _935._m1.w)).x;
            _2253 *= _2253;
            _2274 *= _2274;
            float _2300 = _2253 * _2274;
            float _2306 = _2300 + 0.119999997317790985107421875;
            _2300 = _10(_2306);
            _811._m22 += (_2191 * _2300);
        }
    }
    if (_947._m45 > 0.0)
    {
        uint _2320 = 0u;
        uint _2321 = _2320 & 7u;
        uint _2324 = _2321;
        vec3 _2326 = vec3(_821, _823, _825);
        vec3 _2331 = vec3(_686._m34, _686._m35, _686._m36) + _2326;
        float _2341 = _2342;
        vec2 _2344 = _2331.yz + vec2(_2341);
        vec2 _2350 = _2331.xz + vec2(_2341);
        _2344 *= _935._m14.zw;
        _2350 *= _935._m14.zw;
        float _2366 = _2367;
        vec3 _2369 = SAMPLE_TEXTURE(SAMPLER_2D(_2370, _1222), _2344).xyz;
        vec3 _2377 = SAMPLE_TEXTURE(SAMPLER_2D(_2370, _1222), _2350).xyz;
        vec3 _2384 = mix(_2377, _2369, vec3(_2366));
        float _2390 = _947._m45;
        _811._m0 = mix(_811._m0, _2384, vec3(_2390));
        vec3 _2400 = SAMPLE_TEXTURE(SAMPLER_2D(_2401, _1222), _2344).xyw;
        vec3 _2408 = SAMPLE_TEXTURE(SAMPLER_2D(_2401, _1222), _2350).xyw;
        vec3 _2415 = mix(_2408, _2400, vec3(_2366));
        vec2 _2428 = mix(_811._m6.xy, _2415.xy, vec2(_2390));
        _811._m6 = vec3(_2428.x, _2428.y, _811._m6.z);
        _811._m8 = vec3(_811._m6.xy.x, _811._m6.xy.y, _811._m8.z);
        _811._m2 = (_811._m2 * (1.0 - _2390)) + vec3(0.017999999225139617919921875 * _2390);
        _811._m3 = mix(_811._m3, 0.699999988079071044921875, _2390);
        _811._m5 = _947._m45;
        uint _2458 = _811._m4;
        vec4 _2457 = _86(_2458);
        vec4 _2480 = vec4(mix(_2457.xyz, vec3(_2415.z) * vec3(0.36000001430511474609375, 0.86000001430511474609375, 1.0), vec3(_2390)), _2457.w);
        uint _2481 = _81(_2480);
        _811._m4 = _2481;
    }
    if ((_686._m59 & 1u) != 0u)
    {
        vec4 _2490 = TEXTURE_LOD(SAMPLER_2D(_2491, _1222), vec4(_811._m17.xy * _686._m6.xy, 0.0, 0.0).xy, vec4(_811._m17.xy * _686._m6.xy, 0.0, 0.0).w);
        if (_2490.w > 0.0)
        {
            vec4 _2523 = SAMPLE_TEXTURE(SAMPLER_2D(_2524, _1222), _811._m16.zw * _935._m58);
            float _2537 = _2523.w;
            float _2536 = _10(_2537);
            _811._m6 = mix(_1814, _2523.xyz, vec3(_2536));
            _811._m3 = mix(_811._m3, 0.87999999523162841796875, max(_1813, _2536));
            _811._m3 = max(_935._m59, _811._m3);
            _811._m0 = mix(_811._m0, _811._m0 * _935._m57, vec3(max(_1813, _2536)));
        }
    }
    uint _2576 = 0u;
    bool _2577 = true;
    vec2 _2578 = _811._m6.xy;
    bool _2582 = _2577;
    vec3 _2584 = _135(_2578, _2582);
    _811._m7 = _2584;
    vec2 _2586 = _811._m6.xy;
    mat3 _2590 = _811._m18;
    bool _2593 = _2577;
    _811._m6 = _146(_2586, _2590, _2593);
    vec2 _2597 = _811._m8.xy;
    mat3 _2601 = _811._m18;
    bool _2604 = _2577;
    _811._m8 = _146(_2597, _2601, _2604);
    uvec2 _2608 = uvec2(_811._m17.xy);
    uint _2613 = _2608.x / 256u;
    uint _2618 = _2608.y / 256u;
    float _2623 = _811._m17.z;
    bool _2626 = false;
    float _2627 = _125(_2623, _2626);
    float _2622 = _2627;
    float _2628 = log2(max(1.0, _2622 / _686._m7.z)) * _686._m7.w;
    uint _2638 = min(23u, uint(_2628));
    float _2645 = _686._m53;
    float _2651 = _686._m54;
    uint _2643 = (_32(_2645) + ((_2613 + (_32(_2651) * _2618)) * 24u)) + _2638;
    float _2664 = _947._m53;
    uint _2663 = _32(_2664);
    _811._m21 = _811._m22;
    _811._m25 = 1.0;
    float _2672 = _686._m8.w;
    bool _2675 = _2672 < 0.0;
    _2672 = abs(_2672);
    vec3 _2680 = _811._m15;
    float _2698 = (1.0 - (length(_2680 - vec3(_686._m34, _686._m35, _686._m36)) / _2672)) / 0.25;
    float _2683 = _10(_2698);
    if ((!_2675) && (_2683 > 0.0))
    {
        vec3 _2707 = _686._m8.xyz;
        vec3 _2711 = _686._m9.xyz;
        float _2715 = _2680.z - _2711.z;
        float _2721 = _686._m10.w;
        float _2724 = _686._m11.w;
        float _2727 = float(_2724 < 0.0);
        _2724 = abs(_2724) - 1.0;
        bool _2734 = _2715 <= 0.0;
        float _2737 = 3.5 * float(!(_2724 == 0.0));
        float _2746;
        if (!(_2721 == 0.0))
        {
            _2746 = _2707.z;
        }
        else
        {
            _2746 = _2711.z;
        }
        float _2743 = _2746;
        float _2755 = min(_2734 ? 2.0 : 1000.0, abs(_2715));
        float _2762 = max(_2707.x - _2680.x, _2680.x - _2711.x);
        float _2774 = max(_2707.y - _2680.y, _2680.y - _2711.y);
        float _2786 = max(_2762, _2774) - _2755;
        _2786 = max(_2786, _2743 - _2680.z);
        _2786 = max(_2786, _2715 - _2737);
        if (_2786 <= 0.0)
        {
            float _2807 = _2734 ? _2721 : _2724;
            vec2 _2812 = _811._m18[2].xy;
            float _2816 = length(_2812);
            vec3 _2819 = vec3(_2812, (-1.73205077648162841796875) * _2816);
            _2819 /= vec3(2.0 * _2816);
            vec3 _2832 = _686._m11.xyz;
            vec3 _2836 = mix(_2819, _2832, bvec3(_2734));
            vec2 _2843 = _2680.xy - (_2836.xy * (_2715 / _2836.z));
            float _2854 = (_686._m55 / 100.0) * 16.0;
            vec2 _2861 = _2843 * _2854;
            float _2865 = TEXTURE_LOD(SAMPLER_2D(_2866, _2868), vec4(_2861, 0.0, 0.0).xy, vec4(_2861, 0.0, 0.0).w).x;
            float _2883 = min(8.0, _2711.z - _2707.z);
            float _2895 = (-_2715) / _2883;
            float _2890 = _10(_2895);
            float _2902 = dot(_811._m6, _2836);
            float _2897 = _10(_2902);
            float _2908 = _2762 / _2755;
            float _2904 = 1.0 - _10(_2908);
            float _2914 = _2774 / _2755;
            _2904 *= (1.0 - _10(_2914));
            _2904 *= _2904;
            float _2930 = min(_2715 / 1.0, 1.0 - (_2715 / _2737));
            float _2922 = _10(_2930);
            _2904 *= max(_2922, _2890);
            _2904 *= _2904;
            _2904 *= _2683;
            float _2943 = _2865 - 1.0;
            float _2946 = float(_2734) * _2727;
            float _2951 = max(0.0, _2865 - 0.85000002384185791015625);
            float _2956 = _2734 ? _2943 : _2951;
            float _2961 = (((1.0 - _2946) * _2897) * _2904) * _2807;
            vec3 _2970 = _811._m0 + (_811._m2 * (vec3(1.0) - _811._m0));
            _811._m21 += ((_2970 * (_2956 * _2961)) * _686._m10.xyz);
            float _2994 = _2946 * _2904;
            _811._m25 = 1.0 + (_2994 * (_2865 - 1.0));
        }
    }
    else
    {
        if (_2683 > 0.0)
        {
            _2683 *= _686._m56;
            float _3014 = float(_686._m11.w < 0.0);
            vec3 _3019 = _686._m11.xyz;
            float _3028 = dot(_811._m6, _3019);
            float _3023 = _10(_3028);
            vec2 _3030 = _2680.xy - (_3019.xy * (_2680.z / _3019.z));
            float _3042 = (_686._m55 / 100.0) * 16.0;
            vec2 _3047 = _3030 * _3042;
            float _3051 = TEXTURE_LOD(SAMPLER_2D(_2866, _2868), vec4(_3047, 0.0, 0.0).xy, vec4(_3047, 0.0, 0.0).w).x;
            vec4 _3067 = _686._m10;
            _811._m21 += (_3067.xyz * (((((1.0 - _3014) * (_3051 - 1.0)) * _3023) * _2683) * _3067.w));
            _811._m25 = 1.0 + ((_3014 * (_3051 - 1.0)) * _2683);
        }
    }
    _811._m14 = normalize(vec3(_686._m34, _686._m35, _686._m36) - _811._m15);
    vec3 _3109 = vec3(0.0);
    vec3 _3110 = vec3(0.0);
    vec3 _3111 = vec3(0.0);
    vec3 _3112 = vec3(0.0);
    vec3 _3113 = vec3(0.0);
    vec4 _3114 = _811._m29;
    vec4 _3117 = _811._m30;
    vec4 _3120 = _811._m31;
    _3110 = vec3(_3114.x, _3114.y, _3114.z);
    _3111 = vec3(_3114.w, _3117.x, _3117.y);
    _3112 = vec3(_3117.z, _3117.w, _3120.x);
    _3113 = vec3(_3120.y, _3120.z, _3120.w);
    vec3 _3151 = ((_3110 - (_3111 * _811._m6.y)) + (_3112 * _811._m6.z)) - (_3113 * _811._m6.x);
    float _3175 = _947._m50 * _686._m57;
    _3109 += (max(vec3(0.0), _3151 * _10(_3175)) * _811._m0);
    vec3 _3184 = vec3(0.0);
    vec3 _3185 = vec3(0.0);
    vec3 _3186 = vec3(0.0);
    vec3 _3187 = vec3(0.0);
    vec3 _3188 = vec3(0.0);
    vec4 _3189 = _811._m29;
    vec4 _3192 = _811._m30;
    vec4 _3195 = _811._m31;
    _3185 = vec3(_3189.x, _3189.y, _3189.z);
    _3186 = vec3(_3189.w, _3192.x, _3192.y);
    _3187 = vec3(_3192.z, _3192.w, _3195.x);
    _3188 = vec3(_3195.y, _3195.z, _3195.w);
    vec3 _3226 = ((_3185 - (_3186 * _811._m8.y)) + (_3187 * _811._m8.z)) - (_3188 * _811._m8.x);
    float _3249 = _947._m50 * _686._m57;
    _3184 += (max(vec3(0.0), _3226 * _10(_3249)) * _811._m0);
    uint _3260 = _811._m4;
    _3109 = mix(_3109, _3184, vec3(_86(_3260).w));
    _811._m21 += _3109;
    bool _3272 = true;
    if (true && (_3272 == true))
    {
        uint _3278 = _3282._m0[_2643 * 64u];
        uint _3289 = _3278 & 255u;
        uint _3293 = _3289;
        uint _3295 = _3278;
        uint _3297 = _2643;
        float _3299 = _811._m47;
        float _3308 = dot(_811._m14, _811._m6);
        float _3302 = _10(_3308);
        float _3310 = _3302;
        float _3312 = _811._m3;
        vec3 _3315 = _811._m2;
        _811._m24 = (_105(_3310, _3312, _3315) * _811._m11) * _811._m39;
        uint _3326 = 1u;
        _3357 _3359;
        while (_3326 <= _3293)
        {
            uint _3335 = (_3297 * 64u) + _3326;
            uint _3340 = _3282._m0[_3335];
            uint _3344 = _3340;
            if (_3344 >= _3340)
            {
                _3326++;
            }
            float _3353 = 0.0039215688593685626983642578125;
            int _3355 = 4;
            int _3356 = 4;
            _3359._m0 = _3364._m0[(uint(_3355) * _3344) + 0u].xyz;
            float _3379 = _3364._m0[(uint(_3355) * _3344) + 0u].w;
            _3359._m1 = _32(_3379);
            _3359._m2 = _3364._m0[(uint(_3355) * _3344) + 1u].xyz;
            _3359._m3 = _3364._m0[(uint(_3355) * _3344) + 1u].w;
            _3359._m4 = _3364._m0[(uint(_3355) * _3344) + 2u];
            float _3414 = _3364._m0[(uint(_3355) * _3344) + 3u].x;
            _3359._m8 = _32(_3414);
            float _3424 = _3364._m0[(uint(_3355) * _3344) + 3u].y;
            _3359._m9 = _32(_3424);
            _3359._m10 = _3364._m0[(uint(_3355) * _3344) + 3u].z;
            _3359._m5 = _3440._m0[(uint(_3356) * _3344) + 0u];
            _3359._m6 = _3440._m0[(uint(_3356) * _3344) + 1u];
            _3359._m7 = _3440._m0[(uint(_3356) * _3344) + 2u];
            _3359._m12 = _3440._m0[(uint(_3356) * _3344) + 3u].xyz;
            _3359._m13 = _3440._m0[(uint(_3356) * _3344) + 3u].w;
            vec3 _3482 = vec3(dot(_811._m15, _3359._m5.xyz) + _3359._m5.w, dot(_811._m15, _3359._m6.xyz) + _3359._m6.w, dot(_811._m15, _3359._m4.xyz) + _3359._m4.w);
            float _3511 = _3482.x;
            float _3514 = _3482.y;
            float _3517 = _3482.z;
            bool _3522 = _43(_3511, _3514, _3517) <= _3353;
            bool _3539;
            if (!_3522)
            {
                float _3526 = _3482.x;
                float _3529 = _3482.y;
                float _3532 = _3482.z;
                _3539 = _38(_3526, _3529, _3532) >= (1.0 - _3353);
            }
            else
            {
                _3539 = _3522;
            }
            if (_3539)
            {
                continue;
            }
            uint _3543 = _3359._m1;
            vec3 _3546 = _3359._m0;
            float _3549 = float(bitfieldExtract(_3359._m8, 20, 12));
            float _3554 = 0.800000011920928955078125;
            vec3 _3555 = (_3482 * 2.0) - vec3(1.0);
            vec3 _3560 = _3555;
            vec3 _3559 = _52(_3560);
            vec3 _3563 = _3555 * sqrt(((vec3(1.0) - (_3559.yzx * 0.5)) - (_3559.zxy * 0.5)) + ((_3559.yzx * _3559.zxy) / vec3(3.0)));
            float _3595 = 1.0 - ((length(_3563) - _3554) / ((1.0 - _3554) + 9.9999999747524270787835121154785e-07));
            float _3584 = _10(_3595);
            _3584 *= _3584;
            _3584 *= _3299;
            float _3603 = _3359._m7.w;
            _3584 *= _3603;
            _3299 *= (1.0 - _3584);
            vec3 _3613 = _3359._m12;
            float _3616 = _3359._m13;
            float _3621 = _3584;
            vec3 _3619 = _3613 * (_10(_3621) * _3616);
            vec3 _3627 = _3359._m2;
            vec3 _3630 = _3359._m7.xyz;
            vec3 _3634 = vec3(0.0);
            vec3 _3635 = reflect(-_811._m14, _811._m6);
            vec3 _3642 = (_3630 - _811._m15) / _3635;
            vec3 _3649 = (_3627 - _811._m15) / _3635;
            vec3 _3656 = max(_3642, _3649);
            float _3661 = _3656.x;
            float _3664 = _3656.y;
            float _3667 = _3656.z;
            float _3660 = _43(_3661, _3664, _3667);
            vec3 _3671 = _811._m15 + (_3635 * _3660);
            vec3 _3678 = _3671 - _3546;
            float _3682 = 6.0;
            float _3684 = _3682 - (_3682 * _811._m3);
            _3634 = textureLod(samplerCubeArray(_3693, _3695), vec4(_3678, _3549), _3684).xyz;
            _811._m21 += ((_3634 * _3619) * _811._m24);
            if (_3299 <= (_3353 * 4.0))
            {
                break;
            }
        }
    }
    uint _3725 = _3729._m0[_2643 * 64u];
    uint _3734 = _3725 & 255u;
    uint _3737 = _3734;
    uint _3739 = _3725;
    uint _3741 = _2643;
    uint _3743 = 1u;
    _3357 _3772;
    vec3 _3899;
    float _4021;
    vec2 _4089;
    _4287 _4289;
    _4287 _4436;
    while (_3743 <= _3737)
    {
        uint _3752 = (_3741 * 64u) + _3743;
        uint _3757 = _3729._m0[_3752];
        uint _3761 = _3757;
        if (_3761 >= _3757)
        {
            _3743++;
        }
        int _3770 = 4;
        int _3771 = 4;
        _3772._m0 = _3364._m0[(uint(_3770) * _3761) + 0u].xyz;
        float _3787 = _3364._m0[(uint(_3770) * _3761) + 0u].w;
        _3772._m1 = _32(_3787);
        _3772._m2 = _3364._m0[(uint(_3770) * _3761) + 1u].xyz;
        _3772._m3 = _3364._m0[(uint(_3770) * _3761) + 1u].w;
        _3772._m4 = _3364._m0[(uint(_3770) * _3761) + 2u];
        float _3822 = _3364._m0[(uint(_3770) * _3761) + 3u].x;
        _3772._m8 = _32(_3822);
        float _3832 = _3364._m0[(uint(_3770) * _3761) + 3u].y;
        _3772._m9 = _32(_3832);
        _3772._m10 = _3364._m0[(uint(_3770) * _3761) + 3u].z;
        _3772._m5 = _3440._m0[(uint(_3771) * _3761) + 0u];
        _3772._m6 = _3440._m0[(uint(_3771) * _3761) + 1u];
        _3772._m7 = _3440._m0[(uint(_3771) * _3761) + 2u];
        _3772._m12 = _3440._m0[(uint(_3771) * _3761) + 3u].xyz;
        _3772._m13 = _3440._m0[(uint(_3771) * _3761) + 3u].w;
        float _3886 = 0.0;
        uint _3887 = _3772._m1;
        vec3 _3890 = _3772._m0;
        vec3 _3893 = _3890;
        if ((_3887 & 7u) == 2u)
        {
            _3899 = _3893;
        }
        else
        {
            _3899 = normalize(_3890 - _811._m15);
        }
        vec3 _3895 = _3899;
        uint _3910 = uint(((_2663 & 3u) != 0u) ? 16 : 0);
        _3910 |= 32u;
        if ((_3887 & _3910) != 0u)
        {
            continue;
        }
        vec3 _3926 = vec3(dot(_811._m15, _3772._m5.xyz) + _3772._m5.w, dot(_811._m15, _3772._m6.xyz) + _3772._m6.w, dot(_811._m15, _3772._m7.xyz) + _3772._m7.w);
        vec2 _3960 = _3926.xy / vec2(_3926.z);
        _3926 = vec3(_3960.x, _3960.y, _3926.z);
        _3926.z = dot(_811._m15, _3772._m4.xyz) + _3772._m4.w;
        float _3973 = _3926.x;
        float _3976 = _3926.y;
        float _3979 = _3926.z;
        bool _3984 = _43(_3973, _3976, _3979) <= _3886;
        bool _4001;
        if (!_3984)
        {
            float _3988 = _3926.x;
            float _3991 = _3926.y;
            float _3994 = _3926.z;
            _4001 = _38(_3988, _3991, _3994) >= (1.0 - _3886);
        }
        else
        {
            _4001 = _3984;
        }
        if (_4001)
        {
            continue;
        }
        vec3 _4005 = vec3(1.0);
        uint _4006 = _3887 & 7u;
        vec3 _4009 = _3772._m0 - _811._m15;
        float _4015 = dot(_4009, _4009);
        if (_4006 != 2u)
        {
            _4021 = 1.0 / (1.0 + _4015);
        }
        else
        {
            _4021 = _811._m25;
        }
        _4005 = vec3(_4021);
        if (_4006 == 0u)
        {
            float _4041 = _4015 * _3772._m3;
            float _4044 = 1.0 - _55(_4041);
            float _4046 = _10(_4044);
            float _4036 = _55(_4046);
            _4005 *= _4036;
        }
        else
        {
            if (_4006 == 4u)
            {
                float _4062 = length((_3926.xy - vec2(0.5)) * 2.0);
                float _4056 = _10(_4062);
                float _4064 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_4056 * 7.80000019073486328125))));
                _4005 *= _4064;
            }
            else
            {
                if ((_4006 == 1u) || (_4006 == 2u))
                {
                    if (_4006 == 2u)
                    {
                        _4089 = fract((_3926.xy * _686._m12.xy) + _686._m12.zw);
                    }
                    else
                    {
                        _4089 = _3926.xy;
                    }
                    vec2 _4086 = _4089;
                    vec3 _4107 = vec3(0.0);
                    uint _4108 = bitfieldExtract(_3772._m8, 0, 20);
                    uint _4112 = _4108;
                    uint _4116 = _4112 + 0u;
                    vec3 _4132 = TEXTURE_LOD(SAMPLER_2D(_1217[nonuniformEXT(_4116)], _1096), vec4(_4086, 0.0, 0.0).xy, vec4(_4086, 0.0, 0.0).w).xyz;
                    _4107 = _52(_4132);
                    _4005 *= _4107;
                }
            }
        }
        float _4138 = float((_3887 >> uint(8)) & 255u) / 255.0;
        if ((_4006 == 0u) || (_4006 == 2u))
        {
            vec3 _4151 = abs((_3926 * 2.0) - vec3(1.0));
            float _4157 = _4151.x;
            float _4160 = _4151.y;
            float _4163 = _4151.z;
            float _4168 = 1.0 - _38(_4157, _4160, _4163);
            float _4173 = _10(_4168) / (9.9999999392252902907785028219223e-09 + _4138);
            float _4156 = _10(_4173);
            _4005 *= ((_4156 * _4156) * (3.0 - (2.0 * _4156)));
        }
        else
        {
            if ((_4006 == 1u) || (_4006 == 4u))
            {
                float _4193 = _3926.z;
                float _4197 = _55(_4193);
                float _4200 = 1.0 - _55(_4197);
                float _4202 = _10(_4200);
                float _4207 = _55(_4202) / (9.9999999392252902907785028219223e-09 + _4138);
                float _4192 = _10(_4207);
                _4005 *= _4192;
            }
        }
        float _4212 = _4005.x;
        float _4215 = _4005.y;
        float _4218 = _4005.z;
        if (_38(_4212, _4215, _4218) <= _3886)
        {
            continue;
        }
        float _4227 = 1.0;
        if ((_3887 & 8u) != 0u)
        {
            float _4234 = 0.00200000009499490261077880859375;
            vec3 _4236 = _811._m15 + (_811._m6 * _4234);
            uint _4244 = 0u;
            if ((_3887 & 7u) == 0u)
            {
                vec3 _4250 = _4236 - _3772._m2;
                float _4255 = _4250.x;
                float _4258 = _4250.y;
                float _4261 = _4250.z;
                _4244 = _49(_4255, _4258, _4261);
            }
            else
            {
                if ((_3887 & 7u) == 2u)
                {
                    float _4271 = 0.0;
                    uint _4272 = uint((_686._m13.w > 0.0) ? 3 : 4);
                    for (; _4244 < _4272; _4244++)
                    {
                        int _4286 = 5;
                        _4289._m0 = _4294._m0[(uint(_4286) * ((_3887 >> uint(22)) + _4244)) + 0u];
                        _4289._m1 = _4294._m0[(uint(_4286) * ((_3887 >> uint(22)) + _4244)) + 1u];
                        _4289._m2 = _4294._m0[(uint(_4286) * ((_3887 >> uint(22)) + _4244)) + 2u];
                        _4289._m3 = _4294._m0[(uint(_4286) * ((_3887 >> uint(22)) + _4244)) + 3u];
                        _4289._m4 = _4294._m0[(uint(_4286) * ((_3887 >> uint(22)) + _4244)) + 4u];
                        vec2 _4350 = vec2(dot(_4236, _4289._m0.xyz) + _4289._m0.w, dot(_4236, _4289._m1.xyz) + _4289._m1.w);
                        _4350 = abs((_4350 * 2.0) - vec2(1.0));
                        bool _4376 = _4350.x < 0.9900000095367431640625;
                        bool _4382;
                        if (_4376)
                        {
                            _4382 = _4350.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _4382 = _4376;
                        }
                        if (_4382)
                        {
                            _4271 = (1.0 - max(_4350.x, _4350.y)) * _686._m14.w;
                            break;
                        }
                    }
                    _811._m36 = int(_4244);
                    _4244 = min((_4272 - 1u), _4244);
                    if (_686._m13.w > 0.0)
                    {
                        uint _4409 = uint(_811._m17.x) ^ (uint(_811._m17.y) << uint(1));
                        _4409 ^= uint(_686._m15.x);
                        _4244 += uint(int(((float(_4409 & 3u) * 0.25) + 0.125) > _4271));
                    }
                }
            }
            int _4435 = 5;
            _4436._m0 = _4294._m0[(uint(_4435) * ((_3887 >> uint(22)) + _4244)) + 0u];
            _4436._m1 = _4294._m0[(uint(_4435) * ((_3887 >> uint(22)) + _4244)) + 1u];
            _4436._m2 = _4294._m0[(uint(_4435) * ((_3887 >> uint(22)) + _4244)) + 2u];
            _4436._m3 = _4294._m0[(uint(_4435) * ((_3887 >> uint(22)) + _4244)) + 3u];
            _4436._m4 = _4294._m0[(uint(_4435) * ((_3887 >> uint(22)) + _4244)) + 4u];
            vec4 _4492 = vec4((_4236.x * _4436._m0.x) + ((_4236.y * _4436._m0.y) + ((_4236.z * _4436._m0.z) + _4436._m0.w)), (_4236.x * _4436._m1.x) + ((_4236.y * _4436._m1.y) + ((_4236.z * _4436._m1.z) + _4436._m1.w)), (_4236.x * _4436._m2.x) + ((_4236.y * _4436._m2.y) + ((_4236.z * _4436._m2.z) + _4436._m2.w)), (_4236.x * _4436._m3.x) + ((_4236.y * _4436._m3.y) + ((_4236.z * _4436._m3.z) + _4436._m3.w)));
            vec3 _4579 = _4492.xyz / vec3(_4492.w);
            _4492 = vec4(_4579.x, _4579.y, _4579.z, _4492.w);
            bool _4587 = min(_4492.x, _4492.y) > 0.0;
            bool _4596;
            if (_4587)
            {
                _4596 = max(_4492.x, _4492.y) < 1.0;
            }
            else
            {
                _4596 = _4587;
            }
            if (_4596)
            {
                vec2 _4608 = (_4492.xy * _4436._m4.xy) + _4436._m4.zw;
                _4492 = vec4(_4608.x, _4608.y, _4492.z, _4492.w);
                if (false)
                {
                    _4227 = textureLod(sampler2DShadow(_4615, _4617), vec3(_4492.xyz.xy, _4492.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4626 = (_4492.xy * _686._m16.xy) + vec2(0.5);
                    vec2 _4635 = floor(_4626);
                    vec2 _4638 = _4626 - _4635;
                    _4635 -= vec2(0.5);
                    vec2 _4645 = vec2(4.0) - (_4638 * 3.0);
                    vec2 _4650 = vec2(7.0);
                    vec2 _4652 = vec2(1.0) + (_4638 * 3.0);
                    vec2 _4657 = (_4635 + (((vec2(3.0) - (_4638 * 2.0)) / _4645) - vec2(2.0))) * _686._m16.zw;
                    vec2 _4672 = (_4635 + ((vec2(3.0) + _4638) / _4650)) * _686._m16.zw;
                    vec2 _4684 = (_4635 + ((_4638 / _4652) + vec2(2.0))) * _686._m16.zw;
                    vec3 _4710 = vec3(_4657.x, _4657.y, _4492.z);
                    _4227 = (_4645.x * _4645.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4710.xy, _4710.z), 0.0);
                    vec3 _4728 = vec3(_4672.x, _4657.y, _4492.z);
                    _4227 += ((_4650.x * _4645.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4728.xy, _4728.z), 0.0));
                    vec3 _4748 = vec3(_4684.x, _4657.y, _4492.z);
                    _4227 += ((_4652.x * _4645.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4748.xy, _4748.z), 0.0));
                    vec3 _4768 = vec3(_4657.x, _4672.y, _4492.z);
                    _4227 += ((_4645.x * _4650.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4768.xy, _4768.z), 0.0));
                    vec3 _4788 = vec3(_4672.x, _4672.y, _4492.z);
                    _4227 += ((_4650.x * _4650.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4788.xy, _4788.z), 0.0));
                    vec3 _4808 = vec3(_4684.x, _4672.y, _4492.z);
                    _4227 += ((_4652.x * _4650.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4808.xy, _4808.z), 0.0));
                    vec3 _4828 = vec3(_4657.x, _4684.y, _4492.z);
                    _4227 += ((_4645.x * _4652.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4828.xy, _4828.z), 0.0));
                    vec3 _4848 = vec3(_4672.x, _4684.y, _4492.z);
                    _4227 += ((_4650.x * _4652.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4848.xy, _4848.z), 0.0));
                    vec3 _4868 = vec3(_4684.x, _4684.y, _4492.z);
                    _4227 += ((_4652.x * _4652.y) * textureLod(sampler2DShadow(_4615, _4617), vec3(_4868.xy, _4868.z), 0.0));
                    _4227 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4227 = float((_3887 & 7u) == 2u);
                if ((_3887 & 7u) == 2u)
                {
                    _811._m36 = -1;
                }
            }
            float _4888 = float((_3887 >> uint(16)) & 63u) / 63.0;
            float _4902 = ((_4227 * _4888) + 1.0) - _4888;
            _4227 = _10(_4902);
            if ((_686._m58 > 0.0) && (_4227 > 0.0))
            {
                vec4 _4912 = vec4(_811._m17.xy * _686._m6.xy, _811._m17.z, 1.0);
                float _4925 = _4912.z;
                bool _4928 = false;
                float _4929 = _125(_4925, _4928);
                _4912.z = _4929;
                vec3 _4966 = _811._m15 + (_3895 * 0.100000001490116119384765625);
                mat4 _4967 = mat4(vec4(_686._m17), vec4(_686._m18), vec4(_686._m19), vec4(_686._m20));
                vec4 _4931 = _62(_4966, _4967);
                vec3 _4974 = _4931.xyz / vec3(_4931.w);
                _4931 = vec4(_4974.x, _4974.y, _4974.z, _4931.w);
                float _4977 = _4931.z;
                bool _4980 = false;
                float _4981 = _125(_4977, _4980);
                _4931.z = _4981;
                int _4983 = 4;
                vec3 _4984 = vec3(_4931.xyz - _4912.xyz) / vec3(float(_4983));
                float _4998 = 0.100000001490116119384765625;
                float _4999 = 0.001000000047497451305389404296875 * _4912.z;
                uvec2 _5012 = uvec2(_811._m17.xy);
                uint _5013 = uint(_686._m21.w);
                float _5004 = _152(_5012, _5013) - 0.5;
                vec3 _5016 = _4912.xyz + (_4984 * _5004);
                for (int _5023 = 0; _5023 < _4983; _5023++)
                {
                    _5016 += _4984;
                    float _5035 = 1.0 - TEXTURE_LOD(SAMPLER_2D(_5036, _5038), vec4(_5016.xy, 0.0, 0.0).xy, vec4(_5016.xy, 0.0, 0.0).w).x;
                    float _5057 = _5035;
                    bool _5059 = false;
                    float _5060 = _125(_5057, _5059);
                    float _5056 = _5060 + _4999;
                    bool _5067 = (_5016.z - _5056) > 0.001000000047497451305389404296875;
                    bool _5076;
                    if (_5067)
                    {
                        _5076 = (_5016.z - _5056) <= _4998;
                    }
                    else
                    {
                        _5076 = _5067;
                    }
                    if (_5076)
                    {
                        uint _5080 = _811._m4;
                        vec3 _5079 = _86(_5080).xyz;
                        _4227 *= dot(_5079, vec3(0.333000004291534423828125));
                        break;
                    }
                }
            }
        }
        if (_4227 <= _3886)
        {
            continue;
        }
        vec3 _5100 = (_3772._m12 * _4227) * _4005;
        float _5107 = _3772._m13;
        vec3 _5110 = _5100;
        float _5117 = dot(_811._m6, _3895);
        float _5112 = _10(_5117);
        float _5119 = 1.0;
        vec3 _5121 = _811._m6;
        vec3 _5124 = _811._m14;
        vec3 _5127 = _3895;
        vec3 _5129 = _811._m2;
        float _5132 = _811._m3;
        vec3 _5120 = _99(_5121, _5124, _5127, _5129, _5132);
        _811._m21 += ((((_5120 * _5107) * _5110) * _5112) * _5119);
        vec3 _5149 = _5110;
        uint _5152 = _811._m4;
        vec4 _5151 = _86(_5152);
        vec3 _5156 = _5151.xyz;
        float _5164 = dot(_811._m8, _3895);
        float _5159 = _10(_5164);
        vec3 _5166 = vec3(mix(_5112, _5159, _935._m45), mix(_5112, _5159, _935._m44), mix(_5112, _5159, _935._m43));
        float _5197 = dot(_811._m14, -_3895);
        float _5199 = _10(_5197);
        float _5200 = _935._m13.w;
        vec3 _5207 = ((_935._m13.xyz + vec3(_811._m5)) * _77(_5199, _5200)) * _5156;
        _5166 += _16(_5207);
        float _5211 = _5151.w;
        _5166 = mix(vec3(_5112), _5166, vec3(_5211));
        _811._m21 += ((_5149 * _5166) * _811._m0);
    }
    _811._m21 *= _811._m11;
    vec3 _5236 = vec3(_821, _823, _825);
    float _5241 = _5242;
    float _5244 = _5245;
    float _5247 = _5248;
    float _5250 = _5251;
    if (_947._m52 < 1.0)
    {
        if (vec3(_947._m60, _947._m61, _947._m62).x > 0.0)
        {
            vec2 _5270 = abs(vec2(1.0) / _686._m6.xy);
            vec2 _5277 = ((vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * 1.5) * _686._m6.xy) * (_5270 / vec2(32.0));
            vec4 _5300 = TEXTURE_LOD(SAMPLER_2D(_5301, _1222), vec4(_5277 * vec2(0.699999988079071044921875), 0.0, 0.0).xy, vec4(_5277 * vec2(0.699999988079071044921875), 0.0, 0.0).w);
            float _5319 = 1.0 - dot(_811._m6, normalize(-_5236));
            float _5327 = 1.0;
            float _5328 = vec3(_947._m54, _947._m55, _947._m56).x;
            if (vec3(_947._m60, _947._m61, _947._m62).y >= vec3(_947._m54, _947._m55, _947._m56).z)
            {
                _5328 = vec3(_947._m54, _947._m55, _947._m56).y;
            }
            float _5364 = mix(vec3(_947._m57, _947._m58, _947._m59).x, vec3(_947._m57, _947._m58, _947._m59).y, vec3(_947._m60, _947._m61, _947._m62).y);
            float _5390 = _5236.z * _5364;
            float _5395 = (sin(_5390 + (_686._m52 * _5328)) * _5327) + _5327;
            float _5407 = vec3(_947._m57, _947._m58, _947._m59).z;
            _5395 = pow(_5395, _5407);
            _5395 *= _5319;
            float _5422 = pow(_5319, 4.0);
            float _5432 = (_5300.x * _5319) + _5422;
            vec3 _5425 = (_947._m10.xyz * _10(_5432)) * 2.0;
            _5425 /= _686._m22.xyz;
            vec3 _5444 = _5425 * _5395;
            _811._m21 += max(vec3(0.0), _5444);
        }
        if (_947._m16.w > 0.0)
        {
            vec2 _5459 = abs(vec2(1.0) / _686._m6.xy);
            vec2 _5465 = ((vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * 1.5) * _686._m6.xy) * (_5459 / vec2(32.0));
            vec4 _5486 = TEXTURE_LOD(SAMPLER_2D(_5301, _1222), vec4(_5465 * vec2(0.699999988079071044921875), 0.0, 0.0).xy, vec4(_5465 * vec2(0.699999988079071044921875), 0.0, 0.0).w);
            float _5503 = 1.0 - dot(_811._m6, normalize(-_5236));
            float _5511 = pow(_5503, 4.0);
            float _5521 = (_5486.x * _5503) + _5511;
            vec3 _5514 = (_947._m16.xyz * _10(_5521)) * 6.0;
            _5514 /= _686._m22.xyz;
            _811._m21 += (max(vec3(0.0), _5514) * _5241);
        }
        bool _5543 = _935._m28 > 0.0;
        bool _5549;
        if (_5543)
        {
            _5549 = _947._m36 > 0.0;
        }
        else
        {
            _5549 = _5543;
        }
        if (_5549)
        {
            float _5552 = SAMPLE_TEXTURE(SAMPLER_2D(_2254, _1222), vec2(_5247, _5247) + vec2(_686._m52 * 1.0)).x;
            _5552 *= (_5552 * _5552);
            vec3 _5571 = mix(vec3(1.0, 0.5, 0.00999999977648258209228515625), vec3(1.0, 0.0500000007450580596923828125, 0.00999999977648258209228515625), vec3(_5247));
            vec3 _5578 = mix(vec3(0.01200000010430812835693359375, 0.100000001490116119384765625, 0.60000002384185791015625), vec3(0.0, 0.0, 0.60000002384185791015625), vec3(_5247));
            vec3 _5592;
            if (((_935._m65 & 8u) != 0u) == true)
            {
                _5592 = _5578;
            }
            else
            {
                _5592 = _5571;
            }
            float _5596 = 1.0 - dot(_811._m6, normalize(-_5236));
            float _5604 = pow(_5596, 4.0);
            float _5614 = (1.0 * (_5596 * _5596)) + _5604;
            vec3 _5607 = (((_5592 * _10(_5614)) * _5244) * (_5552 * 10.0)) * 3.0;
            _5607 *= mix(1.0, 0.0, _947._m16.w);
            _811._m21 += (_5607 * _947._m36);
        }
        if (_947._m11.w > 0.0)
        {
            float _5643 = dot(_811._m6, normalize(-_5236));
            _5643 *= (_5643 * _5643);
            vec3 _5655 = vec3(_5643) * _947._m11.xyz;
            _811._m21 += _5655;
        }
        vec2 _5667 = vec2(_814, _816);
        float _5671 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m62], _1222), _5667).x;
        float _5681 = _5682;
        float _5692 = 1.0 - _5681;
        vec3 _5684 = ((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.100000001490116119384765625, 0.0), vec3(_5671)) * _10(_5692)) * _5671) * _947._m67;
        vec4 _5701 = vec4(0.0);
        _5701 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m24], _1222), _5667 * _935._m14.xy);
        float _5714 = _2106;
        vec3 _5716 = ((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.3499999940395355224609375, 0.0), vec3(_5701.w)) * _5701.w) * 20.0) * _5714;
        float _5730 = _5731;
        float _5736 = (_5730 * 10.0) - 3.0;
        _5716 += (((((mix(vec3(0.5, 0.001000000047497451305389404296875, 0.0), vec3(1.0, 0.3499999940395355224609375, 0.0), vec3((_5701.z * _5701.z) * _5701.z)) * _10(_5736)) * _5701.z) * _5701.z) * _5701.z) * 12.0);
        _811._m21 += (_5684 + _5716);
        if (_947._m44 > 0.0)
        {
            vec3 _5774 = SAMPLE_TEXTURE(SAMPLER_2D(_1217[_935._m38], _1222), _811._m16.zw).xyz;
            vec3 _5786 = mix(_947._m0.xyz, _947._m1.xyz, _5774);
            _811._m21 += ((_5774 * _5786) * mix(0.0, 10.0, _947._m44));
        }
        if (_947._m8.w > 0.0)
        {
            float _5811 = 1.0 - dot(_811._m6, _811._m14);
            _5811 = pow(_5811, 42.0);
            vec3 _5821 = mix(vec3(1.0), vec3(0.0), vec3(_811._m7.z));
            _5821 *= (_5821 * _5821);
            vec3 _5831 = vec3(_5811);
            _5831 = clamp(_5831, vec3(0.0), vec3(0.100000001490116119384765625));
            _811._m21 += ((_5821 + (_5831 * vec3(15.0))) * _947._m8.xyz);
        }
        if (_947._m4.w > 0.0)
        {
            float _5857 = 1.0 - (0.85000002384185791015625 * dot(_811._m6, _811._m14));
            float _5865 = _947._m4.w * _5857;
            _811._m21 = mix(_811._m21, _947._m4.xyz, vec3(_5865));
        }
    }
    _809 = _811._m6.x;
    _810 = dot(_811._m6, normalize(-_5236));
    _810 = 1.0 - _810;
    _810 *= _810;
    _811._m21 = mix(_811._m21, _947._m9.xyz * 10.0, vec3(_5250));
    _5903 = vec4(_811._m21, _811._m9);
    vec2 _5912 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _686._m6.xy;
    if (_947._m65 < 1.0)
    {
        vec3 _5933 = TEXTURE_LOD(SAMPLER_2D(_5934, _1222), vec4(_5912 + vec2(_809 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_5912 + vec2(_809 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
        vec3 _5960 = _5933 * vec3(1.0, 0.25, 0.0);
        _5903 = vec4(_5960.x, _5960.y, _5960.z, _5903.w);
        vec3 _5972 = _5903.xyz + ((vec3(_810 * _810) * 10.0) * vec3(1.0, 0.0500000007450580596923828125, 0.0));
        _5903 = vec4(_5972.x, _5972.y, _5972.z, _5903.w);
    }
    float _5975 = _947._m52;
    if (_5975 > 0.0)
    {
        vec2 _5982 = vec2(_814, _816);
        float _5986 = (SAMPLE_TEXTURE(SAMPLER_2D(_2254, _1222), _5982 * _935._m14.xy).x * 0.5) - 0.100000001490116119384765625;
        if (_5975 > _5986)
        {
            vec3 _6026 = TEXTURE_LOD(SAMPLER_2D(_5934, _1222), vec4(_5912 + vec2(_809 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).xy, vec4(_5912 + vec2(_809 * 0.100000001490116119384765625, 0.0), 0.0, 0.0).w).xyz;
            _5903 = vec4(_6026.x, _6026.y, _6026.z, _5903.w);
        }
        else
        {
            if (_5975 > (_5986 - 0.02500000037252902984619140625))
            {
                _5903 = vec4(vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).x, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).y, vec3(2.0, 0.0500000007450580596923828125, 0.0199999995529651641845703125).z, _5903.w);
            }
        }
    }
    _5903.w = _947._m51;
    float _6044 = _5903.w;
    _5903.w = _10(_6044);
    vec3 _6053 = _5903.xyz * _5903.w;
    _5903 = vec4(_6053.x, _6053.y, _6053.z, _5903.w);
}

