#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 40, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(early_fragment_tests) in;

struct _106
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    uint _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    float _m9;
    float _m10;
    float _m11;
    uint _m12;
    uvec3 _m13;
    vec3 _m14;
    vec3 _m15;
    vec4 _m16;
    vec4 _m17;
    mat3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    vec3 _m22;
    vec3 _m23;
    vec3 _m24;
    float _m25;
    uvec4 _m26;
    uvec4 _m27;
    uvec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    uvec2 _m33;
    vec2 _m34;
    float _m35;
    int _m36;
    int _m37;
    vec2 _m38;
    float _m39;
    vec3 _m40;
    int _m41;
    int _m42;
    int _m43;
    int _m44;
    float _m45;
    float _m46;
    float _m47;
};

struct _2532
{
    vec3 _m0;
    uint _m1;
    vec3 _m2;
    float _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    uint _m8;
    uint _m9;
    float _m10;
    uint _m11;
    vec3 _m12;
    float _m13;
};

struct _3460
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _677_679
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    uint _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    float _m57;
    float _m58;
    float _m59;
    float _m60;
    float _m61;
    float _m62;
    float _m63;
    uint _m64;
    float _m65[3];
} _679;

layout(set = 2, binding = 0, std140) uniform _1071_1073
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    float _m16;
    float _m17;
    float _m18;
    uint _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    uint _m24;
    uint _m25;
    uint _m26;
    uint _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    uint _m35;
    float _m36;
    float _m37;
    float _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51;
    float _m52;
    float _m53;
    float _m54;
    float _m55;
    float _m56;
    uint _m57;
    float _m58[2];
} _1073;

layout(set = 1, binding = 0, std140) uniform _1427_1429
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    float _m8;
    float _m9;
    float _m10;
    float _m11;
    float _m12;
    float _m13;
    float _m14;
    float _m15;
    float _m16;
    float _m17;
    float _m18;
    float _m19;
    float _m20;
    float _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    int _m31;
    uint _m32;
    float _m33[3];
} _1429;

layout(set = 0, binding = 17, std430) restrict readonly buffer _1897_1899
{
    uint _m0[];
} _1899;

layout(set = 0, binding = 22, std140) uniform _2537_2539
{
    vec4 _m0[4096];
} _2539;

layout(set = 0, binding = 23, std140) uniform _2613_2615
{
    vec4 _m0[4096];
} _2615;

layout(set = 0, binding = 25, std430) restrict readonly buffer _2895_2897
{
    uint _m0[];
} _2897;

layout(set = 0, binding = 27, std140) uniform _3465_3467
{
    vec4 _m0[4095];
} _3467;

layout(set = 0, binding = 1, std140) uniform _4339_4341
{
    vec4 _m0[64];
} _4341;

layout(push_constant, std430) uniform _4335_4337
{
    int _m0;
    int _m1;
} _4337;

layout(set = 0, binding = 11) uniform TEXTURE_2D _1091;
layout(set = 0, binding = 12) uniform sampler _1095;
layout(set = 0, binding = 13) uniform TEXTURE_2D _1155;
layout(set = 0, binding = 14) uniform sampler _1157;
layout(set = 0, binding = 15) uniform TEXTURE_2D _1632;
layout(set = 0, binding = 16) uniform sampler _1634;
layout(set = 0, binding = 18) uniform TEXTURE_2D _2138;
layout(set = 0, binding = 19) uniform sampler _2140;
layout(set = 0, binding = 20) uniform TEXTURE_2D _2437;
layout(set = 0, binding = 21) uniform sampler _2439;
layout(set = 0, binding = 24) uniform textureCubeArray _2868;
layout(set = 0, binding = 10) uniform sampler _2870;
layout(set = 3, binding = 0) uniform texture2D _3286[34816];
layout(set = 0, binding = 26) uniform sampler _3292;
layout(set = 0, binding = 28) uniform texture2D _3788;
layout(set = 0, binding = 29) uniform samplerShadow _3790;
layout(set = 0, binding = 7) uniform texture3D _4344;
layout(set = 0, binding = 8) uniform sampler _4345;
layout(set = 0, binding = 9) uniform texture3D _4346;

layout(location = 19, component = 0) in float _965;
layout(location = 19, component = 1) in float _967;
layout(location = 19, component = 2) in float _969;
layout(location = 19, component = 3) in float _973;
layout(location = 20, component = 0) in float _975;
layout(location = 20, component = 1) in float _977;
layout(location = 20, component = 2) in float _989;
layout(location = 10, component = 0) in vec4 _1011;
layout(location = 11, component = 0) in vec4 _1014;
layout(location = 12, component = 0) in vec4 _1017;
layout(location = 17, component = 3) in float _1020;
layout(location = 18, component = 0) in float _1022;
layout(location = 18, component = 1) in float _1039;
layout(location = 18, component = 2) in float _1041;
layout(location = 18, component = 3) in float _1043;
layout(location = 0, component = 0) in vec4 _1065;
layout(location = 0, component = 0) out vec4 _4276;
layout(location = 1, component = 0) out vec4 _4290;
layout(location = 2, component = 0) out vec4 _4317;
uint _171;
uint _173;
uint _175;
uint _177;
uint _179;
uint _181;
uint _183;
uint _184;
uint _186;
uint _187;
uint _189;
uint _191;
uint _193;
uint _195;
uint _197;
uint _199;
uint _201;
uint _203;
uint _205;

_106 _108()
{
    _106 _570;
    _570._m0 = vec3(0.0);
    _570._m2 = vec3(0.0);
    _570._m3 = 0.0;
    _570._m4 = 0u;
    _570._m5 = 0.0;
    _570._m6 = vec3(0.0);
    _570._m7 = vec3(0.0, 0.0, 1.0);
    _570._m8 = vec3(0.0, 0.0, 1.0);
    _570._m1 = vec3(0.0);
    _570._m9 = 1.0;
    _570._m10 = 1.0;
    _570._m14 = vec3(0.0);
    _570._m15 = vec3(0.0);
    _570._m16 = vec4(0.0);
    _570._m17 = vec4(0.0);
    _570._m18 = mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0));
    _570._m19 = vec3(0.0);
    _570._m20 = vec3(0.0);
    _570._m21 = vec3(0.0);
    _570._m22 = vec3(0.0);
    _570._m23 = vec3(0.0);
    _570._m24 = vec3(0.0);
    _570._m25 = 1.0;
    _570._m26 = uvec4(0u);
    _570._m27 = uvec4(0u);
    _570._m28 = uvec4(0u);
    _570._m29 = vec4(0.0);
    _570._m30 = vec4(0.0);
    _570._m31 = vec4(0.0);
    _570._m32 = vec4(0.0);
    _570._m33 = uvec2(0u);
    _570._m34 = vec2(0.0);
    _570._m35 = 0.0;
    _570._m36 = -1;
    _570._m37 = 0;
    _570._m38 = vec2(0.0);
    _570._m39 = 1.0;
    _570._m41 = -1;
    _570._m45 = 1.0;
    _570._m11 = 1.0;
    _570._m12 = 0u;
    _570._m13 = uvec3(0u);
    _570._m40 = vec3(0.0);
    _570._m46 = 0.0;
    _570._m47 = 1.0;
    return _570;
}

float _50(float _49)
{
    return _49 * _49;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec2 _120(vec2 _119)
{
    return ((_119 * 255.0) / vec2(128.0)) - vec2(1.0);
}

vec3 _125(inout vec2 _123, bool _124)
{
    vec2 _711 = _123;
    _123 = _120(_711);
    float _731 = (1.0 - (_123.x * _123.x)) - (_123.y * _123.y);
    vec3 _714 = vec3(_123.x, _123.y, sqrt(_10(_731)));
    if (_124 == false)
    {
        _714.z = -_714.z;
    }
    return _714;
}

vec3 _67(mat3 _65, vec3 _66)
{
    return _65 * _66;
}

vec3 _130(vec3 _128, mat3 _129)
{
    mat3 _747 = _129;
    vec3 _749 = _128;
    return normalize(_67(_747, _749));
}

vec3 _136(vec2 _133, mat3 _134, bool _135)
{
    vec2 _756 = _133;
    bool _758 = _135;
    vec3 _760 = _125(_756, _758);
    vec3 _755 = _760;
    vec3 _761 = _755;
    mat3 _763 = _134;
    return _130(_761, _763);
}

float _115(inout float _113, bool _114)
{
    if (_114)
    {
        _113 += (float(_113 < _679._m28) * _679._m29);
    }
    float _692 = _113;
    return _679._m0.w / (_10(_692) + _679._m0.z);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _70(float _69)
{
    return exp2(_69);
}

vec3 _100(float _97, float _98, vec3 _99)
{
    float _521 = 0.0949999988079071044921875 + (_98 * (0.60000002384185791015625 + (4.190000057220458984375 * _98)));
    float _531 = _97 + 0.02500000037252902984619140625;
    float _535 = (9.5 * _98) * _97;
    float _549 = 1.0 - (14.0 * _97);
    float _541 = (_521 * _531) * _70(_549);
    float _556 = -_535;
    float _552 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _70(_556)));
    return mix(vec3(_541), vec3(_552), _99);
}

float _153(uvec2 _151, uint _152)
{
    uvec2 _818 = _151 & uvec2(3u);
    return float(((((2068378560u * (1u - (_818.x >> uint(1)))) + (1500172770u * (_818.x >> uint(1)))) >> ((_818.y + ((_818.x & 1u) << uint(2))) << uint(2))) + _152) & 15u) / 16.0;
}

vec3 _147(vec3 _144, vec4 _145, vec4 _146)
{
    return vec3((_145.xy * _144.xy) + _145.zw, _146.z) / vec3((_146.x * _144.z) + _146.y);
}

vec3 _141(vec3 _139, vec4 _140)
{
    return vec3(vec2(0.5) + (_140.xy * (_139.xy / vec2(_139.z))), (_140.w / _139.z) + _140.z);
}

int _44(uint _43)
{
    return findLSB(_43);
}

vec4 _60(vec3 _55, vec4 _56, vec4 _57, vec4 _58, vec4 _59)
{
    return vec4((_55.x * _56.x) + ((_55.y * _56.y) + ((_55.z * _56.z) + _56.w)), (_55.x * _57.x) + ((_55.y * _57.y) + ((_55.z * _57.z) + _57.w)), (_55.x * _58.x) + ((_55.y * _58.y) + ((_55.z * _58.z) + _58.w)), (_55.x * _59.x) + ((_55.y * _59.y) + ((_55.z * _59.z) + _59.w)));
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

vec3 _47(vec3 _46)
{
    return _46 * _46;
}

uint _38(float _35, float _36, float _37)
{
    bool _241 = abs(_37) >= abs(_35);
    bool _249;
    if (_241)
    {
        _249 = abs(_37) >= abs(_36);
    }
    else
    {
        _249 = _241;
    }
    if (_249)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

float _75(float _73, float _74)
{
    return pow(_73, _74);
}

vec3 _86(vec3 _84, float _85)
{
    float _408 = dot(_84, vec3(16.666500091552734375));
    float _403 = _10(_408);
    float _417 = 1.0 - _85;
    float _420 = _10(_417);
    float _421 = 5.0;
    vec3 _425 = _84 + ((vec3(_403) - _84) * _75(_420, _421));
    return _16(_425);
}

vec3 _94(vec3 _89, vec3 _90, vec3 _91, vec3 _92, float _93)
{
    float _433 = dot(_89, _90);
    float _429 = _10(_433);
    vec3 _435 = normalize(_90 + _91);
    float _444 = dot(_89, _435);
    float _440 = _10(_444);
    float _450 = dot(_91, _435);
    float _446 = _10(_450);
    vec3 _453 = _92;
    float _455 = _446;
    vec3 _452 = _86(_453, _455);
    float _462 = dot(_89, _91);
    float _458 = _10(_462);
    float _464 = 1.0 - (_93 * 0.800000011920928955078125);
    _464 *= _464;
    _464 *= _464;
    float _475 = _464 * _464;
    float _479 = ((_440 * _440) * (_475 - 1.0)) + 1.0;
    _479 = _475 / ((_479 * _479) + 9.9999999392252902907785028219223e-09);
    float _494 = (_429 * (1.0 - _464)) + _464;
    float _501 = (_458 * (1.0 - _464)) + _464;
    _479 /= (((4.0 * _494) * _501) + 9.9999999392252902907785028219223e-09);
    return _452 * _479;
}

float _168(float _166, float _167)
{
    float _934 = _167;
    float _933 = 1.0 - _50(_934);
    float _939 = _167;
    float _938 = (1.0 + _50(_939)) + ((2.0 * _167) * (-_166));
    return _933 / ((12.56637096405029296875 * _938) * sqrt(_938));
}

vec2 _156(vec2 _155)
{
    return (vec2(1.0) - abs(_155.yx)) * vec2((_155.x >= 0.0) ? 1.0 : (-1.0), (_155.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _161(inout vec3 _159, bool _160)
{
    _159 /= vec3((abs(_159.x) + abs(_159.y)) + abs(_159.z));
    vec2 _887;
    if (_159.z >= 0.0)
    {
        _887 = _159.xy;
    }
    else
    {
        vec2 _893 = _159.xy;
        _887 = _156(_893);
    }
    _159 = vec3(_887.x, _887.y, _159.z);
    if (_160)
    {
        vec2 _907 = (_159.xy * 0.5) + vec2(0.5);
        _159 = vec3(_907.x, _907.y, _159.z);
    }
    return _159.xy;
}

float _78(float _77)
{
    return sqrt(_77);
}

float _81(float _80)
{
    return sqrt(_80);
}

float _164(float _163)
{
    float _917 = abs(_163);
    float _914 = _81(_917);
    float _921;
    if (_163 > 0.0)
    {
        _921 = _914;
    }
    else
    {
        _921 = -_914;
    }
    return (_921 * 0.5) + 0.5;
}

void main()
{
    _171 = 2147483648u;
    _173 = 1073741824u;
    _175 = 0u;
    _177 = 268435456u;
    _179 = 536870912u;
    _181 = 805306368u;
    _183 = 1073741824u;
    _184 = 1342177280u;
    _186 = 0u;
    _187 = 16777216u;
    _189 = 33554432u;
    _191 = 50331648u;
    _193 = 67108864u;
    _195 = 83886080u;
    _197 = 100663296u;
    _199 = 117440512u;
    _201 = 134217728u;
    _203 = 150994944u;
    _205 = 167772160u;
    _106 _960 = _108();
    vec3 _962 = vec3(0.0);
    vec3 _963 = vec3(0.0);
    _962 = normalize(vec3(_965, _967, _969));
    _963 = normalize(vec3(_973, _975, _977));
    vec3 _981 = _962;
    vec3 _983 = _963;
    vec3 _985 = normalize(cross(_981, _983) * _989);
    _960._m18 = mat3(vec3(_983), vec3(_985), vec3(_981));
    _960._m29 = _1011;
    _960._m30 = _1014;
    _960._m31 = _1017;
    _960._m16 = vec4(0.0, 0.0, _1020, _1022);
    _960._m17 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w);
    vec3 _1038 = vec3(_1039, _1041, _1043);
    _960._m15 = vec3(_679._m39, _679._m40, _679._m41) + _1038;
    _960._m14 = normalize(-_1038);
    _960._m16 = vec4(0.0, 0.0, _1020, _1022);
    float _1064 = exp((-(1.0 - _1065.y)) * _1073._m46);
    _960._m5 = _1064;
    _960._m0 = vec3(0.0);
    vec2 _1081 = _960._m16.zw * _1073._m41;
    vec2 _1088 = (SAMPLE_TEXTURE(SAMPLER_2D(_1091, _1095), (_1081 * 100.0) / vec2(2.0)).xy * 2.0) - vec2(1.0);
    _1088 += ((SAMPLE_TEXTURE(SAMPLER_2D(_1091, _1095), ((_1081 * 100.0) / vec2(4.0)) + (_1088 * 0.02500000037252902984619140625)).xy * 2.0) - vec2(1.0));
    _1088 += ((SAMPLE_TEXTURE(SAMPLER_2D(_1091, _1095), ((_1081 * 100.0) / vec2(8.0)) + (_1088 * 0.02500000037252902984619140625)).xy * 2.0) - vec2(1.0));
    _1088 *= _1073._m40;
    _960._m6 = vec3(_1088.x, _1088.y, _960._m6.z);
    _960._m2 = vec3(0.0500000007450580596923828125);
    float _1168 = SAMPLE_TEXTURE(SAMPLER_2D(_1155, _1157), (_1081 * _1073._m44) / vec2(16.0)).y;
    float _1171 = _50(_1168);
    float _1182 = SAMPLE_TEXTURE(SAMPLER_2D(_1155, _1157), _1081 * _1073._m44).y;
    float _1185 = _50(_1182);
    float _1189 = (5.0 * _10(_1171)) + (5.0 * _10(_1185));
    _960._m3 = _10(_1189);
    float _1192 = pow(_1065.x, _1073._m45);
    vec2 _1198 = vec2(_1073._m47, _1073._m48) * _679._m57;
    vec2 _1209 = (_1198 * 0.20000000298023223876953125) + ((_960._m16.zw * _1073._m43) * 10.0);
    vec2 _1223 = ((-_1198) * 0.100000001490116119384765625) + ((_960._m16.zw * _1073._m43) * 5.0);
    float _1274 = ((2.0 + _1192) * 0.5) * (SAMPLE_TEXTURE1(SAMPLER_2D(_1155, _1157), vec4(_1209, 0.0, 0.0).xy, vec4(_1209, 0.0, 0.0).w).y + SAMPLE_TEXTURE1(SAMPLER_2D(_1155, _1157), vec4(_1223.yx, 0.0, 0.0).xy, vec4(_1223.yx, 0.0, 0.0).w).y);
    float _1236 = _10(_1274);
    vec2 _1276 = ((_1198 * 0.25) + vec2(_1236 * 0.00999999977648258209228515625)) + ((_960._m16.zw * _1073._m43) * 25.0);
    float _1294 = SAMPLE_TEXTURE(SAMPLER_2D(_1155, _1157), _1276).y;
    float _1304 = _1294 * _1236;
    _1294 = smoothstep(0.100000001490116119384765625, 0.60000002384185791015625, _10(_1304));
    float _1314 = (_1236 * 0.00999999977648258209228515625) + ((_1236 * _1192) * 4.0);
    _1294 *= ((_10(_1314) * _1073._m42) * 20.0);
    float _1324 = _1294;
    _1294 = _10(_1324);
    vec3 _1332 = _960._m0 + vec3(_1294);
    _960._m0 = _16(_1332);
    _960._m3 *= (1.0 - _1294);
    _960._m6 = (_960._m6 * 0.5) + vec3(0.5);
    _960._m19 = vec3(0.0);
    uint _1348 = 0u;
    bool _1349 = true;
    vec2 _1351 = _960._m6.xy;
    bool _1355 = _1349;
    vec3 _1357 = _125(_1351, _1355);
    _960._m7 = _1357;
    vec2 _1359 = _960._m6.xy;
    mat3 _1363 = _960._m18;
    bool _1366 = _1349;
    _960._m6 = _136(_1359, _1363, _1366);
    uvec2 _1370 = uvec2(_960._m17.xy);
    uint _1375 = _1370.x / 256u;
    uint _1380 = _1370.y / 256u;
    float _1385 = _960._m17.z;
    bool _1388 = false;
    float _1389 = _115(_1385, _1388);
    float _1384 = _1389;
    float _1390 = log2(max(1.0, _1384 / _679._m6.z)) * _679._m6.w;
    uint _1400 = min(23u, uint(_1390));
    float _1407 = _679._m58;
    float _1413 = _679._m59;
    uint _1405 = (_21(_1407) + ((_1375 + (_21(_1413) * _1380)) * 24u)) + _1400;
    float _1430 = _1429._m30;
    uint _1425 = _21(_1430);
    _960._m21 = _960._m22;
    _960._m25 = 1.0;
    float _1438 = _679._m7.w;
    bool _1441 = _1438 < 0.0;
    _1438 = abs(_1438);
    vec3 _1446 = _960._m15;
    float _1464 = (1.0 - (length(_1446 - vec3(_679._m39, _679._m40, _679._m41)) / _1438)) / 0.25;
    float _1449 = _10(_1464);
    if ((!_1441) && (_1449 > 0.0))
    {
        vec3 _1473 = _679._m7.xyz;
        vec3 _1478 = _679._m8.xyz;
        float _1482 = _1446.z - _1478.z;
        float _1488 = _679._m9.w;
        float _1491 = _679._m10.w;
        float _1494 = float(_1491 < 0.0);
        _1491 = abs(_1491) - 1.0;
        bool _1501 = _1482 <= 0.0;
        float _1504 = 3.5 * float(!(_1491 == 0.0));
        float _1513;
        if (!(_1488 == 0.0))
        {
            _1513 = _1473.z;
        }
        else
        {
            _1513 = _1478.z;
        }
        float _1510 = _1513;
        float _1522 = min(_1501 ? 2.0 : 1000.0, abs(_1482));
        float _1529 = max(_1473.x - _1446.x, _1446.x - _1478.x);
        float _1541 = max(_1473.y - _1446.y, _1446.y - _1478.y);
        float _1553 = max(_1529, _1541) - _1522;
        _1553 = max(_1553, _1510 - _1446.z);
        _1553 = max(_1553, _1482 - _1504);
        if (_1553 <= 0.0)
        {
            float _1574 = _1501 ? _1488 : _1491;
            vec2 _1579 = _960._m18[2].xy;
            float _1583 = length(_1579);
            vec3 _1586 = vec3(_1579, (-1.73205077648162841796875) * _1583);
            _1586 /= vec3(2.0 * _1583);
            vec3 _1599 = _679._m10.xyz;
            vec3 _1603 = mix(_1586, _1599, bvec3(_1501));
            vec2 _1610 = _1446.xy - (_1603.xy * (_1482 / _1603.z));
            float _1621 = (_679._m60 / 100.0) * 16.0;
            vec2 _1627 = _1610 * _1621;
            float _1631 = TEXTURE_LOD(SAMPLER_2D(_1632, _1634), vec4(_1627, 0.0, 0.0).xy, vec4(_1627, 0.0, 0.0).w).x;
            float _1649 = min(8.0, _1478.z - _1473.z);
            float _1661 = (-_1482) / _1649;
            float _1656 = _10(_1661);
            float _1668 = dot(_960._m6, _1603);
            float _1663 = _10(_1668);
            float _1674 = _1529 / _1522;
            float _1670 = 1.0 - _10(_1674);
            float _1680 = _1541 / _1522;
            _1670 *= (1.0 - _10(_1680));
            _1670 *= _1670;
            float _1696 = min(_1482 / 1.0, 1.0 - (_1482 / _1504));
            float _1688 = _10(_1696);
            _1670 *= max(_1688, _1656);
            _1670 *= _1670;
            _1670 *= _1449;
            float _1709 = _1631 - 1.0;
            float _1712 = float(_1501) * _1494;
            float _1717 = max(0.0, _1631 - 0.85000002384185791015625);
            float _1722 = _1501 ? _1709 : _1717;
            float _1727 = (((1.0 - _1712) * _1663) * _1670) * _1574;
            vec3 _1736 = _960._m0 + (_960._m2 * (vec3(1.0) - _960._m0));
            _960._m21 += ((_1736 * (_1722 * _1727)) * _679._m9.xyz);
            float _1760 = _1712 * _1670;
            _960._m25 = 1.0 + (_1760 * (_1631 - 1.0));
        }
    }
    else
    {
        if (_1449 > 0.0)
        {
            _1449 *= _679._m61;
            float _1780 = float(_679._m10.w < 0.0);
            vec3 _1785 = _679._m10.xyz;
            float _1794 = dot(_960._m6, _1785);
            float _1789 = _10(_1794);
            vec2 _1796 = _1446.xy - (_1785.xy * (_1446.z / _1785.z));
            float _1808 = (_679._m60 / 100.0) * 16.0;
            vec2 _1813 = _1796 * _1808;
            float _1817 = TEXTURE_LOD(SAMPLER_2D(_1632, _1634), vec4(_1813, 0.0, 0.0).xy, vec4(_1813, 0.0, 0.0).w).x;
            vec4 _1833 = _679._m9;
            _960._m21 += (_1833.xyz * (((((1.0 - _1780) * (_1817 - 1.0)) * _1789) * _1449) * _1833.w));
            _960._m25 = 1.0 + ((_1780 * (_1817 - 1.0)) * _1449);
        }
    }
    _960._m14 = normalize(vec3(_679._m39, _679._m40, _679._m41) - _960._m15);
    vec3 _1875 = vec3(0.0);
    _960._m21 += _1875;
    bool _1881 = true;
    _1881 = (((_679._m64 & 1u) != 0u) == true) ? false : true;
    if (true && (_1881 == true))
    {
        uint _1895 = _1899._m0[_1405 * 64u];
        uint _1906 = _1895 & 255u;
        uint _1910 = _1906;
        uint _1912 = _1895;
        uint _1914 = _1405;
        float _1916 = _960._m47;
        float _1925 = dot(_960._m14, _960._m6);
        float _1919 = _10(_1925);
        float _1927 = _1919;
        float _1929 = _960._m3;
        vec3 _1932 = _960._m2;
        _960._m24 = (_100(_1927, _1929, _1932) * _960._m11) * _960._m39;
        float _1943 = _679._m11.x;
        float _1946 = _679._m11.z;
        bool _1950 = _1943 > 0.0;
        bool _1957;
        if (_1950)
        {
            _1957 = _960._m3 > _1946;
        }
        else
        {
            _1957 = _1950;
        }
        if (_1957)
        {
            float _1960 = 0.0;
            vec3 _1961 = normalize(reflect(-_960._m14, _960._m6));
            if (dot(_960._m14, _1961) <= _1960)
            {
                vec2 _1977 = vec2(1.0);
                uvec2 _1991 = uvec2(_960._m17.xy * (vec2(1.0) / _1977));
                uint _1992 = uint(_679._m11.w);
                float _1979 = _153(_1991, _1992);
                _1979 -= 1.0;
                vec2 _1996 = _960._m17.xy * _679._m12.xy;
                vec3 _2011 = vec3(_1996, _960._m17.z);
                vec4 _2012 = _679._m13;
                vec4 _2015 = _679._m14;
                vec3 _2004 = _147(_2011, _2012, _2015);
                mat3 _2019 = mat3(vec3(_679._m15.xyz), vec3(_679._m16.xyz), vec3(_679._m17.xyz));
                mat3 _2043 = _2019;
                vec3 _2045 = _1961;
                vec3 _2042 = normalize(_67(_2043, _2045));
                float _2049 = 0.100000001490116119384765625;
                uint _2050 = uint((_1943 == 1.0) ? 8 : 12);
                _2050 = (_1943 == 3.0) ? 16u : _2050;
                vec3 _2061 = _2004;
                float _2066 = _960._m17.z;
                bool _2069 = true;
                float _2070 = _115(_2066, _2069);
                vec3 _2063 = _2061 + (_2042 * _2070);
                vec4 _2073 = vec4(0.0);
                vec3 _2075 = _2061;
                vec4 _2077 = _679._m18;
                vec3 _2074 = _141(_2075, _2077);
                vec3 _2082 = _2063;
                vec4 _2084 = _679._m18;
                vec3 _2081 = _141(_2082, _2084);
                vec3 _2088 = ((_2081 - _2074) * (_2049 / float(_2050))) / vec3(length(_2081.xy - _2074.xy));
                vec3 _2105 = _2074 + (_2088 * _1979);
                float _2111 = abs(_2088.z) * 1.0;
                uint _2116 = 0u;
                vec3 _2117 = _2105;
                float _2119 = _2074.z;
                float _2306;
                for (uint _2122 = 0u; _2122 < _2050; _2122 += 4u)
                {
                    vec4 _2131 = vec4(1.0, 2.0, 3.0, 4.0) + vec4(float(_2122));
                    vec4 _2137 = vec4(1.0) - vec4(TEXTURE_LOD(SAMPLER_2D(_2138, _2140), vec4(_2105.xy + (_2088.xy * _2131.x), 0.0, 0.0).xy, vec4(_2105.xy + (_2088.xy * _2131.x), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_2138, _2140), vec4(_2105.xy + (_2088.xy * _2131.y), 0.0, 0.0).xy, vec4(_2105.xy + (_2088.xy * _2131.y), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_2138, _2140), vec4(_2105.xy + (_2088.xy * _2131.z), 0.0, 0.0).xy, vec4(_2105.xy + (_2088.xy * _2131.z), 0.0, 0.0).w).x, TEXTURE_LOD(SAMPLER_2D(_2138, _2140), vec4(_2105.xy + (_2088.xy * _2131.w), 0.0, 0.0).xy, vec4(_2105.xy + (_2088.xy * _2131.w), 0.0, 0.0).w).x);
                    uvec4 _2259 = mix(uvec4(0u), uvec4(1u), lessThan(abs(((_2105.zzzz + (_2088.zzzz * _2131)) - _2137) - vec4(_2111)), vec4(_2111)));
                    uint _2279 = (((_2259.x << uint(0)) | (_2259.y << uint(1))) | (_2259.z << uint(2))) | (_2259.w << uint(3));
                    if (_2279 > 0u)
                    {
                        uint _2300 = _2279;
                        uint _2299 = uint(_44(_2300));
                        if (_2299 > 0u)
                        {
                            _2306 = _2137[_2299 - 1u];
                        }
                        else
                        {
                            _2306 = _2119;
                        }
                        _2119 = _2306;
                        _2117 = _2105 + (_2088 * float((_2122 + _2299) + 1u));
                        float _2325 = _2137[_2299] - _2117.z;
                        float _2332 = (_2119 - _2117.z) + _2088.z;
                        float _2346 = _2325 / (_2325 - _2332);
                        float _2340 = _10(_2346);
                        vec3 _2348 = _2117 - _2088;
                        _2117 = (_2348 * _2340) + (_2117 * (1.0 - _2340));
                        _2116 = _2122 + _2299;
                        break;
                    }
                    _2119 = _2137.w;
                }
                if (_2116 > 0u)
                {
                    vec3 _2374 = _2117;
                    vec4 _2376 = _679._m19;
                    vec4 _2379 = _679._m20;
                    vec4 _2382 = _679._m21;
                    vec4 _2385 = _679._m22;
                    vec3 _2373 = _60(_2374, _2376, _2379, _2382, _2385).xyw;
                    vec2 _2395 = _2373.xy / vec2(_2373.z);
                    _2373 = vec3(_2395.x, _2395.y, _2373.z);
                    vec2 _2398 = (_2373.xy * 2.0) - vec2(1.0);
                    float _2412 = (1.0 - (float(_2116) / float(_2050))) * 4.0;
                    float _2404 = _10(_2412);
                    if (false)
                    {
                        float _2416 = _2398.y;
                        float _2421 = 1.0 - _50(_2416);
                        _2404 *= smoothstep(0.0, 0.25, _10(_2421));
                    }
                    else
                    {
                        float _2431 = 1.0 - dot(_2398, _2398);
                        _2404 *= smoothstep(0.0, 0.5, _10(_2431));
                    }
                    vec3 _2436 = TEXTURE_LOD(SAMPLER_2D(_2437, _2439), vec4(_2373.xy, 0.0, 0.0).xy, vec4(_2373.xy, 0.0, 0.0).w).xyz;
                    _2073 = vec4(_2436, _2404);
                }
                float _2470 = 1.0 - ((1.0 - _960._m3) / (1.0 - _1946));
                float _2462 = _10(_2470);
                float _2472 = (_2073.w * _2462) * _679._m62;
                _960._m21 += ((_2073.xyz * _2472) * _960._m24);
                _1916 = 1.0 - _2472;
            }
        }
        uint _2494 = 1u;
        _2532 _2534;
        while (_2494 <= _1910)
        {
            uint _2503 = (_1914 * 64u) + _2494;
            uint _2508 = _1899._m0[_2503];
            uint _2512 = _2508;
            if (_2512 >= _2508)
            {
                _2494++;
            }
            float _2521 = 0.0039215688593685626983642578125;
            if (_1916 <= (_2521 * 4.0))
            {
                break;
            }
            int _2530 = 4;
            int _2531 = 4;
            _2534._m0 = _2539._m0[(uint(_2530) * _2512) + 0u].xyz;
            float _2554 = _2539._m0[(uint(_2530) * _2512) + 0u].w;
            _2534._m1 = _21(_2554);
            _2534._m2 = _2539._m0[(uint(_2530) * _2512) + 1u].xyz;
            _2534._m3 = _2539._m0[(uint(_2530) * _2512) + 1u].w;
            _2534._m4 = _2539._m0[(uint(_2530) * _2512) + 2u];
            float _2589 = _2539._m0[(uint(_2530) * _2512) + 3u].x;
            _2534._m8 = _21(_2589);
            float _2599 = _2539._m0[(uint(_2530) * _2512) + 3u].y;
            _2534._m9 = _21(_2599);
            _2534._m10 = _2539._m0[(uint(_2530) * _2512) + 3u].z;
            _2534._m5 = _2615._m0[(uint(_2531) * _2512) + 0u];
            _2534._m6 = _2615._m0[(uint(_2531) * _2512) + 1u];
            _2534._m7 = _2615._m0[(uint(_2531) * _2512) + 2u];
            _2534._m12 = _2615._m0[(uint(_2531) * _2512) + 3u].xyz;
            _2534._m13 = _2615._m0[(uint(_2531) * _2512) + 3u].w;
            vec3 _2657 = vec3(dot(_960._m15, _2534._m5.xyz) + _2534._m5.w, dot(_960._m15, _2534._m6.xyz) + _2534._m6.w, dot(_960._m15, _2534._m4.xyz) + _2534._m4.w);
            float _2686 = _2657.x;
            float _2689 = _2657.y;
            float _2692 = _2657.z;
            bool _2697 = _32(_2686, _2689, _2692) <= _2521;
            bool _2714;
            if (!_2697)
            {
                float _2701 = _2657.x;
                float _2704 = _2657.y;
                float _2707 = _2657.z;
                _2714 = _27(_2701, _2704, _2707) >= (1.0 - _2521);
            }
            else
            {
                _2714 = _2697;
            }
            if (_2714)
            {
                continue;
            }
            uint _2718 = _2534._m1;
            vec3 _2721 = _2534._m0;
            float _2724 = float(bitfieldExtract(_2534._m8, 20, 12));
            float _2729 = 0.800000011920928955078125;
            vec3 _2730 = (_2657 * 2.0) - vec3(1.0);
            vec3 _2736 = _2730;
            vec3 _2735 = _47(_2736);
            vec3 _2739 = _2730 * sqrt(((vec3(1.0) - (_2735.yzx * 0.5)) - (_2735.zxy * 0.5)) + ((_2735.yzx * _2735.zxy) / vec3(3.0)));
            float _2770 = 1.0 - ((length(_2739) - _2729) / ((1.0 - _2729) + 9.9999999747524270787835121154785e-07));
            float _2759 = _10(_2770);
            _2759 *= _2759;
            _2759 *= _1916;
            float _2778 = _2534._m7.w;
            _2759 *= _2778;
            _1916 *= (1.0 - _2759);
            vec3 _2788 = _2534._m12;
            float _2791 = _2534._m13;
            float _2796 = _2759;
            vec3 _2794 = _2788 * (_10(_2796) * _2791);
            vec3 _2802 = _2534._m2;
            vec3 _2805 = _2534._m7.xyz;
            vec3 _2809 = vec3(0.0);
            vec3 _2810 = reflect(-_960._m14, _960._m6);
            vec3 _2817 = (_2805 - _960._m15) / _2810;
            vec3 _2824 = (_2802 - _960._m15) / _2810;
            vec3 _2831 = max(_2817, _2824);
            float _2836 = _2831.x;
            float _2839 = _2831.y;
            float _2842 = _2831.z;
            float _2835 = _32(_2836, _2839, _2842);
            vec3 _2846 = _960._m15 + (_2810 * _2835);
            vec3 _2853 = _2846 - _2721;
            float _2857 = 6.0;
            float _2859 = _2857 - (_2857 * _960._m3);
            _2809 = textureLod(samplerCubeArray(_2868, _2870), vec4(_2853, _2724), _2859).xyz;
            _960._m21 += ((_2809 * _2794) * _960._m24);
        }
    }
    uint _2893 = _2897._m0[_1405 * 64u];
    uint _2902 = _2893 & 255u;
    uint _2905 = _2902;
    uint _2907 = _2893;
    uint _2909 = _1405;
    uint _2911 = 1u;
    _2532 _2940;
    vec3 _3068;
    float _3190;
    vec2 _3258;
    _3460 _3462;
    _3460 _3609;
    while (_2911 <= _2905)
    {
        uint _2920 = (_2909 * 64u) + _2911;
        uint _2925 = _2897._m0[_2920];
        uint _2929 = _2925;
        if (_2929 >= _2925)
        {
            _2911++;
        }
        int _2938 = 4;
        int _2939 = 4;
        _2940._m0 = _2539._m0[(uint(_2938) * _2929) + 0u].xyz;
        float _2955 = _2539._m0[(uint(_2938) * _2929) + 0u].w;
        _2940._m1 = _21(_2955);
        _2940._m2 = _2539._m0[(uint(_2938) * _2929) + 1u].xyz;
        _2940._m3 = _2539._m0[(uint(_2938) * _2929) + 1u].w;
        _2940._m4 = _2539._m0[(uint(_2938) * _2929) + 2u];
        float _2990 = _2539._m0[(uint(_2938) * _2929) + 3u].x;
        _2940._m8 = _21(_2990);
        float _3000 = _2539._m0[(uint(_2938) * _2929) + 3u].y;
        _2940._m9 = _21(_3000);
        _2940._m10 = _2539._m0[(uint(_2938) * _2929) + 3u].z;
        _2940._m5 = _2615._m0[(uint(_2939) * _2929) + 0u];
        _2940._m6 = _2615._m0[(uint(_2939) * _2929) + 1u];
        _2940._m7 = _2615._m0[(uint(_2939) * _2929) + 2u];
        _2940._m12 = _2615._m0[(uint(_2939) * _2929) + 3u].xyz;
        _2940._m13 = _2615._m0[(uint(_2939) * _2929) + 3u].w;
        float _3054 = 0.0;
        uint _3055 = _2940._m1;
        vec3 _3058 = _2940._m0;
        vec3 _3061 = _3058;
        if ((_3055 & 7u) == 2u)
        {
            _3068 = _3061;
        }
        else
        {
            _3068 = normalize(_3058 - _960._m15);
        }
        vec3 _3063 = _3068;
        uint _3079 = uint(((_1425 & 3u) != 0u) ? 16 : 0);
        _3079 |= 32u;
        if ((_3055 & _3079) != 0u)
        {
            continue;
        }
        vec3 _3095 = vec3(dot(_960._m15, _2940._m5.xyz) + _2940._m5.w, dot(_960._m15, _2940._m6.xyz) + _2940._m6.w, dot(_960._m15, _2940._m7.xyz) + _2940._m7.w);
        vec2 _3129 = _3095.xy / vec2(_3095.z);
        _3095 = vec3(_3129.x, _3129.y, _3095.z);
        _3095.z = dot(_960._m15, _2940._m4.xyz) + _2940._m4.w;
        float _3142 = _3095.x;
        float _3145 = _3095.y;
        float _3148 = _3095.z;
        bool _3153 = _32(_3142, _3145, _3148) <= _3054;
        bool _3170;
        if (!_3153)
        {
            float _3157 = _3095.x;
            float _3160 = _3095.y;
            float _3163 = _3095.z;
            _3170 = _27(_3157, _3160, _3163) >= (1.0 - _3054);
        }
        else
        {
            _3170 = _3153;
        }
        if (_3170)
        {
            continue;
        }
        vec3 _3174 = vec3(1.0);
        uint _3175 = _3055 & 7u;
        vec3 _3178 = _2940._m0 - _960._m15;
        float _3184 = dot(_3178, _3178);
        if (_3175 != 2u)
        {
            _3190 = 1.0 / (1.0 + _3184);
        }
        else
        {
            _3190 = _960._m25;
        }
        _3174 = vec3(_3190);
        if (_3175 == 0u)
        {
            float _3210 = _3184 * _2940._m3;
            float _3213 = 1.0 - _50(_3210);
            float _3215 = _10(_3213);
            float _3205 = _50(_3215);
            _3174 *= _3205;
        }
        else
        {
            if (_3175 == 4u)
            {
                float _3231 = length((_3095.xy - vec2(0.5)) * 2.0);
                float _3225 = _10(_3231);
                float _3233 = 0.980000019073486328125 - (1.0 / (1.0 + exp(3.7999999523162841796875 - (_3225 * 7.80000019073486328125))));
                _3174 *= _3233;
            }
            else
            {
                if ((_3175 == 1u) || (_3175 == 2u))
                {
                    if (_3175 == 2u)
                    {
                        _3258 = fract((_3095.xy * _679._m23.xy) + _679._m23.zw);
                    }
                    else
                    {
                        _3258 = _3095.xy;
                    }
                    vec2 _3255 = _3258;
                    vec3 _3276 = vec3(0.0);
                    uint _3277 = bitfieldExtract(_2940._m8, 0, 20);
                    uint _3281 = _3277;
                    uint _3289 = _3281 + 0u;
                    vec3 _3306 = textureLod(sampler2D(_3286[nonuniformEXT(_3289)], _3292), vec4(_3255, 0.0, 0.0).xy, vec4(_3255, 0.0, 0.0).w).xyz;
                    _3276 = _47(_3306);
                    _3174 *= _3276;
                }
            }
        }
        float _3312 = float((_3055 >> uint(8)) & 255u) / 255.0;
        if ((_3175 == 0u) || (_3175 == 2u))
        {
            vec3 _3325 = abs((_3095 * 2.0) - vec3(1.0));
            float _3331 = _3325.x;
            float _3334 = _3325.y;
            float _3337 = _3325.z;
            float _3342 = 1.0 - _27(_3331, _3334, _3337);
            float _3347 = _10(_3342) / (9.9999999392252902907785028219223e-09 + _3312);
            float _3330 = _10(_3347);
            _3174 *= ((_3330 * _3330) * (3.0 - (2.0 * _3330)));
        }
        else
        {
            if ((_3175 == 1u) || (_3175 == 4u))
            {
                float _3367 = _3095.z;
                float _3371 = _50(_3367);
                float _3374 = 1.0 - _50(_3371);
                float _3376 = _10(_3374);
                float _3381 = _50(_3376) / (9.9999999392252902907785028219223e-09 + _3312);
                float _3366 = _10(_3381);
                _3174 *= _3366;
            }
        }
        float _3386 = _3174.x;
        float _3389 = _3174.y;
        float _3392 = _3174.z;
        if (_27(_3386, _3389, _3392) <= _3054)
        {
            continue;
        }
        float _3401 = 1.0;
        if ((_3055 & 8u) != 0u)
        {
            float _3408 = 0.00999999977648258209228515625;
            vec3 _3409 = _960._m15 + (_960._m6 * _3408);
            uint _3417 = 0u;
            if ((_3055 & 7u) == 0u)
            {
                vec3 _3423 = _3409 - _2940._m2;
                float _3428 = _3423.x;
                float _3431 = _3423.y;
                float _3434 = _3423.z;
                _3417 = _38(_3428, _3431, _3434);
            }
            else
            {
                if ((_3055 & 7u) == 2u)
                {
                    float _3444 = 0.0;
                    uint _3445 = uint((_679._m24.w > 0.0) ? 3 : 4);
                    for (; _3417 < _3445; _3417++)
                    {
                        int _3459 = 5;
                        _3462._m0 = _3467._m0[(uint(_3459) * ((_3055 >> uint(22)) + _3417)) + 0u];
                        _3462._m1 = _3467._m0[(uint(_3459) * ((_3055 >> uint(22)) + _3417)) + 1u];
                        _3462._m2 = _3467._m0[(uint(_3459) * ((_3055 >> uint(22)) + _3417)) + 2u];
                        _3462._m3 = _3467._m0[(uint(_3459) * ((_3055 >> uint(22)) + _3417)) + 3u];
                        _3462._m4 = _3467._m0[(uint(_3459) * ((_3055 >> uint(22)) + _3417)) + 4u];
                        vec2 _3523 = vec2(dot(_3409, _3462._m0.xyz) + _3462._m0.w, dot(_3409, _3462._m1.xyz) + _3462._m1.w);
                        _3523 = abs((_3523 * 2.0) - vec2(1.0));
                        bool _3549 = _3523.x < 0.9900000095367431640625;
                        bool _3555;
                        if (_3549)
                        {
                            _3555 = _3523.y < 0.9900000095367431640625;
                        }
                        else
                        {
                            _3555 = _3549;
                        }
                        if (_3555)
                        {
                            _3444 = (1.0 - max(_3523.x, _3523.y)) * _679._m25.w;
                            break;
                        }
                    }
                    _960._m36 = int(_3417);
                    _3417 = min((_3445 - 1u), _3417);
                    if (_679._m24.w > 0.0)
                    {
                        uint _3582 = uint(_960._m17.x) ^ (uint(_960._m17.y) << uint(1));
                        _3582 ^= uint(_679._m26.x);
                        _3417 += uint(int(((float(_3582 & 3u) * 0.25) + 0.125) > _3444));
                    }
                }
            }
            int _3608 = 5;
            _3609._m0 = _3467._m0[(uint(_3608) * ((_3055 >> uint(22)) + _3417)) + 0u];
            _3609._m1 = _3467._m0[(uint(_3608) * ((_3055 >> uint(22)) + _3417)) + 1u];
            _3609._m2 = _3467._m0[(uint(_3608) * ((_3055 >> uint(22)) + _3417)) + 2u];
            _3609._m3 = _3467._m0[(uint(_3608) * ((_3055 >> uint(22)) + _3417)) + 3u];
            _3609._m4 = _3467._m0[(uint(_3608) * ((_3055 >> uint(22)) + _3417)) + 4u];
            vec4 _3665 = vec4((_3409.x * _3609._m0.x) + ((_3409.y * _3609._m0.y) + ((_3409.z * _3609._m0.z) + _3609._m0.w)), (_3409.x * _3609._m1.x) + ((_3409.y * _3609._m1.y) + ((_3409.z * _3609._m1.z) + _3609._m1.w)), (_3409.x * _3609._m2.x) + ((_3409.y * _3609._m2.y) + ((_3409.z * _3609._m2.z) + _3609._m2.w)), (_3409.x * _3609._m3.x) + ((_3409.y * _3609._m3.y) + ((_3409.z * _3609._m3.z) + _3609._m3.w)));
            vec3 _3752 = _3665.xyz / vec3(_3665.w);
            _3665 = vec4(_3752.x, _3752.y, _3752.z, _3665.w);
            bool _3760 = min(_3665.x, _3665.y) > 0.0;
            bool _3769;
            if (_3760)
            {
                _3769 = max(_3665.x, _3665.y) < 1.0;
            }
            else
            {
                _3769 = _3760;
            }
            if (_3769)
            {
                vec2 _3781 = (_3665.xy * _3609._m4.xy) + _3609._m4.zw;
                _3665 = vec4(_3781.x, _3781.y, _3665.z, _3665.w);
                if (false)
                {
                    _3401 = textureLod(sampler2DShadow(_3788, _3790), vec3(_3665.xyz.xy, _3665.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3799 = (_3665.xy * _679._m27.xy) + vec2(0.5);
                    vec2 _3808 = floor(_3799);
                    vec2 _3811 = _3799 - _3808;
                    _3808 -= vec2(0.5);
                    vec2 _3818 = vec2(4.0) - (_3811 * 3.0);
                    vec2 _3823 = vec2(7.0);
                    vec2 _3826 = vec2(1.0) + (_3811 * 3.0);
                    vec2 _3831 = (_3808 + (((vec2(3.0) - (_3811 * 2.0)) / _3818) - vec2(2.0))) * _679._m27.zw;
                    vec2 _3846 = (_3808 + ((vec2(3.0) + _3811) / _3823)) * _679._m27.zw;
                    vec2 _3858 = (_3808 + ((_3811 / _3826) + vec2(2.0))) * _679._m27.zw;
                    vec3 _3884 = vec3(_3831.x, _3831.y, _3665.z);
                    _3401 = (_3818.x * _3818.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_3884.xy, _3884.z), 0.0);
                    vec3 _3902 = vec3(_3846.x, _3831.y, _3665.z);
                    _3401 += ((_3823.x * _3818.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_3902.xy, _3902.z), 0.0));
                    vec3 _3922 = vec3(_3858.x, _3831.y, _3665.z);
                    _3401 += ((_3826.x * _3818.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_3922.xy, _3922.z), 0.0));
                    vec3 _3942 = vec3(_3831.x, _3846.y, _3665.z);
                    _3401 += ((_3818.x * _3823.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_3942.xy, _3942.z), 0.0));
                    vec3 _3962 = vec3(_3846.x, _3846.y, _3665.z);
                    _3401 += ((_3823.x * _3823.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_3962.xy, _3962.z), 0.0));
                    vec3 _3982 = vec3(_3858.x, _3846.y, _3665.z);
                    _3401 += ((_3826.x * _3823.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_3982.xy, _3982.z), 0.0));
                    vec3 _4002 = vec3(_3831.x, _3858.y, _3665.z);
                    _3401 += ((_3818.x * _3826.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_4002.xy, _4002.z), 0.0));
                    vec3 _4022 = vec3(_3846.x, _3858.y, _3665.z);
                    _3401 += ((_3823.x * _3826.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_4022.xy, _4022.z), 0.0));
                    vec3 _4042 = vec3(_3858.x, _3858.y, _3665.z);
                    _3401 += ((_3826.x * _3826.y) * textureLod(sampler2DShadow(_3788, _3790), vec3(_4042.xy, _4042.z), 0.0));
                    _3401 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3401 = float((_3055 & 7u) == 2u);
                if ((_3055 & 7u) == 2u)
                {
                    _960._m36 = -1;
                }
            }
            float _4062 = float((_3055 >> uint(16)) & 63u) / 63.0;
            float _4076 = ((_3401 * _4062) + 1.0) - _4062;
            _3401 = _10(_4076);
        }
        if (_3401 <= _3054)
        {
            continue;
        }
        vec3 _4084 = (_2940._m12 * _3401) * _3174;
        float _4091 = _2940._m13;
        vec3 _4094 = _4084;
        float _4101 = dot(_960._m6, _3063);
        float _4096 = _10(_4101);
        vec3 _4103 = _4094;
        vec3 _4106 = _960._m6;
        vec3 _4109 = _960._m14;
        vec3 _4112 = _3063;
        vec3 _4114 = _960._m2;
        float _4117 = _960._m3;
        vec3 _4105 = _94(_4106, _4109, _4112, _4114, _4117);
        _960._m21 += (((_4105 * _4091) * _4094) * _4096);
        _960._m21 += ((_4103 * _4096) * _960._m0);
        float _4142 = _960._m5;
        float _4145 = -dot(normalize(_960._m6 + _960._m14), _3063);
        float _4166 = _4145;
        float _4168 = _1073._m39;
        _960._m21 += (((vec3(_1073._m36, _1073._m37, _1073._m38) * _4142) * _4103) * _168(_4166, _4168));
    }
    _960._m21 *= _960._m11;
    vec3 _4183 = vec3(0.0);
    vec3 _4184 = vec3(0.0);
    vec3 _4185 = vec3(0.0);
    vec3 _4186 = vec3(0.0);
    vec4 _4187 = _960._m29;
    vec4 _4190 = _960._m30;
    vec4 _4193 = _960._m31;
    _4183 = vec3(_4187.x, _4187.y, _4187.z);
    _4184 = vec3(_4187.w, _4190.x, _4190.y);
    _4185 = vec3(_4190.z, _4190.w, _4193.x);
    _4186 = vec3(_4193.y, _4193.z, _4193.w);
    vec3 _4224 = ((_4183 - (_4184 * _960._m6.y)) + (_4185 * _960._m6.z)) - (_4186 * _960._m6.x);
    float _4248 = _1429._m21 * _679._m63;
    _4224 = max(vec3(0.0), _4224 * _10(_4248));
    _960._m21 += (_4224 * _960._m0);
    _960._m21 += ((_4224 * _1064) * vec3(_1073._m36, _1073._m37, _1073._m38));
    _4276 = vec4(_960._m21, 0.0);
    if (((_679._m64 & 1u) != 0u) == true)
    {
        vec3 _4291 = _960._m6;
        bool _4294 = false;
        vec2 _4295 = _161(_4291, _4294);
        _4290 = vec4(_4295, 0.0, 0.0);
        float _4305 = dot(_960._m14, _960._m6);
        float _4299 = _10(_4305);
        float _4308 = _4299;
        float _4310 = _960._m3;
        vec3 _4313 = _960._m2;
        vec3 _4307 = _100(_4308, _4310, _4313);
        float _4318 = _4307.x;
        float _4322 = _4307.y;
        float _4326 = _4307.z;
        float _4330 = _960._m3;
        _4317 = vec4(_78(_4318), _78(_4322), _78(_4326), _164(_4330));
    }
}

