#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _293_295
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    float _m20;
    float _m21;
    float _m22;
    float _m23;
    float _m24;
    float _m25;
    float _m26;
    float _m27;
    float _m28;
    float _m29;
    float _m30;
    float _m31;
    float _m32;
    float _m33;
    float _m34;
    float _m35;
    float _m36;
    float _m37;
    uint _m38;
    float _m39;
    float _m40;
    float _m41;
    float _m42;
    float _m43;
    float _m44;
    float _m45;
    float _m46;
    float _m47;
    float _m48;
    float _m49;
    float _m50;
    float _m51[1];
} _295;

layout(set = 2, binding = 0, std140) uniform _366_368
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    uint _m5;
    float _m6;
    float _m7[2];
} _368;

layout(set = 1, binding = 0, std140) uniform _388_390
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    float _m8;
    float _m9;
    int _m10;
    float _m11;
    float _m12;
    uint _m13;
    float _m14[2];
} _390;

layout(set = 0, binding = 1, std140) uniform _800_802
{
    vec4 _m0[64];
} _802;

layout(push_constant, std430) uniform _779_781
{
    int _m0;
} _781;

layout(set = 3, binding = 0) uniform TEXTURE_2D _364[34816];
layout(set = 0, binding = 3) uniform sampler _378;
layout(set = 0, binding = 4) uniform texture3D _565;
layout(set = 0, binding = 5) uniform sampler _567;
layout(set = 0, binding = 6) uniform texture3D _586;
layout(set = 0, binding = 7) uniform texture3D _686;
layout(set = 0, binding = 8) uniform sampler _688;

layout(location = 2, component = 0) in vec4 _383;
layout(location = 0, component = 0) in vec4 _400;
layout(location = 3, component = 0) in vec4 _404;
layout(location = 0, component = 0) out vec4 _466;
uint _71;
uint _73;
uint _75;
uint _77;
uint _79;
uint _81;
uint _83;
uint _84;
uint _86;
uint _87;
uint _89;
uint _91;
uint _93;
uint _95;
uint _97;
uint _99;
uint _101;
uint _103;
uint _105;

float _31(float _30)
{
    float _131;
    if (_30 <= 0.040449999272823333740234375)
    {
        _131 = _30 / 12.9200000762939453125;
    }
    else
    {
        _131 = pow((_30 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
    return _131;
}

vec3 _34(vec3 _33)
{
    float _148 = _33.x;
    float _152 = _33.y;
    float _157 = _33.z;
    return vec3(_31(_148), _31(_152), _31(_157));
}

vec4 _38(vec4 _37)
{
    vec3 _165 = _37.xyz;
    return vec4(_34(_165), _37.w);
}

float _23(vec4 _21, vec4 _22)
{
    return dot(_21, _22);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _63(inout float _61, bool _62)
{
    if (_62)
    {
        _61 += (float(_61 < _295._m20) * _295._m21);
    }
    float _312 = _61;
    return _295._m0.w / (_10(_312) + _295._m0.z);
}

uint _28(float _27)
{
    return floatBitsToUint(_27);
}

vec3 _68(vec2 _67)
{
    return (vec3(_295._m22, _295._m23, _295._m24) + (vec3(_295._m25, _295._m26, _295._m27) * _67.x)) + (vec3(_295._m28, _295._m29, _295._m30) * _67.y);
}

float _41(float _40)
{
    float _178 = (((-0.15658299624919891357421875) * abs(_40)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_40));
    float _192;
    if (_40 >= 0.0)
    {
        _192 = _178;
    }
    else
    {
        _192 = 3.1415927410125732421875 - _178;
    }
    return _192;
}

float _44(float _43)
{
    float _206;
    if (_43 < 1.0)
    {
        _206 = _43;
    }
    else
    {
        _206 = 1.0 / _43;
    }
    float _203 = _206;
    float _214 = _203 * _203;
    float _218 = 0.087292902171611785888671875;
    _218 = (-0.3018949925899505615234375) + (_218 * _214);
    _218 = 1.0 + (_218 * _214);
    _218 *= _203;
    float _234;
    if (_43 < 1.0)
    {
        _234 = _218;
    }
    else
    {
        _234 = 1.57079637050628662109375 - _218;
    }
    return _234;
}

float _47(float _46)
{
    float _247 = abs(_46);
    float _244 = _44(_247);
    float _251;
    if (_46 < 0.0)
    {
        _251 = -_244;
    }
    else
    {
        _251 = _244;
    }
    return _251;
}

float _52(float _50, float _51)
{
    float _265 = _50 / _51;
    float _261 = _47(_265);
    if (_51 < 0.0)
    {
        _261 += ((_50 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _261;
}

float _56(vec3 _55)
{
    return dot(_55, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

void main()
{
    _71 = 2147483648u;
    _73 = 1073741824u;
    _75 = 0u;
    _77 = 268435456u;
    _79 = 536870912u;
    _81 = 805306368u;
    _83 = 1073741824u;
    _84 = 1342177280u;
    _86 = 0u;
    _87 = 16777216u;
    _89 = 33554432u;
    _91 = 50331648u;
    _93 = 67108864u;
    _95 = 83886080u;
    _97 = 100663296u;
    _99 = 117440512u;
    _101 = 134217728u;
    _103 = 150994944u;
    _105 = 167772160u;
    vec4 _359 = SAMPLE_TEXTURE(SAMPLER_2D(_364[_368._m5], _378), _383.xy);
    if (_390._m11 > 0.0)
    {
        vec4 _397 = _359;
        _359 = _38(_397);
    }
    _359 *= _400;
    _359 += _404;
    float _413;
    if (abs(_359.w) <= 0.0039215688593685626983642578125)
    {
        _413 = 0.0;
    }
    else
    {
        _413 = _359.w;
    }
    _359.w = _413;
    vec4 _421 = _368._m0;
    vec4 _425 = _359;
    vec4 _429 = _368._m1;
    vec4 _432 = _359;
    vec4 _436 = _368._m2;
    vec4 _439 = _359;
    vec3 _442 = vec3(_23(_421, _425), _23(_429, _432), _23(_436, _439));
    _359 = vec4(_442.x, _442.y, _442.z, _359.w);
    _359 += _368._m3;
    float _455;
    if (_390._m12 > 0.0)
    {
        _455 = _390._m12;
    }
    else
    {
        _455 = _368._m6;
    }
    float _450 = _455;
    vec3 _467 = _359.xyz;
    vec3 _479 = ((_16(_467) * _359.w) * _295._m49) * _450;
    _466 = vec4(_479.x, _479.y, _479.z, _466.w);
    _466.w = _359.w;
    if (_390._m11 > 0.0)
    {
        vec2 _492 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).xy * _295._m16.xy;
        float _523 = vec4(gl_FragCoord.xy, 1.0 - gl_FragCoord.z, gl_FragCoord.w).z;
        bool _525 = false;
        float _526 = _63(_523, _525);
        float _511 = _526;
        vec2 _527 = _492 + vec2(0.0);
        float _531 = 0.119999997317790985107421875;
        float _533 = _295._m17.y;
        float _537 = _295._m18.z + 1.0;
        float _542 = pow(max(0.0, _511 - _531) / (_533 - _531), 0.5);
        float _553 = (0.5 / _537) + (_542 * (1.0 - (1.0 / _537)));
        vec3 _562 = textureLod(sampler3D(_565, _567), vec4(_527, _553, 0.0).xyz, vec4(_527, _553, 0.0).w).xyz;
        vec2 _585 = textureLod(sampler3D(_586, _567), vec4(_527, _553, 0.0).xyz, vec4(_527, _553, 0.0).w).xy;
        float _604 = _585.x;
        float _607 = _585.y;
        float _613 = _295._m50;
        uint _611 = _28(_613);
        bool _617 = (_611 & 2u) != 0u;
        _562 *= float(_617);
        _604 = _617 ? _604 : 1.0;
        vec3 _628 = vec3(0.0);
        if ((_611 & 1u) != 0u)
        {
            vec3 _635 = vec3(_295._m31, _295._m32, _295._m33);
            vec3 _646 = _68(_492);
            vec4 _649 = vec4(0.0);
            vec3 _651 = normalize(_646);
            float _654 = _651.z;
            _649.x = clamp(_41(_654) / 3.1415927410125732421875, 0.00390625, 0.99609375);
            float _663 = _651.y;
            float _666 = _651.x;
            _649.y = _52(_663, _666) / 6.283185482025146484375;
            _649.z = sqrt(_511 * _295._m19.w);
            _649.z = clamp(_649.z, 0.015625, 0.984375);
            _628 = textureLod(sampler3D(_686, _688), _649.xyz, _649.w).xyz;
            _628 *= _607;
        }
        _628 *= _466.w;
        _562 *= _466.w;
        vec3 _715 = ((_466.xyz + _628) * _604) + _562;
        _466 = vec4(_715.x, _715.y, _715.z, _466.w);
    }
    if (_368._m4.x == 0.0)
    {
    }
    else
    {
        if (_368._m4.x == 1.0)
        {
            _466.w = 9.9999997473787516355514526367188e-05;
        }
        else
        {
            if (_368._m4.x == 2.0)
            {
                _466.w = 1.0;
            }
            else
            {
                if (_368._m4.x == 3.0)
                {
                    float _747 = _466.w;
                    _466.w = _10(_747);
                    vec3 _756 = _466.xyz * _466.w;
                    _466 = vec4(_756.x, _756.y, _756.z, _466.w);
                }
                else
                {
                    if (_368._m4.x == 4.0)
                    {
                        float _766 = _466.w;
                        _466.w = _10(_766);
                        vec3 _775 = _466.xyz * _466.w;
                        _466 = vec4(_775.x, _775.y, _775.z, _466.w);
                        _466.w = 9.9999997473787516355514526367188e-05;
                    }
                }
            }
        }
    }
    if (_781._m0 > 0)
    {
        if (_368._m4.x == 1.0)
        {
            vec3 _793 = _466.xyz;
            _466.w = _56(_793);
        }
    }
}



